/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ CONFIG.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE C du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    de la boite de parametrage                       */
/*                         du programme                                */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*..................... INCLUDES DES AUTRES MODULES DU PROGRAMME ......*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le */
                       /* que le module EAZY_GEM.C met  notre         */
                       /* notre disposition                            */
                       /* et inclure les definitions des variables     */
                       /* globales  EAZY_GEM                           */
#include "EZ_EDIT.H"  /* routines d'affichage et de gestion du texte.  */
#include "EZ_EDIT.SYS\CONFIG.RSH"    /* symboles du ressource          */
#include "EZ_EDIT.SYS\EZ_PRINT.H"    /* symboles du ressource          */
#include "EZ_EDIT.SYS\EZ_TXT.RSH"

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
 
#define  CFG_ADD_VIRG      1
#define  CFG_ADD_COMMENT   2
#define  CFG_ADD_CRLF      4

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
char  IndexExt[MAX_PATH];               /* extensions des fichiers d'index  */

TXT_HEAD DefHeadCfg    = {14,          /* interligne en pixel                   */
                           5,          /* ajustage vertical affichage caractere */
                           2,          /* Marge gauche en pixels                */
                           600,        /* Marge droite en nombre de pixels      */
                           80,         /* Nombre de lignes par page             */
                           6,          /* couleur de fond (jaune)               */
                           3,          /* trame du fond                         */
                           1,          /* expansion de TAB en nbr de caracteres                    */
                           250,        /* caractere utilise pour visualiser TAB                    */
                           15,         /* frequence de clignotement                                */
                           { {1,   0,9,0,"MONACO MONO\0                       "}, /* 0  texte normal       */
                             {13,  0,9,0,"MONACO MONO\0                       "}, /* 1 numero de ligne     */
                             {10,  0,9,0,"MONACO MONO\0                       "}  /* 2 fin de ligne        */
                           },
                           1023,        /* longueur d'une ligne sans le 0 de fin */                           
                         };

TXT_GFG DefTextCfg     = {0,                             /* IsEndOfPage        */
                          0,                             /* IsMargRight        */
                          1,                             /* IsMargLeft         */
                          1,                             /* IsAlignIndent      */
                          0,                             /* IsRetOnRight       */
                          0,                             /* IsBlocErase        */
                          1,                             /* IsBlocPersist      */
                          1,                             /* IsSelInsert        */
                          1,                             /* IsNumLigne         */
                          1,                             /* IsEol              */
                          0,                             /* IsSyntColored      */
                          0,                             /* IsTabVisible       */
                          
                          1,                             /* IsBarVisible       */
                          0,                             /* IsSlideMidle       */
                          1,                             /* IsSlideBack        */
                          1,                             /* IsBarBack          */
                          1,                             /* IsWindBack         */
                          -2,                            /* SlideFrameWidth    */
                          1,                             /* SlideFrame3D       */
                          
                          0,                             /* pointeur sur fichier de syntaxe colore */
                          /*................. private ...................*/
                          FIND_LOOP_REVERSE | FIND_FORWARD,
                          -1L,
                          -1L,
                          {-1L,-1L,-1L,-1L,-1L,-1L,-1L,-1L,-1L,-1L},        /* bookmark                 */
                          "A:\\",                     /* PathTxt                                        */
                          "NONAME.TXT",               /* NpmTxt                                         */
                          "A:\\",                     /* PathSavUnder                                   */
                          "NONAME.TXT",               /* NomSavUnder                                    */
                          "A:\\",                     /* PathBlk                                        */
                          "NONAME.TXT"                /* NomBlk                                         */
                         };
static char *ConfigTxt=0;
static char AppliChangeReelTime = 0;
static char LoadCfgMode = 1;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
CALLBACK WindProcConfig(int w_ind, EVNT_O *Evnt);
int  CfgLoadConfig(char *path, char *name, TXT_HEAD *ptHeadTxt, TXT_PRM *ptTxtCfg);
int  CfgSaveConfig(char *path, char *name, TXT_HEAD *ptHeadTxt, TXT_GFG *ptTxtCfg);
void CfgTokenToDefParam(long token, int n, char *pt, TXT_HEAD *ptHeadTxt, TXT_PRM *ptTxtCfg);
void CfgDialogToParam (int w_ind, TXT_HEAD *ptHeadTxt, TXT_GFG *pt_TxtCfg);
void CfgParamToDialog (int w_ind, TXT_HEAD *ptHeadTxt, TXT_GFG *pt_TxtCfg);
void  FTxtWrite(FILE* fh, long* len_lign, char* src,  int flag);
SYNT_PARAM *SyntParamCreate(char *config, char *name);
SYNT_PARAM *IsSyntaxParamExist(char *pt_ext_ini);
int         GetFreeSyntaxTab(void);
char *ConfigSyntaxFileLoad(char *path, char *name );
int   CompteNbToken( char *pt, long token_to_test);
int   GetGrClassByType(CLASS_GRAPH *clasgr, int nb_class, char *clastyp);
char *GetToken(char *pt, char *dst, long token_to_find);
int KeyWordCompare (const void *one, const void *two);
int CompteNbSectionType(char *config, char *clastyp);
int CompteNbKeyWOrdType(char *config, char *clastyp);
int GetKwSectionByType(KWSECTION *kwsection, int nb_class, char *clastyp);
int CfgParseConfig(char *config, TXT_HEAD *ptHeadTxt, TXT_PRM *pt_TxtCfg);
void SetNumericTab(char *arg_buf, char *tab);
void UpdateTestScrollBar(OBJECT *object,  TXT_GFG *pt_TxtCfg);
char *ArgBuffToStr(char *pt_arg);
char *NextNonSpace(char *pt);

void SyntaxCfgSave(char *path, char *name, SYNT_PARAM* syntprm);
void CfgSaveHeadConfig(FILE *fh, TXT_HEAD *ptHeadTxt, TXT_GFG *ptTxtCfg);
void UpdateConfig(int w_ind, int wind_targ, int ob_ret, TXT_HEAD *ptHeadTxt, SYNT_PARAM* syntprm);
void WriteClassGraph(FILE* fh, SYNT_PARAM* syntprm);
char *PathName_Concat(char *dst, char *path, const char *name);
char *IfComWriteIt(FILE* fh, char *pt);
/*................ Fonction de LISTBOX ................................*/
int    LST_BOX_TARG_func (LIST_GET_TXT *ptLISTGETTXT);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------------- SyntaxConfigure --------------------------*/
SYNT_PARAM *SyntaxConfigure(char *nom)
{char *pt_ext_ini = GetExtension(nom, 0);
 char *pt_ext = 0;
 char *path   = 0;
 char *name   = 0;
 char *config = 0;
 SYNT_PARAM *syntprm;
 
 
 
 /*.......... tester si un fichier de config est deja  .................*/
 /*           charg pour cette extension                               */
 if (pt_ext_ini==0)                                       return 0;
 syntprm   = IsSyntaxParamExist(pt_ext_ini);
 if (syntprm)                                             return syntprm;
 
 /*........ reserver les buffers (pas la pile car recursif) ............*/
 path     = malloc(MAX_PATH<<1);
 if (path==0)                                             return 0;
 name     = path + MAX_PATH;

 /*............ les fichiers de configuration syntaxiques sont dans ....*/
 /*             le fichier systme d'EZ_EDIT                            */
 /*             aller chercher un fichier de configuration              */
 /*             correspondant  l'extension                             */
 /*             (noter qu'un fichier lie  une extension peut tres bien */
 /*              indiquer qu'il faut se referer  un autre fichier     */
 /*              l'aide de l'instruction [EQUIVALENT] si c'est le cas   */
 /*              ConfigSyntaxFileLoad() modifie name et y place le nom  */
 /*              du fichier reellement charge.                          */
 
 GetPathRsc(AdrMessRSC, path);
 PathNomToNomFic(path, 0);
 strcpy(name,"KEYWORD");
 strcat(name, pt_ext_ini);
 config       = ConfigSyntaxFileLoad(path, name);
 if (config  == 0){free(path);                            return 0;}
 
 /*............. il peut etre tres bien charge un fichier ..............*/
 /*              equivalent autre que celui de depart                  */
 /*              cause du mot clef [EQUIVALENT]                         */
 /*              donc l'extension change aussi                          */
 pt_ext       = GetExtension(name, 0);
 
 /*.......... tester si ce fichier de config est deja  .................*/
 /*           charg pour cette extension                               */
 syntprm   = IsSyntaxParamExist(pt_ext);
 if (syntprm)
    {strcat(syntprm->Extension, pt_ext_ini);
    }
 /*........... si pas deja charge il faut le creer .....................*/
 else 
    {syntprm  = SyntParamCreate(config, name);
     if (syntprm) 
        {/*......... noter l'extension lie  ce parametre .............*/
         /*          syntaxique (ce peut etre un indirect equivalent)   */
         strcpy(syntprm->Extension, pt_ext);
         /*...... si le parametrage cree est celui d'un equivalent......*/
         /*       alors stocker  la suite de son extension             */
         /*       celle du fichier initial                              */
         if (strcmpi(pt_ext_ini, pt_ext)!=0)
            {strcat(syntprm->Extension, pt_ext_ini);
            }
        }
    }
 free(path); 
 free(config);
 return syntprm;
}

/*----------------------- IsSyntaxParamExist ----------------------------*/
/* ACTION: verifie si l'extension: char *pt_ext_ini n'est pas deja geree */
/*         par un fichier de configuration syntaxique. Auquel cas il est */
/*         retourne la structure de configuration correspondant  cette  */
/*         extension.                                                    */
/*         la liste d'extension geree par chaque structure de configura- */
/*         tion syntaxique est de la forme ".EXT.C.H.CPP.CC" le point    */
/*         sparant chaque extension de l'autre.                         */

SYNT_PARAM *IsSyntaxParamExist(char *pt_ext_ini)
{int         i = 0;
 char  *pt_ext = 0;
 char  *pt_end = 0;
 char      sav = 0;
 while( SyntPrmTab[i])
  {pt_ext = SyntPrmTab[i]->Extension;
   while (*pt_ext)
         {pt_ext = strchr(pt_ext, '.');
          if (pt_ext==0)                                           break;
          pt_end = strchr(pt_ext+1, '.');
          if (pt_end) {sav = *pt_end; *pt_end = 0;}
          if (strcmpi(pt_ext, pt_ext_ini)==0) 
             {if (pt_end) {*pt_end = sav;}
              return SyntPrmTab[i];
             }
          if (pt_end) {*pt_end = sav;}
          pt_ext++;       /* passer le point  */
         }
   i++;
  }
 return 0;
} 

/*----------------------- GetFreeSyntaxTab -----------------------------*/
int GetFreeSyntaxTab(void)
{int i;
 for (i=0; i<NB_SYNT; i++)
     {if (SyntPrmTab[i]==0) return i;
     }
 return -1;
}

/*----------------------- ConfigSyntaxFileLoad -------------------------*/
/* ACTION:  partir du nom d'un fichier de configuration syntaxique,    */
/*         verifie si dans ce fichier le  token 'EQUI' n'indique pas    */
/*         un autre fichier  charger, et si c'est le cas il le charge  */
/*          la place de l'original.                                    */
/* ENTREE: char *path,  pointe sur le path du fichier de                */
/*                     configuration syntaxique  charger.              */
/*         char *name: pointe sur le nom du fichier de configuration    */
/*                     syntaxique  charger.                            */
/* RETOUR: char*: zero si erreur.                                       */
/*                SInon zone memoire ou a ete charge ce fichier de      */
/*                configuration syntaxique.                             */
/*                Il est  votre charge de liberer cette zone memoire   */
/*                apres utilisation.                                    */
/* NOTE: path doit avoir la place  d'au moins de 256 caractreS         */
/*       name doit avoir la place  d'au moins de 128 caractreS         */

char *ConfigSyntaxFileLoad(char *path, char *name )
{long len_cfg;
 char *config = 0;
 char *arg_buf= malloc(MAX_PATH);
 if (arg_buf==0)                                           return 0;
 /*............. si token 'EQUI' .........................................*/
 /*              charger le fichier indiqu par ce token                  */
 strcpy(arg_buf, path);
 strcat(arg_buf, name);
 do 
  {/*.... si juste nom de fichier alors ajouter path .......*/
   if (arg_buf[1] != ':') InsertStr(arg_buf, path);
   len_cfg     = Fic_exist(arg_buf, 0);
   if (len_cfg>10)
      {if (config) free(config);
       config  = malloc(len_cfg+2);
       if (config==0)  {free(arg_buf);                     return 0;}
       Bload(arg_buf, "", config);
       config[len_cfg] = 0;
      }
   else
      {if (config) free(config);  free(arg_buf);           return 0;
      }
  } while (GetToken(config, arg_buf, 'EQUI'));
 if (config)
    {if (arg_buf[1] != ':') InsertStr(arg_buf, path);
     PathNomToNomFic(arg_buf, name);
     strcpy(path, arg_buf);
    }
 free(arg_buf);
 return config;
}

/*----------------------- InsertStr --------------------------------------*/
char *InsertStr(char *dst, char *src)
{register long len_insert = strlen(src);
 memmove(dst + len_insert, dst, strlen(dst) + 1); /* +1 pour bouger le zero de fin */
 memmove(dst, src, len_insert);
 return dst;

}

/*----------------------- SyntParamCreate --------------------------------*/
SYNT_PARAM *SyntParamCreate(char *config, char *name)
{SYNT_PARAM *syntprm  = 0;
 char            *pt  = 0;
 long          token  = 0;
 long          line   = 0;
 int        nb_graph  = 0;
 int        next_synt = 0;
 int        nb_keyw   = 0;
 int        nb_Sect   = 0;
 int      nb_KwSect   = 0;
 CLASS_GRAPH *clasgr  = 0;
 KEY_WRD   *kwkewwrd  = 0;
 SECTION     *section = 0;
 KWSECTION *kwsection = 0;
 long        len_mem  = 0;
 char        *str_sep = ",";
 char        *pt_ext  = GetExtension(name, 0);
 char  arg_buf[MAX_PATH];
 int i;
 /*............ compter nbr de classes graphiques et mots clefs ..........*/
 /*             et reserver et initialiser une structure avec             */
 /*  typedef struct                                                                               */
 /*       {long Size;                            longueur en octet des donnes de syntaxe         */
 /*        int          NbGrClass;               nombre de classes graphiques                     */
 /*        CLASS_GRAPH *GrClass;                 pointeur sur la zone des classes graphiques      */
 /*        int          NbKeyW;                  nombre total de mots clef                        */
 /*        KEY_WRD     *KeyW;                    pointeur sur la zone des dicos de mots clefs     */
 /*        int          NbKwSection;             nombre de sections de mots cles                  */
 /*        KWSECTION   *KwSection;               pointeur sur la zone des sections de mots clefs  */
 /*        int          NbSection;               nombre de sections normales                      */
 /*        SECTION     *Section;                 pointeur sur la zone des sections normales       */
 /*        char         KwSectBegFirstCar[256];  table des delimiteurs des premiers caracteres,   */
 /*        char         KwSectEndFirstCar[256];  et des derniers des sections mot clefs           */
 /*        char         Extension[256];          extensions des fichiers ayant cette syntaxe      */
 /*        TXT_HEAD     HeadTxt;                 parametres du composant d'edition de texte       */
 /*        TXT_PRM      TxtPrm;                  parametres generaux des textes de cette syntaxe  */
 /*       } SYNT_PARAM;                                                                           */
 
 
 /*.............. creation et initialisation de la ........................*/
 /*               structure de configuration syntaxique                    */
 nb_graph    = CompteNbToken(config, 'CLAS');
 nb_keyw     = CompteNbToken(config, 'KEY_');
 nb_Sect     = CompteNbToken(config, 'SECT');
 nb_KwSect   = CompteNbToken(config, 'KW_S');
 
 if (nb_keyw==0 || nb_graph==0 ||nb_KwSect==0) {free(config); return 0;}
 len_mem     = sizeof(SYNT_PARAM)                +
               sizeof(CLASS_GRAPH) * nb_graph    +
               sizeof(KEY_WRD)     * nb_keyw     +
               sizeof(SECTION)     * nb_Sect     +
               sizeof(KWSECTION)   * nb_KwSect;
 syntprm     = malloc(len_mem);
 if (syntprm==0)                 {free(config);               return 0;}
 /*............ debut de l'analyse du fichier de configuration ...........*/
 /*             syntaxique                                                */
 memset(syntprm, 0, len_mem);       /* mise  zero de la memoire          */
 /*............... noter dans la structure l'extension ...................*/
 strcpy(syntprm->Extension, pt_ext);
 syntprm->Size        = len_mem;
 syntprm->NbGrClass   = nb_graph;
 syntprm->GrClass     = (CLASS_GRAPH*) ((char*) syntprm          + sizeof(SYNT_PARAM) );
 syntprm->NbKeyW      = nb_keyw;
 syntprm->KeyW        = (KEY_WRD*)     ((char*) syntprm->GrClass + sizeof(CLASS_GRAPH) * nb_graph );
 syntprm->NbSection   = nb_Sect;
 syntprm->Section     = (SECTION*)     ((char*) syntprm->KeyW    + sizeof(KEY_WRD)     * nb_keyw );
 syntprm->NbKwSection = nb_KwSect;
 syntprm->KwSection   = (KWSECTION*)   ((char*) syntprm->Section + sizeof(SECTION)     * nb_Sect );
 /*............... voir si parametres generaux dans le fichier ................................*/
 syntprm->HeadTxt = DefHeadCfg;             /* recuperer parametres par defaut                 */
 syntprm->TxtPrm  = *(TXT_PRM*)&DefTextCfg; /* recuperer parametres par defaut                 */
 CfgParseConfig(config, &syntprm->HeadTxt, &syntprm->TxtPrm); /* config. syntax. les modifie ? */
 
 /*............. analyse et mise a jour de la structure d'attributs ..........................*/
 /* typedef struct                                                                            */
 /*   {char Name[34];          nom du mot clef doit faire 34 caracteres y compris zero de fin */
 /*    int  LenKey;            longueur significative du mot clef                             */
 /*    int  GraphClass;        classe graphique du mot clef                                   */
 /*    int  NbToIndent;        nombre d'espaces d'indentation sous le mot clef                */
 /*    CAR_ATTR *AttCat;       adresse des attributs graphiques  de la classe graphique       */
 /*   } KEY_WRD;                                                                              */
 pt        = config;
 clasgr    = syntprm->GrClass;
 kwkewwrd  = syntprm->KeyW;
 section   = syntprm->Section;
 kwsection = syntprm->KwSection;
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt=='[' && pt[1])
      {char *end;
       char  sav;
       char *pt_arg;
       
       pt= GoFirstValid(pt+1, " \t");
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token,pt,4); 
       pt     = NextBreakChar(pt, "]\n\r");
       /*......... analyser le token en question ...................*/
       end    = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
       sav    = *end;                       /* placer un zero de fin     */
       *end   = 0;
       pt_arg = pt + 1;
       /* typedef struct                                                                                      */
       /*    {char LenBegStr;        longueur de la chaine de debut de section                                */
       /*     char BegStr[16];       nom du mot clef marquant le debut de section                             */
       /*     char LenEndStr;        longueur de la chaine de fin de section                                  */
       /*     char EndStr[16];       nom du mot clef marquant la fin de section                               */
       /*     int  MajMin;           bit: 0/Maj-Min mot clef 1/ Maj-Min delimiteurs 2/end=mot clef 3/end=CRLF */
       /*     int  IntGrClass;       Classe graphique pour caractres  l'interieur des delimiteurs           */
       /*     char Type[34];         type de la section.                                                      */
       /*     int  NbKeyW;           nombre de mots clefs de cette section                                    */
       /*     KEY_WRD *KwAdr;        Adresse de la liste de mots clefs de cette section                       */
       /*     int  NbSectionAdr;     nombre de sections de cette section de mots clefs                        */
       /*     SECTION *SectionAdr;   pointe sur la zone des sections de cette section de mots clef            */
       /*     char ValidChar[256];   caracteres autorises pour les mots clefs de cette section                */
       /*     char BegSection[256]   caracteres de debut de section                                           */
       /*     char EndSection[256]   caracteres de fin  de section                                            */
       /*     int  Operator[256]     table de caracteres des operateurs de cette section                      */
       /*     int  OppIndent[256];   table des indentation des operateur de cette section                     */
       /*     int  GraphClass;       Classe graphique avec laquelle afficher les delimiteurs                  */
       /*     CAR_ATTR *CarAtt;      adresse des attributs graphiques  de la classe graphique                 */
       /*     char NumBeg[32];       chaine des debuts de section numeriques                                  */
       /*     char NumCarBeg[256];   premiers caractres autoriss dans une section numerique                 */
       /*     char NumCar[256];      autres caractres autoriss dans une section numerique                   */
       /*     int  NumBegGrClass;    classe graphique pour colorer l'introducteur numeriques                  */
       /*     int  NumGrClass;       classe graphique pour colorer les sections numeriques                    */
       /*    } KWSECTION;                                                                                     */
       
       
       /*............................... Section de validite de mots clefs..................................................*/
       /* type de    | Premier    | deuxime   | Nom et type      | liste des caracteres     |Classe graphique | Ignorer    */
       /* definition | dlimiteur | dlimiteur | de la section    | autorises  pour les mots | utiliser pour  | Majuscules */
       /*            |            |            |                  | cles de cette section    |les delimiteurs  | Minuscules */
       /*.......................................................................................................*/
       /* [KW_SECTION]    DEFAUT    , DEFAUT     , DEFAUT           , 0->9 a->z A->Z _       , ATT_TXT_DEFAULT ,0 */
       /* [KW_SECTION]    #         , EOL        , PRECOMPIL        , acdefgilmnoprsu        , ATT_TXT_PRECOMP ,0 */
        
        if (token == 'KW_S')
          {unsigned char id_op;
           char* kw_str, *eol_str;
           /* chaine de debut de section */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {ArgBuffToStr(arg_buf);
               memcpy(kwsection->BegStr, arg_buf, 15);
               id_op = (unsigned char) arg_buf[0];
               if (*arg_buf) syntprm->KwSectBegFirstCar[id_op] += 1; /* table d'acceleration test */
              }
           kwsection->BegStr[15]=0;
           kwsection->LenBegStr = strlen(kwsection->BegStr);
           /* chaine de fin de section */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep); 
           kw_str  = strstr(arg_buf, "KEYWORD");
           if (kw_str)  {kwsection->MajMin |= 4; kw_str  += 7;}
           eol_str = strstr(arg_buf, "EOL");
           if (eol_str) {kwsection->MajMin |= 8; eol_str += 3;}
           if (eol_str||kw_str) eol_str = Max(eol_str, kw_str);
           else                 eol_str = arg_buf;
           eol_str = NextNonSpace(eol_str);
           if (*eol_str)
              {ArgBuffToStr(eol_str);
               memcpy(kwsection->EndStr, eol_str, 15);
               id_op = (unsigned char) eol_str[0];
               if (*eol_str) syntprm->KwSectEndFirstCar[id_op] += 1; /* table d'acceleration test */
              }
           kwsection->EndStr[15]=0;
           kwsection->LenEndStr = strlen(kwsection->BegStr);
           /* nom de la section */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {memcpy(kwsection->Type, arg_buf, 33);
              }
           kwsection->Type[33]=0;
           /* caracteres autorises pour mots clef de la section */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {char *pt_s = arg_buf;
               char *pt_d = kwsection->ValidChar;
               while(*pt_s)
                  {/*.... si on rencontre la formulation: a->z ..........*/
                   if (pt_s[1]=='-' && pt_s[2] == '>')
                      {char deb    = pt_s[0];
                       char end    = pt_s[3];
                       while (deb <= end)
                          {pt_d[deb] = deb;
                           deb++;
                          }
                       pt_s += 4;
                      }
                   else if (*pt_s != ' ' && *pt_s != '\t')
                      {pt_d[*pt_s] = *pt_s;
                       pt_s++;
                      }
                   else
                      {pt_s++;
                      }
                  }
              }
           /* classe graphique */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {kwsection->GraphClass = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);
               kwsection->CarAtt     = &syntprm->GrClass[kwsection->GraphClass].AttGr;
              }
           /* Majuscule Minuscules */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) kwsection->MajMin |= atoi(arg_buf);
           /* IntGrClass */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) kwsection->IntGrClass = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);
           kwsection->SectionAdr   = section;
           kwsection->KwAdr        = kwkewwrd;
           kwsection->NbKeyW       = 0;
           kwsection->NbSection    = 0;
           *end                    = sav;
           kwkewwrd               += CompteNbKeyWOrdType(config, kwsection->Type);
           section                += CompteNbSectionType(config, kwsection->Type);
           kwsection++;
          }
       /*.............................. Classe graphiques .........................................*/
       /* type de    | type de la       | nom de la classe | couleur | effet  | taille | police    */
       /* definition | classe graphique | qui sera affiche | carac-  | carac- | carac- | carac-    */
       /*            |                  | dans la LISTBOX  | tre    | tre   | tre   | tre      */
       /*            |                  | de parametrage   |         |        |        |           */
       /*..........................................................................................*/
       /* [CLASS_GRAP] ATT_TXT_DEFAULT,    Texte normal   ,   1,        0,        9,      Monaco Mono */
       
       /* typedef struct                                                                              */
       /*   {CAR_ATTR  AttGr;        attribut graphique de cette classe                               */
       /*    char      Type[34];     type de la classe doit faire 34 caracteres y compris zero de fin */
       /*    char      Name[34];     nom  de la classe doit faire 34 caracteres y compris zero de fin */
       /*   } CLASS_GRAPH;                                                                            */
       
       if (token == 'CLAS')
          {/* type de la classe graphique */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) memcpy(clasgr->Type, arg_buf, 33);
           clasgr->Type[33]=0;
           /* texte  afficher dans la LISTBOX */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) memcpy(clasgr->Name, arg_buf, 33);
           clasgr->Name[33]=0;
           /* couleur du texte */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)clasgr->AttGr.CarCol = atoi(arg_buf);
           /* effet du texte */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)clasgr->AttGr.CarEff = atoi(arg_buf);
           /* taille du texte */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)clasgr->AttGr.CarPts = atoi(arg_buf);
           /* police de caracteres  du texte */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {int tabId           = (int) FontNameToFontID(arg_buf, FontTab);
               clasgr->AttGr.FntID = (int) FontID[tabId];
               strcpy(clasgr->AttGr.FntName, FontName + tabId * 36);
              }
           
           clasgr++;
          }
       
       /*.................. tableau de mots clefs C et C++ .................................................*/
       /* type de    | nom du   | Reference de la  | Indentation |Section dans laquelle le mot              */
       /* definition | mot clef | classe graphique | de ce mot   |clef doit etre reconnu (si zero ou DEFAUT */
       /*            |          |  utiliser       | clef        |alors le mot clef est reconnu dans        */
       /*            |          | pour affichage   |             |la section par defaut: texte normal)      */
       /*...................................................................................................*/
       
       /* [KEY_WORD]    char      , ATT_TXT_TYPVAR  , NO_INDENT  , PRECOMPIL                                */
       
       /* typedef struct                                                                             */
       /*   {char Name[34];           nom du mot clef doit faire 34 caracteres y compris zero de fin */
       /*    int  LenKey;             longueur significative du mot clef                             */
       /*    int  GraphClass;         classe graphique du mot clef                                   */
       /*    int  NbToIndent;         nombre d'espaces d'indentation sous le mot clef                */
       /*    int  MajMin;              1/Majuscules-Minuscules ignores                              */
       /*    CAR_ATTR *CarAtt;        adresse des attributs graphiques  de la classe graphique       */
       /* } KEY_WRD;                                                                                 */
       else if (token == 'KEY_')
          {KEY_WRD kewwrd;
           /* chaine du mot clef */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {strcpy(kewwrd.Name, arg_buf);
               kewwrd.LenKey = (int) strlen(arg_buf);
              }
           /* classe graphique du mot clef */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {kewwrd.GraphClass = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);
               kewwrd.CarAtt     = &syntprm->GrClass[kewwrd.GraphClass].AttGr;
              }
           /* indentation du mot clef */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {if (strcmpi(arg_buf,"NO_INDENT")==0)
                  {kewwrd.NbToIndent = NO_INDENT;
                  }
               else
                  {kewwrd.NbToIndent = atoi(arg_buf);
                  }
              }
           /* Section de validite du mot clef */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {i = GetKwSectionByType(syntprm->KwSection, nb_KwSect, arg_buf);
               if (i==-1) i=0;
               kwsection     = &syntprm->KwSection[i];
               /* Majuscule Minuscules */
               kewwrd.MajMin = kwsection->MajMin;
               kwsection->KwAdr[kwsection->NbKeyW] = kewwrd;
               kwsection->NbKeyW++;
              }
          }
       /*.............. caractres  reconnaitre comme oprateurs ............................*/
       /* type de    | caractere de  | classe         | Indentation   |Section dans laquelle  */
       /* definition | l'operateur   | graphique      |               |l'oprateur est valide */
       /*.....................................................................................*/

       /*[OPERATOR]         [        , ATT_TXT_OPERATOR  , NO_INDENT  , DEFAUT                */

       else if (token == 'OPER')
          {unsigned int id_op;
           /* argument de la section de mots clef d'appartenance */
           /*   avec lequel on recherche l'adresse section mot clef d'appartenance   */
           /*   dont le pointeur: NbSectionAdr donne l'adresse de la section         */
           XGetSpecifiedArgument(pt_arg, arg_buf, 3, str_sep);
           if (*arg_buf) 
              {i = GetKwSectionByType(syntprm->KwSection, nb_KwSect, arg_buf);
               if (i==-1) i=0;
              }
           kwsection = &syntprm->KwSection[i];
           /* caractre ASCCI de l'operateur*/
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {if      (strncmp(arg_buf, "POINTVIRG", 9)==0) id_op = (unsigned char)',';
               else if (strncmp(arg_buf, "VIRG", 4)==0)      id_op = (unsigned char)',';
               else                                          id_op = (unsigned char) arg_buf[0];
              }
               
           /* Classe graphique de l'operateur */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) kwsection->Operator[id_op]  = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);
           /* indentation de l'operateur */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf)
              {if (strcmpi(arg_buf,"NO_INDENT")==0)
                  {kwsection->OppIndent[id_op] = NO_INDENT;
                  }
               else
                  {kwsection->OppIndent[id_op] = atoi(arg_buf);
                  }
              }
          }
       
       /* ;.............. caractres  reconnaitre comme valeur numrique ..................................................*/
       /* ;                                                                                                                 */
       /* ; type de    | caracteres     | caracteres         | classe         | classe graphique | Section dans laquelle    */
       /* ; definition | introducteurs  | reconnus apres     | graphique de   | de ce qui suit   | la definition est valide */
       /* ;            |                | l introducteur     | l introducteur | l introducteur   |                          */
       /* ;.................................................................................................................*/
       
       /* [NUMERIC]      #$             , a->f A->F 0->9     ,       NUMERIC  ,    NUMERIC       , DEFAUT                   */

       if (token == 'NUME')
          {/* argument de la section de mots clef d'appartenance */
           /*   avec lequel on recherche l'adresse section mot clef d'appartenance   */
           /*   dont le pointeur: NbSectionAdr donne l'adresse de la section         */
           XGetSpecifiedArgument(pt_arg, arg_buf, 3, str_sep);
           if (*arg_buf) 
              {i = GetKwSectionByType(syntprm->KwSection, nb_KwSect, arg_buf);
               if (i==-1) i=0;
              }
           kwsection = &syntprm->KwSection[i];
           /* chaine de debut de zone numerique */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {ArgBuffToStr(arg_buf);
               memcpy(kwsection->NumBeg, arg_buf, 32);
               SetNumericTab(kwsection->NumBeg, kwsection->NumCarBeg);
              }
           /* caractres autoriss pour une section numerique */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {ArgBuffToStr(arg_buf);
               SetNumericTab(arg_buf, kwsection->NumCar);
              }
           /* classe graphique pour afficher l'introducteur */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {kwsection->NumBegGrClass = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);;
              }
           /* classe graphique pour afficher les numeriques */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {kwsection->NumGrClass = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);;
              }
          }
       
       /* ;........... delimiteurs de debut et fin de section ..............................*/
       /* ;            un double click marque le debut et fin                               */
       /* ; type de    | 1er del- | 2me del | classe    | chaine des | KW_Section          */
       /* ; definition | imiteur  | limiteur | graphique | escapes    | d appartenance      */
       /* ;.................................................................................*/
       /* [SECTION]     "        ,  "     , ATT_TXT_COMMENT   , 0     ,                     */
       /* typedef struct                                                                    */
       /*     {char LenBegStr;     longueur de la chaine de debut de section                */
       /*      char BegStr[16];    nom du mot clef marquant le debut de section             */
       /*      char LenEndStr;     longueur de la chaine de fin de section                  */
       /*      char EndStr[16];    nom du mot clef marquant la fin de section               */
       /*      int  MajMin;        1/Majuscules-Minuscules ignores                         */
       /*      char EscCar;        caractre d'echapement d'une section                     */
       /*      int  GraphClass;    classe graphique de la section                           */
       /*      CAR_ATTR *CarAtt;   adresse des attributs graphiques  de la classe graphique */
       /*     } SECTION;                                                                    */
              
       else if (token == 'SECT')
          {unsigned char id_op;
           /* argument de la section de mots clef d'appartenance */
           /*   avec lequel on recherche l'adresse section mot clef d'appartenance   */
           /*   dont le pointeur: NbSectionAdr donne l'adresse de la section         */
           XGetSpecifiedArgument(pt_arg, arg_buf, 4, str_sep);
           if (*arg_buf) 
              {i = GetKwSectionByType(syntprm->KwSection, nb_KwSect, arg_buf);
               if (i==-1) i=0;
              }
           
           kwsection = &syntprm->KwSection[i];
           section   = &kwsection->SectionAdr[kwsection->NbSection];
           kwsection->NbSection++;
           /* premier delimiteur (de debut)*/
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {ArgBuffToStr(arg_buf);
               memcpy(section->BegStr, arg_buf, 15);
               id_op = (unsigned char) arg_buf[0];
               kwsection->BegSection[id_op] += 1; /* table d'acceleration test */
              }
           section->BegStr[15]=0;
           section->LenBegStr = strlen(section->BegStr);
           /* deuxime delimiteur (de fin)*/
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {ArgBuffToStr(arg_buf);
               memcpy(section->EndStr, arg_buf, 15);
               id_op = (unsigned char) arg_buf[0];
               kwsection->EndSection[id_op] += 1; /* table d'acceleration test */
              }
           section->EndStr[15] = 0;
           section->LenEndStr  = strlen(section->BegStr);
           /* classe graphique */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) 
              {section->GraphClass = GetGrClassByType(syntprm->GrClass, nb_graph, arg_buf);
               section->CarAtt     = &syntprm->GrClass[section->GraphClass].AttGr;
              }           
           /* caractere escape */
           pt_arg = XGetArgument(pt_arg, arg_buf, str_sep);
           if (*arg_buf) section->EscCar = *arg_buf;
          }
       *end = sav;                             /* restaurer la fin de ligne */
       pt   = NextLine(pt);
      }
  }  /* end  while (*pt)  */
 
 /*.................. trier les tableaux de mots clefs ..................*/
 for (i=0; i<nb_KwSect; i++)
     {qsort(syntprm->KwSection[i].KwAdr, syntprm->KwSection[i].NbKeyW, sizeof(KEY_WRD), KeyWordCompare);
     }
 /*............. Placer flag de derniere section de mot clef ..........*/
 /* syntprm->KwSection[syntprm->NbKwSection-1].MajMin |= 4;            */
 /*............. Placer flag de chaque derniere section ...............*/
 for (i=0; i<syntprm->NbKwSection; i++)
     {kwsection  = &syntprm->KwSection[i];
      kwsection->SectionAdr[kwsection->NbSection - 1].MajMin |= 4;
     }
 /*.............. chercher une place dans le tableau de ...............*/
 /*               parametres syntaxiques                               */
 next_synt = GetFreeSyntaxTab();
 if (next_synt>-1) 
    {/*......... recuperer attribut texte par defaut .......*/
     /* syntprm->HeadTxt.ATT_Def[ATT_TXT_NORMAL] = syntprm->GrClass->AttGr; */
     SyntPrmTab[next_synt]                    =  syntprm;
     return syntprm;
    }
 else
    {free(syntprm);
    }
return 0;
}

/*------------------------------- SetNumericTab --------------------------*/
void SetNumericTab(char *arg_buf, char *tab)
{
 /*....... fermer les fins de chaines (espaces) par zero de fin .......*/
 /*        et enlever espaces de separation inutiles                   */
 char *pt_car = arg_buf; /* "0x   0X   0->9" */
 char *pt_end = pt_car + strlen(pt_car);
 while (*pt_car) 
       {if (*pt_car==' ') 
           {*pt_car=0;
            pt_car++;
            /*....si pointe encore sur des espaces, les eliminer .............*/
            while (*pt_car==' ') { memcpy(pt_car, pt_car+1, pt_end-pt_car); pt_end--;}
           }
        else pt_car++;
       }
 /*....... analyse de la chaine de la forme "truc\0Machin\0Bidule\0" ..*/
 pt_car = arg_buf;
 while (pt_car<pt_end)
       {/*........... si formulation type a->z .........................*/
        if (pt_car[1]=='-' && pt_car[2]=='>')
           {unsigned char frst_car = (unsigned char) pt_car[0];
            unsigned char last_car = (unsigned char) pt_car[3];
            while (frst_car<=last_car)
                  {tab[frst_car] += 1; /* table d'acceleration test */
                   frst_car++;
                  }
           }
        else
           {while(*pt_car)
                 {tab[(unsigned char) *pt_car] += 1;        /* table d'acceleration test */
                  pt_car++;
                 }
           }
        pt_car += strlen(pt_car)+1;  
       } /* endwhile pt_car<pt_end  */
 }
/*------------------------------- argBuffToStr ---------------------------*/
/* ACTION: remplace les symbole caracteres par le vrais caracteres        */
char *ArgBuffToStr(char *pt_arg)
{char *pt    = pt_arg;
 char *suite = 0;
 while (*pt)
    {if      (strncmp(pt, "EOL", 3)==0)       {pt[0] = '\r';
                                               pt[1] = '\n';
                                               suite = NextNonSpace(pt+3); /* peut etre la fin de la chaine */
                                               pt   += 2;
                                               memmove(pt, suite, strlen(suite)+1);
                                              }
     else if (strncmp(pt, "POINTVIRG", 9)==0) {pt[0] = ';'; 
                                               suite = NextNonSpace(pt+9); /* peut etre la fin de la chaine */
                                               pt++;
                                               memmove(pt, suite, strlen(suite)+1);
                                              }
     else if (strncmp(pt, "SPACE", 5)==0) {pt[0] = ' '; 
                                               suite = NextNonSpace(pt+5); /* peut etre la fin de la chaine */
                                               pt++;
                                               memmove(pt, suite, strlen(suite)+1);
                                              }
     else if (strncmp(pt, "VIRG", 4)==0)      {pt[0] = ','; 
                                               suite = NextNonSpace(pt+4); /* peut etre la fin de la chaine */
                                               pt++;
                                               memmove(pt, suite, strlen(suite)+1);
                                              }
     else if (strncmp(pt, "DEFAUT", 6)==0)    {*pt_arg=0; return pt_arg;}
     else pt++;
    }
 return pt_arg;
}
/*----------------------NextNonSpace -------------------------------------*/
char *NextNonSpace(char *pt)
{while (*pt && *pt==' ')pt++;
 return pt;
}
/*-------------------------------- KeyWordCompare ------------------------*/
int KeyWordCompare (const void *one, const void *two)
{KEY_WRD *kw_one = (KEY_WRD*) one;
 KEY_WRD *kw_two = (KEY_WRD*) two;
 return strcmp( kw_one->Name, kw_two->Name );

}

/*------------------------- CompteNbSectionType --------------------------*/
/* [[SECTION]     "        ,  "     , CLASS_STRING ,    \   ,  DEFAULT    */
       
int CompteNbSectionType(char *config, char *clastyp)
{char *pt         = config;
 int   nb_section = 0;
 long line        = 0;
 long token       = 0;
 char    *str_sep = ",";
 char  arg_buf[MAX_PATH];

 while (*pt)
  {pt = GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt=='[' && pt[1])
      {char *end;
       char  sav;
       char *pt_arg;
       
       pt= GoFirstValid(pt+1, " \t");
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token,pt,4); 
       pt     = NextBreakChar(pt, "]\n\r");
       /*......... executer le token en question ...................*/
       end    = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
       sav    = *end;                       /* placer un zero de fin     */
       *end   = 0;
       pt_arg = pt + 1;
       
       if (token == 'SECT')
          {pt_arg = XGetSpecifiedArgument(pt_arg, arg_buf, 4, str_sep);
           if (arg_buf==0)  goto CompteNbSectionErreur;
           if (strcmp(clastyp, arg_buf)==0) nb_section++;
          }
       *end = sav;                             /* restaurer la fin de ligne */
       pt   = NextLine(pt);
       line ++;
      }
  }  /* end  while (*pt)  */
return nb_section;

CompteNbSectionErreur:
strcpy(arg_buf,TxtPtStrMess[ALR_KEYWRD_ERR1]);
strcat(arg_buf,ltoa(line,"                 ",10));
strcat(arg_buf,TxtPtStrMess[ALR_KEYWRD_ERR2]);
form_alert(0,arg_buf);
return 0;
}
/*------------------------- CompteNbKeyWOrdType --------------------------*/
/* [KEY_WORD]    include   , ATT_TXT_INCLUDE , NO_INDENT   ,PRECOMPIL     */
       
int CompteNbKeyWOrdType(char *config, char *clastyp)
{char *pt         = config;
 int   nb_keyword = 0;
 long line        = 0;
 long token       = 0;
 char    *str_sep = ",";
 char  arg_buf[MAX_PATH];

 while (*pt)
  {pt = GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt=='[' && pt[1])
      {char *end;
       char  sav;
       char *pt_arg;
       
       pt= GoFirstValid(pt+1, " \t");
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token,pt,4); 
       pt     = NextBreakChar(pt, "]\n\r");
       /*......... executer le token en question ...................*/
       end    = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
       sav    = *end;                       /* placer un zero de fin     */
       *end   = 0;
       pt_arg = pt + 1;
       
       if (token == 'KEY_')
          {pt_arg = XGetSpecifiedArgument(pt_arg, arg_buf, 3, str_sep);
           if (*arg_buf==0)  goto CompteNbKeyWOrdErreur;
           if (strcmp(clastyp,arg_buf)==0) nb_keyword++;
          }
       *end = sav;                             /* restaurer la fin de ligne */
       pt   = NextLine(pt);
       line ++;
      }
  }  /* end  while (*pt)  */
return nb_keyword;

CompteNbKeyWOrdErreur:
strcpy(arg_buf,TxtPtStrMess[ALR_KEYWRD_ERR1]);
strcat(arg_buf,ltoa(line,"                 ",10));
strcat(arg_buf,TxtPtStrMess[ALR_KEYWRD_ERR2]);
form_alert(0,arg_buf);
return 0;
}

/*---------------------- GetToken ----------------------------------------*/
char *GetToken(char *pt, char *dst, long token_to_find)
{long token;
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') pt = NextLine(pt);
   else if (*pt=='[' && pt[1])
           {char *end;
            char *pt_arg;
            long  nb_car;
            pt= GoFirstValid(pt+1, " \t");
            /*........ relever les 4 premiers caracteres du token .......*/
            memcpy(&token, pt, 4);
            if (token == token_to_find)
               {pt     = NextBreakChar(pt, "]\n\r"); 
                /*......... executer le token en question ...................*/
                end    = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
                pt_arg = GoFirstValid(pt+1, " \t");
                nb_car = end - pt_arg;
                if (dst&&nb_car>0) {memcpy(dst, pt_arg, nb_car); 
                                    dst[nb_car]=0;
                                    StrTrimEnd(dst);                                    
                                   }
                return pt_arg;
               }
           }
   else    {pt++;
           }
  }
 return 0;
}

/*---------------------- GetKwSectionByType --------.----------------*/
int GetKwSectionByType(KWSECTION *kwsection, int nb_class, char *clastyp)
 {int i;
  for (i=0; i<nb_class; i++)
     {if (strcmp(clastyp, kwsection[i].Type)==0) return i;
     }
 return -1;
 }

/*---------------------- GetGrClassByType ---------------------------*/
int GetGrClassByType(CLASS_GRAPH *clasgr, int nb_class, char *clastyp)
 {int i;
  for (i=0; i<nb_class; i++)
     {if (strcmp(clastyp, clasgr[i].Type)==0) return i;
     }
 return 0;
 }
 
/*---------------------- CompteNbToken ------------------------------*/
int CompteNbToken( char *pt, long token_to_test)
{long line     = 0;
 int  nb_token = 0;
 long token    = 0;
 char buft[MAX_PATH];

 while (*pt)
  {pt = GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt=='[' && pt[1])
      {pt= GoFirstValid(pt+1, " \t");
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token, pt, 4); 
       pt = NextBreakChar(pt, "]\n\r");
       /*........ sortir si erreur .................................*/
       if (*pt==0|| pt[1]==0)
          {strcpy(buft,TxtPtStrMess[ALR_SYNT_CFG1]);
           strcat(buft,ltoa(line,"                 ",10));
           strcat(buft,TxtPtStrMess[ALR_SYNT_CFG2]);
           form_alert(0,buft);
           return 0;
          }
       /*......... executer le token en question ...................*/
       else if (token == token_to_test) 
          {nb_token++;
          }
       pt = NextLine(pt);
       line++;
      }
  }  /* end  while (*pt)  */
 return nb_token;
}

/*----------------------- RaccFileToCfg ----------------------------------*/
/* ACTION: charge si il existe le fichier de configuration des raccourcis */
/*         clavier, et l'installe dans les raccourcis,                    */
void RaccFileToCfg(char *path, char *name)
{long   len_cfg = 0;
 char *config   = 0;
 char       *pt = 0;
 long     line  = 0;
 char arg[128];
 char racc[128];
 /*........... charger fichier de config si existe .......................*/
 len_cfg = Fic_exist(path, name);
 if (len_cfg<10) return;
 config  = malloc(len_cfg+2);
 if (config==0)  return;
 Bload(path, name, config);
 config[len_cfg] = 0;
 /*............. analyse et mise a jour des raccourcis ....................*/
 pt = config;
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt>='0' && *pt<='9')
      {pt     = GetArgument(pt, arg) ;
       if (pt) 
          {char sav;
           /*... fin peut etre soit le commentaire ';' soit fin de ligne ...*/
           char *pt_end = strchr(pt,';');
           if (pt_end==0) pt_end  = EndOfLine(pt);
           sav = *pt_end; *pt_end = 0;
           strcpy(racc, pt); 
           /*.......... attention modifie racc ...........*/
           RaccStrToShortCut(atoi(arg), racc);
           if (pt_end) {*pt_end = sav;}
           pt = NextLine(pt);
           line++;
          }
       else    
          {free(config);
           return;
          }
      }
   else pt++;
  }
 free(config);
}

/*----------------------- RaccToMenuStr --------------------------------*/
int RaccToMenuStr(OBJECT *object, int num_func, int ksp, int key)
{int ind      = -1;
 long len_str = 0;
 char raccStr[64];
 do
   {ind ++;          
    if ( object[ind].ob_type == G_STRING)
       {char *men_str = object[ind].ob_spec.free_string;
        char *pt_fnc  = strchr(men_str, '|');
        
        if (pt_fnc)
           {int num_fnc = atoi(pt_fnc+1);
            if (num_fnc == num_func) 
               {ShortCutToStr(raccStr, ksp, key);
                len_str = strlen(raccStr);
                if (pt_fnc - men_str > len_str)
                   {memcpy(pt_fnc - len_str, raccStr, len_str);
                   }
                return ind;
               }
           }
        
       }
   } while( ! (object[ind].ob_flags & LASTOB));
return 0;
}
/*----------------------- ShortCutToStr --------------------------------*/
char *ShortCutToStr(char *dst, int ksp, int key)
{char *car = " ";
 *dst      = 0;
 *car      = (char)key;
 if (ksp & K_LRSHIFT) strcat(dst, "SHIFT ");
 if (ksp & K_CTRL)    strcat(dst, "CTRL ");
 if (ksp & K_ALT)     strcat(dst, "ALT ");
 
 if (key<0)
    {switch (key)
      {case  -98: strcat(dst, "HELP");  break;
       case  -97: strcat(dst, "UNDO");  break;
       case  -71: strcat(dst, "HOME");  break;
       case  -82: strcat(dst, "INSRT"); break;
       case  -59: strcat(dst, "F1");    break;
       case  -60: strcat(dst, "F2");    break;
       case  -61: strcat(dst, "F3");    break;
       case  -62: strcat(dst, "F4");    break;
       case  -63: strcat(dst, "F5");    break;
       case  -64: strcat(dst, "F6");    break;
       case  -65: strcat(dst, "F7");    break;
       case  -66: strcat(dst, "F8");    break;
       case  -67: strcat(dst, "F9");    break;
       case  -68: strcat(dst, "F10");   break;
      }
    }
 else if (key=='')  strcat(dst, "DEL");
 else if (key=='')  strcat(dst, "BACK");
 else if (key==' ')  strcat(dst, "SPACE");
 else if (key=='9')  strcat(dst, "TAB");
 else if (key=='13') strcat(dst, "RETURN");
 else if (key=='27') strcat(dst, "ESC");
 else                strcat(dst,car);
 return dst;
}

/*----------------------- CfgLoadConfig ----------------------------------*/
int CfgLoadConfig(char *path, char *name, TXT_HEAD *ptHeadTxt, TXT_PRM *ptTxtCfg)
{long   len_cfg  = 0;
 int    nb_token = 0;
 char*  config   = 0;
 int i;
 /*........... charger fichier de config si existe .......................*/
 len_cfg = Fic_exist(path, name);
 if (len_cfg<10) return 0;
 config  = malloc(len_cfg+2);
 if (config==0) return 0;
 Bload(path, name, config);
 config[len_cfg] = 0;
 
 nb_token = CfgParseConfig(config, ptHeadTxt, ptTxtCfg);
 
 free(config);
 /*........... mettre  jour les polices ............*/
 /*            en recherchant les ID fontes VDI      */
 /*             partir u nom de la police           */
  for(i=0; i<3; i++)
    {EZ_ED_SetTxtGraphAttr(-1,
                           -1, 
                           -1,
                           -1, 
                           ptHeadTxt->ATT_Def[i].FntName, 
                           &ptHeadTxt->ATT_Def[i], 
                           1
                          );
    }
 return nb_token;
}

/*---------------------------- CfgParseConfig -----------------------------------*/
int CfgParseConfig(char *config, TXT_HEAD *ptHeadTxt, TXT_PRM *pt_TxtCfg)
{char       *pt = 0;
 int          n = 0;
 long     token = 0;
 int   nb_token = 0;
 long     line  = 0;
 /*............. analyse et mise a jour de la ressource ..................*/
 pt = config;
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt=='[' && pt[1])
      {pt= GoFirstValid(pt+1, " \t");
       
       /*........ si valeur numerique l'extraire ...................*/
       if (*pt>='0' && *pt<='9')
          {char *end = pt;
           char sav;
           while(*end && (*end>='0' && *end<='9')) end++;
           sav  = *end; *end = 0;
           n    = atoi(pt);
           *end = sav;
           pt   = end;  /* on ne considere le token qu'apres les chiffres */
           
          }
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token,pt,4);
       /*............... si instruction de fin de config ...........*/
       if (token=='EndG')                      break;
       pt = NextBreakChar(pt, "]\n\r");
       /*........ sortir si erreur .................................*/
       if (*pt==0|| pt[1]==0)
          {break;
          }
       /*......... executer le token en question ...................*/
       else 
          {char *end = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
           char sav  = *end;                       /* placer un zero de fin     */
           *end      = 0;
           CfgTokenToDefParam(token, n,  pt+1, ptHeadTxt,  pt_TxtCfg);
           *end = sav;                             /* restaurer la fin de ligne */
           nb_token++;
          }
       pt = NextLine(pt);
       line++;
      }
  }  /* end  while (*pt)  */
  return nb_token;
}

/*------------------------------ CfgParamToTexte --------------------------------*/
void CfgParamToTexte (int wind_targ, TXT_HEAD *ptHeadTxt, TXT_PRM *pt_TxtCfg, SYNT_PARAM *syntprm)
{int i;
 int ident                       = GETWINDIDENT(wind_targ); /* identificateur de la fenetre      */
 OBJECT *object                  = GETWINDTREE(wind_targ);  /* recuperer ressource de la fenetre */
 /*........... on ne copie pas les chemins .......................*/
 /*            donc juste partie de la structure                  */
 /* long len_copy     = (long)(&pt_TxtCfg->SyntPrm) - (long)pt_TxtCfg; */
 TXTED_OB  *TXT_A  = 0;
 TXT_GFG *ptTxtCfg = 0;
 if (!IS_IDWINDTXT(ident))            return;
 TXT_A     = WTXT_A(wind_targ);
 ptTxtCfg  = WTXT_CFG(wind_targ);
 /*memcpy(TXT_A, ptHeadTxt, sizeof(TXT_HEAD));*/
 TXT_A->IntLg     =   ptHeadTxt->IntLg;
 TXT_A->BaseAjust =   ptHeadTxt->BaseAjust;
 TXT_A->MargLeft  =   ptHeadTxt->MargLeft;
 TXT_A->MargRight =   ptHeadTxt->MargRight;
 TXT_A->NblPage   =   ptHeadTxt->NblPage;
 TXT_A->BckCol    =   ptHeadTxt->BckCol;
 TXT_A->BckTrm    =   ptHeadTxt->BckTrm;
 TXT_A->ExpTAB    =   ptHeadTxt->ExpTAB;
 TXT_A->CharTAB   =   ptHeadTxt->CharTAB;
 TXT_A->CurFqce   =   CursorSpeed;

/*.............. positionner syntaxe colore .......................*/
 #pragma warn -pia   /* Possible incorrect assignment. */
 if (syntprm==0 && (syntprm = ptTxtCfg->SyntPrm) )
    {syntprm->HeadTxt = *ptHeadTxt;
     syntprm->TxtPrm  = *pt_TxtCfg;
    }
 #pragma warn .pia   /* Possible incorrect assignment. */

 for(i=0; i<3; i++)
    {EZ_ED_SetTxtGraphAttr(ptHeadTxt->ATT_Def[i].CarCol,
                           ptHeadTxt->ATT_Def[i].CarEff, 
                           ptHeadTxt->ATT_Def[i].CarPts,
                           -1, 
                           ptHeadTxt->ATT_Def[i].FntName, 
                           &TXT_A->ATT_Def[i], 
                           1
                          );
    }
 if (pt_TxtCfg->IsTabVisible==0)   TXT_A->State &= ~EDIT_TAB_VISIBLE;
 else                              TXT_A->State |=  EDIT_TAB_VISIBLE;
 
 /*........... si syntaxe existe voyant syntaxe visible .............*/
 if (syntprm)
    {object[EZ_TXT_COLOR_SYNT].ob_flags &= ~HIDETREE;
    }
 else
    {object[EZ_TXT_COLOR_SYNT].ob_flags |=  HIDETREE;
    }
 /*........... si syntaxe active voyant syntaxe enfonc .............*/
 /*        TXT_HEAD     HeadTxt;                 parametres du composant d'edition de texte       */
 /*        TXT_PRM      TxtPrm;                  parametres generaux des textes de cette syntaxe  */
 /*       } SYNT_PARAM;                                                                           */
 
 if (pt_TxtCfg->IsSyntColored && syntprm)
    {EZ_ED_SetDrawLineFunc(AfficheColorLigne, TXT_A);
     object[EZ_TXT_COLOR_SYNT].ob_state |=  SELECTED;
    }
 else  
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
     EZ_ED_SetDrawLineFunc(0L, TXT_A);
     object[EZ_TXT_COLOR_SYNT].ob_state &=  ~SELECTED;
    }
 
 if (pt_TxtCfg->IsEOL==0)          TXT_A->ATT_Def[2].CarCol = -1;
 if (pt_TxtCfg->IsNumLigne==0)     TXT_A->ATT_Def[1].CarCol = -1;
 
 ptTxtCfg->IsEndOfPage         = pt_TxtCfg->IsEndOfPage;
 ptTxtCfg->IsMargRight         = pt_TxtCfg->IsMargRight;
 ptTxtCfg->IsMargLeft          = pt_TxtCfg->IsMargLeft;
 ptTxtCfg->IsAlignIndent       = pt_TxtCfg->IsAlignIndent;
 ptTxtCfg->IsRetOnRight        = pt_TxtCfg->IsRetOnRight;
 ptTxtCfg->IsBlocErase         = pt_TxtCfg->IsBlocErase;
 ptTxtCfg->IsBlocPersist       = pt_TxtCfg->IsBlocPersist;
 ptTxtCfg->IsSelInsert         = pt_TxtCfg->IsSelInsert;
 ptTxtCfg->IsEOL               = pt_TxtCfg->IsEOL;
 ptTxtCfg->IsNumLigne          = pt_TxtCfg->IsNumLigne;
 ptTxtCfg->IsSyntColored       = pt_TxtCfg->IsSyntColored;
 ptTxtCfg->IsTabVisible        = pt_TxtCfg->IsTabVisible;
 
 ptTxtCfg->IsBarVisible        = pt_TxtCfg->IsBarVisible;
 ptTxtCfg->IsSlideBack         = pt_TxtCfg->IsSlideBack;
 ptTxtCfg->IsBarBack           = pt_TxtCfg->IsBarBack;
 ptTxtCfg->IsWindBack          = pt_TxtCfg->IsWindBack;
 ptTxtCfg->SlideFrameWidth     = pt_TxtCfg->SlideFrameWidth;
 ptTxtCfg->SlideFrame3D        = pt_TxtCfg->SlideFrame3D;
 
 /*.............. mise a jour des elements de l'interface ...............*/
 
 {
 XSCRGADGET *xscrgadgetV;
 XSCRGADGET *xscrgadgetH;
 xscrgadgetH = (XSCRGADGET*) object[EZ_TXT_HORZ_BAR].ob_spec.userblk->ub_parm;
 xscrgadgetV = (XSCRGADGET*) object[EZ_TXT_VERT_BAR].ob_spec.userblk->ub_parm;
 xscrgadgetH->Type = 0;
 xscrgadgetV->Type = 0;
 if (!(ptTxtCfg->IsBarVisible))
    {xscrgadgetH->Type |= NO_REDRAW;
     xscrgadgetV->Type |= NO_REDRAW;
    }
 if (!(ptTxtCfg->IsBarBack))
    {xscrgadgetH->Type |= NOBMP_BACKDRAW;
     xscrgadgetV->Type |= NOBMP_BACKDRAW;
    }
 xscrgadgetH = (XSCRGADGET*) object[EZ_TXT_HORZ_ASC].ob_spec.userblk->ub_parm;
 xscrgadgetV = (XSCRGADGET*) object[EZ_TXT_VERT_ASC].ob_spec.userblk->ub_parm;
 xscrgadgetH->Type = 0;
 xscrgadgetV->Type = 0;
 if (!(ptTxtCfg->IsSlideMidle))
    {xscrgadgetH->Type |= NOBMP_DRAW;
     xscrgadgetV->Type |= NOBMP_DRAW;
    }
 if (!(ptTxtCfg->IsSlideBack))
    {xscrgadgetH->Type |= NOBMP_BACKDRAW;
     xscrgadgetV->Type |= NOBMP_BACKDRAW;
    }
 
 xscrgadgetV->tedinfo->te_thickness = ptTxtCfg->SlideFrameWidth;
 xscrgadgetH->tedinfo->te_thickness = ptTxtCfg->SlideFrameWidth;
 
 xscrgadgetH = (XSCRGADGET*) object[EZ_TXT_HEAD_BOX].ob_spec.userblk->ub_parm;
 xscrgadgetH->Type = 8;      /* NOBMP_BACKDRAW  */
 if (ptTxtCfg->IsWindBack) xscrgadgetH->Type = 0;
 if (ptTxtCfg->SlideFrame3D)
    {object[EZ_TXT_HORZ_ASC].ob_flags |= 0x0400;
     object[EZ_TXT_VERT_ASC].ob_flags |= 0x0400;
    }
 else
    {object[EZ_TXT_HORZ_ASC].ob_flags &= ~0x0400;
     object[EZ_TXT_VERT_ASC].ob_flags &= ~0x0400;
    }
 }
 
 /* memcpy(ptTxtCfg, pt_TxtCfg, len_copy); */
}

/*------------------------------ CfgParamToDialog --------------------------------*/
void CfgParamToDialog (int w_ind, TXT_HEAD *ptHeadTxt, TXT_GFG *pt_TxtCfg)
{char buft[32];
 long i;
 OBJECT *object         = GETWINDTREE(w_ind);     /* adr. arbre integre en fenetre  */
 SYNT_PARAM *syntprm    = pt_TxtCfg->SyntPrm;

ObjcSetTxt(object, PRM_DIAL_PRM_INTLG_EDIT,          itoa(ptHeadTxt->IntLg,buft,10) );
ObjcSetTxt(object, PRM_DIAL_PRM_MRG_GCH_EDIT,        itoa(ptHeadTxt->MargLeft,buft,10) );
ObjcSetTxt(object, PRM_DIAL_PRM_MRG_DTE_EDIT,        itoa(ptHeadTxt->MargRight,buft,10) );
ObjcSetTxt(object, PRM_DIAL_PRM_PG_LGN_EDIT,         itoa(ptHeadTxt->NblPage,buft,10) );
ObjcSetTxt(object, PRM_DIAL_PRM_TAB_EDIT,            itoa(ptHeadTxt->ExpTAB,buft,10) );
ObjcSetTxt(object, PRM_DIAL_PRM_TABASCIIEDIT,        itoa(ptHeadTxt->CharTAB,buft,10));
ObjcSetTxt(object, PRM_DIAL_PRM_CURSSPEED_EDIT,      itoa(CursorSpeed,buft,10));
ObjcSetTxt(object, PRM_DIAL_PRM_POP_MEN_WIDTH,       itoa(PopMenWidth,buft,10));
ObjcSetTxt(object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF,  itoa(WcontrolOngActif+1,buft,10));



/*................... positionner l'affichage en reel ou pas ...*/
/*                    des LISTBOX de Fontes                     */
SetFntListBoxMode(object, PRM_DIAL_PRM_TXT_FONTE,  IsViewFntReel);
SetFntListBoxMode(object, PRM_DIAL_PRM_SYNT_FONTE, IsViewFntReel);

/*.......... positionner listbox de fonte par defaut............*/
i =  FontNameToFontID(ptHeadTxt->ATT_Def[0].FntName, FontTab);
i =  Max(0,i);
SetListBoxParam(object, PRM_DIAL_PRM_TXT_FONTE,(int)i,(int)i,-2,-2,-2,(void*)-2L); 
/*.......... positionner listbox de couleur texte par defaut....*/
SetListBoxParam(object, PRM_DIAL_PRM_TXT_COLOR, ptHeadTxt->ATT_Def[0].CarCol,   ptHeadTxt->ATT_Def[0].CarCol,-2,-2,-2,(void*)-2L);
/*.......... positionner listbox de taille texte par defaut.....*/
SetListBoxParam(object, PRM_DIAL_PRM_TXT_PTS,   ptHeadTxt->ATT_Def[0].CarPts-1, ptHeadTxt->ATT_Def[0].CarPts-1,-2,-2,-2,(void*)-2L);
if (syntprm) 
   {int nb_grclass       = syntprm->NbGrClass;
    CLASS_GRAPH *grClass = syntprm->GrClass;
    /*.......... positionner listbox mots clefs.................*/
    SetListBoxParam(object, PRM_DIAL_PRM_SYNT_TYPE,0,0,Min(16,nb_grclass), nb_grclass,-2,(void*)pt_TxtCfg);
    /*.......... positionner listbox de couleur syntaxe ........*/
    SetListBoxParam(object, PRM_DIAL_PRM_SYNT_COLOR,  grClass->AttGr.CarCol, grClass->AttGr.CarCol, -2,-2,-2,(void*)-2L);
    /*.......... positionner listbox de effet syntaxe...........*/
    SetListBoxParam(object, PRM_DIAL_PRM_SYNT_EFFECT, grClass->AttGr.CarEff, grClass->AttGr.CarEff, -2,-2,-2,(void*)-2L);
    /*.......... positionner listbox de fonte syntaxe...........*/
    i =  FontNameToFontID(grClass->AttGr.FntName, FontTab);
    i =  Max(0,i);
    SetListBoxParam(object, PRM_DIAL_PRM_SYNT_FONTE, (int)i, (int)i, -2,-2,-2,(void*)-2L);
    /*.......... positionner listbox de taille syntaxe .........*/
    SetListBoxParam(object, PRM_DIAL_PRM_SYNT_PTS, grClass->AttGr.CarPts-1, grClass->AttGr.CarPts, -2,-2,-2,(void*)-2L);
    /*.......... Positionner nombre de mots clefs ..............*/
    ObjcSetTxt(object, PRM_DIAL_PRM_NB_KEYWORD, itoa(syntprm->NbKeyW, buft, 10));
    /*.......... Positionner taille syntaxe ....................*/
    ObjcSetTxt(object, PRM_DIAL_PRM_SIZE_SYNTAX, ltoa(syntprm->Size, buft, 10));
    /*........... Activer le groupe syntaxique .................*/
    object[PRM_DIAL_PRM_GROUP_SYNTAX].ob_flags &= ~HIDETREE;
    object[PRM_DIAL_PRM_CHK_COL_SYN].ob_flags  &= ~HIDETREE;
   }
else
   {/*........... Desactiver le groupe syntaxique ..............*/
    object[PRM_DIAL_PRM_GROUP_SYNTAX].ob_flags |= HIDETREE;
    object[PRM_DIAL_PRM_CHK_COL_SYN].ob_flags  |= HIDETREE;
   }

/*.......... positionner listbox arriere plan couleur.............*/
SetListBoxParam(object, PRM_DIAL_PRM_BACK_COLOR,  ptHeadTxt->BckCol, ptHeadTxt->BckCol, -2,-2,-2,(void*)-2L);
/*.......... positionner listbox arriere plan trame ..............*/
SetListBoxParam(object, PRM_DIAL_PRM_BACK_MOTIF,  ptHeadTxt->BckTrm, ptHeadTxt->BckTrm, -2,-2,-2,(void*)-2L);

/*.......... positionner listbox fin de ligne.....................*/
/*     placer DefHeadCfg.CarCol car ceux du texte peuvent etre    */
/*     mis  -1                                                   */
SetListBoxParam(object, PRM_DIAL_PRM_ENDLGN_COLOR,  DefHeadCfg.ATT_Def[2].CarCol, DefHeadCfg.ATT_Def[2].CarCol, -2,-2,-2,(void*)-2L);
if (pt_TxtCfg->IsEOL) object[PRM_DIAL_PRM_CHK_END_LGN].ob_state |=  SELECTED;
else                  object[PRM_DIAL_PRM_CHK_END_LGN].ob_state &= ~SELECTED;

/*.......... positionner listbox numero de lignes ................*/
/*     placer DefHeadCfg.CarCol car ceux du texte peuvent etre    */
/*     mis  -1                                                   */
SetListBoxParam(object, PRM_DIAL_PRM_NUMLGN_COLOR,  DefHeadCfg.ATT_Def[1].CarCol, DefHeadCfg.ATT_Def[1].CarCol, -2,-2,-2,(void*)-2L);
if (pt_TxtCfg->IsNumLigne) object[PRM_DIAL_PRM_CHK_NUMLGN].ob_state |=  SELECTED;
else                       object[PRM_DIAL_PRM_CHK_NUMLGN].ob_state &= ~SELECTED;
/*.......... positionner extension des index .....................*/
ObjcSetTxt(object, PRM_DIAL_PRM_INDEXT_EDIT, IndexExt);

if (pt_TxtCfg->IsAlignIndent) object[PRM_DIAL_PRM_CHK_ALGMENT].ob_state           |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_ALGMENT].ob_state           &= ~SELECTED;
if (pt_TxtCfg->IsRetOnRight)  object[PRM_DIAL_PRM_CHK_RET_MDTE].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_RET_MDTE].ob_state          &= ~SELECTED;
if (pt_TxtCfg->IsBlocErase)   object[PRM_DIAL_PRM_CHK_REPLACE].ob_state           |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_REPLACE].ob_state           &= ~SELECTED;
if (pt_TxtCfg->IsBlocPersist) object[PRM_DIAL_PRM_CHK_BLK_STAY].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_BLK_STAY].ob_state          &= ~SELECTED;
if (pt_TxtCfg->IsSelInsert)   object[PRM_DIAL_PRM_CHK_BLKDESEL].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_BLKDESEL].ob_state          &= ~SELECTED;
if (pt_TxtCfg->IsTabVisible)  object[PRM_DIAL_PRM_CHK_TAB_VISI].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_TAB_VISI].ob_state          &= ~SELECTED;
if (pt_TxtCfg->IsSyntColored) object[PRM_DIAL_PRM_CHK_COL_SYN].ob_state           |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_COL_SYN].ob_state           &= ~SELECTED;
if (IsIndexAnim)              object[PRM_DIAL_PRM_CHK_ANIMIND].ob_state           |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_ANIMIND].ob_state           &= ~SELECTED;
if (IsFindAnim)               object[PRM_DIAL_PRM_CHK_ANIMFIND].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_ANIMFIND].ob_state          &= ~SELECTED;
if (IsWindList)               object[PRM_DIAL_PRM_CHK_IS_WINDLIST].ob_state       |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_IS_WINDLIST].ob_state       &= ~SELECTED;
if (IsMarkList)               object[PRM_DIAL_PRM_CHK_IS_MARKLIST].ob_state       |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_IS_MARKLIST].ob_state       &= ~SELECTED;
if (IsViewFntReel)            object[PRM_DIAL_PRM_CHK_IS_FNT_REAL].ob_state       |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_IS_FNT_REAL].ob_state       &= ~SELECTED;
if (LastFicMustBeLoaded)      object[PRM_DIAL_PRM_CHK_RUNLASTF].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_RUNLASTF].ob_state          &= ~SELECTED;
if (LastCfgMustBeSaved)       object[PRM_DIAL_PRM_CHK_SAVAFTER].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_SAVAFTER].ob_state          &= ~SELECTED;
if (FicMustBeSavedOnQuit)     object[PRM_DIAL_PRM_CHK_SAVFICQU].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_SAVFICQU].ob_state          &= ~SELECTED;
if (AppliChangeReelTime)      object[PRM_DIAL_PRM_CHK_REALTIME].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_REALTIME].ob_state          &= ~SELECTED;
if (IsWcontrolOpen)           object[PRM_DIAL_PRM_CHK_WCONTROL_AFFI].ob_state     |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_WCONTROL_AFFI].ob_state     &= ~SELECTED;
if (IsTidyManageError)        object[PRM_DIAL_PRM_CHK_TIDY_ERR].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_PRM_CHK_TIDY_ERR].ob_state          &= ~SELECTED;


ObjcSetTxt(object, PRM_DIAL_PRM_SLDE_FRAME_WIDTH,    itoa(pt_TxtCfg->SlideFrameWidth, buft,10) );
ObjcSetTxt(object, PRM_DIAL_PRM_TXT_PRJ_PATH,      PathProject);
ObjcSetTxt(object, PRM_DIAL_PRM_TXT_PCSTUDIO_PATH, PathPcStudio);
if (pt_TxtCfg->IsBarVisible)  object[PRM_DIAL_CHK_BAR_VISIBLE].ob_state           |=  SELECTED;
else                          object[PRM_DIAL_CHK_BAR_VISIBLE].ob_state           &= ~SELECTED;
if (pt_TxtCfg->IsSlideMidle)  object[PRM_DIAL_CHK_SLIDER_MIDLE].ob_state          |=  SELECTED;
else                          object[PRM_DIAL_CHK_SLIDER_MIDLE].ob_state          &= ~SELECTED;
if (pt_TxtCfg->IsSlideBack)   object[PRM_DIAL_CHK_SLIDE_BACK].ob_state            |=  SELECTED;
else                          object[PRM_DIAL_CHK_SLIDE_BACK].ob_state            &= ~SELECTED;
if (pt_TxtCfg->IsBarBack)     object[PRM_DIAL_CHK_BAR_BACK].ob_state              |=  SELECTED;
else                          object[PRM_DIAL_CHK_BAR_BACK].ob_state              &= ~SELECTED;
if (pt_TxtCfg->IsWindBack)    object[PRM_DIAL_CHK_WIND_BACK].ob_state             |=  SELECTED;
else                          object[PRM_DIAL_CHK_WIND_BACK].ob_state             &= ~SELECTED;
if (pt_TxtCfg->SlideFrame3D)  object[PRM_DIAL_CHK_SLIDE_3D].ob_state              |=  SELECTED;
else                          object[PRM_DIAL_CHK_SLIDE_3D].ob_state              &= ~SELECTED;

/*.............. mise a jour des elements de l'interface ...............*/
UpdateTestScrollBar(object,  pt_TxtCfg);

}

/*------------------------------ UpdateTestScrollBar-----------------------------*/
void UpdateTestScrollBar(OBJECT *object,  TXT_GFG *pt_TxtCfg)
{XSCRGADGET *xscrgadget = 0; 
 
 /* ................ Scroll bar ....................*/
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_SCROLL_BAR].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 0;
 if (!(pt_TxtCfg->IsBarVisible))   xscrgadget->Type |= NO_REDRAW;
 if (!(pt_TxtCfg->IsBarBack))      xscrgadget->Type |= NOBMP_BACKDRAW;
 /*.................slider .........................*/
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_SLIDER].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 0;
 if (!(pt_TxtCfg->IsSlideMidle))    xscrgadget->Type |= NOBMP_DRAW;
 if (!(pt_TxtCfg->IsSlideBack))     xscrgadget->Type |= NOBMP_BACKDRAW;
 xscrgadget->tedinfo->te_thickness = pt_TxtCfg->SlideFrameWidth;
 if (pt_TxtCfg->SlideFrame3D)   object[PRM_DIAL_SLIDER].ob_flags |=  0x0400;
 else                           object[PRM_DIAL_SLIDER].ob_flags &= ~0x0400;
 /*.......... fond de la boite .....................*/
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_PRM_ONG_INTERFACE].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 8;      /* NOBMP_BACKDRAW  */
 if (pt_TxtCfg->IsWindBack)         xscrgadget->Type = 0;
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_PRM_ONG_ASPECT].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 8;      /* NOBMP_BACKDRAW  */
 if (pt_TxtCfg->IsWindBack)         xscrgadget->Type = 0;
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_PRM_ONG_EDITEUR].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 8;      /* NOBMP_BACKDRAW  */
 if (pt_TxtCfg->IsWindBack)         xscrgadget->Type = 0;
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_PRM_ONG_EDITEUR_00].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 8;      /* NOBMP_BACKDRAW  */
 if (pt_TxtCfg->IsWindBack)         xscrgadget->Type = 0;
 xscrgadget = (XSCRGADGET*) object[PRM_DIAL_PRM_ONG_SYNTAXE].ob_spec.userblk->ub_parm;
 xscrgadget->Type = 8;      /* NOBMP_BACKDRAW  */
 if (pt_TxtCfg->IsWindBack)         xscrgadget->Type = 0;

}

/*------------------------------ CfgDialogToParam--------------------------------*/
void CfgDialogToParam (int w_ind, TXT_HEAD *ptHeadTxt, TXT_GFG *pt_TxtCfg)
{OBJECT *object         = GETWINDTREE(w_ind);     /* adr. arbre integre en fenetre  */
 SYNT_PARAM *syntprm    = 0;
 long i, effet; 
 int pts;
 int wind_targ                   = IsWindExist(CurIDDoc);
 if (wind_targ>-1) pt_TxtCfg     =  WTXT_CFG(wind_targ);
 syntprm   = pt_TxtCfg->SyntPrm;

 ptHeadTxt->IntLg       = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_INTLG_EDIT));
 ptHeadTxt->MargLeft    = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_MRG_GCH_EDIT));
 ptHeadTxt->MargRight   = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_MRG_DTE_EDIT));
 ptHeadTxt->NblPage     = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_PG_LGN_EDIT));
 ptHeadTxt->ExpTAB      = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_TAB_EDIT));
 ptHeadTxt->CharTAB     = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_TABASCIIEDIT));
 CursorSpeed            = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_CURSSPEED_EDIT));
 PopMenWidth            = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_POP_MEN_WIDTH));
 WcontrolOngActif       = atoi(ObjcGetTxt(object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF))-1;
 
 /*.......... recuperer listbox de fonte par defaut..............*/
 i = GetSelectedListBoxItem(object, PRM_DIAL_PRM_TXT_FONTE);
 EZ_ED_SetTxtGraphAttr(-1, -1, -1, (int)FontID[i], NULL, ptHeadTxt->ATT_Def, (int)(sizeof(ptHeadTxt->ATT_Def)/sizeof(CAR_ATTR)));
 /*.......... recuperer listbox de couleur texte par defaut......*/
 DefHeadCfg.ATT_Def[0].CarCol = GetSelectedListBoxItem(object, PRM_DIAL_PRM_TXT_COLOR);
 /*.......... recuperer listbox de taille texte par defaut.......*/
 pts = 1 + GetSelectedListBoxItem(object, PRM_DIAL_PRM_TXT_PTS);
 EZ_ED_SetTxtGraphAttr(-1, -1, pts, (int)FontID[i], NULL, ptHeadTxt->ATT_Def, (int)(sizeof(ptHeadTxt->ATT_Def)/sizeof(CAR_ATTR)));


 /*............ Cas ou texte sans Syntaxe ...................*/
 /*             Cas ou texte avec Syntaxe Active             */
 /*             Cas ou texte avec Syntaxe Inactive           */
 /* if ( !(object[PRM_DIAL_PRM_ONG_ASPECT].ob_flags &HIDETREE) )
    i = GetSelectedListBoxItem(object, PRM_DIAL_PRM_SYNT_TYPE) ;
 */
 
 /*............ Cas ou texte avec Syntaxe ...................*/
 if (syntprm)
    {CLASS_GRAPH *grClass = 0;
     int nb_grClass       = syntprm->NbGrClass;
     int size, fonte;
     /*.......... recuperer listbox classe graphique ................*/
     i = GetSelectedListBoxItem(object, PRM_DIAL_PRM_SYNT_TYPE);
     grClass = &syntprm->GrClass[i];
     /*.......... recuperer listbox de couleur ......................*/
     grClass->AttGr.CarCol = GetSelectedListBoxItem(object, PRM_DIAL_PRM_SYNT_COLOR);
     /*.......... recuperer listbox de effet ........................*/
     GetListBoxParam ( object, PRM_DIAL_PRM_SYNT_EFFECT, 0, 0, 0, 0, 0, &effet );
     grClass->AttGr.CarEff = (int)effet;
     /*.......... recuperer listbox de police .......................*/
     fonte = GetSelectedListBoxItem(object, PRM_DIAL_PRM_SYNT_FONTE);
     /*.......... recuperer listbox de taille .......................*/
     size  = 1 + GetSelectedListBoxItem(object, PRM_DIAL_PRM_SYNT_PTS);
     /*.......... fonte et taille idem pour toutes les classes ......*/
     for (i=0; i<nb_grClass; i++)
         {grClass = &syntprm->GrClass[i];
          grClass->AttGr.CarPts  = size;
          grClass->AttGr.FntID   =  (int)FontID[fonte];
          memcpy(grClass->AttGr.FntName, FontName+fonte*36, 34);
          grClass->AttGr.FntName[33] = 0;
         }
    }
 /*.......... recuperer listbox arriere plan couleur.............*/
 ptHeadTxt->BckCol = GetSelectedListBoxItem(object, PRM_DIAL_PRM_BACK_COLOR);
 /*.......... recuperer listbox arriere plan trame ..............*/
 ptHeadTxt->BckTrm = GetSelectedListBoxItem(object, PRM_DIAL_PRM_BACK_MOTIF);

 /*.......... recuperer listbox fin de ligne.....................*/
 DefHeadCfg.ATT_Def[2].CarCol = GetSelectedListBoxItem(object, PRM_DIAL_PRM_ENDLGN_COLOR);
 pt_TxtCfg->IsEOL             = object[PRM_DIAL_PRM_CHK_END_LGN].ob_state &  SELECTED;
 /*.......... recuperer listbox numero de lignes ................*/
 DefHeadCfg.ATT_Def[1].CarCol =  GetSelectedListBoxItem(object, PRM_DIAL_PRM_NUMLGN_COLOR);
 pt_TxtCfg->IsNumLigne        =  object[PRM_DIAL_PRM_CHK_NUMLGN].ob_state             &  SELECTED;
 pt_TxtCfg->IsAlignIndent     =  object[PRM_DIAL_PRM_CHK_ALGMENT].ob_state            &  SELECTED;
 pt_TxtCfg->IsRetOnRight      =  object[PRM_DIAL_PRM_CHK_RET_MDTE].ob_state           &  SELECTED;
 pt_TxtCfg->IsBlocErase       =  object[PRM_DIAL_PRM_CHK_REPLACE].ob_state            &  SELECTED;
 pt_TxtCfg->IsBlocPersist     =  object[PRM_DIAL_PRM_CHK_BLK_STAY].ob_state           &  SELECTED;
 pt_TxtCfg->IsSelInsert       =  object[PRM_DIAL_PRM_CHK_BLKDESEL].ob_state           &  SELECTED;
 pt_TxtCfg->IsTabVisible      =  object[PRM_DIAL_PRM_CHK_TAB_VISI].ob_state           &  SELECTED;
 pt_TxtCfg->IsSyntColored     =  object[PRM_DIAL_PRM_CHK_COL_SYN].ob_state            &  SELECTED;
 
 pt_TxtCfg->IsBarVisible      =  object[PRM_DIAL_CHK_BAR_VISIBLE].ob_state            &  SELECTED;
 pt_TxtCfg->IsSlideMidle      =  object[PRM_DIAL_CHK_SLIDER_MIDLE].ob_state           &  SELECTED;
 pt_TxtCfg->IsSlideBack       =  object[PRM_DIAL_CHK_SLIDE_BACK].ob_state             &  SELECTED;
 pt_TxtCfg->IsBarBack         =  object[PRM_DIAL_CHK_BAR_BACK].ob_state               &  SELECTED;
 pt_TxtCfg->IsWindBack        =  object[PRM_DIAL_CHK_WIND_BACK].ob_state              &  SELECTED; 
 pt_TxtCfg->SlideFrameWidth   =  atoi(ObjcGetTxt(object, PRM_DIAL_PRM_SLDE_FRAME_WIDTH));
 pt_TxtCfg->SlideFrame3D      =  object[PRM_DIAL_CHK_SLIDE_3D].ob_state               &  SELECTED;
 UpdateTestScrollBar(object,  pt_TxtCfg);
 
 IsFindAnim                   =  object[PRM_DIAL_PRM_CHK_ANIMFIND].ob_state           &  SELECTED;
 IsIndexAnim                  =  object[PRM_DIAL_PRM_CHK_ANIMIND].ob_state            &  SELECTED;
 IsWindList                   =  object[PRM_DIAL_PRM_CHK_IS_WINDLIST].ob_state        &  SELECTED;
 IsMarkList                   =  object[PRM_DIAL_PRM_CHK_IS_MARKLIST].ob_state        &  SELECTED;
 IsViewFntReel                =  object[PRM_DIAL_PRM_CHK_IS_FNT_REAL].ob_state        &  SELECTED;
 LastFicMustBeLoaded          =  object[PRM_DIAL_PRM_CHK_RUNLASTF].ob_state           &  SELECTED;
 LastCfgMustBeSaved           =  object[PRM_DIAL_PRM_CHK_SAVAFTER].ob_state           &  SELECTED;
 FicMustBeSavedOnQuit         =  object[PRM_DIAL_PRM_CHK_SAVFICQU].ob_state           &  SELECTED;
 AppliChangeReelTime          =  object[PRM_DIAL_PRM_CHK_REALTIME].ob_state           &  SELECTED;
 IsWcontrolOpen               =  object[PRM_DIAL_PRM_CHK_WCONTROL_AFFI].ob_state      &  SELECTED;
 IsTidyManageError            =  object[PRM_DIAL_PRM_CHK_TIDY_ERR].ob_state           &  SELECTED;
 
 strcpy(PathProject,  ObjcGetTxt(object, PRM_DIAL_PRM_TXT_PRJ_PATH) );
 strcpy(PathPcStudio, ObjcGetTxt(object, PRM_DIAL_PRM_TXT_PCSTUDIO_PATH) );

 /*.......... si pt_TxtCfg n'est pas celui par defaut ................*/
 /*           car celui d'un texte, mettre aussi celui par defaut     */
 /*            jour.                                                 */
 if (&DefTextCfg != pt_TxtCfg)
    {long len_copy     = (long)(&pt_TxtCfg->SyntPrm) - (long)pt_TxtCfg;
     memcpy(&DefTextCfg, pt_TxtCfg, len_copy);
    }
 /*.............. recuperer extension des index .................*/
 /*               sans les CR LF                                 */
 {char *pt_src = ObjcGetTxt(object, PRM_DIAL_PRM_INDEXT_EDIT);
  char *pt_dst = IndexExt;
  while (*pt_src)
        {if (*pt_src != 13 && *pt_src != 10) {*pt_dst = *pt_src; pt_dst++;}
         pt_src++;
        }
  *pt_dst = 0;
 }
}

/*------------------------------ FTxtWrite ---------------------------------------*/
void FTxtWrite(FILE* fh, long* len_lign, char* src,  int flag)
{char *space    = "                                        ";
 char *Virg     = ", ";
 char *CrLf     = "\r\n";
 long len_srce  = strlen(src);
 
 if (flag & CFG_ADD_COMMENT)     /* ajoute la source au 40 me espace de ce qui existe deja  */
    {long len_spc = Max(1, 40 - *len_lign);
     /* Fwrite(fh, len_spc, space); */
     fwrite(space, len_spc, 1, fh);
     *len_lign  += len_spc;
    } 
 fwrite(src, len_srce, 1, fh);
 /* Fwrite(fh, len_srce, src); */
 *len_lign  += len_srce;
 
 if (flag & CFG_ADD_VIRG)         /* ajoute la source et la fait suivre d'une virgule       */
    {/* Fwrite(fh, 2, Virg); */
     fwrite(Virg, 2, 1, fh);
     *len_lign  += 2;
    }
    
 if (flag & CFG_ADD_CRLF)        /* ajoute une fin de ligne  ce qui existe deja             */
    {/* Fwrite(fh, 2, CrLf); */
      fwrite(CrLf, 2, 1, fh);
     *len_lign  = 0;
    }
}
/*------------------------------CfgSaveHeadConfig --------------------------------*/
void  CfgSaveHeadConfig(FILE *fh, TXT_HEAD *ptHeadTxt, TXT_GFG *ptTxtCfg)
{long  len_lgn   = 0; 
 char buft[64];
 /*............................. interligne ....................................*/
 FTxtWrite(fh, &len_lgn, "[Interligne] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->IntLg, buft,10),              0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_INTERLIGNE],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Ajustage vertical .............................*/
 FTxtWrite(fh, &len_lgn, "[VerticalAdjust] ",                          0);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->BaseAjust, buft,10),          0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_VERTADJUST],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Marge gauche ..................................*/
 FTxtWrite(fh, &len_lgn, "[LeftOfset] ",                               0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsMargLeft, buft,10),          CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->MargLeft, buft,10),           0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_MARGLEFT],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
/*............................. Marge doite ...................................*/
 FTxtWrite(fh, &len_lgn, "[RightOfset] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsMargRight, buft,10),         CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->MargRight, buft,10),          0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_MARGRIGHT],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Nombre de lignes par page ....................*/
 FTxtWrite(fh, &len_lgn, "[NbLinePage] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsEndOfPage, buft,10),         CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->NblPage, buft,10),            0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_NBLIGNPAGE],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Background ....................................*/
 FTxtWrite(fh, &len_lgn, "[Background] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->BckCol, buft,10),             CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->BckTrm, buft,10),             0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_BACKGROUND],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
/*............................. Numero de Ligne ...............................*/
 FTxtWrite(fh, &len_lgn, "[NumLine] ",                                 0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsNumLigne, buft,10),          CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[1].CarCol, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[1].CarEff, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[1].CarPts, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, ptHeadTxt->ATT_Def[1].FntName,                0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_NUMLIGNE],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Nombre d'espace pour TAB .....................*/
 FTxtWrite(fh, &len_lgn, "[TabSpace] ",                                0);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ExpTAB, buft,10),             0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_NBTABSPACE],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
  /*............................. Code ASCII pour visualiser TAB ..............*/
 FTxtWrite(fh, &len_lgn, "[CharTAB] ",                                 0);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->CharTAB, buft,10),            0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_CHAR_TAB],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. TAB visible ou pas ...........................*/
 FTxtWrite(fh, &len_lgn, "[TabVisible] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsTabVisible, buft,10),        0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_TAB_VISIBLE],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Fin de Ligne ..................................*/
 FTxtWrite(fh, &len_lgn, "[EndOfLine] ",                               0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsEOL, buft,10),               CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[2].CarCol, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[2].CarEff, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[2].CarPts, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, ptHeadTxt->ATT_Def[2].FntName,                0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_ENDOFLINE],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 }

/*------------------------------ CfgSaveConfig -----------------------------------*/
int CfgSaveConfig(char *path, char *name, TXT_HEAD *ptHeadTxt, TXT_GFG *ptTxtCfg)
{char  file[MAX_PATH];
 char  buft[64];
 long  len_lgn   = 0;
 FILE*  fh       = fopen( PathName_Concat(file, path, name) , "wb");
 if (fh==0)      return 0;
 /*....................... petit header by roland sevin ........................*/
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_HEAD_FIC0],                  CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_HEAD_FIC1],                  CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_HEAD_FIC2],                  CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_HEAD_FIC3],                  CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, " ",                                          CFG_ADD_CRLF);
 /*............................. Numero de Version .............................*/
 FTxtWrite(fh, &len_lgn, "[NumVers] ",                                 0);
 FTxtWrite(fh, &len_lgn, "0,99,a",                                     0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_NUMVERS],                    CFG_ADD_COMMENT|CFG_ADD_CRLF);
 
 CfgSaveHeadConfig(fh, ptHeadTxt, ptTxtCfg);

 /*............................. DefaultTexte ...................................*/
 FTxtWrite(fh, &len_lgn, "[DefaultTexte] ",                            0);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[0].CarCol, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[0].CarEff, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptHeadTxt->ATT_Def[0].CarPts, buft,10),  CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, ptHeadTxt->ATT_Def[0].FntName,                0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_DEFAUTTEXTE],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
/*............................. syntaxe colore ..............................*/
 FTxtWrite(fh, &len_lgn, "[ColSyntaxe] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsSyntColored, buft,10),       0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_COLOR_SYNT],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
/*............................. Bloc Persistant lorsque curseur bouge ........*/
 FTxtWrite(fh, &len_lgn, "[StayBloc] ",                                0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsBlocPersist, buft,10),       0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_BLKPERSIST],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
/*............................. Retour sur marge droite .....................*/
 FTxtWrite(fh, &len_lgn, "[RetOnRight] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsRetOnRight, buft,10),        0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_RETONRIGHTM],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
/*............................. Bloc efface par toute saisie ................*/
 FTxtWrite(fh, &len_lgn, "[ReplaceBloc] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsBlocErase, buft,10),         0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_BLKREPLACE],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Insertion non selectionnee ................*/
 FTxtWrite(fh, &len_lgn, "[SelInsert] ",                               0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsSelInsert, buft,10),         0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_BLKINSERT],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Alignement sur derniere position ..........*/
 FTxtWrite(fh, &len_lgn, "[AlignIndent] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsAlignIndent, buft,10),       0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_ALIGNINDENT],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Frequence de clignotement curseur .........*/
 FTxtWrite(fh, &len_lgn, "[CursorSpeed] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(CursorSpeed,   buft,10),                 0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_CURSSPEED],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. TAB visible ou pas ...........................*/
 FTxtWrite(fh, &len_lgn, "[AniIndex] ",                                0);
 FTxtWrite(fh, &len_lgn, itoa(IsIndexAnim, buft,10),                   0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_ANIM_INDEX],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. TAB visible ou pas ...........................*/
 FTxtWrite(fh, &len_lgn, "[AniFind] ",                                 0);
 FTxtWrite(fh, &len_lgn, itoa(IsFindAnim, buft,10),                    0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_ANIM_FIND],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Liste de fenetre dans Popup ou pas............*/
 FTxtWrite(fh, &len_lgn, "[IsWindList] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(IsWindList, buft,10),                    0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_IS_WINDLIST],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Liste des Marques dans Popup ou pas..........*/
 FTxtWrite(fh, &len_lgn, "[IsMarkList] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(IsMarkList, buft,10),                    0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_IS_MARKLIST],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.................. affichage des LISTBOX de fontes en reel ou pas..........*/
 FTxtWrite(fh, &len_lgn, "[IsViewFntReel] ",                           0);
 FTxtWrite(fh, &len_lgn, itoa(IsViewFntReel, buft,10),                 0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_IS_FNTVIEW],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Largeur du Popup menu en nb de car ........*/
 FTxtWrite(fh, &len_lgn, "[PopMenWidth] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(PopMenWidth,   buft,10),                 0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_POP_WIDTH],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Sauver fichier en quittant ................*/
 FTxtWrite(fh, &len_lgn, "[SaveFileOnQuit] ",                          0);
 FTxtWrite(fh, &len_lgn, itoa(FicMustBeSavedOnQuit, buft,10),          0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_SAVFILONQUIT],               CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................ Sauver Configuration en quittant ...........*/
 FTxtWrite(fh, &len_lgn, "[ConfigSaveOnQuit] ",                        0);
 FTxtWrite(fh, &len_lgn, itoa(LastCfgMustBeSaved, buft,10),            0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_CFGSAVONQUIT],               CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................ Charger fichiers en demarrant ..............*/
 FTxtWrite(fh, &len_lgn, "[LastFicLoad] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(LastFicMustBeLoaded, buft,10),           0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_LASFICLOAD],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................ Changements en temps reel ..................*/
 FTxtWrite(fh, &len_lgn, "[ChangeRealTime] ",                          0);
 FTxtWrite(fh, &len_lgn, itoa(AppliChangeReelTime, buft,10),           0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_CHGREELTIME],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Chemin du fichier REF et ST_GUIDE .........*/
 FTxtWrite(fh, &len_lgn, "[PC_H] ",                                    0);
 FTxtWrite(fh, &len_lgn, PathPCHelp,                                   CFG_ADD_CRLF);
 /*............................. Code Clavier Page UP ......................*/
 FTxtWrite(fh, &len_lgn, "[PG_UP] ",                                   0);
 FTxtWrite(fh, &len_lgn, itoa(EZ_PG_UP, buft,10),                      0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PAGEUP],                     CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Code Clavier Page Down ....................*/
 FTxtWrite(fh, &len_lgn, "[PG_DW] ",                                   0);
 FTxtWrite(fh, &len_lgn, itoa(EZ_PG_DW, buft,10),                      0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PAGEDW],                     CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Hauteur et largeur des ascenseurs .........*/
 FTxtWrite(fh, &len_lgn, "[SLIDE_WIDTH] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(MIN_SLIDE_W, buft,10),                   0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_SLIDEMIN],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Marges d'impression .......................*/
 FTxtWrite(fh, &len_lgn, "[PrtMarges] ",                               0);
 FTxtWrite(fh, &len_lgn, itoa(MrgLeft, buft,10),                       CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(MrgTop, buft,10),                        CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(MrgRight, buft,10),                      CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(MrgBottom, buft,10),                     0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PRTMARGE],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.................... Taille et nom de la police d'impression ............*/
 FTxtWrite(fh, &len_lgn, "[PrtFont] ",                                 0);
 FTxtWrite(fh, &len_lgn, itoa(PrtSizeFont, buft,10),                   CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, PrtFontName,                                  0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PRTFONTNAME],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.................... Flag d'impression de l'entete ......................*/
 FTxtWrite(fh, &len_lgn, "[PrtHead] ",                                 0);
 FTxtWrite(fh, &len_lgn, itoa(PrtHead, buft,10),                       0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PRTHEAD],                    CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.................... Flag d'impression du pied de page ..................*/
 FTxtWrite(fh, &len_lgn, "[PrtNoteFoot] ",                             0);
 FTxtWrite(fh, &len_lgn, itoa(PrtNoteFoot, buft,10),                   0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PRTNOTEFOOT],                CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.................... Flag d'impression noir et blanc ....................*/
 FTxtWrite(fh, &len_lgn, "[IsPrtColor] ",                              0);
 FTxtWrite(fh, &len_lgn, itoa(IsPrtColor, buft,10),                    0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_ISPRTCOLOR],                 CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*........... ligne preselectionee dans la liste des drivers...............*/
 FTxtWrite(fh, &len_lgn, "[PrtDriver] ",                               0);
 FTxtWrite(fh, &len_lgn, itoa(DrvSel, buft,10),                        0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PRTDRIVER],                  CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.............................Fenetre de Controle ........................*/
 FTxtWrite(fh, &len_lgn, "[WControl] ",                                0);
 FTxtWrite(fh, &len_lgn, itoa(IsWcontrolOpen, buft,10),                CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(WcontrolOngActif+1, buft,10),            CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(wControlDefGrect.g_x, buft,10),          CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(wControlDefGrect.g_y, buft,10),          CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(wControlDefGrect.g_w, buft,10),          CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(wControlDefGrect.g_h, buft,10),          0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_WCONTROL],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*.............................extensions des fichiers d'index ............*/
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_INDEXEXT],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, "[IndExtension] ",                            0);
 FTxtWrite(fh, &len_lgn, IndexExt,                                     CFG_ADD_CRLF);
 /*............................. Chemin du dossier INCLUDE ................*/
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_INCLPATH],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, "[InclPath] ",                                0);
 FTxtWrite(fh, &len_lgn, InclPath,                                     CFG_ADD_CRLF);
 /*............................. Chemin du GEMTIDY ........................*/
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_TIDY],                       CFG_ADD_COMMENT|CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, "[Tidy] ",                                    0);
 FTxtWrite(fh, &len_lgn, PathTidy,                                     CFG_ADD_CRLF);
  /*............................ Management de erreurs par GEMtydy .........*/
 FTxtWrite(fh, &len_lgn, "[TidError] ",                                0);
 FTxtWrite(fh, &len_lgn, itoa(IsTidyManageError, buft,10),             0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_IS_TIDY_MNGR],               CFG_ADD_COMMENT|CFG_ADD_CRLF);
 /*............................. Chemin du PcStudio ........................*/
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PCS_PATH],                   CFG_ADD_COMMENT|CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, "[PcStudio] ",                                    0);
 FTxtWrite(fh, &len_lgn, PathPcStudio,                                 CFG_ADD_CRLF);
 /*............................. Chemin du Projet courant...................*/
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_PRJPATH],                    CFG_ADD_COMMENT|CFG_ADD_CRLF);
 FTxtWrite(fh, &len_lgn, "[PrjPath] ",                                     0);
 FTxtWrite(fh, &len_lgn, PathProject,                                  CFG_ADD_CRLF);
/*.............................Parametres interface .......................*/
 FTxtWrite(fh, &len_lgn, "[Slider] ",                                  0);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsSlideMidle, buft,10),        CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsSlideBack, buft,10),         CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->SlideFrameWidth, buft,10),     CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsBarVisible, buft,10),        CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsBarBack, buft,10),           CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->IsWindBack, buft,10),          CFG_ADD_VIRG);
 FTxtWrite(fh, &len_lgn, itoa(ptTxtCfg->SlideFrame3D, buft,10),        0);
 FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_SLIDER],                     CFG_ADD_COMMENT|CFG_ADD_CRLF);
 
 /*............................. positions des fenetres ....................*/
 {int n  = 0;
  int wind, ident,i;
  long blkdeb,blkend;
  for (wind=0; wind<MAX_WIND; wind++)
      {ident = GETWINDIDENT(wind);
       if (IS_IDWINDTXT(ident) )
          {TXT_GFG *ptTxtCfg = WTXT_CFG(wind);
           TXTED_OB  *TXT_A  = WTXT_A(wind);
           *buft = '[';
           itoa(n, buft+1,10); strcat(buft,"_WindXYLH] "); 
           FTxtWrite(fh, &len_lgn, buft,                                         0);
           FTxtWrite(fh, &len_lgn, itoa(Windtab[wind].ExtGrectUse.g_x, buft,10), CFG_ADD_VIRG);
           FTxtWrite(fh, &len_lgn, itoa(Windtab[wind].ExtGrectUse.g_y, buft,10), CFG_ADD_VIRG);
           FTxtWrite(fh, &len_lgn, itoa(Windtab[wind].ExtGrectUse.g_w, buft,10), CFG_ADD_VIRG);
           FTxtWrite(fh, &len_lgn, itoa(Windtab[wind].ExtGrectUse.g_h, buft,10), 0);
           FTxtWrite(fh, &len_lgn, TxtPtStrMess[PRM_WINDPOS],                    CFG_ADD_COMMENT|CFG_ADD_CRLF);
           *buft = '[';
           itoa(n, buft+1,10); strcat(buft,"_LastLoaded] "); 
           FTxtWrite(fh, &len_lgn, buft,                                         0);
           FTxtWrite(fh, &len_lgn, ptTxtCfg->PathTxt,                            0);
           FTxtWrite(fh, &len_lgn, ptTxtCfg->NomTxt,                             CFG_ADD_CRLF);
           *buft = '[';
           itoa(n, buft+1,10); strcat(buft,"_Curs&BlkPosition] ");
           FTxtWrite(fh, &len_lgn, buft,                                         0);
           EZ_ED_GraphUpdate(TXT_A);
           EZ_ED_GetLigCol(BLK_TXT_MARK, &blkdeb, &blkend, TXT_A);
           FTxtWrite(fh, &len_lgn, ltoa(EZ_ED_GETCURPOS(TXT_A),    buft,10),     CFG_ADD_VIRG);
           FTxtWrite(fh, &len_lgn, ltoa(blkdeb-(long)TXT_A->ptTxt, buft,10),     CFG_ADD_VIRG);
           FTxtWrite(fh, &len_lgn, ltoa(blkend-(long)TXT_A->ptTxt, buft,10),     CFG_ADD_CRLF);
           *buft = '[';
           itoa(n, buft+1,10); strcat(buft,"_BookMark] ");
           FTxtWrite(fh, &len_lgn, buft,                                         0);
           for (i=0; i<9; i++)
               {FTxtWrite(fh, &len_lgn, ltoa(ptTxtCfg->Bookmark[i], buft,10),    CFG_ADD_VIRG);
               }
           FTxtWrite(fh, &len_lgn, ltoa(ptTxtCfg->Bookmark[9],      buft,10),    CFG_ADD_CRLF);
           
           n ++;
          }
      } /* end for(wind==0; wind<MAX_WIND; wind++) */
 }
 fclose(fh);
 return 1;
}

/*------------------------------ CfgTokenToDefParam -----------------------------*/
void CfgTokenToDefParam(long token, int n, char *pt, TXT_HEAD *ptHeadTxt, TXT_PRM *ptTxtCfg)
{char buft[MAX_PATH];
 
 if      (token=='Defa')     /* [DefaultTexte] 1,0,9,Monaco Mono   ;couleur, effet, taille, fonte */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[0].CarCol = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[0].CarEff = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[0].CarPts = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) strcpy(ptHeadTxt->ATT_Def[0].FntName,buft);
         }
 else if (token=='Inte') /* [Interligne] 9                     ;interligne en pixels */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->IntLg = atoi(buft);
         }
 else if (token=='Back') /* [Background] 8,2                   ;couleur, trame       */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->BckCol = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->BckTrm = atoi(buft);
         }
 /*............. si mode light cassos ...........................................*/
 /*           le mode light est utilise juste par la fonction                    */
 /*           de sauvegarde des paramtre lors du rechargement des parametres    */
 /*           texte par defaut en l'absence de texte par defaut (non syntaxique) */
 if (LoadCfgMode==0) return;
 if      (token=='Tidy') /* [Tidy]                             ;chemin de GEMTIDY */
         {pt = GetArgument(pt, buft);
          if (*buft ) strcpy(PathTidy, buft);
         }
 else if (token=='PrjP') /* [PrjPath]                          ;Chemin du projet courant */
         {pt = GetArgument(pt, buft);
          if (*buft ) strcpy(PathProject, buft);
         }
 else if (token=='PcSt') /* [PcStudio]                         ;Chemin de PcStudio */
         {pt = GetArgument(pt, buft);
          if (*buft ) strcpy(PathPcStudio, buft);
         }
 else if (token=='TidE') /* [TidError]                         ;Gestion des erreurs HTML 0/par GEMtidy 1/par Code Manager */
         {pt = GetArgument(pt, buft);
          if (*buft ) IsTidyManageError = (char)atoi(buft);
         }
 else if (token=='Vert') /* [VerticalAdjust] 5                 ;ajustage vertical pour fontes speedo en pixels */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->BaseAjust = atoi(buft);
         }
 else if (token=='NumV')
         {pt = GetArgument(pt, buft);
          pt = GetArgument(pt, buft);
          pt = GetArgument(pt, buft);
         }
 else if (token=='NumL') /* [NumLine]   1,13                   ;0/non affiche 1/affich, couleur */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsNumLigne         = (char)atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[1].CarCol = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[1].CarEff = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[1].CarPts = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) strcpy(ptHeadTxt->ATT_Def[1].FntName,buft);
         }
 else if (token=='EndO') /* [EndOfLine] 1,10,0,9,Monaco Mono   ;0/non affiche 1/affich,couleur, effet, taille, fonte */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsEOL              = (char)atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->ATT_Def[2].CarCol = atoi(buft);
         }
 else if (token=='Left') /* [LeftOfset] 1,45,9,1               ;0/non affiche 1/affich, taille en pixels,couleur,type ligne */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsMargLeft        = (char)atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->MargLeft          = atoi(buft);
          
         }
 else if (token=='Righ') /* [RightOfset] 1,45,9,1              ;0/non affiche 1/affich, taille en pixels,couleur,type ligne */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsMargRight   = (char)atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->MargRight     = atoi(buft);
         }
 else if (token=='NbLi') /* [NbLinePage] 1,45,9,1              ;0/non affiche 1/affich, taille en pixels,couleur,type ligne */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsEndOfPage   = (char)atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptHeadTxt->NblPage       = atoi(buft);
         }
 else if (token=='TabS') /* [TabSpace] 4                       ;nombre d'espaces pour expandre une tabulation */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptHeadTxt->ExpTAB       = atoi(buft);
         }
 else if (token=='Char') /* [CharTAB] 250                      ;code ASCII du caractere a employer pour visualiser les Tabulations */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptHeadTxt->CharTAB      = (char)atoi(buft);
         }
 else if (token=='TabV') /* [TabVisible] 1                     ;1/tabulation visible 0/tabulation non visibles */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsTabVisible  = (char)atoi(buft);
         }
 else if (token=='ColS') /* [ColSyntaxe] 1                     ;1/syntaxe coloree active 0/syntaxe coloree inactive */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsSyntColored = (char)atoi(buft);
         }         
 else if (token=='Stay') /* [StayBloc] 1                       ;0/bloc efface lors deplacement curseur 1/pas efface */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsBlocPersist = (char)atoi(buft);
         }
 else if (token=='RetO') /* [RetOnRight] 1                     ;1/retour sur marge droite, 0/pas de retour */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsRetOnRight  = (char)atoi(buft);
         }
 else if (token=='Repl') /* [ReplaceBloc] 1                    ;1/tout caractere saisi remplace le bloc 0/remplace que si contre le bloc */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsBlocErase   = (char)atoi(buft);
         }
 else if (token=='SelI') /* [SelInsert] 1                      ;1/l'insertion est selectionnee apres un coller 0/non selectionnee  */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsSelInsert   = (char)atoi(buft);
         } 
 else if (token=='Alig') /* [AlignIndent] 1                    ;1/un retour  la ligne se fait sous la position actuelle 0/au debut de la ligne  */
         {pt = GetArgument(pt, buft);
          if (*buft )  ptTxtCfg->IsAlignIndent = (char)atoi(buft);
         }
 else if (token=='Save') /* [SaveFileOnQuit] 1                 ;1/sauver fichiers en quittant 0/ne pas sauver en quittant  */
         {pt = GetArgument(pt, buft);
          if (*buft )  FicMustBeSavedOnQuit = (char)atoi(buft);
         }
 else if (token=='Last') /* [LastFicLoad] 1                    ;1/charger les derniers fichiers au demarrage 0/ne pas charger  */
         {pt = GetArgument(pt, buft);
          if (*buft ) LastFicMustBeLoaded  = (char)atoi(buft);
         }
 else if (token=='Conf') /* [ConfigSaveOnQuit] 1               ;1/sauver config en quittant 0/ne pas sauver  */
         {pt = GetArgument(pt, buft);
          if (*buft ) LastCfgMustBeSaved  = (char)atoi(buft);
         }  
 else if (token=='Chan') /* [ChangeRealTime] 1                 ;1/changements de configuration en temps reel 0/pas en temps reel  */
         {pt = GetArgument(pt, buft);
          if (*buft ) AppliChangeReelTime   = (char)atoi(buft);
         }
 else if (token=='Curs') /* [CursorSpeed] 1                    ;Frquence de clignotement du curseur texte */
         {pt = GetArgument(pt, buft);
          if (*buft ) CursorSpeed = (char)atoi(buft);
         }
 else if (token=='PopM') /* [PopMenWidth] 1                    ;Largeur en nombre de caractres du Popup Menu */
         {pt = GetArgument(pt, buft);
          if (*buft ) PopMenWidth = (char)atoi(buft);
         }
  else if (token=='AniI') /* [AniIndex] 1                      ;0/ index non anim   1/index anim lorsqu'il s'ajoute une ligne */
         {pt = GetArgument(pt, buft);
          if (*buft )  IsIndexAnim   = (char)atoi(buft);
         }
 else if (token=='AniF') /* [AniFind] 1                        ;0/ animation   1/pas d'animation lors d'un chercher/remplacer */
         {pt = GetArgument(pt, buft);
          if (*buft )  IsFindAnim    = (char)atoi(buft);
         }                           
 else if (token=='IsWi') /* [IsWindList] 1                     ;1/ le popup menu affiche la liste des fenetres. 0/ il ne les affiche pas */
         {pt = GetArgument(pt, buft);
          if (*buft ) IsWindList     = (char)atoi(buft);
         }
 else if (token=='IsMa') /* [IsMarkList] 1                     ;1/ le popup menu affiche la liste des marques. 0/ il ne les affiche pas */
         {pt = GetArgument(pt, buft);
          if (*buft ) IsMarkList     = (char)atoi(buft);
         }
 else if (token=='IsVi') /* [IsViewFntReel] 0                  ;0/Fontes listes en police systme  1/police relle  */
         {pt = GetArgument(pt, buft);
          if (*buft ) IsViewFntReel  = (char)atoi(buft);
         }
 else if (token=='PG_D') /* [PG_DW] 25641                      ;code evenementiel d'une page DOWN d'un clavier etendu type PC (sur Mac je ne sais pas) */
         {pt = GetArgument(pt, buft);
          if (*buft ) EZ_PG_DW  = atoi(buft);
         }
 else if (token=='PG_U') /* [PG_UP] 25384                      ;code evenementiel d'une page DOWN d'un clavier etendu type PC (sur Mac je ne sais pas) */
         {pt = GetArgument(pt, buft);
          if (*buft ) EZ_PG_UP  = atoi(buft);
         }
 else if (token=='SLID') /* [SLIDE_WIDTH] 5                    ;Hauteur et largeur minimum des ascensseurs */
         {pt = GetArgument(pt, buft);
          if (*buft ) MIN_SLIDE_W  = atoi(buft);
         }
 else if (token=='Slid') /* [Slider]1,1,1,2,1,1,1              ;Motif central, de fond, epaisseur cadre, barre visible, motif barre , fond fenetre, relief */
         {pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsSlideMidle      =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsSlideBack       =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->SlideFrameWidth   =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsBarVisible      =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsBarBack         =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->IsWindBack        =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptTxtCfg->SlideFrame3D      =  atoi(buft);
         }
 else if (token=='PrtM') /* [PrtMarges] 1,0,9,0             ;Marge Gauche, Marge Haute, Marge droite, Marge Basse */
         {pt = GetArgument(pt, buft);
          if (*buft ) MrgLeft     =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) MrgTop      =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) MrgRight    =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) MrgBottom   =  atoi(buft);
         }
 else if (token=='PrtF') /* [PrtFont] 7, Monospace          ;taille en points, nom de la police d'impression */
         {pt = GetArgument(pt, buft);
          if (*buft ) PrtSizeFont =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) {memcpy(PrtFontName, buft, 40); PrtFontName[39]=0;}
         }
 else if (token=='PrtH') /* [PrtHead] 1                     ; 0/ pas d'impression de l'entete 1/impression   */
         {pt = GetArgument(pt, buft);
          if (*buft ) PrtHead      = (char)atoi(buft);
         }
 else if (token=='PrtN') /* [PrtNoteFoot] 1                 ; 0/ pas d'impression du pied de page 1/impression */
         {pt = GetArgument(pt, buft);
          if (*buft ) PrtNoteFoot  = (char)atoi(buft);
         }
 else if (token=='IsPr') /* [IsPrtColor] 1                  ;0/ imprimer en noir et blanc   1/en couleur */
         {pt = GetArgument(pt, buft);
          if (*buft ) IsPrtColor  = (char)atoi(buft);
         }
 else if (token=='PrtD') /* [PrtDriver] 0                   ; numero de la ligne preselectionne de la liste de drivers */
         {pt = GetArgument(pt, buft);
          if (*buft ) DrvSel      = atoi(buft);
         }
 else if (token=='WCon') /* [WControl] 0                    ; Fentre de contrle: Ouvrir au demarrage, Onglet actif, position XYLH */
         {pt = GetArgument(pt, buft);
          if (*buft ) IsWcontrolOpen          =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) WcontrolOngActif        =  atoi(buft)-1;
          pt = GetArgument(pt, buft);
          if (*buft ) wControlDefGrect.g_x    =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) wControlDefGrect.g_y    =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) wControlDefGrect.g_w    =  atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) wControlDefGrect.g_h    =  atoi(buft);
         }
 /*.... fin de la syntaxe coloree ................................*/
 else if (token=='PC_H') /* [PC_HELP_PATH]                                      */
         {pt = GetArgument(pt, buft);
          if (*buft )strcpy(PathPCHelp,buft);
         }
else if (token=='Incl') /* [PRM_INCLPATH]                                      */
         {pt = GetArgument(pt, buft);
          if (*buft )strcpy(InclPath, buft);
         }
 else if (token=='IndE') /* [IndExtension]                     ;extensions des fichiers d'index (max 256 caracteres) */
         {long len_arg = 0;
          char *pt_dst = IndexExt;
          pt = GetArgument(pt, buft);
          while (*buft)
           {len_arg = strlen(buft);
            strcpy(pt_dst , buft);
            strcpy(pt_dst + len_arg, ",");
            pt_dst += len_arg + 1;
            pt      = GetArgument(pt, buft);
           }
          if (pt_dst != IndexExt)pt_dst[-1] = 0;               /* eliminer virgule de fin */ 
         }        
 else if (token=='_Win') /* [1_WindXYLH] 0,0,100,100           ;coordonnes fenetre 1   */
         {n++;   /* histoire de calmer compil */
          /*
          n = Min(MAX_WIND-1, n);  
          pt = GetArgument(pt, buft);
          if (*buft ) ptWndPos[n].g_x = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptWndPos[n].g_y = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptWndPos[n].g_w = atoi(buft);
          pt = GetArgument(pt, buft);
          if (*buft ) ptWndPos[n].g_h = atoi(buft);
          */
         }
}

/*--------------------- CfgLoadDefaultConfig -----------------------------------*/
int CfgLoadDefaultConfig(void *adr_rsc)
{char path[MAX_PATH];
 GetPathRsc(adr_rsc, path);
 PathNomToNomFic(path, 0);
 strcpy(PrtFontName, "Monospace");  /* nom de la police par defaut pour imprimer */
 RaccFileToCfg(path, "SHORTCUT.PRM");
 return CfgLoadConfig( path, TxtPtStrMess[PRM_CFG_NAME] , &DefHeadCfg,  (TXT_PRM*)&DefTextCfg);
}

/*--------------------- CfgSaveDefaultConfig -----------------------------------*/
/* NOTE: Il s'agit de ne sauver que les parametres de la derniere fenetre sans  */
/*       syntaxe.                                                               */
void CfgSaveDefaultConfig(int w_ind)
{char path[MAX_PATH];
 int wind, ident;
 int wind_cur             = IsWindExist(CurIDDoc);
 int wind_last_nosynt     = -1; /* derniere fenetre sans syntaxe */
 int wind_last_synt       = -1; /* derniere fenetre avec syntaxe */
 
 GetPathRsc(GETWINDRSC(w_ind), path);
 PathNomToNomFic(path, 0);
 /*.......... rechercher dernieres fenetres ................*/
 /*           avec et sans syntaxe                          */
 for (wind=0; wind<MAX_WIND; wind++)
     {ident = GETWINDIDENT(wind);
      if (IS_IDWINDTXT(ident) )
         {TXT_GFG  *ptTxtCfg    =  WTXT_CFG(wind);
          if (ptTxtCfg->SyntPrm == 0)
             {wind_last_nosynt = wind;
             }
          else
             {wind_last_synt   = wind;
             }
         }
     }
 /*........... si fenetre courante sans syntaxe ............*/
 /*            on sauve tous ses parametres                 */
 if (wind_cur >-1)
    {TXT_GFG  *ptTxtCfg =  WTXT_CFG(wind_cur);
     if (ptTxtCfg->SyntPrm == 0)
        {CfgSaveConfig(path, TxtPtStrMess[PRM_CFG_NAME], (TXT_HEAD*)WTXT_A(wind_cur),  ptTxtCfg);
         return;
        }
    }
 /*........... si fenetre sans syntaxe existe ..............*/
 /*            on se sert de ses parametres pour            */
 /*            les textes par defaut                        */
 if (wind_last_nosynt>-1)
    {TXT_GFG  *ptTxtCfg        = WTXT_CFG(wind_last_nosynt);
     TXT_GFG  *ptTxtCfgCur     = WTXT_CFG(wind_cur);

     ptTxtCfg->IsTabVisible    = ptTxtCfgCur->IsBarBack;
     ptTxtCfg->IsBarVisible    = ptTxtCfgCur->IsBarVisible;
     ptTxtCfg->IsSlideMidle    = ptTxtCfgCur->IsSlideMidle;
     ptTxtCfg->IsSlideBack     = ptTxtCfgCur->IsSlideBack;
     ptTxtCfg->IsBarBack       = ptTxtCfgCur->IsBarBack;
     ptTxtCfg->IsWindBack      = ptTxtCfgCur->IsWindBack;
     ptTxtCfg->SlideFrameWidth = ptTxtCfgCur->SlideFrameWidth;
     ptTxtCfg->SlideFrame3D    = ptTxtCfgCur->SlideFrame3D;
     CfgSaveConfig(path, TxtPtStrMess[PRM_CFG_NAME], (TXT_HEAD*)WTXT_A(wind_last_nosynt),  ptTxtCfg);
     return;
    }
 /*........... si fenetre sans syntaxe existe pas ..........*/
 /*            recharger les parametres par defaut          */
 /*            car ceux d'une fenetre syntaxique ne         */
 /*            peuvent pas s'appliquer  ceux des textes    */
 /*            par defaut en dehors de ceux des sliders.    */
 if (wind_last_synt>-1)
    {TXT_GFG  *ptTxtCfg          = &DefTextCfg;
     TXT_GFG  *ptTxtCfgCur       = WTXT_CFG(wind_last_synt);
     if (wind_cur>-1) ptTxtCfgCur= WTXT_CFG(wind_cur);
     LoadCfgMode = 0; /* mode light */
     CfgLoadConfig( path, TxtPtStrMess[PRM_CFG_NAME] , &DefHeadCfg,  (TXT_PRM*)&DefTextCfg);
     LoadCfgMode = 1; /* mode full  */
     ptTxtCfg->IsTabVisible    = ptTxtCfgCur->IsBarBack;
     ptTxtCfg->IsBarVisible    = ptTxtCfgCur->IsBarVisible;
     ptTxtCfg->IsSlideMidle    = ptTxtCfgCur->IsSlideMidle;
     ptTxtCfg->IsSlideBack     = ptTxtCfgCur->IsSlideBack;
     ptTxtCfg->IsBarBack       = ptTxtCfgCur->IsBarBack;
     ptTxtCfg->IsWindBack      = ptTxtCfgCur->IsWindBack;
     ptTxtCfg->SlideFrameWidth = ptTxtCfgCur->SlideFrameWidth;
     ptTxtCfg->SlideFrame3D    = ptTxtCfgCur->SlideFrame3D;
    }
 CfgSaveConfig(path, TxtPtStrMess[PRM_CFG_NAME], &DefHeadCfg,  &DefTextCfg);
}

/*------------------------------ SetFntListBoxGraphMode ------------------------*/
void SetFntListBoxGraphMode(OBJECT *object, int ind_ob, int mode)
{XUSERBLK *xuserblk = (XUSERBLK*) object[ind_ob].ob_spec.userblk->ub_parm;
 xuserblk->P1       =   mode;
}

/*------------------------------ WindProcConfig -------------------------*/
/* Affiche la boite d'information du programme                           */
CALLBACK WindProcConfig(int w_ind, EVNT_O *Evnt)
{/*....recuperer l'adresse du premier objet (racine) de la ressource....*/
 OBJECT *object = GETWINDTREE(w_ind); /* adr. arbre integre en fenetre  */
 int        w_h = GETGEMHAND(w_ind);  /* handle GEM de notre fenetre    */
 /*.... recuperer handle fenetre avant plan (besoin apres)..............*/
 int wh_top;                    /* handle fenetre en avant plan         */
 wind_get( 0, WF_TOP, &wh_top); /* recuperer handle fen. avt plan.      */
 
 if (Evnt->evnt & MU_KEYBD && w_h == wh_top)
    {if (w_h == wh_top ) Xform_keybd(w_ind, Evnt);
    }
    
 if (Evnt->evnt & MU_BUTTON )
    {int ob_ret          = Xform_button(w_ind, Evnt);
     int wind_targ       = IsWindExist(CurIDDoc);
     
     if (ob_ret>-1)            
        {Evnt->evnt &= ~MU_BUTTON;   /* empecher propagation message  MU_BUTTON */
         /*.......... si objet type fleche haute ou basse ......................*/
         /*           c'est une icone dont le pere est une G_BOXTEXT            */
         if (GET_XOBTYPE(object, ob_ret)==G_CICON)
            {int ob_father  = FindParentOfObject(object, ob_ret);
             int min_val    = 1;
             if (ob_father != -1 && GET_XOBTYPE(object, ob_father)==G_FBOXTEXT)
                {/*............ rechercher celui le plus  gauche ..............*/
                 /*                 c'est le decrementeur                       */
                 char buft[64];
                 int val = atoi(ObjcGetTxt(object, ob_father));
                 SetFocus(w_ind, Evnt, object, ob_father);
                 if (ob_father==PRM_DIAL_PRM_SLDE_FRAME_WIDTH) min_val = 0;
                 
                 do {if (object[ob_ret].ob_x <20)
                       {val = Max(min_val,val-1);
                       }
                    else
                       {val = Min(2000,val+1);
                       }
                    ObjcSetTxt(object, ob_father,  itoa(val, buft,10));
                    Wobjc_draw(w_ind, object, ob_father, 2, 0);
                   }  while(Mousek());
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
                 /*..... activer le temps reel selon objet clique ....*/
                 switch (ob_father)
                   {/*....... sans le redraw de la fenetre active ....*/
                    case PRM_DIAL_PRM_SLDE_FRAME_WIDTH:
                         ob_ret = PRM_DIAL_CHK_SLIDE_3D;
                         break;
                    case PRM_DIAL_PRM_CURSSPEED_EDIT:
                    case PRM_DIAL_PRM_POP_MEN_WIDTH:
                         CfgDialogToParam (w_ind,    &DefHeadCfg,  &DefTextCfg);
                         CfgParamToTexte (wind_targ, &DefHeadCfg,  (TXT_PRM*)&DefTextCfg, 0);
                         break;
                    /*....... avec le redraw de la fenetre active ....*/
                    default:
                         ob_ret = PRM_DIAL_PRM_APPLIQUER2; /* active temps reel */
                   } 
                } /* endif (ob_father != -1 && GET_XOBTYPE(object, ob_father)==G_FBOXTEXT) */
            } /* endif (GET_XOBTYPE(object, ob_ret)==G_CICON) */
         /*............. si objet exit selectionne ...................*/
         switch(ob_ret)
           {case PRM_DIAL_PRM_BUT_PCSTUDIO:
                 ExeTxtFunc(w_ind, TXT_PCSTUDIO_FIND);
                 break; 
            case PRM_DIAL_PRM_BUT_PRJPATH:
                 ExeTxtFunc(w_ind, TXT_PRJ_LOAD);
                 break; 
            case PRM_DIAL_PRM_SYNT_TYPE:
                {int i                   = GetSelectedListBoxItem(object, PRM_DIAL_PRM_SYNT_TYPE);
                 TXT_GFG   *ptTxtCfg     =  WTXT_CFG(wind_targ);
                 if (ptTxtCfg)
                    {SYNT_PARAM *syntprm = ptTxtCfg->SyntPrm;
                     if (syntprm) 
                        {CLASS_GRAPH *grClass = &syntprm->GrClass[i];
                         SetListBoxParam(object, PRM_DIAL_PRM_SYNT_COLOR,  grClass->AttGr.CarCol, grClass->AttGr.CarCol, -2,-2,-2,(void*)-2L);
                         SetListBoxParam(object, PRM_DIAL_PRM_SYNT_EFFECT, grClass->AttGr.CarEff, grClass->AttGr.CarEff, -2,-2,-2,(void*)-2L);
                         SendObjectRedraw(w_h, object, PRM_DIAL_PRM_SYNT_COLOR);
                         SendObjectRedraw(w_h, object, PRM_DIAL_PRM_SYNT_EFFECT);
                        }
                    }
                 
                }
                 break;
            case PRM_DIAL_PRM_CHK_IS_MARKLIST:
            case PRM_DIAL_PRM_CHK_IS_WINDLIST:
                 CfgDialogToParam (w_ind,    &DefHeadCfg,  &DefTextCfg);
                 break;
            case PRM_DIAL_PRM_CHK_IS_FNT_REAL:
                {int wind_Prnt     = IsWindExist(W_EZ_EDIT_PRT);
                 CfgDialogToParam (w_ind,    &DefHeadCfg,  &DefTextCfg);
                 SetFntListBoxGraphMode(object, PRM_DIAL_PRM_TXT_FONTE,  IsViewFntReel);
                 SetFntListBoxGraphMode(object, PRM_DIAL_PRM_SYNT_FONTE, IsViewFntReel);
                 if (wind_Prnt>-1)
                    {OBJECT *pr_ob = GETWINDTREE(wind_Prnt);
                     SetFntListBoxGraphMode(pr_ob, PRT_LST_FONT, IsViewFntReel);
                    } 
                }
                 break;
            case PRM_DIAL_PRM_SYNT_COLOR:
            case PRM_DIAL_PRM_SYNT_EFFECT:
            case PRM_DIAL_PRM_SYNT_PTS:
            case PRM_DIAL_PRM_SYNT_FONTE:
                {CfgDialogToParam (w_ind,    &DefHeadCfg,  &DefTextCfg);
                 if (!(GETWINDTREE(wind_targ)[EZ_TXT_COLOR_SYNT].ob_state &SELECTED))
                    {break;
                    }
                }
            case PRM_DIAL_CHK_SLIDE_3D:
            case PRM_DIAL_PRM_SLDE_FRAME_WIDTH:
            case PRM_DIAL_CHK_WIND_BACK:
            case PRM_DIAL_CHK_BAR_BACK:
            case PRM_DIAL_CHK_BAR_VISIBLE:
            case PRM_DIAL_CHK_SLIDE_BACK:
            case PRM_DIAL_CHK_SLIDER_MIDLE:
                 CfgDialogToParam (w_ind,    &DefHeadCfg,  &DefTextCfg);
                 if (wind_targ>-1 && AppliChangeReelTime)
                    {CfgParamToTexte (wind_targ, &DefHeadCfg, (TXT_PRM*)&DefTextCfg, 0);
                     SendWindRedraw(GETGEMHAND(wind_targ));
                    }
                 if (ob_ret==PRM_DIAL_CHK_WIND_BACK)
                    {Wobjc_draw(w_ind, object, PRM_DIAL_PRM_ONG_INTERFACE, 3, 0);
                    }
                 else
                    {Wobjc_draw(w_ind, object, PRM_DIAL_SCROLL_BAR, ALL_OBJECT,0);
                    }
                 break;
                 
            case PRM_DIAL_PRM_APPLIQUER0:
            case PRM_DIAL_PRM_APPLIQUER1:
            case PRM_DIAL_PRM_APPLIQUER0_00:
            case PRM_DIAL_PRM_APPLIQUER2:
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
            
            case PRM_DIAL_PRM_CHK_COL_SYN:
            case PRM_DIAL_PRM_CHK_TAB_VISI:
            case PRM_DIAL_PRM_CHK_RET_MDTE:
            case PRM_DIAL_PRM_CHK_BLK_STAY:
            case PRM_DIAL_PRM_CHK_REPLACE:
            case PRM_DIAL_PRM_CHK_BLKDESEL:
            case PRM_DIAL_PRM_CHK_ALGMENT:
            case PRM_DIAL_PRM_CHK_SAVAFTER:
            case PRM_DIAL_PRM_CHK_RUNLASTF:
            case PRM_DIAL_PRM_CHK_SAVFICQU:
            case PRM_DIAL_PRM_TXT_FONTE:
            case PRM_DIAL_PRM_TXT_PTS:
            case PRM_DIAL_PRM_TXT_COLOR:
            case PRM_DIAL_PRM_BACK_COLOR:
            case PRM_DIAL_PRM_BACK_MOTIF:
            case PRM_DIAL_PRM_ENDLGN_COLOR:
            case PRM_DIAL_PRM_CHK_END_LGN:
            case PRM_DIAL_PRM_CHK_NUMLGN:
            case PRM_DIAL_PRM_NUMLGN_COLOR:
            case PRM_DIAL_PRM_CHK_REALTIME:
            case PRM_DIAL_PRM_CHK_TIDY_ERR:
                 UpdateConfig(w_ind, wind_targ, ob_ret, 0, 0);
                 break;
                  
            case PRM_DIAL_PRM_APL_PARTOUT0:
            case PRM_DIAL_PRM_APL_PARTOUT1:
            case PRM_DIAL_PRM_APL_PARTOUT0_00:
            case PRM_DIAL_PRM_APL_PARTOUT2:
                {int wind_targ, ident;
                 CfgDialogToParam (w_ind,    &DefHeadCfg,  &DefTextCfg);                 
                 for (wind_targ=0; wind_targ<MAX_WIND; wind_targ++)
                     {ident = GETWINDIDENT(wind_targ);
                      if (IS_IDWINDTXT(ident) )
                         {CfgParamToTexte (wind_targ, &DefHeadCfg,  (TXT_PRM*)&DefTextCfg, 0);
                          SetScrollBoxParam(GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, DefHeadCfg.IntLg, -2, -2, -2, -2, -2, -2, -2,(void*)-2L, -2);
                          AdjustSrollEditSlide(GETWINDTREE(wind_targ));
                          UpdateParamTexte( GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, WTXT_A(wind_targ)); 
                          Wobjc_draw(wind_targ, GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, 1, 0);
                          Wobjc_draw(wind_targ, GETWINDTREE(wind_targ), EZ_TXT_VERT_BAR, 1, 0);
                          Wobjc_draw(wind_targ, object, EZ_TXT_COLOR_SYNT, 1, 0);
                         }
                    } /* endfor (wind_targ=0; wind_targ<MAX_WIND; wind_targ++) */
                 }
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
                 break;
            case PRM_DIAL_PRM_SAV_SYNT:
            case PRM_DIAL_PRM_SAV_SYNT_SOUS:
                {TXT_GFG   *ptTxtCfg     =  WTXT_CFG(wind_targ);
                 if (ptTxtCfg)
                    {char path[MAX_PATH];
                     char name[MAX_PATH>>1];
                     char*        pt_ext = GetExtension(ptTxtCfg->NomTxt, 0);
                     SYNT_PARAM* syntprm = ptTxtCfg->SyntPrm;
                     GetPathRsc(AdrMessRSC, path);
                     PathNomToNomFic(path, 0);
                     if (pt_ext==0)         break;
                     strcpy(name, "KEYWORD");
                     strcat(name,  pt_ext);
                     if (syntprm) 
                        {if (ob_ret==PRM_DIAL_PRM_SAV_SYNT_SOUS )
                            {if (FileSelect (path, name, pt_ext, TxtPtStrMess[PRM_MESS_FICSAV]) != -2L)
                                {SyntaxCfgSave( path, name, syntprm);
                                }
                            }
                         else
                            {SyntaxCfgSave( path, name, syntprm);
                            }
                        }
                    }
                 }
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
                 break;
            case PRM_DIAL_PRM_SAV0:
            case PRM_DIAL_PRM_SAV1:
            case PRM_DIAL_PRM_SAV0_00:
            case PRM_DIAL_PRM_SAV2:
                 CfgSaveDefaultConfig(w_ind);
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
                 break;
            case PRM_DIAL_PRM_SAV_SOUS0:
            case PRM_DIAL_PRM_SAV_SOUS1:
            case PRM_DIAL_PRM_SAV_SOUS0_00:
            case PRM_DIAL_PRM_SAV_SOUS2:
                {char path[MAX_PATH];
                 char nom[MAX_PATH>>1];
                 strcpy(nom,TxtPtStrMess[PRM_FIC_NAME]);
                 GetPathRsc(GETWINDRSC(w_ind), path);
                 PathNomToNomFic(path, 0);
                 if ( FileSelect (path, nom, ".INF", TxtPtStrMess[PRM_MESS_FICSAV]) != -2L )
                    {CfgSaveConfig(path, nom, &DefHeadCfg,  &DefTextCfg);
                    }
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
                }
                 break;
            case PRM_DIAL_PRM_CHARGER0:
            case PRM_DIAL_PRM_CHARGER1:
            case PRM_DIAL_PRM_CHARGER0_00:
            case PRM_DIAL_PRM_CHARGER2:
                {char path[MAX_PATH], nom[MAX_PATH>>1];
                 int wind;
                 GetPathRsc(GETWINDRSC(w_ind), path);
                 PathNomToNomFic(path, 0);
                 strcpy(nom, TxtPtStrMess[PRM_CFG_NAME]);
                 if ( Fic_select (path, nom, ".INF", TxtPtStrMess[PRM_MESS_FICLOAD]) >0 )
                    {if (CfgLoadConfig(path, nom, &DefHeadCfg,  (TXT_PRM*)&DefTextCfg))
                        {CfgParamToDialog (w_ind, &DefHeadCfg,  &DefTextCfg);
                         SendWindMessage(w_h, WM_REDRAW, &Windtab[w_ind].GemWorkGrect);
                         /*................. la fenetre impression comporte aussi des parametres ..................*/
                         wind = IsWindExist(W_EZ_EDIT_PRT);
                         if (wind !=-1 && IsWindOpen(wind))
                            {SendWindMessage(GETGEMHAND(wind), WM_PRT_PRM_CHG, 0);
                            }
                        }
                    }
                 object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
                 SendObjectRedraw(w_h, object, ob_ret);
                }
                 break;
           } /*end switch(ob_ret) */
        }
    } /* endif MU_BUTTON  et fenetre au premier plan */

 if (Evnt->evnt & MU_TIMER && w_h==wh_top)  Xform_timer(w_ind, Evnt);    
 if (Evnt->evnt & MU_MOVE)                  Xform_mu_move(w_ind, Evnt);     
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_PRM_ONG_UPDATE:
            {char buft[32];
             ObjcSetTxt(object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF, itoa(WcontrolOngActif+1,buft,10));
             if ( !(object[PRM_DIAL_PRM_ONG_EDITEUR_00].ob_flags &HIDETREE) )
                {SendObjectRedraw(w_h, object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF);
                }
             /*ExeWindMessage(wind_Parm, WM_ACT_TXT_CHG, 0, 0);*/
            }
             break;
        case WM_PRM_SYNT_UPDATE:
            {int wind_targ               = IsWindExist(CurIDDoc);
             /*......... si fenetre cible placer ressource .............*/
             /*          sur les parametres de cette fenetre            */
             if (wind_targ>-1)
                {TXT_GFG   *ptTxtCfg     =  WTXT_CFG(wind_targ);
                 if (ptTxtCfg->IsSyntColored) object[PRM_DIAL_PRM_CHK_COL_SYN].ob_state |=  SELECTED;
                 else                         object[PRM_DIAL_PRM_CHK_COL_SYN].ob_state &= ~SELECTED;
                 if ( !(object[PRM_DIAL_PRM_ONG_ASPECT].ob_flags &HIDETREE) )
                    {SendObjectRedraw(w_h, object, PRM_DIAL_PRM_CHK_COL_SYN);
                    }
                }
            }
             break;
        case WM_CONSTRUCT:
            {if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "CONFIG.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT; 
             object   = GETWINDTREE(w_ind);
            /*........... charger fichier de config si existe .......................*/
             if (IsCfgLoaded==0 && CfgLoadDefaultConfig(GETWINDRSC(w_ind)) )
                {IsCfgLoaded = 1;
                }
             /*........... Placer notre fonction d'affichage ...............*/ 
             /*            personnelle de la LISTBOX des mots clefs         */
             SetListCallBackFunc (object, PRM_DIAL_PRM_SYNT_TYPE, LST_BOX_TARG_func); 
             SetListBoxParam(object, PRM_DIAL_PRM_SYNT_TYPE,0,0,0,0,-2,(void*)0);  
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);
            }
        case WM_ACT_TXT_CHG: /* reu chaque fois qu'une fenetre texte prend le focus */
            {int wind_targ               = IsWindExist(CurIDDoc);
             /*......... si fenetre cible placer ressource .............*/
             /*          sur les parametres de cette fenetre            */
             if (wind_targ>-1)
                {TXT_GFG   *ptTxtCfg     =  WTXT_CFG(wind_targ);
                 char path[MAX_PATH]; path[0] = 0;
                 if (ptTxtCfg)
                    {strcpy(path, ptTxtCfg->PathTxt);
                     strcat(path, ptTxtCfg->NomTxt);
                     CfgParamToDialog (w_ind, (TXT_HEAD*)WTXT_A(wind_targ), ptTxtCfg);
                    }
                 ObjcSetTxt(object, PRM_DIAL_PRM_TITLE, path);
                }
             /*......... si pas de fenetre cible placer ressource ......*/
             /*          sur les parametres par defaut                  */
             else
                {CfgParamToDialog (w_ind, &DefHeadCfg, &DefTextCfg);
                }
             if (Evnt->pipe[MESG] == WM_ACT_TXT_CHG)
                {int i;
                 if ( !(object[PRM_DIAL_PRM_ONG_ASPECT].ob_flags&HIDETREE))
                    {if (object[PRM_DIAL_PRM_CHK_COL_SYN].ob_flags&HIDETREE)
                        {SendObjectRedraw(w_h, object, PRM_DIAL_PRM_CHK_COL_SYN);
                        }
                     i= PRM_DIAL_PRM_ONG_ASPECT;
                    }
                 else if ( !(object[PRM_DIAL_PRM_ONG_EDITEUR].ob_flags&HIDETREE))
                    {i= PRM_DIAL_PRM_ONG_EDITEUR;
                    }
                 else if ( !(object[PRM_DIAL_PRM_ONG_EDITEUR_00].ob_flags&HIDETREE))
                    {i= PRM_DIAL_PRM_ONG_EDITEUR_00;
                    }
                 else if ( !(object[PRM_DIAL_PRM_ONG_INTERFACE].ob_flags&HIDETREE))
                    {i= PRM_DIAL_PRM_ONG_INTERFACE;
                    }
                 else if ( !(object[PRM_DIAL_PRM_ONG_SYNTAXE].ob_flags&HIDETREE))
                    {if (object[PRM_DIAL_PRM_GROUP_SYNTAX].ob_flags&HIDETREE)
                        {SendObjectRedraw(w_h, object, PRM_DIAL_PRM_GROUP_SYNTAX);
                         i = 0;
                        }
                     else
                        {i = PRM_DIAL_PRM_GROUP_SYNTAX;
                        }
                    }
                 if (i) 
                    {Wobjc_draw(w_ind, object, i, 4, 0);
                    }
                 Wobjc_draw(w_ind, object, PRM_DIAL_PRM_TITLE, 4, 0);
                 /*SendWindRedraw(GETGEMHAND(w_ind));*/
                }
            }
             break;
        case WM_DESTRUCT:        
             Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);
             if (ConfigTxt) free(ConfigTxt);
             break;
        case WM_MOUSEWHEEL:       Xform_WheelButton(w_ind, Evnt, 1);                  break;
        case WM_TT_ON_OFF:        SetBulleState(w_h, object);                         break;
        case WM_REDRAW:           Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);    break;
        case WM_BOTTOM:           wind_set(w_h, WF_BOTTOM );                          break;
        case WM_TOPPED:           wind_set(w_h, WF_TOP );                             break;
        case WM_CLOSED:           DestroyWindow(w_h);                                 break;
        case WM_ALLICONIFY:       AllIconify((GRECT*)&Evnt->pipe[X_G]);               break;
        case WM_ICONIFY:          IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]);    break;
        case WM_UNICONIFY:        UnconifyWindow(w_ind);                              break;
        case WM_SIZED:    
        case WM_MOVED:            Xform_moved(w_ind, Evnt);                           break;
       }
    }      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*-------------------------- UpdateConfig ---------------------------------*/
void UpdateConfig(int w_ind, int wind_targ, int ob_ret, TXT_HEAD *ptHeadTxt,  SYNT_PARAM* syntprm)
{if (ptHeadTxt==0) ptHeadTxt = &DefHeadCfg;
 CfgDialogToParam (w_ind,    ptHeadTxt,  &DefTextCfg);
 if (AppliChangeReelTime                 ||
     ob_ret==PRM_DIAL_PRM_CHK_REALTIME   ||
     ob_ret==PRM_DIAL_PRM_APPLIQUER0     ||
     ob_ret==PRM_DIAL_PRM_APPLIQUER1     ||
     ob_ret==PRM_DIAL_PRM_APPLIQUER0_00  ||
     ob_ret==PRM_DIAL_PRM_APPLIQUER2
    )
    {if (wind_targ>-1)
        {CfgParamToTexte (wind_targ, ptHeadTxt, (TXT_PRM*)&DefTextCfg, syntprm);
         SetScrollBoxParam(GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, ptHeadTxt->IntLg,-2,-2,-2, -2, -2, -2,-2,(void*)-2L,-2);
         AdjustSrollEditSlide(GETWINDTREE(wind_targ));
         UpdateParamTexte(GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, WTXT_A(wind_targ)); 
         Wobjc_draw(wind_targ, GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, 1, 0);
         Wobjc_draw(wind_targ, GETWINDTREE(wind_targ), EZ_TXT_VERT_BAR, 1, 0);
         Wobjc_draw(wind_targ, GETWINDTREE(wind_targ), EZ_TXT_COLOR_SYNT, 1, 0);
        }
    }
}
/*------------------------- SetFntListBoxMode -----------------------------*/
void SetFntListBoxMode(OBJECT *object, int ind_ob, int mode)
{XUSERBLK* xuserblk= (XUSERBLK*) object[ind_ob].ob_spec.userblk->ub_parm;
 xuserblk->P1      =   mode;
}
/*------------------------- LST_BOX_TARG_func -----------------------------*/
/* ACTION: routine d'affichage des elements d'une LISTBOX choix couleurs   */
/*         chaque fois que la listbox de couleur a besoin d'afficher une   */
/*         case elle fait appel  notre routine avec en entree la struct-  */
/*         re LIST_GET_TXT *ptLISTGETTXT permettant de savoir quelle       */
/*         partie de la list box il faut afficher.                         */
/*         Cette fonction un peu delirante affiche les couleurs dans des   */
/*         ellipses.                                                       */
/* les coordonnes de l'element  afficher peuvent etre calculees en       */
/* faisant:                                                                */
/*          coord.left    = ptLISTGETTXT->grect.g_x;                       */
/*          coord.top     = ptLISTGETTXT->grect.g_y  +                     */
/*                          ptLISTGETTXT->h_lign     *                     */
/*                         (ptLISTGETTXT->lign + 1)                        */
/*          coord.right   = ptLISTGETTXT->grect.g_x  +                     */
/*                          ptLISTGETTXT->grect.g_w  - 1                   */
/*          coord.bottom  = coord.top  + ptLISTGETTXT->h_lign -1           */
/*                                                                         */
/* ENTREE:  *ptLISTGETTXT  (pointeur sur structure  LIST_GET_TXT )         */
/*                                                                         */
/* Rappel sur la structure d'entree LIST_GET_TXT:                          */
/* Distinguons deux types d'elements:                                      */
/*            a) ceux de notre liste  afficher : element liste            */
/*                        exemple liste des polices caractere              */
/*                        exemple liste des couleurs etc..                 */
/*            b) ceux de la boite listbox :       element listbox          */
/*                        element de la boite de selection                 */
/*                        premier element de la listbox                    */
/*                        dernier element de la list box                   */
/* typedef struct                                                          */
/*      {int lign;     N de l'element listbox  afficher                  */
/*                        que l'on nous demande d'afficher                 */
/*                        si -1 c'est celui de la boite de selection       */
/*                        si zero c'est celui sous la boite de selection   */
/*                        si un c'est le suivant                           */
/*                        si deux le suivant etc...                        */
/*                                                                         */
/*       int preml;   N de l'element liste  afficher en zero listbox     */
/*       int pointl;  N de l'element liste selectionn  afficher en -1   */
/*       int h_lign;  hauteur en pixel d'un element listbox                */
/*       GRECT grect; coordonnes de la liste en absolu pix. ecran         */
/*       GRECT clipgrect; coordonnes de clipping en absolu pix. ecran     */
/*       void *LstBoxParam; parametre optionnel de transmission            */
/*                          par lequel l'on reoit des info specifiques    */
/*                          au type de list box                            */
/*                          (adresse d'une table, adresse d'un texte...)   */
/*                          ici inutilise                                  */
/*     }LIST_GET_TXT;                                                      */

static int LST_BOX_TARG_func (LIST_GET_TXT *ptLISTGETTXT)
{int vectxy[4];
 int i;    
 int idxref;  
 RECT coord;
 GRECT lstgrect;
 TXT_GFG *ptTxtCfg     = (TXT_GFG *)ptLISTGETTXT->LstBoxParam;
 SYNT_PARAM *syntprm   = ptTxtCfg->SyntPrm;
 CLASS_GRAPH *GrClass  = 0;
 int nb_grclass        = 0;
 if (ptTxtCfg && syntprm) 
    {GrClass      = syntprm->GrClass;
     nb_grclass   = syntprm->NbGrClass;
    }
 /*.............. determiner et calculer coordonnees ................*/
 /*               de la case (ou ligne) qu'il nous                   */
 /*                    est demande d'afficher                       */
 coord.left    = ptLISTGETTXT->grect.g_x;                       
 coord.top     = ptLISTGETTXT->grect.g_y  +                     
                 ptLISTGETTXT->h_lign     *                     
                (ptLISTGETTXT->lign + 1);                       
 coord.right   = ptLISTGETTXT->grect.g_x  +                     
                 ptLISTGETTXT->grect.g_w  - 1;                  
 coord.bottom  = coord.top  + ptLISTGETTXT->h_lign -1;          
 
 /*.......... determiner l'element de la liste, qu'il convient .......*/
 /*           d'afficher, en fonction de la ligne qu'il est demand   */
 /*                           d'afficher.                             */
 /*                                                                   */
 /*                    SI il est demande d'afficher la premiere case  */
 /*                       de la LISTBOX, (ptLISTGETTXT->lign == -1)   */
 /*                       il faut afficher l'element selectionn      */
 /*                       (ptLISTGETTXT->pointl) dans notre liste.    */
 /*                                                                   */
 if   (ptLISTGETTXT->lign == -1) idxref = ptLISTGETTXT->pointl;
 
 /*                    SI il est demande d'afficher une autre case    */
 /*                       de la LISTBOX, il faut afficher la liste   */
 /*                       partir du premier devant etre affiche en    */
 /*                       deuxieme ligne.                             */
 /*                                                                   */
 else  idxref = ptLISTGETTXT->preml + ptLISTGETTXT->lign;
 
 
 /*.......... tracer le rectangle blanc .................*/
 Deffill(1,0,0);                                          
 Graphmode(1); 
 Defline(1,1,0,0,1);
 /*........... dessiner rectangle boite selection ......*/
 if (ptLISTGETTXT->lign == -1)        
    {vectxy[0]=coord.left   + 2;
     vectxy[1]=coord.top    + 2;     
     vectxy[2]=coord.right  - 1;
     vectxy[3]=coord.bottom - 1; 
     vr_recfl(VDIhandle,vectxy);            
     Box(vectxy); 
    }
 /*............ afficher texte du mot clef ........*/   
 VRECT_to_GRECT((VRECT*)&coord, &lstgrect);  
 if ( idxref < nb_grclass && 
      Rc_intersect(&ptLISTGETTXT->clipgrect,&lstgrect)
    )
    {ClipGrect(&lstgrect);           
     Graphmode(MD_TRANS);    
     vst_alignment (VDIhandle,0,ALI_TOP, &i, &i );  
     vst_font(VDIhandle,0);    
     vst_point(VDIhandle,  9, &i, &i, &i, &i);
     vst_color (VDIhandle,1);
     if (GrClass)
         v_gtext(VDIhandle,coord.left + 5, coord.top + 5 , GrClass[idxref].Name);
     else
         v_gtext(VDIhandle,coord.left + 5, coord.top + 5 , "NO SYNTAX LOAD");
    }
 
 /*.......... tracer sillon de separation entre deux elements .........*/
 /*          que si on affiche un element different de celui de        */
 /*                        la premiere ligne                           */
 if (ptLISTGETTXT->lign != -1)
    {vectxy[0]=coord.left;
     vectxy[1]=coord.top;     
     vectxy[2]=coord.right;
     vectxy[3]=vectxy[1];
     DrawSillonHori(vectxy, 1);
    } 
 return 1;
}  

/*-------------------------- SyntaxCfgSave --------------------------------*/
void SyntaxCfgSave(char *path, char *name, SYNT_PARAM* syntprm)
{FILE *fh;
 char isgeneparam = 0;
 char isclasgraph = 0;
 char file[MAX_PATH];
/* char *head      = "KEYWHEAD.TXT"; */
 char *config    = ConfigSyntaxFileLoad(path, name);
 char *pt        = config;
 long token;
 char *pt_ini;
 if (config  == 0) return;
 
 /*........... ouvrir le fichier .......................*/
 /* fh  = fopen( PathName_Concat(file, path, "TEST.C") , "wb"); */
 fh  = fopen( PathName_Concat(file, path, name) , "wb");
 
 if (fh==0)         goto erreur_synt_sav;
 while (*pt)
  {/*...... ecrire tant qu'il y a des commentaires ..........*/
   pt    = IfComWriteIt(fh, pt);
   if (*pt=='[' && pt[1])
      {pt_ini = pt;
       pt= GoFirstValid(pt+1, " \t");
       /*........ si valeur numerique l'extraire ...................*/
       if (*pt>='0' && *pt<='9')
          {char *end = pt;
           char sav;
           while(*end && (*end>='0' && *end<='9')) end++;
           sav  = *end; *end = 0;
           /* n    = atoi(pt); */
           *end = sav;
           pt   = end;  /* on ne considere le token qu'apres les chiffres */
          }
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token, pt, 4);
       pt = NextBreakChar(pt, "]\n\r");
       /*........ sortir si erreur .................................*/
       if (*pt==0|| pt[1]==0)        break;
       /*......... reecrire les parametres generaux ..................*/
       if (token=='EndG')
          {if (isgeneparam==0)
              {char *pt_t = "[EndGenParam]                           ;indique la fin des paramtres gnraux \r\n";
               CfgSaveHeadConfig(fh, &syntprm->HeadTxt, (TXT_GFG*)&syntprm->TxtPrm);
               fwrite(pt_t, strlen(pt_t), 1, fh);
               isgeneparam = 1;
              }
           pt     = NextLine(pt);
          }
       /*......... reecrire les classes graphiques ...................*/
       else if (token=='CLAS')
          {if (isclasgraph==0)
              {isclasgraph = 1;
               WriteClassGraph(fh, syntprm);
              }
           pt     = NextLine(pt);
          }
       /*......... reecrire ce qui n'est pas un token (\r\n) .........*/
       /*          ou tout si les token generaux sont passes          */
       else if (isgeneparam)
          {pt = NextLine(pt);
           fwrite(pt_ini, pt-pt_ini, 1, fh);
          }
       else
          {pt     = NextLine(pt);
          }
      }
   /*.... a ne commence pas par [ et ce n'est pas un commentaire .....*/
   /*     (cela ne devrait etre que ' ' '\t' '\r' '\n')                */ 
   else 
      {pt_ini = pt;
       pt     = NextLine(pt);
       /* fwrite("\r\n", 2, 1, fh); */
       fwrite(pt_ini, pt-pt_ini, 1, fh);
       
      }
  }  /* end  while (*pt)  */
 fclose (fh);
 erreur_synt_sav:
 free(config);
}

/*----------------- WriteClassGraph ----------------------------*/
void WriteClassGraph(FILE* fh, SYNT_PARAM* syntprm)
{int i;
 char buft[64];
 for (i=0; i<syntprm->NbGrClass; i++)
     {fwrite("[CLASS_GRAPH] ,", 14, 1, fh);
      fwrite(syntprm->GrClass[i].Type, strlen(syntprm->GrClass[i].Type), 1, fh);
      fwrite(" ,", 2, 1, fh);
      
      fwrite(syntprm->GrClass[i].Name, strlen(syntprm->GrClass[i].Name), 1, fh);
      fwrite(" ,", 2, 1, fh);
      
      itoa(syntprm->GrClass[i].AttGr.CarCol,buft,10);
      fwrite(buft, strlen(buft), 1, fh);
      fwrite(" ,", 2, 1, fh);
      
      itoa(syntprm->GrClass[i].AttGr.CarEff,buft,10);
      fwrite(buft, strlen(buft), 1, fh);
      fwrite(" ,", 2, 1, fh);
      
      itoa(syntprm->GrClass[i].AttGr.CarPts,buft,10);
      fwrite(buft, strlen(buft), 1, fh);
      fwrite(" ,", 2, 1, fh);
      
      fwrite(syntprm->GrClass[i].AttGr.FntName, strlen(syntprm->GrClass[i].AttGr.FntName), 1, fh);
      fwrite("\r\n", 2, 1, fh);
     }
}

/*----------------- IfComWriteIt -------------------------------*/
char *IfComWriteIt(FILE* fh, char *pt)
{char *pt_ini = pt;
 /*........... passer le header de commentaires ...............*/
 while (*pt)
   {pt=GoFirstValid(pt, " \n\r\t");
    if (*pt==';') 
       {pt = NextLine(pt);/* line++;*/
       }
    else break;
   }
  fwrite(pt_ini, pt-pt_ini, 1, fh);
 return pt;
}
 
/*------------------------- PathName_Concat -------------------------*/
char *PathName_Concat(char *dst, char *path, const char *name)
 {if (dst==0) 
     dst = path;
  else
     strcpy(dst, path);
  if (name) strcat(dst, name);
  return dst;
 }