;---------------------------- FICHIER DE PARAMETRAGE SYNTAXIQUE ---------------------------
;                             pour EZ_EDIT par SEVIN Roland  15/12/2000                   
;                                                                                          
; Tout ce qui suit un point virgule sera considr comme un commentaire et non             
; interprt
; ce fichier doit toujours avoir le nom: KEYWORD et                                        
; l extension determine  quel type de fichier il doit s appliquer, exemple si ce fichier
; porte le nom KEYWORD.C tous les fichiers d extension C utiliseront ses paramtres.
; Les fichiers de parametrage syntaxique doivent se trouver dans le dossier systeme:
; EZ_EDIT.SYS (situe  lui meme dans le repertoire d EZ_EDIT.PRG)
; il existe plusieurs types de definitions (entre crochets) suivies par des parametres:
; L exemple suivant est le fichier utilis pour coloriser la syntaxe du C et C++
; Y sont inclus aussi les mots clefs des constantes et definitions utilises par le GEM
; ainsi que ceux d EZ_GEM (si ils vous sont inutiles effacez les)
;
; Description des differentes definitions avec syntaxe et paramtres:
;
; CLASS_GRAPH  defini une classe graphique, regroupant les attributs d'affichage d'un texte
;   - 1 - Il faut lui donner un type identificateur comme premier paramtre. C'est ce
;              type qui sera utilis dans les autre definitions, pour y faire reference et
;              determiner l'affichage. 
;              - 2 - Le parametre suivant est le nom tel qu il doit etre
;              affich dans la LISTBOX de parametrage syntaxique d'EZ_EDIT.
;              - 3 - les autres parametres sont les attributs graphiques correspondant: 
;                    couleur, 
;              - 4 - Effet: 0/sans + 1/gras + 2/gris + 4/italique + 8/souligne + 16/evid 
;              - 5 - taille en points des caracteres, 
;              - 6 - police en clair: seuls les premiers caractres suffisent si significatifs
;
;              IMPORTANT: LES DEFINITIONS DES CLASSES GRAPHIQUES DOIVENT TOUJOURS ETRE EN PREMIER
;              
; KW_SECTION   defini un type de section dans laquelle des mots clefs, oprateurs, et sections d'exclusion
;    seront reconnus. Nous l'appelerons Section de mots clef: Cette section est delimitee
;              par une sequence de caracteres de debut et une sequence de caracteres de fin. 
;              Exemple en HTML: les TAG (mots cles du langage HTML) ne sont reconnus qu entre les caracteres: < et >.
;                                                                                                         
;              - 1 - le premier  parametre est la sequence de caracteres definissant le debut de la section
;                                                                                                          
;              - 2 - le deuxime parametre est la sequence de caracteres definissant la fin de la section
;                    il est possible de placer le mot clef: KEYWORD au lieu d'une sequence de caracteres de fin
;                    alors la fin de la section sera marque par un des mots clefs lis  elle.
;                    Il est tout de meme possible d'indiquer en plus  la suite de KEYWORD, une sequence
;                    de caracteres de fin de section (utile si pas de mot clef rencontr).
;                                                                                                          
;              - 3 - le troisieme parametre est le type de section. (celui qui devra etre place en 4me 
;                     parametre d'un mot clef afin d'indiquer  quelle section appartient ce mot clef).
;                                                                                                          
;              - 4 - le quatrime parametre est une chaine indiquant les caractere autoriss pour les
;              mot clefs en sachant que 0->9 et a->z signifient les caractere de 09 et de a  z
;              cela ne fonctionne que dans l ordre croissant.
;                                                                                                         
;              - 5 - le cinquime paramtre indique la classe graphique  utiliser pour colorer les
;              delimiteurs et UNIQUEMENT les delimiteurs de cette section.
;                                                                                                         
;              - 6 - le Sixime paramtre est un flag qui indique si il doit etre tenu compte 
;              de majuscules minuscules lors de la recherche et identification des mots clefs 
;              et des delimiteur de section:
;                                                                                                         
;              
;                                  Recherche  des                       Recherche des                     
;                    Flag                 MOTS CLEFS                           DELIMITEURS                
;                                   l intrieur de la section          marquant la section               
;              
;                   0              Majuscules  Minuscules  sont         Majuscules Minuscules   sont      
;                                  diffrencies                        diffrencies                     
;                                  Exple: MOT different de: mot         Exple: MOT different de: mot      
;                                         M != m                                   M != m                 
;                                                                                                         
;                   1              Majuscules Minuscules sont           Majuscules Minuscules sont        
;                                  permises pour meme mot clef          diffrencies                     
;                                  Exple: MOT egal  mot ou Mot         Exple: MOT different de: mot      
;                                         M  = m                                   M != m                 
;                                                                                                         
;                   2              Majuscules Minuscules sont           Majuscules Minuscules sont        
;                                  diffrencies                        permises pour meme mot clef       
;                                  Exple: MOT different de: mot         Exple: MOT egal  mot ou Mot      
;                                         M != m                                   M  = m                 
;                                                                                                         
;                   3              Majuscules Minuscules sont           Majuscules Minuscules sont        
;                                  permises pour meme mot clef          permises pour meme mot clef       
;                                  Exple: MOT egal  mot ou Mot         Exple: MOT egal  mot ou Mot      
;                                         M  = m                                   M  = m                 
;              
;                                                                                                         
;              - 7 - le septime paramtre indique la classe graphique  utiliser pour colorer les     
;              caractres  l'INTERIEUR des delimiteurs de cette section.
;                                                                                                         
;              IMPORTANT: cette definition doit obligatoirement etre situe avant celle des
;               mots clef concerns.
;              IMPORTANT: la section DEFAUT, est celle du texte normal situe en dehors de tout
;               delimiteur et elle EST OBLIGATOIRE.
;              IMPORTANT: si vous placez le 6me parametre  1 afin que les mots clefs
;               soient reconnus aussi bien en majuscules que minuscules, ou les deux,
;                         la liste des mots clefs du fichier de configuration doit etre
;                         saisie en minuscules sous peine de non reconnaissance des mots cles.
;
; KEY_WORD    defini un mot clef. 
;             - 1 - Le premier parametre est le texte du mot clef tel qu'il devra etre trouv dans
;                   le texte. 
;             - 2 - Le deuxime la reference  la classe graphique permettant de coloriser ce mot clef
;             - 3 - Le troisime parametre est l indentation  placer  la suite de ce mot clef
;                   apres appui sur la touche RETURN. 
;             - 4 - Le quatrime paramtre designe la section de mots clef: KW_SECTION dans laquelle doit 
;                   etre reconnu ce mot clef, si vous placez la mention DEFAUT la section sera 
;                   celle par defaut CAD le texte normal.
;             
;             IMPORTANT: tous les mots clefs appartenant  une meme section doivent etre
;              placs ensembles.
;             IMPORTANT: un mot clef ne doit pas comporter plus de 32 caractres !!
;             
;             IMPORTANT: un mot clef ne peut pas comporter de caractres reconnus comme
;               oprateurs.
;
; OPERATOR    est pareil que KEY_WORD sauf que le premier parametre doit indiquer sur 1
;             caractre le caractre  considerer comme un oprateur.
;             - 1 - Le premier parametre est le caractre devant etre reconnu comme operateur.
;                   dans le texte. Il ne doit pas y avoir d'operateur dans les caracteres d'un
;                   mot clef.
;             - 2 - Le deuxime la reference  la classe graphique permettant de coloriser cet operateur
;             - 3 - Le troisime parametre est l indentation  placer  la suite de cet operateur
;                   apres appui sur la touche RETURN. 
;             - 4 - Le quatrime paramtre designe la section de mots clef: KW_SECTION dans laquelle doit 
;                   etre reconnu cetoperateur, si vous placez la mention DEFAUT la section sera 
;                   celle par defaut CAD le texte normal.
;
; NUMERIC     defini la faon dont les valeurs numriques sont reprsentes.
;             une valeur numerique commence par des caractres d'introduction, ne pouvant etre suivis
;             que des caractres reconnus comme possibles pour expriner une valeur, tout espace
;             ou caractre non reconnu est la fin.
;             - 1 - Le premier parametre est la liste des sequences de caractres (separes par des espaces) 
;                   introduisant une valeur numerique.
;             - 2 - Le deuxime paramtre est la liste des caractres possibles pour exprimer une valeur
;                   numrique(tous les caractres doivent etre contigus).
;             - 3 - Le troisime parametre est la reference  la classe graphique permettant de 
;                   coloriser les caractres introducteurs d'une valeur numrique
;             - 4 - Le quatrime parametre est la reference  la classe graphique permettant de 
;                   coloriser une valeur numrique
;             - 5 - Le cinquime paramtre designe la section de mots clef: KW_SECTION dans laquelle doit 
;                   etre reconnu une valeur numerique , si vous placez la mention DEFAUT la section sera 
;                   celle par defaut CAD le texte normal.
;

; SECTION     appele aussi section d'exclusion car tout se qui se trouve encadr par les 
;             delimiteurs de cette section, ne peut etre reconu ni comme un operateur ni
;             comme un mot clef, ni comme un debut ou fin de section de mot clefs.
;             exemple: les chaines de caracteres en C ou strings places entre guillemets
;                      les commentaires entre: /*            et */            ou
;                                              //            et fin de ligne  ou 
;                                              point virgule et fin de ligne (assembleur)
;             - 1 - Le premier parametre defini les caracteres delimiteurs de debut,
;             - 2 - Le deuxime paramtre defini les caracteres delimiteurs de fin
;                   en sachant que EOL comme deuxieme parametre signifie que c'est la fin de ligne.
;             - 3 - Le troisime paramtre indique la classe graphique  utiliser pour l affichage
;                   des caractres encadres par les delimiteurs.
;             - 4 - Le quatrime paramtre est le caractre d echapement (celui apres lequel un
;                   caractre ne doit pas etre interprete). 
;             - 5 - Le cinquime parametre indique si il est present la section de mots clefs:
;                   KW_SECTION pourlaquelle cette section est definie.
;             
;             IMPORTANT: Aucun mot clef ni oprateur ne peuvent etre reconnus dans une telle 
;               section. Si vous voulez reconnaitre des mots clefs dans une section
;                        utilisez la definition KW_SECTION.
; 
; EQUIVALENT  designe le fichier qui devra etre utilis comme fichier de definition  la place
;             de celui-ci (cela permet de ne definir qu un seul fichier pour plusieurs types)
;             exemple je definis un fichier KEYWORD.C pour la syntaxe colore du C
;             le fichier KEYWORD.H   aura comme simple texte: [EQUIVALENT] KEYWORD.C
;             afin que les fichier .H se servent du fichier KEYWORD.C pour afficher leur syntaxe
; 
; Il existe plusieurs constantes pour definir certains attributs:
;
; NO_INDENT   en place de la valeur d'indentation d'un mot clef ou d'un operateur signifie
;             l'absence d'indentation
; POINTVIRG   en place d'un caractere signifie un point virgule
; EOL         en place d'un caractere signifie la fin d'une ligne
; DEFAUT      si plac dans le type de section d'un mot clef, ce symbole signifie' que la section
;             dans laquelle ce mot clef doit etre reconnu est celle du texte normal.
; VIRG        en place d un caractere signifie une virgule
; KEYWORD     en place des caractres de fin de section signifie que lorsqu'un mot clef est reconnu
;             il marque la fin de la section. Apres le mot clef KEYWORD il peut etre plac une
;             chaine marquant aussi la fin de la section.
;
; Parametres generaux (comme ceux de CONFIG.INF) 
;                      ces paramtres sont facultatifs et permettent                         
;                      de specifier pour les fichiers concerns par                          
;                      le fichier de configuration syntaxique en cours                       
;                      des paramtres spcifiques                                            
;                                                                                            
[Interligne] 11                         ;interligne en pixels
[VerticalAdjust] 5                      ;ajustage vertical pour fontes speedo en pixels
[LeftOfset] 1, 1                        ;0/non affiche 1/affich, taille en pixels,couleur,type ligne
[RightOfset] 1, 70                      ;0/non affiche 1/affich, taille en pixels,couleur,type ligne
[NbLinePage] 1, 80                      ;0/non affiche 1/affich, taille en pixels,couleur,type ligne
[Background] 0, 3                       ;couleur, trame
[NumLine] 0, -1, 0, 10, Monaco Mono     ;0/non affiche 1/affich, couleur
[TabSpace] 4                            ;nombre d'espaces pour expandre une tabulation
[CharTAB] 248                           ;code ASCII du caractere a employer pour visualiser les Tabubulations
[TabVisible] 1                          ;1/tabulation visible 0/tabulation non visible
[EndOfLine] 1, 10, 0, 10, Monaco Mono   ;0/non affiche 1/affich, couleur
[EndGenParam]                           ;indique la fin des paramtres gnraux 

;.............................. Classe graphiques .........................................
;                                                                                          
; type de    | type de la       | nom de la classe | couleur | effet  | taille | police    
; definition | classe graphique | qui sera affiche | carac-  | carac- | carac- | carac-    
;            |                  | dans la LISTBOX  | tre    | tre   | tre   | tre      
;            |                  | de parametrage   |         |        |        |           
;..........................................................................................



[CLASS_GRAPH] JAVA_DEFAULT ,Texte normal ,1 ,0 ,9 ,Monaco Mono
[CLASS_GRAPH] JAVA_TYPVAR ,Typage variable ,15 ,0 ,9 ,Monaco Mono
[CLASS_GRAPH] JAVA_KEYWRD ,Mots Clefs du C ,4 ,0 ,9 ,Monaco Mono
[CLASS_GRAPH] JAVA_STRING ,Chaines ,14 ,0 ,9 ,Monaco Mono
[CLASS_GRAPH] JAVA_COMMENT ,Commentaires ,11 ,0 ,9 ,Monaco Mono
[CLASS_GRAPH] JAVA_OPERATOR ,Oprateurs ,2 ,0 ,9 ,Monaco Mono
[CLASS_GRAPH] JAVA_NUMERIC ,Numerique ,13 ,0 ,9 ,Monaco Mono

;...................... Section de validite de mots clefs (texte normal)...............................................................
;                                                                                                                                      
; type de    | 1er   | 2me   | Nom et type | liste des caracteres    | Classe graphique | Flag champ de bit:      | Classe graphique  
; definition | dlim | dlim  | de cette    | autorises pour les mots | pour afficher    | Bit 0: si 1 il est tenu | pour afficher     
;            | iteur | iteur  | section     | cles de cette section   | les delimiteurs  | compte des Majuscules   | ce qu il y a ENTRE
;            |                |             |                         |                  | Minuscules pour identi- | les delimiteurs.  
;            | DEFAUT pour fin|             |                         |                  | fier les mots cles      |                   
;            | et debut signi-|             |                         |                  | Bit 1: pareil mais pour |                   
;            | fie: texte nor-|             |                         |                  | les delimiteurs.        |                   
;            | mal            |             |                         |                  |                         |                   
;......................................................................................................................................
[KW_SECTION]  DEFAUT , DEFAUT , DEFAUT      , 0->9 a->z A->Z _        , JAVA_DEFAULT    ,0                        ,JAVA_DEFAULT


; Mots clefs de la section par defaut (java): DEFAUT 

[KEY_WORD]    char      , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    int       , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    long      , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    static    , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    void      , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    double    , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    float     , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    volatile  , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    short     , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    const     , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    byte      , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    boolean   , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    persistent, JAVA_TYPVAR  , NO_INDENT           ,DEFAUT
[KEY_WORD]    var       , JAVA_TYPVAR  , NO_INDENT           ,DEFAUT

[KEY_WORD]    if        , JAVA_KEYWRD  , 3                   ,DEFAUT
[KEY_WORD]    else      , JAVA_KEYWRD  , 3                   ,DEFAUT
[KEY_WORD]    switch    , JAVA_KEYWRD  , 3                   ,DEFAUT
[KEY_WORD]    case      , JAVA_KEYWRD  , 4                   ,DEFAUT
[KEY_WORD]    break     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    function  , JAVA_FUNC    , NO_INDENT           ,DEFAUT
[KEY_WORD]    with      , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    continue  , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    default   , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    do        , JAVA_KEYWRD  , 3                   ,DEFAUT
[KEY_WORD]    for       , JAVA_KEYWRD  , 3                   ,DEFAUT
[KEY_WORD]    goto      , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    while     , JAVA_KEYWRD  , 3                   ,DEFAUT
[KEY_WORD]    return    , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    class     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    private   , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    public    , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    protected , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    new       , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    this      , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    try       , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    catch     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    throw     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    throws    , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    abstract  , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    extends   , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    false     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    final     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    finally   , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    implements, JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    import    , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    instanceof, JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    interface , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    native    , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    null      , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    package   , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    super     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    transient , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    true      , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    privateprotected     , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    synchronous          , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    strictfp             , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT
[KEY_WORD]    synchronized         , JAVA_KEYWRD  , NO_INDENT           ,DEFAUT

;.............. caractres  reconnaitre comme oprateurs ....................
;             
; type de    | caractere | classe         | Indentation   |Section dans laquelle
; definition | operateur | graphique      |               |l oprateur est valide
;............................................................................

[OPERATOR]    [          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    ]          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    =          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    &          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    !          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    *          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    -          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    +          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    :          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    (          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    )          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    {          , JAVA_OPERATOR  , -1          , DEFAUT
[OPERATOR]    }          , JAVA_OPERATOR  , -4          , DEFAUT
[OPERATOR]    ?          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    <          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    >          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    |          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    ^          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    %          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    ~          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT
[OPERATOR]    /          , JAVA_OPERATOR  , NO_INDENT   , DEFAUT

;.............. caractres  reconnaitre comme valeur numrique .............
;             
; type de    | caracteres     | caracteres         | classe         | classe graphique | Section dans laquelle
; definition | introducteurs  | reconnus apres     | graphique de   | de ce qui suit   | la definition est valide
;            |                | l introducteur     | l introducteur | l introducteur   |          
;............................................................................
[NUMERIC]      0->9           , a->f A->F 0->9 xXlL. , CLASS_NUMERIC  , CLASS_NUMERIC  , DEFAUT


;........... delimiteurs de debut et fin de section .........................
;            un double click marque le debut et fin
;             
; type de    | 1er del- | 2me del | classe    | chaine des | KW_Section
; definition | imiteur  | limiteur | graphique | escapes    | d appartenance
;............................................................................
[SECTION]     /*        ,  */     , JAVA_COMMENT ,         ,DEFAUT
[SECTION]     //        , EOL     , JAVA_COMMENT ,         ,DEFAUT
[SECTION]     "         ,"        , JAVA_STRING  ,\        ,DEFAUT
[SECTION]     '         ,'        , JAVA_NUMERIC ,\        ,DEFAUT
