/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME ------*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le */
                       /* que le module EAZY_GEM.C met  notre         */
                       /* notre disposition                            */
                       /* et inclure les definitions des variables     */
                       /* globales  EAZY_GEM                           */

#include "EZ_EDIT.SYS\EZ_MESSG.H"

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#define MAX_PATH  256    /* taille maxi possible d'un path             */

#define NB_WDOC  40      /* nombre de fenetres documents possibles     */
#define NB_SYNT  32      /* nombre de parametres syntaxiques possibles */
/*....................... TYPAGE DES FENETRES..........................*/
#define W_TXT_DESK    1     /* ID Fenetre principale                   */
#define W_INFO_BOX    2     /* ID Fenetre information                  */
#define W_BOOK        3     /* ID Fenetre Bookmark                     */
#define W_CONFIG      4     /* ID Fenetre Parametrage                  */
#define W_POPUP       5     /* ID Fenetre Popup                        */
#define W_EZ_EDIT_PRT 6     /* ID Fenetre Impression                   */
#define W_EZ_INFO     7     /* ID Fenetre Message                      */
#define W_EZ_ASCII    8     /* ID Fenetre saisie code ASCII.           */
#define W_FIRST_DOC   100   /* ID premiere fenetre document.           */
/*.............. nombre de mots cles ..................................*/
#define NB_KEYWORD    57
/*.............. attributs graphiques de chaque type de mot ...........*/

#define NO_INDENT          -9999   /* symbole de non indentation         */
/*................. flag de recherhe texte ..............................*/
#define FIND_LOOP_REVERSE     1
#define FIND_FORWARD          2
#define FIND_LOOP_BREAK       4
#define FIND_MINMAJ           8
#define FIND_WORD            16
#define FIND_FUNC            32
/*.................. flag de recherche fenetre ..........................*/
#define GOTO_OPENWIND         1
#define SET_TO_TOP            2
#define ABS_POS               4
#define FNC_LIST_S            8
#define FNC_LIST_C            16
#define FNC_LIST_H            32
#define FNC_LIST_P            64
#define FNC_LIST_CC           128
#define NOT_SELECT            256
/*................... flag d'effacement de la liste index ...............*/
#define INDEX_MERGE           0  /* l'index est ajoute                   */
#define INDEX_DELETE          1  /* tous les index de la fenetre effaces */
#define INDEX_ADDSTRING       2  /* "LISTED ..." (ou autre) ajoute   */
#define INDEX_NOT_DEL         4  /* autorise un doublon dans la liste    */
/*.................. type d'onglet a activer ............................*/
/*                   pour la fenetre BOOKMARK                            */
#define FIND_ALLER_A      1
#define FIND_FIND         2
#define FIND_REPLACE      3
#define FIND_LISTE        4
#define WM_INIT_BOOK       (WM_USER + 345)
#define WM_MARK_CHG        (WM_USER + 346)
#define WM_INIT_MARK       (WM_USER + 347)
#define WM_CURS_TO_INDENT  (WM_USER + 348)
#define WM_ACT_TXT_CHG     (WM_USER + 349)
#define WM_PRT_PRM_CHG     (WM_USER + 350)
#define WM_PRM_ONG_UPDATE  (WM_USER + 351)
#define WM_PRM_SYNT_UPDATE (WM_USER + 352)

#define ISCOMMENT   1   /* etat de fin de ligne = dans un commentaire  */
#define ISSTRING    2   /* etat de fin de ligne = dans une chaine      */
/*.................. structure de raccourci clavier ...................*/
/*                   associe un  etat  du clavier                     */
/*                     une fonction du programme                       */
typedef struct
       {int ksp;       /* etat des touches ALT, SHIFT, CONTROL         */
        int key;       /* scancode si negatif/ code ASCII si positif   */
        int Func;      /* numero de la fonction programme a executer   */
       } SHORT_CUT;
/*................. structure header de composant ........................*/
typedef struct 
{int     IntLg;            /* interligne en pixel                                   */
 int     BaseAjust;        /* ajustage vertical de la fonte                         */
 int     MargLeft;         /* Marge gauche en pixels                                */
 int     MargRight;        /* Marge droite                                          */
 int     NblPage;          /* Nombre de lignes d'une page                           */
 int     BckCol;           /* Couleur du fond                                       */
 int     BckTrm;           /* trame du fond                                         */
 int     ExpTAB;           /* nombre d'espaces pour expandre une tabulation         */
 char    CharTAB;          /* caractere  utiliser pour visualiser les TAB          */
 int     CurFqce;          /* frequence de clignotement                             */
 CAR_ATTR ATT_Def[3];      /* attributs affichage de chague type de mots            */
 long    SizeLgn;          /* longueur max d'une ligne de texte                     */
} TXT_HEAD;

typedef struct {/*........ public .......*/
                char IsEndOfPage;         /*  */
                char IsMargRight;         /*  */
                char IsMargLeft;          /*  */
                char IsAlignIndent;       /*  */
                char IsRetOnRight;        /*  */
                char IsBlocErase;         /*  */
                char IsBlocPersist;       /*  */
                char IsSelInsert;         /*  */
                char IsEOL;               /*  */
                char IsNumLigne;          /*  */
                char IsSyntColored;       /*  */
                char IsTabVisible;        /*  */
                
                char IsBarVisible;
                char IsSlideMidle;
                char IsSlideBack;
                char IsBarBack;
                char IsWindBack;
                int  SlideFrameWidth;
                char SlideFrame3D;
                
               }TXT_PRM;
/*.................... structure de classe graphique .........................................*/
/*          defini un type d'attribut graphique avec son nom                                  */
/*          33 caracteres ensuite 0 de fin donc au total 34 char                              */
typedef struct
    {CAR_ATTR  AttGr;       /* attribut graphique de cette classe                               */
     char      Type[34];    /* type de la classe doit faire 34 caracteres y compris zero de fin */
     char      Name[34];    /* nom  de la classe doit faire 34 caracteres y compris zero de fin */
    } CLASS_GRAPH;


/*.............................. structure de mots clefs .....................................*/
/*          le nom du mot clef doit etre complete avec des espaces jusqu'a                    */
/*          33 caracteres ensuite 0 de fin donc au total 34 char                              */
typedef struct
    {char Name[34];         /* nom du mot clef doit faire 34 caracteres y compris zero de fin */
     int  LenKey;           /* longueur significative du mot clef                             */
     int  GraphClass;       /* classe graphique du mot clef                                   */
     int  NbToIndent;       /* nombre d'espaces d'indentation sous le mot clef                */
     int  MajMin;           /* 1/Majuscules-Minuscules ignores                               */
     CAR_ATTR *CarAtt;      /* adresse des attributs graphiques  de la classe graphique       */
    } KEY_WRD;

/*.............................. structure de section ........................................*/
typedef struct
    {char LenBegStr;        /* longueur de la chaine de debut de section                      */
     char BegStr[16];       /* nom du mot clef marquant le debut de section                   */
     char LenEndStr;        /* longueur de la chaine de fin de section                        */
     char EndStr[16];       /* nom du mot clef marquant la fin de section                     */
     int  MajMin;           /* 1/Majuscules-Minuscules ignores                               */
     char EscCar;           /* caractre d'echapement d'une section                           */
     int  GraphClass;       /* classe graphique de la section                                 */
     CAR_ATTR *CarAtt;      /* adresse des attributs graphiques  de la classe graphique       */
    } SECTION;
    
/*.............................. structure de section de mots clefs ..........................*/
typedef struct
    {char LenBegStr;        /* longueur de la chaine de debut de section                      */
     char BegStr[16];       /* nom du mot clef marquant le debut de section                   */
     char LenEndStr;        /* longueur de la chaine de fin de section                        */
     char EndStr[16];       /* nom du mot clef marquant la fin de section                     */
     int  MajMin;           /* bit: 0/Maj-Min mot clef 1/ Maj-Min delimiteurs 2/end=mot clef  */
     int  IntGrClass;       /* Classe graphique pour caractres  l'interieur des delimiteurs */
     char Type[34];         /* type de la section.                                            */
     int  NbKeyW;           /* nombre de mots clefs de cette section                          */
     KEY_WRD *KwAdr;        /* Adresse de la liste de mots clefs de cette section             */
     int  NbSection;        /* nombre de sections de cette section de mots clefs              */
     SECTION *SectionAdr;   /* pointe sur la zone des sections de cette section de mots clef  */
     char ValidChar[256];   /* caracteres autorises pour les mots clefs de cette section      */
     char BegSection[256];  /* caracteres de debut de section                                 */
     char EndSection[256];  /* caracteres de fin  de section                                  */
     int  Operator[256];    /* table de caracteres des operateur de cette section             */
     int  OppIndent[256];   /* table des indentation des operateur de cette section           */
     int  GraphClass;       /* Classe graphique avec laquelle afficher les delimiteurs        */
     CAR_ATTR *CarAtt;      /* adresse des attributs graphiques  de la classe graphique       */
     char NumBeg[32];       /* chaine des debuts de section numeriques                        */
     char NumCarBeg[256];   /* premiers caractres autoriss dans une section numerique       */
     char NumCar[256];      /* autres caractres autoriss dans une section numerique         */
     int  NumBegGrClass;    /* classe graphique pour colorer l'introducteur numeriques        */
     int  NumGrClass;       /* classe graphique pour colorer les sections numeriques          */
    } KWSECTION;

/*.................. structure de syntaxe colore .....................*/
typedef struct
    {long Size;                           /* longueur en octet des donnes de syntaxe         */
     int          NbGrClass;              /* nombre de classes graphiques                     */
     CLASS_GRAPH *GrClass;                /* pointeur sur la zone des classes graphiques      */
     int          NbKeyW;                 /* nombre total de mots clef                        */
     KEY_WRD     *KeyW;                   /* pointeur sur la zone des dicos de mots clefs     */
     int          NbKwSection;            /* nombre de sections de mots cles                  */
     KWSECTION   *KwSection;              /* pointeur sur la zone des sections de mots clefs  */
     int          NbSection;              /* nombre de sections normales                      */
     SECTION     *Section;                /* pointeur sur la zone des sections normales       */
     char         KwSectBegFirstCar[256]; /* table des delimiteurs des premiers caracteres,   */
     char         KwSectEndFirstCar[256]; /* et des derniers des sections mot clefs           */
     char         Extension[256];         /* extensions des fichiers ayant cette syntaxe      */
     TXT_HEAD     HeadTxt;                /* parametres du composant d'edition de texte       */
     TXT_PRM      TxtPrm;                 /* parametres generaux des textes de cette syntaxe  */
    } SYNT_PARAM;

extern SYNT_PARAM *SyntPrmTab[NB_SYNT];
/*................. structure supplementaire stocke ..................*/
/*                  en debut de chaque ligne et notant                 */
/*                  l'etat du dernier caractere de la                  */
/*                  ligne. Deux etats possibles:                       */
/*        1/ISCOMMENT lorsque la fin de ligne est dans un commentaire  */
/*        2/ISSTRING  lorsque la fin de ligne est dans une chaine      */
/*                                                                     */
/*        cela permet a une ligne en cours d'affichage de savoir dans  */
/*        quel etat elle est, en se referant  l'etat de la ligne      */
/*        d'avant. Comme a elle sait si elle est en mode commentaire  */
/*        ou mode string.                                              */
/*        Cet etat de fin de ligne, est mis a jour lors de chaque      */
/*        affichage de ligne par la fonction d'affichage,              */
/*        et lors, du chargement d'un fichier ou copier coller par     */
/*        la fonction de formatage de lignes:   EZeditInitTabLgnCtx()  */
/*                                                                     */
typedef struct
       {char LgnState;
        char KwSection;
       } LGN_STAT;

/*............... structure de configuration ..............................*/
/* la fonction :CfgTokenToDefParam() ne modifie que les paramtres public  */
typedef struct {/*........ public .......*/
                char IsEndOfPage;         /*  */
                char IsMargRight;         /*  */
                char IsMargLeft;          /*  */
                char IsAlignIndent;       /*  */
                char IsRetOnRight;        /*  */
                char IsBlocErase;         /*  */
                char IsBlocPersist;       /*  */
                char IsSelInsert;         /*  */
                char IsEOL;               /*  */
                char IsNumLigne;          /*  */
                char IsSyntColored;       /*  */
                char IsTabVisible;        /*  */
                
                char IsBarVisible;
                char IsSlideMidle;
                char IsSlideBack;
                char IsBarBack;
                char IsWindBack;
                int  SlideFrameWidth;
                char SlideFrame3D;
                /*....... private ......*/
                SYNT_PARAM  *SyntPrm;
                long FindFlag;
                long FindPos;
                long FindEnd;                
                long Bookmark[10];
                char PathTxt[MAX_PATH];
                char NomTxt[MAX_PATH>>1];
                char PathSavUnder[MAX_PATH];
                char NomSavUnder[MAX_PATH>>1];
                char PathBlk[MAX_PATH];
                char NomBlk[MAX_PATH>>1];
               } TXT_GFG;
               
/*........... Flag d'erreur lors analyse source C .......................*/
typedef struct {int Flag;
                char *pt;
               }ERR_C;
               
/*............ Structure d'un enregistrement dans la ....................*/
/*             base des listes de fonctions                              */
typedef struct {char SepBeg[2];
                   char PtFunc[10];
                   char SepNum[2];
                   char NameVar[64];
                   char Numfile[6];
                   char End[2];
                  }VAR_RECORD;


#define ACCO_END_NOT_FIND      1 
#define ACCO_DEB_NOT_FIND      2 
#define PARNTH_END_NOT_FIND    3 
#define PARNTH_DEB_NOT_FIND    4 
#define COMMENT_END_NOT_FIND   5 
#define COMMENT_DEB_NOT_FIND   6 
#define GUILLM_END_NOT_FIND    7 
#define GUILLM_DEB_NOT_FIND    8 
#define APPOST_END_NOT_FIND    9 
#define APPOST_DEB_NOT_FIND   10 
#define END_BCONST_NOT_FIND   11   /* la fin d'un constructeur de base non trouve   */
#define DEB_BCONST_NOT_FIND   12   /* le debut d'un constructeur de base non trouve */

/*........... Macro testant caracteres...................................*/
#define GotoNextLigne(a)    NextLine((a))
#define ISPTEOL(a)         (*(a)==13||*(a)==10)
#define ISPTBRK(a)         (*(a)=='\\'&&((a)[1]==13||(a)[1]==10))
#define ISPTDEBCOM(a)      (*(a)=='/'&&(a)[1]=='*')
#define ISPTCPPCOM(a)      (*(a)=='/'&&(a)[1]=='/')
#define ISPTENDCOM(a)      (*(a)=='*'&&(a)[1]=='/')
#define ISPTAPPOST(a)      (*(a)=='\'')
#define ISPTESCAPE(a)      (*(a)=='\\'&&(a)[1])
#define ISVARNAME(a)       (*(a)=='_'||isalnum(*(a)))

#define ISPTAFTERENDCOM(b,a)      ((a)-2>(b)&&(a)[-2]=='*'&&(a)[-1]=='/')
#define ISPTAFTERDEBCOM(b,a)      ((a)-2>(b)&&(a)[-2]=='/'&&(a)[-1]=='*')
#define ISPTAFTERENDSTR(b,a)      ((a)-1>(b)&&ISENDSTRING((a)-1))
#define ISPTAFTERDEBSTR(b,a)      ((a)-1>(b)&&ISDEBSTRING((a)-1))
#define ISPTAFTERAPPOST(b,a)      ((a)-1>(b)&&(a)[-1]=='\'')
#define ISPTAFTERDEBACO(b,a)      ((a)-1>(b)&&(a)[-1]=='{')
#define ISPTAFTERENDACO(b,a)      ((a)-1>(b)&&(a)[-1]=='}')
/*........... Macro retournant la variable de traitement de texte .......*/
/*                        affecte  une fenetre                         */
#define WTXT_A(a) ((TXTED_OB*)(Windtab[(a)].UserPtr))         
/*........... Macro permettant si l'identificateur d'une fenetre ........*/
/*               est celui d'une fenetre edition texte                   */
#define IS_IDWINDTXT(a) ((a)>=W_FIRST_DOC&&(a)<W_FIRST_DOC+NB_WDOC)
/*........... Macro retournant la variable de configuration .............*/
/*             affecte  une fenetre edition de texte                   */
#define WTXT_CFG(a) ((TXT_GFG*)(*(long*)Windtab[(a)].MemSup))
/*........... Macro retournant la variable de Pile UNDO .................*/
/*             affecte  une fenetre edition de texte                   */
#define WUN_STACK(a) ((UNDO_STACK*)(*(long*)(Windtab[(a)].MemSup+4)))
/*............ Fonctions d'EZ_EDIT ......................................*/
#define TXT_OUVRIR           1000
#define TXT_CHARGER          1001
#define TXT_MERGER           1002
#define TXT_SAUVER           1003
#define TXT_SAUVER_SOUS      1004
#define TXT_SAUVER_TOUT      1005
#define TXT_GOTO_LGN         1006
#define TXT_CLOSE            1007
#define TXT_NEW              1008
#define TXT_UNDO             1009
#define TXT_REDO             1010
#define TXT_HELP             1011
#define TXT_FIND             1012
#define TXT_REPLACE          1013
#define TXT_REPLACE_AGAIN    1014
#define TXT_SYNT_UPD         1015
#define TXT_FIND_SELECT      1016
#define TXT_FIND_AGAIN       1017
#define TXT_FIND_ERROR       1018
#define TXT_VOIR_ERROR       1019
#define TXT_TEST_MARK        1020
#define TXT_MARK_ACCO        1021
#define TXT_MARK_COMM        1022
#define TXT_MARK_PARH        1023
#define TXT_VERIFY_C         1024
#define TXT_VERI_ACCO        1025
#define TXT_VERI_COMM        1026
#define TXT_VERI_PARH        1027
#define TXT_CTRL_F1          1028
#define TXT_CTRL_F2          1029
#define TXT_CTRL_F3          1030
#define TXT_CTRL_F4          1031
#define TXT_CTRL_F5          1032
#define TXT_CTRL_F6          1033
#define TXT_CTRL_F7          1034
#define TXT_CTRL_F8          1035
#define TXT_CTRL_F9          1036
#define TXT_CTRL_F10         1037
#define TXT_F1               1038
#define TXT_F2               1039
#define TXT_F3               1040
#define TXT_F4               1041
#define TXT_F5               1042
#define TXT_F6               1043
#define TXT_F7               1044
#define TXT_F8               1045
#define TXT_F9               1046
#define TXT_F10              1047
#define TXT_ABOUT            1048
#define TXT_CLOSED           1049
#define TXT_PRINT            1050
#define TXT_BLKPRINT         1051
#define TXT_MARK_STR         1052
#define TXT_MARK_EOL         1053
#define TXT_GEMTIDY          1054
#define TXT_RELOAD           1055
#define TXT_FIND_FUNC        1056

#define TXT_PRJ_LOAD         1057
#define TXT_PCSTUDIO_FIND    1058
#define TXT_PRJ_UPDATE       1059
#define TXT_PRJ_LINK         1060
#define TXT_PRJALLMAKE       1061
#define TXT_PRJ_RUN          1062
#define TXT_PRJ_SET          1063
#define PRJ_CHANGE           1064
#define TXT_HTML_CONV        1065
#define TXT_UN_HELP          1066

#define PRM_COLOR_FUNC_ON    1100
#define PRM_ACTIVE_PARAM     1101
#define PRM_RACC_CHANGE      1102

#define BLK_COUPER           1200
#define BLK_COPIER           1201
#define BLK_COPIER_ADD       1202
#define BLK_COLLER           1203
#define BLK_SET_ALL          1204
#define BLK_CUT_LGN          1205

#define BLK_SET_DEB          1206
#define BLK_SET_END          1207
#define BLK_SET_RELEASE      1208
#define BLK_SAV_SOUS         1209

#define DESK_QUIT            1300
#define DESK_QUIT_SAVE_ALL   1301
#define DESK_QUIT_SAVE_CFG   1302
#define DESK_QUIT_SAVE_FIC   1303
#define DESK_WIND_CYCLE      1304
#define DESK_WIND_LISTE      1305
#define DESK_WIND_ALIGN      1306

#define MANAGERL_OPEN        1400
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*.............. Identificateurs de chaque fenetres document ............*/
/*...................... fichier EZ_EDIT.C ..............................*/ 
extern void *Gsc;
extern void *GscPcStud;
extern void * AdrMessRSC;
extern int    WIND_ID[NB_WDOC]; 
extern int    CurIDDoc;    
extern char **TxtPtStrMess;  /* pointera sur tableau de messages */
extern char   PathTidy[MAX_PATH];
extern char   PathTxt[MAX_PATH<<1];
extern char   NomTxt[MAX_PATH];
extern char   PathAppli[MAX_PATH];   
extern size_t LenPathVABuff;  
extern char  *PathVABuff;
extern char   PathIndex[MAX_PATH];
extern char   NomIndex[MAX_PATH>>1];
extern char   PathPcStudio[MAX_PATH];
extern char   PathProject[MAX_PATH];

extern long   LastHelpPos;
extern char   LastHelpFic[MAX_PATH];
extern char  *TxtRef;
extern char  *TxtRep;
extern char  *LSTBOX_TARG_STR[13];
extern char  IsCfgLoaded;
extern char  IsWindList;
extern char  IsMarkList;
extern char  IsViewFntReel;
extern char  IsFindAnim;
extern char  IsIndexAnim;
extern char  IsWcontrolOpen;
extern char  WcontrolOngActif;
extern GRECT wControlDefGrect;
extern char  CursorSpeed;
extern char PopMenWidth;
extern char LastFicMustBeLoaded;
extern char LastCfgMustBeSaved;
extern char FicMustBeSavedOnQuit;
extern char **EnvList;
extern int  LenFindStr;
extern int  PrtSizeFont;
extern char PrtFontName[40];   /* nom de la police pour imprimer */
extern int  ZoomX;             /* zomm en x pour imprimer        */
extern int  ZoomY;             /* zomm en y pour imprimer        */
extern int  DrvSel;            /* driver selectionn             */
extern int  MrgLeft;           /* marge gauche en mm/10          */
extern int  MrgTop;            /* marge haute  en mm/10          */
extern int  MrgRight;          /* marge droite en mm/10          */
extern int  MrgBottom;         /* marge basse  en mm/10          */
extern int  VdiFntId;          /* Fonte Vdi pour imprimer        */
extern char PrtHead;           /* Imprimer entete de page?       */
extern char PrtNoteFoot;       /* Imprimer pied de page?         */
extern char IsPrtColor;        /* Imprimer en couleur?           */
extern char IsTidyManageError; /* GEMTIDY manage les erreurs     */
extern char PathPCHelp[MAX_PATH];
extern int   EZ_PG_DW;
extern int   EZ_PG_UP;
extern char InclPath[MAX_PATH];
/*...................... fichier CONFIG.C ...............................*/ 
extern char IndexExt[MAX_PATH];          /* extensions des fichiers d'index  */
extern TXT_HEAD DefHeadCfg;
extern TXT_GFG DefTextCfg; 
extern int IC_EOF[9];
extern int OFSL;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\ P R O T O T Y P E S  D E  F O N C T I O N S \\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*................Fonction non documente interne  EAZY_GEM ..........*/
extern DrawSillonHori(int *vectxy, int mode);

/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  P U B L I C S \\\\\\\\\\\\\\\\\\*/
/*................Definies dans le fichier: C_2_HTML.C ................*/
int    C_to_HTML(char* path, char* nom, TXTED_OB* TXT_A, TXT_GFG* ptTxtCfg, char* source);

/*................Definies dans le Fichier: EZ_EDIT.C .................*/
int   KeyWordCompare (const void *one, const void *two);
char *IsThisExtensionIndex(char *ext, char *extlist);
char *ReallocPathAVBuffer(long size);
char *GetFileExtension(char *path, char *nom);
char *MultiFicToVA_START(char *path, char *pt_files);
int   OpenTxtInWind(int ident, char *path, GRECT *grect, int flag);
int   ChargerFichiers(void);
int   ActiveWindowTexte(int ident, long attr, char *title, GRECT *grect, CALLBACK (*w_proc)(int w_ind, EVNT_O *Evnt));
void  ActiveWindow(int ident, long attr, char *title, CALLBACK (*w_proc)(int w_ind, EVNT_O *Evnt));
char *ArgvPathToVA_START(const char *argv[], int nb_files);
int   ProjectFind(char *txt, char* path_in, char *path_find, long *pt_find);
char *PathCat(char *dst, const char *path, const char* nom);
long  NormaliseRelativPath(char *dst, char *src, long size_buf);
char *PathName_Concat(char *dst, char *path, const char *name);
char *LoadFic(const char *path);
int   InListFuncFind(char* to_find, char*  path_in, char* nom_in, long* pt_find);
int   GetSourceFromBFN(char *path, char* nom, int flag);
/*................ fonctions de fenetres de EZ_EDIT.C .................*/
CALLBACK WindProcDeskWind(int w_ind, EVNT_O *Evnt);
CALLBACK DefautCallbackProc(int w_ind, EVNT_O *Evnt);

/*................Definies dans le Fichier: CONFIG.C ..................*/
SYNT_PARAM *SyntaxConfigure(char *nom);
void  RaccFileToCfg(char *path, char *name);
void  RaccStrToShortCut(int num_func, char *racc);
char *ShortCutToStr(char *dst, int ksp, int key);
int   CfgLoadDefaultConfig(void *adr_rsc);
void  CfgSaveDefaultConfig(int w_ind);
void  CfgParamToTexte (int w_ind, TXT_HEAD *ptHeadTxt, TXT_PRM *pt_TxtCfg, SYNT_PARAM *synt_param);
SYNT_PARAM * LoadSyntParam(char *path, char *name);
char *InsertStr(char *dst, char *src);
void  SetFntListBoxMode(OBJECT *object, int ind_ob, int mode);
void  SetFntListBoxGraphMode(OBJECT *object, int ind_ob, int mode);
/*................ fonctions de fenetres de CONFIGUR.C .................*/
CALLBACK WindProcConfig(int w_ind, EVNT_O *Evnt);
/*................Definies dans le Fichier: EZ_TXT.C ..................*/
void InstalleRaccInMenu(OBJECT *object);
int  RaccToMenuStr(OBJECT *object, int num_func, int ksp, int key);
char *StrPathStrNameToStrPath(char *dst, char *path, char* name, long len_max);
void  ActiveMessList(char * path, char *deb, char *txt, int flag);
int   LoadTxtInWind(char *path, char *nom, long lig, int flag);
int   GetNbTXT_Wind(void);
int   CreateNewTxtWindIdent(int *TabIdent, int nbIdent, int first_ID);
void  ReleaseTxtWindIdent( int ident, int *TabIdent, int nbIdent, int first_ID);
int   GetDerTXT_Wind(int w_ind);
int   GetFirstWindTxt(void);
char *EndOfLine(char *pt);
char *DebOfLine(char *deb, char *pt);
char *NextLine(char *pt);
int   ExeTxtFunc(int w_ind, int func);
char *GoFirstValid(char *pt, char *tojump);
int   IsThisTxtLoaded(char *path, char* nom);
int   StrMenuToShortCut(char *txt, int *key, int *ksp);
int   SetTxtChgIndicator(int w_ind, int state);
int   GetNextWindTxt(int w_ind);
void  AdjustSrollEditSlide(OBJECT *object);;
void  AddString(int w_ind, char *txtref, TXTED_OB  *TXT_A);
long  TxtFind (int w_ind, char *txtref);
long  TxtReplace (int w_ind, char *txtref);
char *TxtFindRef(char *deb, char *end, char *pos, char *ref, long flag);
int   TesteFermantOuvrant(int w_ind, char *pt, TXTED_OB  *TXT_A);
void  UpdateParamTexte( OBJECT *object, int ob_ind, TXTED_OB *TXT_A);
int   BeforeIsValid(char *pt_src, long lig, char *valid_tab, TXTED_OB *TXT_A);
int   NewKeyWordCompare (const void *one, const void *two);
int   AfficheColorLigne(long i, int tx, int ty, TXTED_OB *pTXT_A);
char  *FIndParentPath(char *deb, char *pt, char *dst);

char  *FindFunc(char *deb, char *pos, char **endfunc, ERR_C *err);
char  *FindDebFunc(char *deb, char*fstparenth, char**finfunc);

char  *FindFirstAcco(char *pt, ERR_C *err);
char  *GotoEndBConst(char *pt, ERR_C *err);
char  *GotoEndPrePro(char *pt, ERR_C *err);
char  *GotoEndParnth(char *pt, ERR_C *err);
char  *GotoEndAcolld(char *pt, ERR_C *err);
char  *GotoEndComent(char *pt, ERR_C *err);
char  *GotoEndGuillm(char *pt, ERR_C *err);
char  *GotoEndAppost(char *pt, ERR_C *err);

char  *GotoReverseFirstComent(char *deb, char *pt, ERR_C *err);
char  *GotoReverseFirstParnth(char *deb, char *pt, ERR_C *err);
char  *GotoReverseFirstGuillm(char *deb, char *pt, ERR_C *err);
char  *GotoReverseFirstAppost(char *deb, char *pt, ERR_C *err);
char  *GotoReverseFirstAcolld(char *deb, char *pt, ERR_C *err);

int   IsBegSection(char *pt_src, int *section_type, int *idgrclass, int kwsection, SYNT_PARAM *syntprm);
int   IsEndSection(char *pt_src, int *section_type, int kwsection, SYNT_PARAM *syntprm);
int   IsBegKwSection(char *pt_src, int *section_type, int *idgrclass, SYNT_PARAM *syntprm);
int   IsEndKwSection(char *pt_src, int *section_type, int *idgrclass, SYNT_PARAM *syntprm);
/*................ fonctions de fenetres de EZ_TXT.C ..................*/
CALLBACK WindTxtWind(int w_ind, EVNT_O *Evnt);

/*................fonctions de fenetres de INFO_BOX.C .................*/
CALLBACK WindProcInfo(int w_ind, EVNT_O *Evnt);
/*................ Fonction de fenetre de EZ_ASCII.C ..................*/
CALLBACK WindProcEZ_ASCII(int w_ind, EVNT_O *Evnt);

/*................fonctions de fenetres de BOOKMARK.C .................*/
CALLBACK WindProcBookmark(int w_ind, EVNT_O *Evnt);
char *GetMessageError(int error);
char *MakeMessageString(char *dest,
                        char *token, 
                        char *path, char *nom, long len_max, 
                        long lig, long col, char *message);

/*................fonctions de fenetres de EZ_INFO.C ..................*/
CALLBACK WindProcEZ_INFO(int w_ind, EVNT_O *Evnt);                        
void     ActiveInfoWindow(int func);
int      AddIndex(char *path, char *nom, int flag);
char    *IsKeyWordInThisLigne(char *buft, char *pt_src, int *isInKwSection, int *isInSection, KEY_WRD **key_out, SYNT_PARAM  *syntprm);
int      MakeInterDepList(char *path, char *nom);
/*................fonctions de fenetres de EZ_PRINT.C .................*/
CALLBACK WindProc_PRT(int w_ind, EVNT_O *Evnt);                        
/*.................... FAST_ASM.S .....................................*/
extern int   ISDEBCOM(char *src);
extern int   ISENDCOM(char *src);
extern int   ISDEBSTRING(char *src);
extern int   ISENDSTRING(char *src);
extern int   IS_C_NAME(char *src);
extern int   IS_C_OPP(char *src, int *op_tab);
extern long  IS_NUMERIC(char *src, char *op_tab);
extern int   IS_IF_ELSE(char *src);
extern int   COMBACK(char *end, char *deb);
extern int   CPY_STR_TO_TEST(char *src, char *dst, long valid_str);
extern int   CPY_KW_TO_TEST(char *src, char *dst);
extern int   ISSECTION(char *str, char *ref_str, int ofs_refstr, long pt_id_find_refstr);
/*........ les fonctions de copie sont ecrites pour des petits volumess ..................*/
/*         de donnes: en effet memcpy dans un but d'optimisation                         */
/*         rajoute un code de test faisant gagner du temps pour les                       */
/*         grands volumes de donnes mais en fait perdre pour les petits                  */
extern void FAST_CHARCPY(char* src, char *dst);    /* la chaine src doit etre terminee par zero */
extern void FAST_CHARMEMCPY(char* src, char *dst, long nb_car);  /* il n'est pas place de zero de fin */
extern void FAST_CHARNCPY(char* src, char *dst, long nb_car);    /* un zero de fin est plac    */
extern int  FAST_CHARCMP(char* src, char *dst);
extern int  NOTESCCAR(int esc_car, char *str);
extern int  ISENDSECTION(int esc_car, char *str, char *str_ref);
