/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ EZ_TXT.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE   du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    d'une fenetre d'edition de                       */
/*                    texte C avec syntaxe colore                     */
/*              cet exemple montre comment synchroniser                */
/*              une SCROLLBOX avec un composant d'edition              */
/*              d'edition de texte.                                    */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#include "EZ_EDIT.H"  /* routines d'affichage et de gestion du texte.  */

/*................ inclure les definitions generees par ...............*/
/*                 l'editeur de ressources afin d'utiliser             */
/*                 les symboles plutot que des nombres                 */
#include "EZ_EDIT.SYS\EZ_TXT.RSH"
#include "EZ_EDIT.SYS\CONFIG.RSH"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/


/*.................. structure de raccourci clavier ...................*/
/*                   associe un  etat  du clavier                     */
/*                     une fonction du programme                       */
/* typedef struct                                                      */
/*       {int ksp;        etat des touches ALT, SHIFT, CONTROL         */
/*        int key;        scancode si negatif/ code ASCII si positif   */
/*        int Func;       numero de la fonction programme a executer   */
/*       } SHORT_CUT;                                                  */
/*.................. table des raccourcis possibles ...................*/
/*                         avec leur definition                        */

SHORT_CUT ShortCut[88] = {  {K_CTRL,         'N', TXT_NEW},               /* 0  */
                            {K_CTRL,         'O', TXT_OUVRIR},            /* 1  */
                            {K_CTRL_SHIFT,   'O', TXT_CHARGER},           /* 2  */
                            {K_CTRL,         'M', TXT_MERGER},            /* 3  */
                            {K_CTRL,         'S', TXT_SAUVER},            /* 4  */
                            {K_CTRL_SHIFT,   'S', TXT_SAUVER_SOUS},       /* 5  */
                            {K_CTRL,         '*', TXT_SAUVER_TOUT},       /* 6  */
                            {K_CTRL_SHIFT,   '%', TXT_CLOSE},             /* 7  */
                            {K_CTRL,         'X', BLK_COUPER},            /* 8  */
                            {K_CTRL,         'C', BLK_COPIER},            /* 9  */
                            {K_CTRL_SHIFT,   'C', BLK_COPIER_ADD},        /* 10 */
                            {K_CTRL,         'V', BLK_COLLER},            /* 11 */
                            {K_CTRL,         '(', BLK_SET_DEB},           /* 12 */
                            {K_CTRL,         ')', BLK_SET_END},           /* 13 */
                            {K_CTRL,         'A', BLK_SET_ALL},           /* 14 */
                            {K_CTRL_SHIFT,   '5', BLK_SET_RELEASE},       /* 15 */
                            {K_CTRL_SHIFT,   '', BLK_SAV_SOUS},          /* 16 */
                            {K_CTRL,         'Y', BLK_CUT_LGN},           /* 17 */
                            {K_CTRL,         'Q', DESK_QUIT},             /* 18 */
                            {K_CTRL_SHIFT,   'Q', DESK_QUIT_SAVE_ALL},    /* 19 */
                            {K_CTRL_SHIFT,   'K', DESK_QUIT_SAVE_CFG},    /* 20 */
                            {K_CTRL_SHIFT,   'H', DESK_QUIT_SAVE_FIC},    /* 21 */
                            {K_CTRL,         'W', DESK_WIND_CYCLE},       /* 22 */
                            {K_CTRL_SHIFT,   'W', DESK_WIND_LISTE},       /* 23 */
                            {0,              -98, TXT_HELP},              /* 24 */
                            {0,              -97, TXT_UNDO},              /* 25 */
                            {K_CTRL,         -97, TXT_REDO},              /* 25 */
                            {K_CTRL,         'F', TXT_FIND},              /* 27 */
                            {K_CTRL,         'D', TXT_GOTO_LGN},          /* 28 */
                            {K_CTRL,         'L', TXT_GOTO_LGN},          /* 29 */
                            {K_CTRL_SHIFT,   'U', TXT_SYNT_UPD},          /* 30 */
                            {K_CTRL,         'R', TXT_REPLACE},           /* 31 */
                            {K_CTRL,         'T', TXT_REPLACE_AGAIN},     /* 32 */
                            {K_CTRL,         'I', TXT_FIND_SELECT},       /* 33 */
                            {0     ,         ' ', 0},                     /* 34 */
                            {K_CTRL,         'G', TXT_FIND_AGAIN},        /* 35 */
                            {K_CTRL,         'E', TXT_FIND_ERROR},        /* 36 */
                            {K_CTRL_SHIFT,   'E', TXT_VOIR_ERROR},        /* 37 */
                            {K_CTRL,         -59, TXT_CTRL_F1},           /* 38 */
                            {K_CTRL,         -60, TXT_CTRL_F2},           /* 39 */
                            {K_CTRL,         -61, TXT_CTRL_F3},           /* 40 */
                            {K_CTRL,         -62, TXT_CTRL_F4},           /* 41 */
                            {K_CTRL,         -63, TXT_CTRL_F5},           /* 42 */
                            {K_CTRL,         -64, TXT_CTRL_F6},           /* 43 */
                            {K_CTRL,         -65, TXT_CTRL_F7},           /* 44 */
                            {K_CTRL,         -66, TXT_CTRL_F8},           /* 45 */
                            {K_CTRL,         -67, TXT_CTRL_F9},           /* 46 */
                            {K_CTRL,         -68, TXT_CTRL_F10},          /* 47 */
                            {K_LRSHIFT,      -59, TXT_CTRL_F1},           /* 48 */
                            {K_LRSHIFT,      -60, TXT_CTRL_F2},           /* 49 */
                            {K_LRSHIFT,      -61, TXT_CTRL_F3},           /* 50 */
                            {K_LRSHIFT,      -62, TXT_CTRL_F4},           /* 51 */
                            {K_LRSHIFT,      -63, TXT_CTRL_F5},           /* 52 */
                            {K_LRSHIFT,      -64, TXT_CTRL_F6},           /* 53 */
                            {K_LRSHIFT,      -65, TXT_CTRL_F7},           /* 54 */
                            {K_LRSHIFT,      -66, TXT_CTRL_F8},           /* 55 */
                            {K_LRSHIFT,      -67, TXT_CTRL_F9},           /* 56 */
                            {K_LRSHIFT,      -68, TXT_CTRL_F10},          /* 57 */
                            {0,              -59, TXT_F1},                /* 58 */
                            {0,              -60, TXT_F2},                /* 59 */
                            {0,              -61, TXT_F3},                /* 60 */
                            {0,              -62, TXT_F4},                /* 61 */
                            {0,              -63, TXT_F5},                /* 62 */
                            {0,              -64, TXT_F6},                /* 63 */
                            {0,              -65, TXT_F7},                /* 64 */
                            {0,              -66, TXT_F8},                /* 65 */
                            {0,              -67, TXT_F9},                /* 66 */
                            {0,              -68, TXT_F10},               /* 67 */
                            {K_CTRL,         'B', TXT_TEST_MARK},         /* 68 */
                            {K_LRSHIFT,      -98, TXT_ABOUT},             /* 69 */
                            {K_CTRL,         'K', PRM_ACTIVE_PARAM},      /* 70 */
                            {K_CTRL,         'Z', TXT_UNDO},              /* 71 */
                            {K_CTRL,         'P', TXT_PRINT},             /* 72 */
                            {K_CTRL_SHIFT,   'P', TXT_BLKPRINT},          /* 73 */
                            {K_CTRL,         'U', MANAGERL_OPEN},         /* 74 */
                            {K_CTRL,         'J', PRM_RACC_CHANGE},       /* 75 */
                            {K_CTRL_SHIFT,   'A', DESK_WIND_ALIGN},       /* 76 */
                            {0,              ' ', TXT_GEMTIDY},           /* 77 */
                            {K_CTRL,         -98, TXT_FIND_FUNC},         /* 78 */
                            {0,              ' ', TXT_PRJ_LOAD},          /* 79 */
                            {0,              ' ', TXT_PCSTUDIO_FIND},     /* 80 */
                            {0,              ' ', TXT_PRJ_UPDATE},        /* 81 */
                            {0,              ' ', TXT_PRJ_LINK},          /* 82 */
                            {0,              ' ', TXT_PRJALLMAKE},        /* 83 */
                            {0,              ' ', TXT_PRJ_RUN},           /* 84 */
                            {0,              ' ', TXT_PRJ_SET},           /* 85 */
                            {0,              ' ', TXT_HTML_CONV},         /* 86 */
                            {0,              ' ', TXT_UN_HELP},           /* 87 */
                           };

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
extern int EZ_font, EZ_point; /* declaree dans EAZY_GEM.C              */
extern EVNT_I Default_evnt_i;
/*\\\\\\\\\\\\\\ V A R I A B L E S  I N T E R N E S \\\\\\\\\\\\\\\\\\\*/

/*............... symbole de fin de ligne ...............................*/
/*                pour notre affichage custom                            */
int IC_EOF[9] = {0X4   , 0X5   , 0X1   , 
                        0XE000, 0X2000, 0X2000, 0XF800, 0X7000, 0X2000, 
                       };
/*............. pointeur courant sur la structure par defaut ............*/

FILE *STD_OUT;

/*\\\\\\\\\\\\\\\\\ P R O T O T Y P E S  E X T E R N E S \\\\\\\\\\\\\\\\*/

/*\\\\\\\\\\\\\\\\\ P R O T O T Y P E S  I N T E R N E S \\\\\\\\\\\\\\\\*/

/*................ fonctions de fenetres ..............................*/
CALLBACK WindTxtWind(int w_ind, EVNT_O *Evnt);
/*.............. petites fonctions pour faciliter la vie !! ...........*/
void   Spys(const char *mes);
char  *AnalyseArg(char *path, char *arg);
char  *Strbackstr(char *deb, char *pos, char *ref, long flag);
char  *Strfrwdstr(char *deb, char *pos, char *ref, long flag);
long   RecursTxtFind (int w_ind, char *txtref, int recurs);
int    SaveAllTxt(void);
void   AdjustRscToNewGrectWind(long w_attr, OBJECT *object, GRECT *oldGrect,  GRECT *newGrect);
char  *GetMarkListWindList(int len_ligne, int is_Mlist, char is_Wlist);
void   SelectWindTxt(OBJECT *object, short w);
int    PtTxtToPosCar(char *pt, char *pt_pos, int tab);
int    ComputeIndentation(TXTED_OB* TXT_A);
/*............. affichage colore d'une ligne de texte .................*/
long   EZeditInitTabLgnCtx(TXTED_OB *TXT_A, char *txt, long iTab, long nb_l);
void  UNDO_DO(int w_ind, UNDO_REC *undo_rec, TXTED_OB *TXT_A);
char *FromEndGetArg(char *txt, char *pt, char *str_cpy);
int   SetTxtChgIndicator(int w_ind, int state);
int   IsKeyShortCut(int ksp, int key);
int   TXT_ED_To_Wind (TXTED_OB *TXT_A);
int   NewKeyWordCompare (const void *one, const void *two);
int   IsGemTidyLog( char *txt, int flag);
void  SauverTexte(int w_ind, TXTED_OB  *TXT_A, TXT_GFG *ptTxtCfg);
int   IspaceInName(char *pt);
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                    */
/*              Definition des fonctions de ce module                    */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*----------------------- RaccStrToShortCut --------------------------------*/
void RaccStrToShortCut(int num_func, char *racc)
{int key, ksp;
 int nb_short_cut    = (int)(sizeof(ShortCut)/sizeof(SHORT_CUT));
 int ptShortCut      = 0;
 /*........ rechercher le raccourci lie a ce numero de fonction ....*/
 for (ptShortCut = 0; ptShortCut<nb_short_cut; ptShortCut++)
     {if      (ShortCut[ptShortCut].Func == num_func) break;
     }
 if (ptShortCut >= nb_short_cut)                         return;
 /*........ chaine raccourci vers touches ..........................*/
 racc = StrTrimDeb(racc);
 StrTrimEnd(racc);
 StrMenuToShortCut(racc, &key, &ksp);
 /*........ y placer le raccourci clavier donn en entree ..........*/
 ShortCut[ptShortCut].ksp = ksp;
 ShortCut[ptShortCut].key = key;
}

/*----------------------- InstalleRaccInMenu ----------------------------*/
void InstalleRaccInMenu(OBJECT *object)
{int nb_short_cut    = (int)(sizeof(ShortCut)/sizeof(SHORT_CUT));
 int            i    = 0;
 if (object==0)        return ;
 for (i = 0; i<nb_short_cut; i++)
     {RaccToMenuStr(object, ShortCut[i].Func, ShortCut[i].ksp, ShortCut[i].key);
     }
}

/*------------------------- GetMarkListWindList -------------------------*/
/* ACTION: Cree une chaine en memoire (y compris la reservation memoire) */
/*         comportant, la liste des nom de fichiers textes, edites dans  */
/*         chaque fenetre d'edition. Chaque ligne se termine par un \r\n */
/*         et est de la forme:                                           */
/*         " MonTexte.TXT          W:1 \r\n" o "W:1" indique l'indice   */
/*         EAZY_GEM de la fenetre (Cela permet de l'activer) contenant   */
/*         le fichier: "MonTexte.TXT"                                    */
/* ENTREE: int len_ligne: longueur totale de la ligne y compris "w: "    */
/*                        c'est apres que sont inscrits les chiffres de  */
/*                        fenetre. Cette valeur doit etre au minimum 4   */
/* RETOUR: un char*: qui pointe sur la liste de fenetres ouvertes.       */
/*                   il convient de liberer ce pointeur apres usage en   */
/*                   faisant un free().                                  */

char *GetMarkListWindList(int len_ligne, int is_Mlist, char is_Wlist)
{int nb_txt         = 0; 
 int nb_mrk         = 0;
 int wind_targ      = IsWindExist(CurIDDoc);
 TXT_GFG*  ptTxtCfg = 0;
 int              i = 0;
 char*     txt;
 char*     pt;
 TXTED_OB* TXT_A;
 long      len;
 char      buft[32];
 int       wind, ident;

 if (is_Mlist==0 && is_Wlist==0) return 0;
 /*........ Compter les Bookmarks .....................*/
 if (is_Mlist && wind_targ>-1 && IS_IDWINDTXT(CurIDDoc))
    {TXT_A    = WTXT_A(wind_targ);
     ptTxtCfg = WTXT_CFG(wind_targ);
     while (i<10) 
       {if (ptTxtCfg->Bookmark[i] > -1) nb_mrk++;
        i++;
       }
    }
 /*......... Compter le nb de fenetre texte ..........*/
 if (is_Wlist)
    {nb_txt = GetNbTXT_Wind()+1;
    }
 
 /*......... Reserver la memoire pour les deux .......*/
 len_ligne -= 3;           /* les chiffres sont rajoutes apres */
 if (len_ligne<=0)               return 0;
 if (len_ligne>57)               return 0;
 if (nb_txt==0 && nb_mrk==0)     return 0;
 if (nb_mrk) nb_mrk++; /* si bookmark presents ajouter ligne separation */
 txt      = malloc( (nb_txt + nb_mrk) * 64);
 if (txt == 0)                   return 0;
 
 pt       =  txt;
 /*...... collecter tous les noms de fenetre et faire la chaine ........*/
 if (nb_txt)
    {/*.......... rajouter ligne de separation .........................*/
     *pt = '-';
     strcpy( pt+1 , "Activer une fenetre"); strcat(pt,"\r\n"); pt += strlen(pt);
     /*.......... rajouter chaque titre de fenetre .....................*/
     for (wind=0; wind<MAX_WIND; wind++)
         {ident = GETWINDIDENT(wind);
          if (IS_IDWINDTXT(ident))
             {ptTxtCfg = WTXT_CFG(wind);
              /*....... si fenetre en cours ........*/
              if (wind == wind_targ)
                 {strcpy( pt,   "");
                 }
              else
                 {strcpy( pt,   " ");
                 }
              /*....... si fenetre modifie ........*/
              if ( WTXT_A(wind)->State & EDIT_CHG)
                 {strcat( pt,   "*");
                 }
              else
                 {strcat( pt,   " ");
                 }
              /*........ rajouter nom du fichier....*/
              strcpy( pt+2, ptTxtCfg->NomTxt);
              len      = Min(strlen(pt), len_ligne - 1);
              memset( pt + len, 32, len_ligne - len);
              pt += len_ligne;
              /*........ rajouter numero fenetre ...*/
              strcpy (pt, "W: "); pt+=3;
              strcpy (pt, itoa(wind,buft,10));
              strcat (pt,"\r\n");
              pt += strlen(pt);
             }
         } /* end for(wind==0; wind<MAX_WIND; wind++) */
    } /* endif (is_Wlist) */
 /*............. rajouter les book mark ...............................*/
 if (nb_mrk && TXT_A)
    {char* pt_end;
     /*.......... rajouter ligne de separation ........................*/
     *pt = '-';
     strcpy( pt+1 , "Aller sur une marque"); strcat(pt,"\r\n"); pt += strlen(pt);
     /*.......... rajouter les bookmarks ..............................*/
     ptTxtCfg = WTXT_CFG(wind_targ);
     for (i=0;  i<10; i++)
         {if(ptTxtCfg->Bookmark[i] > -1)
            {strcpy(pt, "  ");
             strncpy(pt+3, TXT_A->ptTxt+ptTxtCfg->Bookmark[i], len_ligne-2);
             pt_end = pt + 1 + len_ligne-2;
             while(pt<pt_end)
                  {if (*pt==13 || *pt==10 || *pt==0) *pt=32;
                   pt++;
                  }
             strcpy(pt , " M: ");
             pt += 4;
             strcpy(pt, itoa(i + 1,buft,10));
             strcat (pt,"\r\n");
             pt += strlen(pt);
            }
         }
    }
 return txt;
}
/*--------------------------IspaceInName --------------------------------*/
int IspaceInName(char *pt)
{while(*pt)
   {if(*pt==' ') return 1;
    pt++;
   }
 return 0;
}
/*--------------------------- ExeTxtFunc --------------------------------*/
int  ExeTxtFunc(int w_ind, int func)
{OBJECT *object    = GETWINDTREE(w_ind);  /* recuperer pointeur ressource */
 int w_h           = GETGEMHAND(w_ind);   /* handle GEM de notre fenetre  */
 int ident         = GETWINDIDENT(w_ind); /* identificateur de la fenetre */
 TXTED_OB  *TXT_A  = 0;
 TXT_GFG *ptTxtCfg = 0;
 int param[8];
 char path[MAX_PATH];
 char nom[MAX_PATH>>1];
 int wind;

 /*........... recuperer adresses editeur de texte et configuration .......*/
 /*                           lies a la fenetre                            */
 if (IS_IDWINDTXT(ident)) 
    {TXT_A    = WTXT_A(w_ind);
     ptTxtCfg = WTXT_CFG(w_ind);
    }
 switch (func)
 {case TXT_HTML_CONV:
      {long sav_mouseform = GetMouseForm();
       
       strcpy( path, ptTxtCfg->PathTxt);
       strcpy( nom,  ptTxtCfg->NomTxt );
       Enleve_ext(nom);
       strcat(nom,".HTM");
       if (TXT_A && ptTxtCfg && 
           FileSelect (path, nom, ".HTM", TxtPtStrMess[HTML_CONV])  != -2L
          )
          {EZ_ED_GraphUpdate( TXT_A);
           SetMouseForm(BUSYBEE);
           C_to_HTML(path, nom, TXT_A, ptTxtCfg, ptTxtCfg->NomTxt);
           SetMouseForm(sav_mouseform);
          }
      }
       break;
  case  PRJ_CHANGE:
        if (ptTxtCfg)
       {int pcstudio  = appl_find("PCSTUDIO");
        if (GscPcStud )
           {GSClose(GscPcStud);
            GscPcStud = 0;
           }
        GscPcStud = GSOpen( pcstudio);
        if ( GscPcStud)
           {strcpy(path, ptTxtCfg->PathTxt);
            strcat(path, ptTxtCfg->NomTxt);
            GSSendCommand( GscPcStud, "ProjectChanged" ,1, path);
           }
        }
        break;
  case  TXT_PRJ_LOAD:
        if (*PathProject==0)
           {GetPathAppli(PathProject, NomAppli, 0);
            strcpy(nom,  "PCSTUDIO.PRG");
           }
        else
           {PathNomToNomFic(PathProject, nom);
           }
        FileSelect (PathProject, nom, ".PRJ", TxtPtStrMess[LOAD_PRJ]);
        strcat(PathProject, nom);
  case  TXT_PRJ_SET:
        wind = IsWindExist(W_CONFIG); 
        if ( wind >- 1) 
           {OBJECT *obj = GETWINDTREE(wind);
            ObjcSetTxt(obj, PRM_DIAL_PRM_TXT_PRJ_PATH, PathProject);
            if (IsThisObInvisible(obj, PRM_DIAL_PRM_TXT_PRJ_PATH) == -1)
               {Wobjc_draw(wind, obj, PRM_DIAL_PRM_TXT_PRJ_PATH, 3, 0);
               }
           }
        break;
  case  TXT_PCSTUDIO_FIND:
        if (*PathPcStudio==0)
           {GetPathAppli(PathPcStudio, NomAppli, 0);
            strcpy(nom,  "DEFAUT.PRJ");
           }
        else
           {PathNomToNomFic(PathPcStudio, nom);
           }
        FileSelect (PathPcStudio, nom, ".PRG", TxtPtStrMess[LOAD_PCS]);
        strcat(PathPcStudio, nom);
        wind = IsWindExist(W_CONFIG); 
        if ( wind >- 1) 
           {OBJECT *obj = GETWINDTREE(wind);
            ObjcSetTxt(obj, PRM_DIAL_PRM_TXT_PCSTUDIO_PATH, PathPcStudio);
            Wobjc_draw(wind, obj, PRM_DIAL_PRM_TXT_PCSTUDIO_PATH, 3, 0) ;
           }
        break;
  case  TXT_PRJ_UPDATE:
  case  TXT_PRJ_LINK:
  case  TXT_PRJALLMAKE:
  case  TXT_PRJ_RUN:
      {long len_fic  = Fic_exist(PathPcStudio,0);
       int pcstudio  = appl_find("PCSTUDIO");
       char cmd[MAX_PATH];
       if (len_fic == -1L)
          {GetPathAppli(PathPcStudio, NomAppli, 0);
           strcpy(nom,  "PCSTUDIO.PRG");
           len_fic =  FileSelect (PathPcStudio, nom, ".PRG", TxtPtStrMess[LOAD_PCS]);
           strcat(PathPcStudio, nom);
          }
       if (len_fic >0)
          {EVNT_I evnt_i;
           EVNT_O evnt_o;
           clock_t chrono;
           evnt_i         = Default_evnt_i;
           evnt_i.lotimer = 200;
           /*........ verifier si le projet existe ..................*/
           len_fic  = Fic_exist(PathProject,0);
           if (len_fic == -1L)
              {GetPathAppli(PathProject, NomAppli, 0);
               strcpy(nom,  "DEFAUT.PRJ");
               len_fic =  FileSelect (PathProject, nom, ".PRJ", TxtPtStrMess[LOAD_PRJ]);
               strcat(PathProject, nom);
              }
           if ( GscPcStud )
                  {GSClose(GscPcStud);
                   GscPcStud = 0;
                  }
           /*........ lancer PcStudio ...............................*/
           if (AESversion>=0x0399 && pcstudio<=0)
              {
               strcpy(cmd+1, PathProject);
               *cmd = (char)strlen(PathProject);
               shel_write(1, 1, 100, PathPcStudio, cmd );
               /*......attendre 4 secondes que le PRG s'installe ....*/
               chrono         = clock();
               while (  (clock() - chrono < 800)  &&
                        pcstudio<=0
                     )  /* 4 secondes */
                     {pcstudio     = appl_find("PCSTUDIO ");
                      EvntEZ_GEM(MU_MESAG | MU_TIMER, &evnt_i, &evnt_o);
                     }
              }
          if (pcstudio>=0)
             {if ( GscPcStud == 0) GscPcStud = GSOpen( pcstudio);
              if ( GscPcStud)
                 {char *pt;
                  switch(func)
                     {case  TXT_PRJ_UPDATE: pt = "ProjectUpdate";  break;
                      case  TXT_PRJ_LINK:   pt = "ProjectLink";    break;
                      case  TXT_PRJALLMAKE: pt = "ProjectAllMake"; break;
                      case  TXT_PRJ_RUN:    pt = "ProjectRun";     break;
                     }
                  GSSendCommand( GscPcStud, pt ,1, PathProject);
                 }
             }
           else
              {/*shel_write(1, 1, 1, PathPCHelp, PathVABuff );*/
               /* Pexec(0, PathPCHelp, PathVABuff, 0 ); */
               form_alert(1, TxtPtStrMess[ALR_PCSTUDIO]);
              }
          }
       else
          {OutMessage(" Erreur: PcStudio non Trouve");
          }
      }
       break;
  case TXT_GEMTIDY:
      {long len_fic = Fic_exist(PathTidy,0);
       int tidy     = appl_find("GEMTIDY ");
       SauverTexte(w_ind, TXT_A, ptTxtCfg);
       if (len_fic == -1L || Kbshift(-1)&4)
          {GetPathAppli(PathTidy, NomAppli, 0);
           strcpy(nom,  "GEMTIDY.PRG");
           len_fic =  FileSelect (PathTidy, nom, ".PRG", TxtPtStrMess[LOAD_TIDY]);
           strcat(PathTidy, nom);
          }
       if (len_fic >0)
          {EVNT_I evnt_i;
           EVNT_O evnt_o;
           clock_t chrono;
           evnt_i         = Default_evnt_i;
           evnt_i.lotimer = 200;
           /*........ lancer GEMtidy ................................*/
           if (AESversion>=0x0399 && tidy<=0)
              {if ( Gsc )
                  {GSClose(Gsc);
                   Gsc = 0;
                  }
               shel_write(1, 1, 100, PathTidy, "\n-gemscript" );
               /*......attendre 4 secondes que le PRG s'installe ....*/
               chrono         = clock();
               while (  (clock() - chrono < 800)  &&
                        tidy<=0
                     )  /* 4 secondes */
                     {tidy     = appl_find("GEMTIDY ");
                      EvntEZ_GEM(MU_MESAG | MU_TIMER, &evnt_i, &evnt_o);
                     }
              }
          if (tidy>=0)
             {if ( Gsc == 0) Gsc = GSOpen( tidy);
              if ( Gsc)
                 {char *pt_ext = 0;
                  char ext[32];
                  /*.......... effacer les differents fichiers ........*/
                  /*           de debug generes par GEMtidy            */
                  if (Fic_exist(PathAppli,"GEMtidy.LOG")>-1L)
                     {strcpy(PathVABuff,    PathAppli);
                      strcat(PathVABuff, "GEMtidy.LOG");
                      Fdelete(PathVABuff);
                     }
                  if (Fic_exist(PathAppli,"W_gs.LOG")>-1L)
                     {strcpy(PathVABuff,    PathAppli);
                      strcat(PathVABuff, "W_gs.LOG");
                      Fdelete(PathVABuff);
                     }
                  /*......... effacer l'eventuel fichier ..............*/
                  /*          d'erreur relatif au fichier              */
                  /*           traiter.                               */
                  strcpy( PathVABuff, ptTxtCfg->PathTxt);
                  strcat( PathVABuff, ptTxtCfg->NomTxt );
                  pt_ext = GetExtension(PathVABuff, ext);
                  strcpy(pt_ext, ".err");
                  if (Fic_exist(PathVABuff,0)>-1L)
                     {Fdelete(PathVABuff);
                     }
                  strcpy(pt_ext, ext);    /* restaurer extension initiale */
                  /*.......... lancer un message GEMSCRIPT ...............*/
                  if (IsTidyManageError)
                     GSSendCommand( Gsc, "choice",1, PathVABuff);
                  else
                     GSSendCommand( Gsc, "verify",2, PathVABuff,"-NoWinErr");
                 }
             }
           else
              {/*shel_write(1, 1, 1, PathPCHelp, PathVABuff );*/
               /* Pexec(0, PathPCHelp, PathVABuff, 0 ); */
               form_alert(1, TxtPtStrMess[ALR_TIDY]);
              }
          }
       else
          {OutMessage(" Erreur: GEMTIDY non Trouve");
          }
      }
       break;
  case PRM_RACC_CHANGE:
       strcpy(nom,  "SHORTCUT.PRM");
       *path = 0;
       if (FindFicSys(path, NomAppli, nom) > 0 &&
           Fic_select (path, nom, ".PRM", TxtPtStrMess[LOAD_RACCOURCIS]) >0
          )
          {OBJECT *obj_men;
           RaccFileToCfg(path, nom);
           for (w_ind=0; w_ind<MAX_WIND; w_ind++)
               {ident = GETWINDIDENT(w_ind);
                if (IS_IDWINDTXT(ident) )
                   {TXT_A    = WTXT_A(w_ind);
                    ptTxtCfg = WTXT_CFG(w_ind);
                    xrsrc_gaddr (R_TREE, WIND_MENU, &obj_men, GETWINDRSC(w_ind));
                    InstalleRaccInMenu(obj_men);
                   }
               } /* end for(w_ind==0; w_ind<MAX_WIND; w_ind++) */
           } /* endif (FindFicSys() */
       break;
  case TXT_UN_HELP:
       if (LastHelpPos>=0)
          {/* long     param[2];
              param[0] = (long)(LastHelpPos+TXT_A->ptTxt);
              param[1] = (long)TXT_A;                 *  W_G H_G  adresse de l'editeur cible       *
              ptTxtCfg->FindPos  =  param[0];
              EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
              EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
           */
           strcpy(path, LastHelpFic);
           PathNomToNomFic(path, nom);
           LoadTxtInWind(path, nom, LastHelpPos, GOTO_OPENWIND|SET_TO_TOP|ABS_POS|NOT_SELECT);
          }
       break;
  case TXT_FIND_FUNC:
  case TXT_HELP:
      {if (TXT_A && ptTxtCfg)
          {char *deb, *end, *cur_txt;
           char sav;
           long len_ref;
           int  viewer   = appl_find("ST-GUIDE");
           long pt_find;
           /*int flag;*/
           /*..................... chercher une selection .......................*/
           EZ_ED_GraphUpdate(TXT_A);
           cur_txt = EZ_ED_GetLigCol(BLK_TXT_MARK, (long*) &deb, (long*)&end, TXT_A);
           /*..................... si pas trouve en creer une au curseur ........*/
           if ( deb==0 || end ==0 || *deb == *end) 
              {int i;
               if ((int)Kbshift(-1) & K_LRSHIFT) i = WORD_VAR;
               else                              i = WORD_SIMPLE;
               deb = EZ_ED_CarPtToWord(cur_txt, TXT_A->ptTxt, &end, i);
              }
           /*................... placer zero de fin provisoire ...................*/
           sav  = *end;
           *end = 0;
           /*flag = InListFuncFind(deb,   ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, &pt_find);
           if (flag != -1)
              {*end  = sav;
               LoadTxtInWind(path, nom, pt_find, flag|GOTO_OPENWIND|SET_TO_TOP|ABS_POS);
              }
           else */
           if (ProjectFind(deb, 0, path, &pt_find))
              {PathNomToNomFic(path, nom);
               *end        = sav;
               LastHelpPos = EZ_ED_GETCURPOS(TXT_A);
               strcpy( LastHelpFic, ptTxtCfg->PathTxt);
               strcat( LastHelpFic, ptTxtCfg->NomTxt );
               LoadTxtInWind(path, nom, pt_find, GOTO_OPENWIND|SET_TO_TOP|ABS_POS);
              }
           else
              {/*..........................noter la chaine de recherche ..............*/
               if (*deb==0) deb = "Index";
               *PathVABuff = ' ';
               strcpy( PathVABuff + 1, "*:\\PC_H.REF " ); /* BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__); */
               len_ref = strlen(PathVABuff);
               memcpy( PathVABuff + len_ref, deb, Min( LenPathVABuff - len_ref , strlen(deb) + 1 ) );
               /* BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__); */
               PathVABuff[0] = (char)strlen(PathVABuff);
               
               if (viewer>0)
                  {Send_VA_START(viewer, PathVABuff+1); 
                  }
               else if (AESversion>=0x0399)
                  {shel_write(1, 1, 100, PathPCHelp, PathVABuff );
                  }
               else
                  {form_alert(1,TxtPtStrMess[ALR_STGUIDE_NOT]);               
                  }
              }
           *end = sav;
          }       
      }
       break;
  case TXT_SYNT_UPD:
       if (TXT_A && ptTxtCfg->SyntPrm)
          {long sav_mouseform = GetMouseForm();
           SetMouseForm(BUSYBEE);
           EZeditInitTabLgnCtx(TXT_A,TXT_A->ptTxt, 0, LONG_MAX);
           SetMouseForm(sav_mouseform);
           /* SendObjectRedraw(w_h, object, EZ_TXT_SCLBOX); */
           Wobjc_draw(w_ind, object, EZ_TXT_SCLBOX, 1, 0);
          }
       break;
  case TXT_SAUVER_TOUT:
       CfgSaveDefaultConfig(w_ind);
       SaveAllTxt();
       break;
  case MANAGERL_OPEN:
       ActiveInfoWindow(-1);
       break;
  case TXT_PRINT:
       ActiveWindow(W_EZ_EDIT_PRT, SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER, TxtPtStrMess[PRT_WIND_NAME], WindProc_PRT);
       break;
  case PRM_ACTIVE_PARAM:
       ActiveWindow(W_CONFIG, SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER, TxtPtStrMess[PRM_WIND_NAME], WindProcConfig);
       break;
  case TXT_TEST_MARK:
       if (TXT_A)
          {EZ_ED_GraphUpdate(TXT_A);
           TesteFermantOuvrant(w_ind, EZ_ED_GETCURTXT(TXT_A), TXT_A);
          }
       break;
  case TXT_ABOUT:
       ActiveWindow(W_INFO_BOX, XMOVER|XBORDER, TxtPtStrMess[INF_WIND_NAME], WindProcInfo);
       break;
  case TXT_VERI_ACCO:         /* 54 */
       break;
  case TXT_VERI_COMM:         /* 55 */
       break;
  case TXT_VERI_PARH:         /* 56 */
       break;
  case TXT_UNDO:
       if (! TXT_A || !ptTxtCfg || !TXT_A->U_Stack)                  break;
       EZ_ED_DirectExeEvntKey(w_ind, 0x6100, 0, TXT_A);
       break;
       
  case DESK_WIND_CYCLE:
       {int old_wind;
        WindCycle(&old_wind);
        /*.......... si ancienne fenetre est une texte mettre ...........*/
        /*           a jour son texte  avant d'activer l'autre           */
        if (old_wind != -1 && IS_IDWINDTXT(GETWINDIDENT(old_wind)))
           {EZ_ED_GraphUpdate(WTXT_A(old_wind));
           }
       }
       break;
  case DESK_WIND_LISTE:
       if (TXT_A && ptTxtCfg)
          {SelectWindTxt(object, PopMenWidth);
          }
       break;
       
  case DESK_WIND_ALIGN:
       if (TXT_A)
          {int wind, targ_ident;
           param[APPL]  = Appl_id;    /*   identificateur de l'appelant (moi)   */
           param[SUPL]  = 0;          /*   message sans surplus                 */
           param[MESG]  = WM_SIZED;
           GetGemWindExtGRECT(w_h, (GRECT*)&param[X_G]);
           for (wind=0; wind<MAX_WIND; wind++)
               {targ_ident = GETWINDIDENT(wind);
                if (targ_ident != ident && IS_IDWINDTXT(targ_ident) )
                   {param[WHND] = GETGEMHAND(wind);    /*   on l'envoie  cette fenetre          */
                    appl_write(Appl_id, 16, param );
                   }
               }
          }
       break;
  case TXT_NEW:       
       strcpy(PathVABuff+1, PathAppli);
       strcat(PathVABuff+1, TxtPtStrMess[DESK_NEW_FIC]);
       /* BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__); */
       *PathVABuff = ' ';
       ActiveWindowTexte(-1, SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER|XSIZER|FULLER, 
                                     PathVABuff,0,
                                     WindTxtWind);
       /*BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__);*/
       break;
       
  case TXT_OUVRIR:
      {char *pt_ext = GetExtension(ptTxtCfg->NomTxt, 0);
       if (pt_ext==0) pt_ext = ".*";
       strcpy(PathTxt, ptTxtCfg->PathTxt);
       strcpy(NomTxt,  ptTxtCfg->NomTxt);
       XFilesSelect(PathTxt, NomTxt, pt_ext, TxtPtStrMess[MESS_LOAD_TXT], 1);
      }
       break;
         
  case TXT_RELOAD:
      {int wind = IsThisTxtLoaded(PathVABuff, 0);
       strcpy(path, PathVABuff);
       PathNomToNomFic(path, nom);
       if (wind>-1)
          {long sav_mouseform = GetMouseForm();
           int wind_Parm      = IsWindExist(W_CONFIG);
           TXT_A    = WTXT_A(wind);
           ptTxtCfg = WTXT_CFG(wind);
           SetMouseForm(BUSYBEE);
           if (EZ_ED_LoadTxt(wind, path, nom, TXT_A))
              {int param[8];
               long x,y;
               char *txt;
               strcpy(ptTxtCfg->PathTxt, path); 
               strcpy(ptTxtCfg->NomTxt,  nom);
               strcpy(Windtab[w_ind].titre + 1, ptTxtCfg->PathTxt);
               strcat(Windtab[w_ind].titre + 1, ptTxtCfg->NomTxt);
               /*........ reajuster eventuelle position curseur ........*/
               /*         (cas ou texte plus court)                     */
               EZ_ED_GetLigCol(CURS_POSXY,  &y, &x, TXT_A);
               txt   = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_A);
               *(long*) &param[2] = (long)TXT_A;  /*  W_G H_G  adresse de l'editeur cible           */
               *(long*) &param[0] = (long)txt+x;  /* pointe sur texte ou on doit placer le curseur  */
               EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
               
               Wobjc_draw(wind, object, EZ_TXT_SCLBOX, 1, 0);
               Wobjc_draw(wind, object, EZ_TXT_COLOR_SYNT, 1, 0);
               Wobjc_draw(wind, object, EZ_TXT_VERT_BAR, 1, 0);
               SetTxtChgIndicator(wind, 0);
               if (wind_Parm >- 1)
                  {ExeWindMessage(wind_Parm, WM_ACT_TXT_CHG, 0, 0);
                  }
               }
           SetMouseForm(sav_mouseform);
           return 1;
          } /* endif (wind>-1) */
       else if (Fic_exist(PathVABuff,0) )
          {PlaceQuote(PathVABuff, 0);
           Send_VA_START(Appl_id, PathVABuff);
           return 1;
          }
       else
          {return 0;
          }
       }
  
  case TXT_CHARGER:
      {char *pt_ext = GetExtension(ptTxtCfg->NomTxt, 0);
       long len_fic;
       if (pt_ext==0) pt_ext = ".*";
       strcpy(path, ptTxtCfg->PathTxt);
       strcpy(nom,  ptTxtCfg->NomTxt);
       if (! TXT_A || !ptTxtCfg)                                          break;
       len_fic =  FileSelect (path, nom, pt_ext, TxtPtStrMess[DESK_LOAD_TXT]);
       if (len_fic >-2L )
          {int    i = 2;
           int wind = IsThisTxtLoaded(path, nom);
           int wh_top;          
           wind_get( 0, WF_TOP, &wh_top);          /* celui de fenetre avant plan  */

           if (wind>-1 && GETGEMHAND(wind) != wh_top)
              {ActiveWindowTexte(GETWINDIDENT(wind), SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER|XSIZER|FULLER, 
                                     TxtPtStrMess[REG_MENU_NAME],0,
                                     WindTxtWind); 
              i=0;
              }
           else if (TXT_A->State & EDIT_CHG)
              {i = form_alert(1,TxtPtStrMess[ALR_LOAD_MOD]);
              }
           if (i==2)
              {long sav_mouseform = GetMouseForm();
               int wind_Parm      = IsWindExist(W_CONFIG);
               SetMouseForm(BUSYBEE);
               ptTxtCfg->SyntPrm  = SyntaxConfigure(nom);
               if (ptTxtCfg->SyntPrm) 
                  {/*........ le fichier de parametrage syntaxique peut ......................*/
                   /*          aussi comporter des parametres generaux                        */
                   CfgParamToTexte ( w_ind, &ptTxtCfg->SyntPrm->HeadTxt, &ptTxtCfg->SyntPrm->TxtPrm, ptTxtCfg->SyntPrm);
                   /*
                   SetScrollBoxParam(object,EZ_TXT_SCLBOX,ptTxtCfg->SyntPrm->HeadTxt.IntLg,-2,-2,-2, -2, -2, -2,-2,(void*)-2L,-2);
                   */
                   UpdateParamTexte(object, EZ_TXT_SCLBOX, TXT_A); 
                   /* Wobjc_draw(wind, object, EZ_TXT_COLOR_SYNT, 1, 0);*/
                  }
               else
                  {object[EZ_TXT_COLOR_SYNT].ob_flags |= HIDETREE;
                   EZ_ED_SetDrawLineFunc(0L, TXT_A);
                   /* SendObjectRedraw(w_h, object, EZ_TXT_COLOR_SYNT); */
                  }
               if (EZ_ED_LoadTxt(w_ind, path, nom, TXT_A))
                  {int param[8];
                   long x,y;
                   char *txt;
                   strcpy(ptTxtCfg->PathTxt, path); 
                   strcpy(ptTxtCfg->NomTxt,  nom);
                   strcpy(Windtab[w_ind].titre + 1, ptTxtCfg->PathTxt);
                   strcat(Windtab[w_ind].titre + 1, ptTxtCfg->NomTxt);
                   /*........ reajuster eventuelle position curseur ........*/
                   /*         (cas ou texte plus court)                     */
                   EZ_ED_GetLigCol(CURS_POSXY,  &y, &x, TXT_A);
                   txt   = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_A);
                   *(long*) &param[2] = (long)TXT_A;  /*  W_G H_G  adresse de l'editeur cible           */
                   *(long*) &param[0] = (long)txt+x;  /* pointe sur texte ou on doit placer le curseur  */
                   EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
                   
                   Wobjc_draw(w_ind, object, EZ_TXT_SCLBOX, 1, 0);
                   Wobjc_draw(w_ind, object, EZ_TXT_COLOR_SYNT, 1, 0);
                   Wobjc_draw(w_ind, object, EZ_TXT_VERT_BAR, 1, 0);
                   
                   /* SendObjectRedraw(w_h, object, EZ_TXT_SCLBOX); */
                   SetTxtChgIndicator(w_ind, 0);
                   /*
                   SendObjectRedraw(w_h, object, EZ_TXT_COLOR_SYNT);
                   */
                   if (wind_Parm >- 1)
                      {ExeWindMessage(wind_Parm, WM_ACT_TXT_CHG, 0, 0);
                      }
                  }
               SetMouseForm(sav_mouseform);
              }
          }
       }
       break;
       
  case BLK_COUPER:
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CUT, param, 4, TXT_A);
          }
       break;     
  case BLK_COPIER:
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_COPY, param, 4, TXT_A);
          }
       break;     
  case BLK_COPIER_ADD:
       if (TXT_A && ptTxtCfg) 
          {*(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_COPY_ADD, param, 4, TXT_A);
          }
       break;     
  case BLK_COLLER:
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[0] = 0;
           *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SCRAP_PASTE, param, 4, TXT_A);
           if (ptTxtCfg->IsSelInsert == 0)
              {EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,   param, 4, TXT_A);
              }
          }
       break;
  case BLK_SET_ALL:
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[0] = (long)(TXT_A->ptTxt);
           *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB, param, 4, TXT_A);
           *(long*) &param[0] = (long)(TXT_A->EndTxt);
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END, param, 4, TXT_A);
          }
       break; 
  case BLK_SET_RELEASE: 
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[0] = 0;
           *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,   param, 4, TXT_A);
          }
       break;
  case BLK_SET_DEB:
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[0] = (long)EZ_ED_GetLigCol(CURS_POS, 0, 0, TXT_A);
           *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB, param, 4, TXT_A);
           if (func==BLK_SET_RELEASE) EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END, param, 4, TXT_A);
          }
       break;     
  case BLK_SET_END:
       if (TXT_A && ptTxtCfg)
          {*(long*) &param[0] = (long)EZ_ED_GetLigCol(CURS_POS, 0, 0, TXT_A);
           *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END, param, 4, TXT_A);
          }
       break;
  case TXT_VOIR_ERROR:
       if (TXT_A && ptTxtCfg)
          {ActiveMessList(ptTxtCfg->PathTxt, TXT_A->ptTxt, EZ_ED_GETCURLIG(TXT_A), 0);
           ClearKeybdMessage(0L);
          }
       break;
  case TXT_FIND_ERROR:
       if (TXT_A && ptTxtCfg)
          {ActiveMessList(ptTxtCfg->PathTxt, TXT_A->ptTxt, EZ_ED_GETCURLIG(TXT_A), GOTO_OPENWIND|SET_TO_TOP);
           ClearKeybdMessage(0L);
          }
       break; 
  case BLK_SAV_SOUS:
      {char *pt_ext = GetExtension(ptTxtCfg->NomBlk, 0);
       if (pt_ext==0) pt_ext = ".*";
       if (TXT_A && ptTxtCfg && 
           FileSelect (ptTxtCfg->PathTxt, ptTxtCfg->NomBlk, pt_ext, TxtPtStrMess[DESK_SAV_BLK]) != -2L
          )
          {EZ_ED_SaveTxt(ptTxtCfg->PathBlk, ptTxtCfg->NomBlk, BLK_SAVE, TXT_A);
          }
      }
       break;      
       
  case TXT_MERGER:
      {char *pt_ext = GetExtension(ptTxtCfg->NomBlk, 0);
       if (pt_ext==0) pt_ext = ".*";
       
       if (TXT_A && ptTxtCfg && 
           FileSelect (ptTxtCfg->PathBlk, ptTxtCfg->NomBlk, pt_ext, TxtPtStrMess[DESK_MERGE]) >-2L
          )
          {strcpy(path, ptTxtCfg->PathBlk);
           strcat(path, ptTxtCfg->NomBlk);
           *(long*) &param[0] = (long)(path);   /*  path du fichier a merger                  */
           *(long*) &param[2] = (long)TXT_A;    /*  W_G H_G  adresse de l'editeur cible       */
           EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_FILE_PASTE, param, 4, TXT_A);
          }
       }
       break;
       
  case TXT_SAUVER:
       SauverTexte(w_ind, TXT_A, ptTxtCfg);
       break;
       
  case TXT_SAUVER_SOUS:
      {char *pt_ext = GetExtension(ptTxtCfg->NomSavUnder, 0);
       if (pt_ext==0) pt_ext = ".*";
       
       if (TXT_A && ptTxtCfg && 
           FileSelect (ptTxtCfg->PathSavUnder, ptTxtCfg->NomSavUnder, pt_ext, TxtPtStrMess[DESK_SAV_TXTSOUS])  != -2L
          )
          {/* EZ_ED_GraphUpdate( TXT_A);                 */
           /* Bsave(ptTxtCfg->PathSavUnder, ptTxtCfg->NomSavUnder, TXT_A->ptTxt, TXT_A->EndTxt - TXT_A->ptTxt); */
           
           EZ_ED_SaveTxt(ptTxtCfg->PathSavUnder, ptTxtCfg->NomSavUnder, TXT_SAVE, TXT_A);
           strcpy(ptTxtCfg->PathTxt,ptTxtCfg->PathSavUnder);
           strcpy(ptTxtCfg->NomTxt, ptTxtCfg->NomSavUnder);
           strcpy(Windtab[w_ind].titre + 1, ptTxtCfg->PathTxt);
           strcat(Windtab[w_ind].titre + 1, ptTxtCfg->NomTxt);
           *Windtab[w_ind].titre = ' ';
           TXT_A->State &= ~EDIT_CHG;
           SetTxtChgIndicator(w_ind, 0);
          }
      }
       break;
       
  case TXT_FIND_SELECT:
   if (TXT_A && ptTxtCfg)
      {char *deb, *end, *cur_txt;
       char sav;
       long len_ref;
       long pos_find;
       /*..................... chercher une selection .......................*/
       EZ_ED_GraphUpdate( TXT_A);
       cur_txt = EZ_ED_GetLigCol(BLK_TXT_MARK, (long*) &deb, (long*)&end, TXT_A);
       /*..................... si pas trouve en creer une au curseur ........*/
       if ( deb==0 || end ==0 || *deb == *end) 
          {int i;
           if ((int)Kbshift(-1) & K_LRSHIFT) i = WORD_VAR;
           else                              i = WORD_SIMPLE;
           deb = EZ_ED_CarPtToWord(cur_txt, TXT_A->ptTxt, &end, i);
          }
       pos_find = deb - TXT_A->ptTxt;
       len_ref  = end - deb;   
       WTXT_CFG(w_ind)->FindPos = pos_find;
       /*................... placer zero de fin provisoire ...................*/
       sav  = *end;
       *end = 0;
       /*..........................noter la chaine de recherche ..............*/
       if (TxtRef) free(TxtRef);
       TxtRef      = malloc(len_ref+1);
       if (TxtRef) strcpy(TxtRef, deb);
       *end = sav;
       /*.....................executer le find ................................*/
       ptTxtCfg->FindFlag &= ~FIND_LOOP_BREAK;
       TxtFind (w_ind, TxtRef);
      }
       break;

  case TXT_REPLACE_AGAIN:     
  case TXT_FIND_AGAIN:
   if (TXT_A && ptTxtCfg)
      {if (TxtRef==0 || *TxtRef==0) break;
       EZ_ED_GraphUpdate(TXT_A);
       ptTxtCfg->FindPos   = EZ_ED_GetLigCol(BLK_TXT_MARK, 0, 0, TXT_A) - TXT_A->ptTxt;
       ptTxtCfg->FindFlag &= ~FIND_LOOP_BREAK;
       TxtFind (w_ind, TxtRef);
       if (func==TXT_REPLACE_AGAIN && TxtRep && *TxtRep)
          {TxtReplace (w_ind, TxtRep);
          }
      }
       break;
       
  case TXT_FIND:
  case TXT_REPLACE:     
  case TXT_GOTO_LGN:
      /*   #define FIND_ALLER_A     1    */
      /*   #define FIND_FIND        2    */
      /*   #define FIND_REPLACE     3    */ 
       if ( !(TXT_A && ptTxtCfg)) return 0;
      {int i, wind;
       EZ_ED_GraphUpdate( TXT_A);
       switch (func)
        {case TXT_FIND:      i= FIND_FIND;      break;
         case TXT_REPLACE:   i= FIND_REPLACE;   break;
         case TXT_GOTO_LGN:  i= FIND_ALLER_A;   break;
        }
       wind = IsWindExist(W_BOOK);
       if ( wind != -1 )
          {int wh_top;
           wind_get( 0, WF_TOP, &wh_top);
           Windtab[wind].UserPtr = (void*)i;
           if (!IsWindOpen(wind)) OpenWindow(wind, 0); 
           if (GETGEMHAND(wind) != wh_top)
              {SendWindMessage(GETGEMHAND(wind), WM_TOPPED, 0);
               ExeAllMessage();
               ExeAllMessage();
              }
           ExeWindMessage(wind, WM_INIT_BOOK, 0, 0);
          }
       else
          {int w_h = CreateWindow (0x8000|SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER, 
                                   W_BOOK, (void*)i, WindProcBookmark, 0, 0, 0, 0, TxtPtStrMess[DESK_BOOK_TITLE] );
           if (w_h==-3||w_h==-2) form_alert(1,TxtPtStrMess[ALR_NOWIND_MORE]);
          }
      }
       break;

  case DESK_QUIT_SAVE_CFG:
  case DESK_QUIT_SAVE_ALL:
       CfgSaveDefaultConfig(w_ind);
  case DESK_QUIT_SAVE_FIC:
       if (func != DESK_QUIT_SAVE_CFG) SaveAllTxt();
  case DESK_QUIT:
      {int wind = IsWindExist(W_TXT_DESK); 
       if ( wind >- 1) SendWindMessage(GETGEMHAND(wind), WM_CLOSED, 0);
       else  
          {if (LastCfgMustBeSaved) CfgSaveDefaultConfig(w_ind);
           EZGemRun = -1;                
          }
      }
      break; 

  case TXT_CLOSE:  /* la fonction appelante ne se charge pas du WM_CLOSED */
       SendWindMessage(w_h, WM_CLOSED, 0);
       break;

  case TXT_CLOSED: /* la fonction appelante se charge du WM_CLOSED        */
       if (TXT_A && ptTxtCfg)
          {int ret   = 3;
           if (TXT_A->State & EDIT_CHG)
              {char *str = malloc(512);
               if (str)
                  {strcpy(str, TxtPtStrMess[DESK_DOC_CHG1]);
                   strcat(str, ptTxtCfg->PathTxt);
                   strcat(str, ptTxtCfg->NomTxt);
                   strcat(str,TxtPtStrMess[DESK_DOC_CHG2]);
                   ret = form_alert(1, str);
                   free(str);
                  }
               if (ret==2) /*....... Fermer et Sauver le texte ............*/
                  {/*
                   EZ_ED_GraphUpdate(TXT_A);
                   Bsave(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_A->ptTxt, TXT_A->EndTxt - TXT_A->ptTxt);
                   */
                   EZ_ED_SaveTxt(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_SAVE, TXT_A);
                  }
               if (ret==3) /*.......  Fermer et ne pas sauver le texte ....*/
                  {TXT_A->State &= ~EDIT_CHG;
                  }
              }
           return ret;
          }
       return 1;
       
  case PRM_COLOR_FUNC_ON:
       if (TXT_A && ptTxtCfg)
          {int wind_Parm     = IsWindExist(W_CONFIG);
           if (object[EZ_TXT_COLOR_SYNT].ob_state & SELECTED && ptTxtCfg->SyntPrm)
              {EZ_ED_SetDrawLineFunc(AfficheColorLigne, WTXT_A(w_ind));
               ptTxtCfg->IsSyntColored = 1;
              }
           else  
              {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
               EZ_ED_SetDrawLineFunc(0L, WTXT_A(w_ind));
               ptTxtCfg->IsSyntColored = 0;
              }
           /*............... si dialogue W_CONFIG ouvert ...............*/
           /*                mettre  jour ses donnes                  */
           if (wind_Parm>-1) ExeWindMessage(wind_Parm, WM_PRM_SYNT_UPDATE, 0, 0);
           Wobjc_draw(w_ind, object, EZ_TXT_SCLBOX, 1, 0);
           /* SendObjectRedraw(w_h, object, EZ_TXT_SCLBOX); */
          }
       break;
  case TXT_F1:
  case TXT_F2:
  case TXT_F3:
  case TXT_F4:
  case TXT_F5:
  case TXT_F6:
  case TXT_F7:
  case TXT_F8:
  case TXT_F9:
  case TXT_F10:
       if (TXT_A && ptTxtCfg)
          {int nf = func - TXT_F1;
           if (ptTxtCfg->Bookmark[nf] != -1)
              {long     param[2];
               param[0] = (long)(ptTxtCfg->Bookmark[nf]+TXT_A->ptTxt);
               param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
               ptTxtCfg->FindPos  =  param[0];
               LastHelpPos        = EZ_ED_GETCURPOS(TXT_A);
               strcpy( LastHelpFic, ptTxtCfg->PathTxt);
               strcat( LastHelpFic, ptTxtCfg->NomTxt );
               EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
               EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
              }
               
          }
       break;
  case TXT_CTRL_F1:
  case TXT_CTRL_F2:
  case TXT_CTRL_F3:
  case TXT_CTRL_F4:
  case TXT_CTRL_F5:
  case TXT_CTRL_F6:
  case TXT_CTRL_F7:
  case TXT_CTRL_F8:
  case TXT_CTRL_F9:
  case TXT_CTRL_F10:
       if (TXT_A && ptTxtCfg)
          {int wind = IsWindExist(W_BOOK); 
           ptTxtCfg->Bookmark[func - TXT_CTRL_F1] = EZ_ED_GETCURPOS(TXT_A);
           if ( wind >- 1) 
              {int param[4];
               param[0]            = func - TXT_CTRL_F1;
               *(long*)&param[2]   = (long)(ptTxtCfg->Bookmark[func - TXT_CTRL_F1]+TXT_A->ptTxt); 
               ExeWindMessage(wind, WM_MARK_CHG, param, 4);
              }
          }
       break;
 }
 return 1;
}

/*--------------------------- SauverTexte ----------------------------*/
void SauverTexte(int w_ind, TXTED_OB  *TXT_A, TXT_GFG *ptTxtCfg)
{if (TXT_A && ptTxtCfg)
    {char *pt_ext = GetExtension(ptTxtCfg->NomTxt, 0);
     if (pt_ext==0) pt_ext = ".*";
     EZ_ED_GraphUpdate(TXT_A);
     if (Fic_exist(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt) >= 0)
        {
         EZ_ED_SaveTxt(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_SAVE, TXT_A);
         TXT_A->State &= ~EDIT_CHG;
         SetTxtChgIndicator(w_ind, 0);
         if (pt_ext && strcmpi(pt_ext,".prj")==0)
            {ExeTxtFunc(w_ind, PRJ_CHANGE);
            }
        }
     else if (FileSelect (ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, pt_ext, TxtPtStrMess[DESK_SAVE])!= -2L)
        {EZ_ED_SaveTxt(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_SAVE, TXT_A);
         TXT_A->State &= ~EDIT_CHG;
         SetTxtChgIndicator(w_ind, 0);
        }
     }
 }
/*--------------------------- SelectWindTxt ----------------------------*/
void SelectWindTxt(OBJECT *object, short w)
{char* item_str;
 /*.............. creer une chaine avec noms ........*/
 /*                des fenetres textes               */
 item_str = GetMarkListWindList(w,0,1);
 if (item_str)
    {/*.......... appel du popup fichier .............*/
     /*     auquel on ajoute la liste de fenetres     */
     int ob_r = DoPopMenuFromFile(object, EZ_TXT_WINDMEN, "", "", item_str);
     if (*item_str && ob_r>0)
        {char *pt = item_str + strlen(item_str);
         char der_arg[16];
         char avt_der_arg[16];
         /*...... regarder si c'est pas un item ......*/
         /*       de la liste des fenetres            */
         /*........... extraire les mots en partant de la fin .........*/
          pt = FromEndGetArg(item_str, pt, der_arg);
          pt = FromEndGetArg(item_str, pt, avt_der_arg);
          if (strcmp(avt_der_arg,"W:")==0)
             {int wind = atoi(der_arg);
              SendWindMessage(GETGEMHAND(wind), WM_TOPPED, &Windtab[wind].GemWorkGrect);
             }
        }
     free (item_str);
    }
 return;
}
/*--------------------------- SaveAllTxt -------------------------------*/
int SaveAllTxt(void)
{int  w_ind, ident,n;
 TXTED_OB  *TXT_A  = 0;
 TXT_GFG *ptTxtCfg = 0;
 n = 0;
 for (w_ind=0; w_ind<MAX_WIND; w_ind++)
     {ident = GETWINDIDENT(w_ind);
      if (IS_IDWINDTXT(ident) )
         {TXT_A    = WTXT_A(w_ind);
          ptTxtCfg = WTXT_CFG(w_ind);
          EZ_ED_GraphUpdate(TXT_A);
          if (TXT_A->State&EDIT_CHG && Fic_exist(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt) >= 0)
             {EZ_ED_SaveTxt(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_SAVE, TXT_A);
              TXT_A->State &= ~EDIT_CHG;
              SetTxtChgIndicator(w_ind, 0);
              n++;
             }
         }
     } /* end for(w_ind==0; w_ind<MAX_WIND; w_ind++) */
return n;
}

/*--------------------------- ActiveMessList ---------------------------*/
void ActiveMessList(char *path, char *deb, char *txt, int flag)
{/* PUREC: Found E:\PURE_C\EAZY_GEM\TOOLBOX.C                 17     : OBJECT *EZB_GetScriptContainer(i */
 /* HCP:   warning: E:\PURE_C\EAZY_GEM\EZ_GUIDE\EAZY_DOC.STG, line 29: Illegal Command ualabel          */
 char *pt      = txt;
 /*
 char *arg     = malloc(MAX_PATH<<1);
 char *nom     = malloc(MAX_PATH);
 char *arg_lig = malloc(MAX_PATH>>1);
 */
 char arg[MAX_PATH<<1];
 char nom[MAX_PATH];
 char arg_lig [MAX_PATH];
 if (arg&&nom&&arg_lig)
    {pt = Extrait_mot(arg, pt, 0," ");
     if (strcmp(arg, "line")==0 && 
         IsGemTidyLog(txt, flag)
        )
        {return;
        }
     else if (strcmp(arg, "Logout")==0)
        {/*...... "Logout"...............*/    /* <<<< PURE C        */
         pt = GoFirstValid(pt," ");
         /*......."E:\PURE_C\"..........*/
         pt = Extrait_mot(arg, pt, 0," ");
        }
     else if (strcmp(arg, "Found")==0)
        {/*...... "Found"...............*/     /* <<<< PURE C        */
         pt = GoFirstValid(pt," ");
         /*......."E:\PURE_C\"..........*/
         pt = Extrait_mot(arg, pt, 0," ");
        }
     else if (strncmpi(arg, "warning",7)==0 || /* <<<< PURE C HCP    */
              strncmpi(arg, "error",5) ==0
             )
        {pt = GoFirstValid(pt," ");
         /*......."E:\PURE_C\"..........*/
         pt = Extrait_mot(arg, pt, 0,", ");
         if (*pt==',') pt++;       /* HCP  */
        }
     else if (strncmp(arg, "", 2)==0)
        {pt = GoFirstValid(pt," ");
         /*......."E:\PURE_C\"..........*/
         pt = Extrait_mot(arg, pt, 0," ");
        }
     else if (*arg>='#'&&*arg<='*'&& pt[11]==':') /*# 214987    : IsBegSection */
        {if      (*arg=='#') flag |= FNC_LIST_C;   /* ".FNC" */
         else if (*arg=='%') flag |= FNC_LIST_CC;  /* ".FCC" */
         else if (*arg=='&') flag |= FNC_LIST_P;   /* ".FPC" */
         else if (*arg=='*') flag |= FNC_LIST_H;   /* ".FHC" */
         else if (*arg=='$') flag |= FNC_LIST_S;   /* ".FNS" */
         pt = GoFirstValid(pt," ");
         pt = Extrait_mot(arg_lig, pt, 0," ");
         arg[0]=0;   /* pas de concatenation du contenu de arg au path */
         if (FIndParentPath(deb, txt, arg))
            {PathNomToNomFic(arg, nom);
             *arg = 0;
             flag = GetSourceFromBFN(arg, nom, flag);
             if (flag)
                {LoadTxtInWind(arg, nom, Max(0,atol(arg_lig)-OFSL), flag|ABS_POS);
                }
             goto endActiveMessList;
            }
        }
     else if (strncmp(arg, ":", 1)==0)         /*: 12345 : int *function(int val)      */
        {pt = GoFirstValid(pt," ");
         pt = Extrait_mot(arg_lig, pt, 0," ");
         arg[0]=0;   /* pas de concatenation du contenu de arg au path */
         if (FIndParentPath(deb, txt, arg))
            {PathNomToNomFic(arg, nom);
             LoadTxtInWind(arg, nom, Max(0,atol(arg_lig)-OFSL), flag);
             goto endActiveMessList;
            }
        }
     else /*..... GCC ? ................*/   /* <<<< GCC    .LOG                           */
        { /* E:\GCC272ST\INCLUDE\/gemfast.h:370: previous declaration of `VRECT'           */
          /* eazy_gem.h:735: conflicting types for `VRECT'                                 */
          /* LOADED E:\PURE_C\EAZY_GEM\EAZY_GEM.LOG  : Fichier index charge by EZ_EDIT */
         if      (txt[1]==':')        pt  = txt + 2;
         else if (! IS_C_NAME(txt) ) {pt  = txt;
                                      while(*pt && !IS_C_NAME(pt)) pt++;
                                      txt = pt;
                                     }
         else                         pt = txt;
         pt = strchr(pt,':');
         if (pt)
            {*pt=0;
             strcpy(arg, txt);
             *pt=':';
             AnalyseArg(path, arg);
             if (Fic_exist(arg, "")==-1L)
                {*pt=0;
                 strcpy(arg, txt);
                 AnalyseArg(0, arg);
                 *pt=':';
                }
             pt++;
            }
         else 
            {*arg = 0;
              pt  = txt;
            }
        }
     nom[0]=0; /* indispensable !!!    */
     /*........ si path tronqu .......*/
     /*    cassos car non utilisable   */
     if (arg[3] == '.') goto endActiveMessList;;
     /*......... Si path relatif ......*/
     /*     construire un path absolu  */
     /*      partir d'un eventuel     */
     /*      LOADED                */
     /*      CREATED               */
     /*      LISTED                */
     if (arg[1] != ':' )
        {if (FIndParentPath(deb, txt, arg))
            {PathNomToNomFic(arg, nom);
            }
         else 
            {strcpy(nom, arg);
             strcpy(arg, path);
            }
        }
     /*..................."17" ...........................*/
     /*........ extraire argument (si il existe) .........*/
     pt           = GoFirstValid(pt," :");
     if (strncmp(pt, "line", 4)==0) pt +=5;   /* HCP */
     if (*pt >='0' && *pt<='9')
        {pt = Extrait_mot(arg_lig, pt, 0," :");
        }
     else
        {strcpy(arg_lig, "0");
        }
     /*............ ouvrir la fenetre ....................*/
     LoadTxtInWind(arg, nom, Max(0, atol(arg_lig)-OFSL), flag);
    }
 /*............ liberer memoire et cassos ................*/
 endActiveMessList:
 /*
  free(arg);
  free(nom);
  free(arg_lig);
  */
 return;
}
/*------------------- IsGemTidyLog --------------------------------------------*/
int IsGemTidyLog(char *txt, int flag)
{char *pt = txt;
 char *end;
 int ret  = 1;
 long lig /*, col*/;
 char sav;
 /*
 char *arg     = malloc(MAX_PATH<<1);
 char *nom     = malloc(MAX_PATH);
 char *arg_lig = malloc(MAX_PATH>>1);
 */
 char arg[MAX_PATH<<1];
 char nom[MAX_PATH];
 char arg_lig [MAX_PATH>>1];
 
 if (arg&&nom&&arg_lig)
    {/*......... chercher arguments colonne et ligne .....*/
     pt = Extrait_mot(arg, pt, 0," \t\n\r");
     if (strcmp(arg, "line")!= 0)   goto  endIsGemTidyLog0;
     pt  = GoFirstValid(pt," \t"); /* sauter espaces et tabulations */
     pt  = Extrait_mot(arg, pt, "0123456789"," \t\n\r");
     if (*arg==0)                   goto  endIsGemTidyLog0;
     lig = atol(arg);
     pt  = GoFirstValid(pt," \t"); /* sauter espaces et tabulations */
     pt  = Extrait_mot(arg, pt, 0," \t\n\r");
     if (strcmp(arg, "column")!= 0) goto  endIsGemTidyLog0;
     pt  = GoFirstValid(pt," \t"); /* sauter espaces et tabulations */
     pt  = Extrait_mot(arg, pt, "0123456789"," \t\n\r");
     if (*arg==0)                   goto  endIsGemTidyLog0;
     /*col = atol(arg);*/
     /*........... chercher fichier concerne ..............*/
     /*        on saute toutes les lignes commenant       */
     /*        par "line"                                  */
     pt  = NextLine(pt);
     while(*pt && strncmp(pt, "line ",5)==0)
        {pt  = NextLine(pt);
        }
     /*......... chercher premier texte significatif ......*/
     /*          normalement le nom du fichier             */
     pt  = GoFirstValid(pt," \t\n\r"); /* sauter espaces et tabulations */
     if ( !(*pt && pt[1]==':') )    goto  endIsGemTidyLog0;
     /*......... chercher fin du fichier ..................*/
     end = strchr(pt+2,':');
     if (end==0)                    goto  endIsGemTidyLog0;
     sav  = *end; *end=0;
     strcpy(arg, pt);
     *end = sav;
     PathNomToNomFic(arg, nom);
     /*......... charger le texte .........................*/
     LoadTxtInWind(arg, nom, Max(0, lig-OFSL), flag);
     ret = 1;
     goto  endIsGemTidyLog1;
    }
  /*............ liberer memoire et cassos ................*/
 endIsGemTidyLog0:
  ret = 0;
 endIsGemTidyLog1:
 /*
  free(arg);
  free(nom);
  free(arg_lig);
  */
 return ret;
}


/*------------------------------ LoadTxtInWind --------------------------------*/
int LoadTxtInWind(char *path, char *nom, long lig, int flag)
{int w_ind;
 if (flag&FNC_LIST_C)
    {char *pt_ext = GetExtension(nom, 0);
     if (pt_ext && strcmpi(pt_ext,".FNC")==0)
        {strcpy(pt_ext,".C");
        }
    }
 else if (flag&FNC_LIST_S)
    {char *pt_ext = GetExtension(nom, 0);
     if (pt_ext && strcmpi(pt_ext,".FNS")==0)
        {strcpy(pt_ext,".S");
        }
    }
 else if (flag&FNC_LIST_H)
    {char *pt_ext = GetExtension(nom, 0);
     if (pt_ext && strcmpi(pt_ext,".FHC")==0)
        {strcpy(pt_ext,".H");
        }
    }
 else if (flag&FNC_LIST_P)
    {char *pt_ext = GetExtension(nom, 0);
     if (pt_ext && strcmpi(pt_ext,".FPC")==0)
        {strcpy(pt_ext,".CPP");
        }
    }
 else if (flag&FNC_LIST_CC)
    {char *pt_ext = GetExtension(nom, 0);
     if (pt_ext && strcmpi(pt_ext,".FCC")==0)
        {strcpy(pt_ext,".CC");
        }
    }
 w_ind = IsThisTxtLoaded(path, nom);
 /*.............. si texte n'existe pas retourner message erreur ..............*/
 if (Fic_exist(path, nom)==-1L && flag==GOTO_OPENWIND)
    {char buft[MAX_PATH];
     strcpy(buft,TxtPtStrMess[FIC_NOT_FOUND_01]);
     StrPathStrNameToStrPath( buft + strlen(buft), path, nom, 70);
     strcat(buft, TxtPtStrMess[FIC_NOT_FOUND_02]);
     form_alert(0,buft);
     return 0;
    }
 MultiFicToVA_START(path, nom);
 if (w_ind == -1 && flag & GOTO_OPENWIND)
    {OpenTxtInWind(-1, PathVABuff, 0, 0);
     /* BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__); */
     ExeAllMessage();
    }
 w_ind = IsThisTxtLoaded(path, nom); 
 if (w_ind != -1)
    {long param[4];
     long pos;
     TXTED_OB  *TXT_A   = WTXT_A(w_ind);
     TXT_GFG *ptTxtCfg  = WTXT_CFG(w_ind);
     
     if (Windtab[w_ind].w_flag & W_IS_ICON
        )
        {UnconifyWindow(w_ind);
         ExeAllMessage();
         ExeAllMessage();
        } 
     /*........ se positionner sur la ligne ..............*/
     TXT_A->CarPt       = 0;
     if (flag&FNC_LIST_C||
         flag&FNC_LIST_P||
         flag&FNC_LIST_H||
         flag&FNC_LIST_CC||
         flag&FNC_LIST_S||
         flag&ABS_POS)
        {ptTxtCfg->FindPos  = lig;                           /* caractere en relatif / debut texte  */
         pos                = lig + (long)TXT_A->ptTxt;
        }
     else
        {pos                = Min( lig, TXT_A->NbLgn -1);
         pos                = (long)TXT_A->TabLgnCtx[pos].ptTxt;
         ptTxtCfg->FindPos  =  pos - (long)TXT_A->ptTxt;
        }
     param[0]           = pos;
     param[1]           = (long)TXT_A;             /*  W_G H_G  adresse de l'editeur cible     */
     
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
     if ( !(flag&NOT_SELECT) )
        {EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,  (int*)param, 4, TXT_A);
         param[0] = (long) NextBreakChar((char*)pos, "\n\r");
         EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,  (int*)param, 4, TXT_A);
        }
     if (flag & SET_TO_TOP)SendWindMessage(GETGEMHAND(w_ind),WM_TOPPED, 0);
     return w_ind;
    } 
 return 0;
}

/*---------------------------- FIndParentPath -----------------------------------*/
char *FIndParentPath(char *deb, char *pt, char *dst)
{char buft[MAX_PATH];
 long len_fic;
 if (pt > deb) pt--;
 while (pt > deb && !(*pt == '' && pt[1] == '')) pt--;
 /*..................... on a trouve le debut ....................*/
 if (*pt == '' && pt[1] == '')
    {char *end, sav_end;
     pt     = NextBreakChar(pt, " ");
     pt++;      /* passer l'espace pour pointer au debut du path  */
     if (dst)
        {end      = NextBreakChar(pt+2, " ");
         sav_end  = *end; *end = 0;   /* recuper le path complet  */
         strcpy(buft, pt);
         *end     = sav_end;
         /*........... si la destination est vide ................*/
         /*            sortir le path tel que                     */
         if (*dst==0)
            {strcpy(dst, buft);                          return pt;}
         /*........... si destination non vide ...................*/
         /*            la concatener au path trouve               */
         PathNomToNomFic(buft, 0);    /* virer le nom             */
         /*....... si le nom a concatener a deja un slash ........*/
         /*        ne pas le copier car le path en a deja un      */
         if (*dst=='\\') strcat(buft, dst +1);
         else            strcat(buft, dst);
         /*........ teste si ce fichier existe ...................*/
         /*         si n'existe pas tester "included from e:\"    */
         /*         faut vraiment aimer  GCC !!!                  */
         len_fic  = Fic_exist(buft, "");
         if (len_fic >10L) {strcpy(dst, buft);           return pt;}
         pt       = end;
         /*......... rechercher le \:  ...........................*/
         while (*pt && !(*pt == ':' && pt[1] == '\\') ) pt++;
         if (*pt==0 || !(*pt == ':' && pt[1] == '\\') )  return pt;
         end      = NextBreakChar(pt+2, ": ");
         sav_end  = *end; *end = 0;   /* recuper le path complet  */
         strcpy(buft, Max(pt-1,deb));
         *end     = sav_end;
         PathNomToNomFic(buft, 0);    /* virer le nom             */
         /*....... si le nom a concatener a deja un slash ........*/
         /*        ne pas le copier car le path en a deja un      */
         if (*dst=='\\') strcat(buft, dst +1);
         else            strcat(buft, dst);
         strcpy(dst, buft);                              return pt;
        }
    }
 return 0;
}
 
/*---------------------------- AnalyseArg -----------------------------*/
char *AnalyseArg(char *path, char *arg)
{char *pt  = arg;
 char *end = pt + strlen(pt);
 while(pt<end)
   {if (*pt=='\\' && pt[1]=='/')
       {memmove(pt, pt+1, end-pt);
        *pt='\\';
        end--;
       }
    else if (*pt=='/') *pt = '\\';
    else if (*pt=='\\' && pt[1]=='\\')
       {memmove(pt, pt+1, end-pt);
        *pt='\\';
        end--;
       }
    else pt++;
   }
 /*............ si juste nom fichier, linker path ........*/
 if (arg[1] != ':' && path && *path)
    {long len_path = strlen(path);
     long len_arg  = strlen(arg);
     memmove(arg + len_path, arg, len_arg + 1);
     memmove(arg, path, len_path);
    }
 return arg;
}
/*--------------------------- GoFirstValid ----------------------------*/
char *GoFirstValid(char *pt, char *tojump)
{while (strchr(tojump, *pt)         /* tant que car doit etre saute        */
               && *pt) pt++;        /* et 0 de fin non atteint poursuivre  */
 return pt;
}

/*--------------- StrPathStrNameToStrPathName ---------------------*/
/* ACTION: concatene le path et le nom d'un fichier sans depasser  */
/*         une longueur maximum. Si depassement,le debut du chemin */
/*         est coupe (il est quand meme garde les 3 premiers       */
/*         caracteres afin de voir quel disque est concerne: "C:\" */
/*         cela donne une chaine du type: "C:\...chemin\nom.ext"   */
/* ENTREE: char *dst: lieu ou doit se faire la recopie (peut  etre */
/*                    le meme que path. Si = 0 c'est path qui sera */
/*                    utilise.                                     */
/*         char *path: chemin d'entree. "C:\DOCUMENT\"             */
/*         char *name: nom du fichier.  "NOM.EXT" si egal a zero   */
/*                     la fonction considerera que path est        */
/*                     complet."C:\DOCUMENT\NOM.EXT"               */
/*         long len_max: longueur maxi que la chaine doit avoir.   */
/*                       sI negatif, la chaine ne sera pas         */
/*                          completee avec des espaces si trop     */
/*                          courte.                                */
/*                       sI positif la chaine sera completee avec  */
/*                          espaces pour atteindre: len_max        */
/*                          ou coupe  len_max si trop longue.    */
/*                       SI zero la chaine sera copiee dans dst    */
/*                          il faut que dst ait assez de place.    */
/* SORTIE: char * pointe sur le debut de la chaine resultat.       */
/*                                                                 */

char *StrPathStrNameToStrPath(char *dst, char *path, char* name, long len_max)
{long len_path, len_buft;
 char *buft;
 char *pt;
 char complete_with_space = len_max>0; /* si negatif on complete pas avec espaces */
 len_max = labs(len_max);
 /*............. D:\ .... PATH\FICHIER.TXT .......*/
 /* StrPathStrNameToStrPath(txt, InclPath, 0, len -1);*/
 if (dst==0)  dst = path;
 /*........ calcul de la longueur du buffer de travail ........................*/
 len_buft = strlen(path);
 if (name) len_buft += strlen(name);
 buft                = malloc(Max(len_buft,len_max)+2);
 if (buft==0)          return 0;
 /*........ recopie des chaines ...............................................*/
 strcpy(buft, path);
 if (name) strcat(buft, name);
 /*........ reformatage selon si trop grand ou trop petit .....................*/
 len_path = strlen(buft);
 if (len_max==0)
    {strcpy(dst, buft);
    }
 else if (len_path > len_max)                   /* "D:\"  et "..." */ 
    {pt = buft + len_path - len_max + 6; 
     memcpy( buft + 3, "...",3 );
     strcpy( buft + 6,  pt);
    } 
 else if (complete_with_space)
    {char *end = buft + len_max-1; 
     pt        = buft + len_path;
     while(pt<end) {*pt = ' '; pt++;}
     *pt = 0;
    }
 strcpy(dst, buft);
 free (buft);
 return dst;
}

/*--------------------------- AddString --------------------------------*/
void AddString(int w_ind, char *txtref, TXTED_OB  *TXT_A)
{long param[4];
 size_t len_ref = strlen(txtref);
 char      *str = 0;
 /*............. placer le curseur en fin de texte .....................*/
 /*              et deselectionne le texte                              */
 if (TXT_A==0)
    {
     #define EZ_INFO_BOX 1  /* BOXTEXT in tree EZ_INFO */
     TXT_A   =  EZ_ED_GetTxtEditStruct(GETWINDTREE(w_ind), EZ_INFO_BOX);
    }
 if (TXT_A==0) return;
 TXT_A->State |= (EDIT_BLK_NOT_AFTER_PASTE|EDIT_SCRLH_NOT_AFTER_PASTE);
 
 param[0] = (long)(TXT_A->EndTxt);
 param[1] = (long)TXT_A;
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
 
/*.............. si la chaine ne finit par par un \r\n .................*/
/*                            le rajouter                               */
str = malloc (len_ref + 4);
if (str==0)                                          return;
strcpy(str, txtref);
if (len_ref>2 && !(str[len_ref-2]==13 && str[len_ref-1]==10))
   {strcpy(str+len_ref, "\r\n");
   }
 param[0] = (long)(str);
 param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
 
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_MEMORY_PASTE, (int*)param, 4, TXT_A);
 TXT_A->State &= ~(EDIT_BLK_NOT_AFTER_PASTE|EDIT_SCRLH_NOT_AFTER_PASTE);
 /*
 param[0] = (long)(TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
 */
 free (str);
}

/*--------------------------- TxtReplace -------------------------------*/
long TxtReplace (int w_ind, char *txtref)
{long param[2];
 TXTED_OB  *TXT_A  = WTXT_A(w_ind);
 param[0] = (long)(txtref);
 param[1] = (long)TXT_A;
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_MEMORY_PASTE,  (int*)param, 4, TXT_A); 
 /*..........................noter la chaine de recherche ..............*/
 if (TxtRep != txtref) 
    {if (TxtRep) free(TxtRep);
     TxtRep      = malloc(strlen(txtref)+1);
     if (TxtRep) strcpy(TxtRep, txtref);
    }
 return 1;
}

/*--------------------------- TxtFind ----------------------------------*/
long TxtFind (int w_ind, char *txtref)
{return RecursTxtFind (w_ind, txtref, 1);
}

/*--------------------------- RecursTxtFind ----------------------------*/
long RecursTxtFind (int w_ind, char *txtref, int recurs)
{long param[2];
 size_t  len_ref   = strlen(txtref);
 char *txttofind   = 0;
 char *endtofind   = 0;
 char  *txtfind    = 0;
 TXTED_OB  *TXT_A  = WTXT_A(w_ind);
 TXT_GFG *ptTxtCfg = WTXT_CFG(w_ind);
 char *deb         = TXT_A->ptTxt;
 
 if ( txtref==0 || *txtref==0 )                             return -1;
 /*............. positionner le curseur de recherche ...................*/
 if (ptTxtCfg->FindPos == -1)
    {ptTxtCfg->FindPos = 0;
    }
 /*.....................................................................*/
 txttofind =   TXT_A->ptTxt + ptTxtCfg->FindPos;
 endtofind =   TXT_A->ptTxt + ptTxtCfg->FindEnd;
 if (ptTxtCfg->FindFlag & FIND_FORWARD)                                      
    {txttofind = Min(txttofind, TXT_A->EndTxt);
     if ( !(ptTxtCfg->FindFlag & FIND_LOOP_BREAK) && txttofind != TXT_A->ptTxt) txttofind++; 
    }   
 
 /*..........................noter la chaine de recherche ..............*/
 if ( txtref != TxtRef)
    {if (TxtRef) free(TxtRef);
     TxtRef      = malloc(len_ref+1);
    }
 if (TxtRef) strcpy(TxtRef, txtref);
 
 /*.....................................................................*/
 txtfind = TxtFindRef(deb, endtofind, txttofind, txtref, ptTxtCfg->FindFlag);
 if (txtfind)
    {if (ptTxtCfg->FindFlag & FIND_FORWARD)
        {ptTxtCfg->FindPos = txtfind - TXT_A->ptTxt + len_ref;         
        }
     else
        {ptTxtCfg->FindPos = txtfind - TXT_A->ptTxt;
        }
     param[0] = (long)(txtfind);
     param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,  (int*)param, 4, TXT_A);
     param[0] = (long)(txtfind + len_ref);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,  (int*)param, 4, TXT_A);
    }
 else if (recurs)
    {if (ptTxtCfg->FindFlag & FIND_LOOP_BREAK) return -1;
     if (ptTxtCfg->FindFlag & FIND_FUNC)
        {ptTxtCfg->FindPos = 0;
        }
     else if ( ptTxtCfg->FindFlag & FIND_LOOP_REVERSE)
        {ptTxtCfg->FindFlag ^= FIND_FORWARD;
         RecursTxtFind (w_ind, txtref, 0); 
        }
     else
        {if (ptTxtCfg->FindFlag & FIND_FORWARD) 
            {ptTxtCfg->FindPos = 0;
             RecursTxtFind (w_ind, txtref, 0); 
            }
         else
            {ptTxtCfg->FindPos = TXT_A->EndTxt - TXT_A->ptTxt - len_ref;
             RecursTxtFind (w_ind, txtref, 0); 
            }
        }
    }
 return  ptTxtCfg->FindFlag;
}

/*--------------------------- TxtFindRef -------------------------------*/
char *TxtFindRef(char *deb, char *end, char *pos, char *ref, long flag)
{char sav = *end;
 *end     = 0;
 if (flag&FIND_FORWARD)
     pos = Strfrwdstr(deb, pos, ref, flag);
 else
     pos = Strbackstr(deb, pos, ref, flag);
 *end    = sav;   
 return pos;
}

/*------------------------ FindFunc ------------------------------------*/
char *FindFunc(char *deb, char *pt, char **finfunc, ERR_C *err)
{char *fst_parenth = 0;  /* premiere parenthese des arg de la fonction */
 char *lst_parenth = 0;  /* derniere parenthese des arg de la fonction */
 char *fst_acco    = 0;  /* premiere accolade du corps de la fonction  */
 if (pt==0) return 0;
 while(*pt) 
  {if      (ISPTBRK(pt)      ) {pt = GotoNextLigne(pt);
                               }
   else if (ISPTDEBCOM(pt)   ) {pt = GotoEndComent(pt+2, err);  
                                if (err->Flag)     return 0;
                               }
   else if (ISPTCPPCOM(pt)   ) {pt = GotoNextLigne(pt);
                               }
   else if (ISDEBSTRING(pt)  ) {pt = GotoEndGuillm(pt+1, err);  
                                if (err->Flag)     return 0;
                               }
   else if (ISPTAPPOST(pt)   ) {pt = GotoEndAppost(pt+1, err);  
                                if (err->Flag)     return 0;
                               }
   else if (*pt == '('       ) 
                             { fst_parenth = pt;
                               lst_parenth = GotoEndParnth(pt+1, err);
                               if (err->Flag)      return 0;
                               fst_acco    = FindFirstAcco(lst_parenth, err);
                               if (err->Flag)      return 0;
                               if (fst_acco)
                                  {char *endfunc;
                                   char *debfunc = FindDebFunc(deb, fst_parenth, &endfunc);
                                   *finfunc      = GotoEndAcolld(fst_acco+1, err);
                                   if (err->Flag)  return 0;
                                   return     DebOfLine(deb, debfunc);
                                  }
                               pt = lst_parenth;
                             }
   else if (*pt == '#'       ) {pt = GotoEndPrePro(pt+1, err);
                                if (err->Flag)     return 0;
                               }
   else pt++;
  }
 return 0;
}

/*---------------------------- FindDebFunc ----------------------------------*/
/* ACTION: recule de la premiere parenthese jusqu'au premier  caractere du   */
/*         nom de la fonction. Au passage fourni le dernier caractere du nom */
/*         finfunc.                                                          */
char *FindDebFunc(char *deb, char *fstparenth, char**finfunc)
{char *pt      = fstparenth;
 *finfunc      = 0;
 while (pt>deb)
  {pt--;
   if      (*finfunc==0 &&  ISVARNAME(pt))   *finfunc = pt+1;
   else if (*finfunc    && !ISVARNAME(pt))       return pt+1;
  }
 return 0;
}

/*----------------------- FindFirstAcco -------------------------------------*/
/* ACTION: cette fonction scane le texte entre la fin de la derniere parenth-*/
/*         ese du texte, et la premiere accolade de la fonction. Si un       */
/*         caractere autre qu'un CR LF ou espace ou commentaire est trouve,  */
/*         c'est que la parenthese fermante n'est pas celle d'une definition */
/*         de fonction. Cette propriete n'est bien sur valable que pour les  */
/*         fonction dont les parametres d'entree sont entre parentheses.     */
/*         L'ancienne faon d'ecrire les fonctions C avec les parametres     */
/*         indiques entre la derniere parenthese et la premiere accolade     */
/*         n'est pas supporte. (trop lourde a gerer)                        */
char *FindFirstAcco(char *pt, ERR_C *err)
{int list_ini = 0;    /* mis  un quand on rencontre une liste d'initialisation */
 while(*pt)
  {if      (ISPTEOL(pt) || *pt==' ' || *pt=='\t') pt++;
   else if (ISPTDEBCOM(pt)         ) {pt = GotoEndComent(pt+2, err);
                                      if (err->Flag) return 0;
                                     }
   else if (ISPTCPPCOM(pt)         ) {pt = GotoNextLigne(pt);}
   else if (*pt == 'c'             && 
            strncmp(pt,"const",5) == 0
           )                         {pt += 5;
                                     }
   else if (*pt == '#'             ) {pt = GotoEndPrePro(pt+1, err);
                                      if (err->Flag) return 0;
                                     }
   else if (*pt ==',' && list_ini  ) {pt = GotoEndBConst(pt+1, err);
                                      list_ini++;
                                      if (err->Flag) return 0;
                                     }
   else if (*pt ==':'              ) {pt = GotoEndBConst(pt+1, err);
                                      list_ini = 1;
                                      if (err->Flag) return 0;
                                     }
   else if (*pt == '{'             ) return pt;
   else                              return 0;
  }
 return 0;
}

/*------------------------ GotoEndBConst ------------------------------------*/
/* ACTION: recherche la fin de la chaine suivante ": xxxxxx()"               */
/*         retourne un message d'erreur si pas trouve!!!                    */
/*         cette routine permet de reperer et sauter les listes              */
/*         d'initialisation telles que celles trouves dans les              */
/*         constructeurs en C++                                              */

char *GotoEndBConst(char *pt, ERR_C *err)
{int deb_parnt   = 0;
 int end_parnt   = 0;
 char *pt_ini    = pt;
 /*................. rechercher premiere parenthse ..................*/
 while (*pt)
       {if      (ISPTBRK(pt)    ) {pt = GotoNextLigne(pt);}
        else if (ISPTEOL(pt)    ) {pt = GotoNextLigne(pt);}
        else if (ISPTDEBCOM(pt) ) {pt = GotoEndComent(pt+2, err);
                                   if (err->Flag) return pt;
                                  }
        else if (ISPTCPPCOM(pt) ) {pt = GotoNextLigne(pt);}
        else if (*pt=='\('      ) {deb_parnt++;
                                   pt++;
                                   break;
                                  }
        else                      {pt++;}
       }
 if (deb_parnt==0){ err->Flag  = DEB_BCONST_NOT_FIND;
                    err->pt    = pt_ini;
                    return       pt;
                  }
 /*................. rechercher deuxime parenthse ..................*/
 pt_ini    = pt;
 while (*pt)
       {if      (ISPTBRK(pt)    ) {pt = GotoNextLigne(pt);}
        else if (ISPTEOL(pt)    ) {pt = GotoNextLigne(pt);}
        else if (ISPTDEBCOM(pt) ) {pt = GotoEndComent(pt+2, err);
                                   if (err->Flag) return pt;
                                  }
        else if (ISPTCPPCOM(pt) ) {pt = GotoNextLigne(pt);}
        else if (*pt=='\('      ) {deb_parnt++; pt++;}
        else if (*pt=='\)'      ) {deb_parnt--; pt++;
                                   if (deb_parnt==0) 
                                      {end_parnt = 1;   /* trouve !!! */
                                       break;
                                      }
                                  }
        else                      {pt++;}
       }
 if (end_parnt==0){ err->Flag  = END_BCONST_NOT_FIND;
                    err->pt    = pt_ini;
                  }
 return pt;
}

/*------------------------ GotoEndPrePro ------------------------------------*/
char *GotoEndPrePro(char *pt, ERR_C *err)
{
 while (*pt)
       {if      (ISPTBRK(pt)    ) {pt = GotoNextLigne(pt);}
        else if (ISPTEOL(pt)    ) {pt = GotoNextLigne(pt); break;}
        else if (ISPTDEBCOM(pt) ) {pt = GotoEndComent(pt+2, err);
                                   if (err->Flag) return pt;
                                  }
        else if (ISPTCPPCOM(pt) ) {pt = GotoNextLigne(pt);}
        else                      {pt++;}
       }
 return pt;
}

/*------------------------ GotoEndParnth ------------------------------------*/
char *GotoEndParnth(char *pt, ERR_C *err)
{int nparnt   = 1;
 char *pt_ini = pt;
 while (nparnt && *pt)
       {if      (ISPTBRK(pt)    ) {pt  = GotoNextLigne(pt);
                                  }
        else if (ISPTDEBCOM(pt) ) {pt  = GotoEndComent(pt+2, err);
                                   if (err->Flag) return pt;
                                  }
        else if (ISPTCPPCOM(pt) ) {pt  = GotoNextLigne(pt);}
        else if (ISPTAPPOST(pt) ) {pt  = GotoEndAppost(pt+1, err);
                                   if (err->Flag) return pt; 
                                  }
        else if (ISDEBSTRING(pt) ){pt  = GotoEndGuillm(pt+1, err);
                                   if (err->Flag) return pt;
                                  }
        else if (*pt=='\('      ) {nparnt++; pt++;}
        else if (*pt=='\)'      ) {nparnt--; pt++;}
        else                      {pt++;}
       }
 if (nparnt) {err->Flag  = PARNTH_END_NOT_FIND;
              err->pt    = pt_ini;
             }
 return pt;
}

/*------------------------ GotoEndAcolld ------------------------------------*/
char *GotoEndAcolld(char *pt, ERR_C *err)
{int nacoll   = 1;
 char *pt_ini = pt;
 while (nacoll && *pt)
       {if      (ISPTBRK(pt)    ) {pt  = GotoNextLigne(pt);}
        else if (ISPTDEBCOM(pt) ) {pt  = GotoEndComent(pt+2, err);
                                   if (err->Flag) return pt;
                                  }
        else if (ISPTCPPCOM(pt) ) {pt  = GotoNextLigne(pt);}
        
        else if (ISPTAPPOST(pt) ) {pt  = GotoEndAppost(pt+1, err);
                                   if (err->Flag) return pt;
                                  } 
        else if (ISDEBSTRING(pt) ){pt  = GotoEndGuillm(pt+1, err);
                                   if (err->Flag) return pt;
                                  }
        else if (*pt=='{'       ) {nacoll++; pt++;}
        else if (*pt=='}'       ) {nacoll--; pt++;}
        else                      {pt++;}
       }
 if (nacoll) {err->Flag  = ACCO_END_NOT_FIND;
              err->pt    = pt_ini;
             }
 return pt;
}

/*------------------------ GotoEndComent -----------------------------------*/
char *GotoEndComent(char *pt, ERR_C *err)
{int ncom     = 1;
 char *pt_ini = pt;
 while (ncom && *pt)
       {if      (ISPTBRK(pt)    ) {pt  = GotoNextLigne(pt);}
        else if (ISPTENDCOM(pt) ) {ncom--; pt +=2;}
        else if (ISPTDEBCOM(pt) ) {ncom++; pt +=2;}
        /*else if (ISPTCPPCOM(pt) ) {pt  = GotoNextLigne(pt);}*/
        else                      {pt++;}
       }
 if (ncom){ err->Flag  = COMMENT_END_NOT_FIND;
            err->pt    = pt_ini;
          }
 return pt;
}

/*---------------------- GotoEndGuillm --------------------------------------*/
char *GotoEndGuillm(char *pt, ERR_C *err)
{char *pt_ini = pt;
 while (*pt)
       {if      (ISPTBRK(pt)    ) {pt  = GotoNextLigne(pt);}
        else if (ISPTESCAPE(pt) ) {pt += 2;}
        else if (ISENDSTRING(pt) ){pt++; break;}
        else                      {pt++;}
       }
 if (*pt==0){ err->Flag  = GUILLM_END_NOT_FIND;
              err->pt    = pt_ini;
            }

 return pt;
}
/*---------------------- GotoEndAppost --------------------------------------*/
char *GotoEndAppost(char *pt, ERR_C *err)
{char *pt_ini = pt;
 while (*pt)
       {if      (ISPTBRK(pt)    ) {pt  = GotoNextLigne(pt);}
        else if (ISPTESCAPE(pt) ) {pt += 2;}
        else if (ISPTAPPOST(pt) ) {pt++; break;}
        else                      {pt++;}
       }
 if (*pt==0){ err->Flag  = APPOST_END_NOT_FIND;
              err->pt    = pt_ini;
            }

 return pt;
}

/*------------------------ GotoReverseFirstComent ---------------------------*/
char *GotoReverseFirstComent(char *deb, char *pt, ERR_C *err)
{char *pt_ini = pt;
 int     ncom = 1;
 while(ncom && pt>deb)
  {if      (ISPTAFTERDEBCOM(deb,pt)) {ncom--; pt -= 2;}
   else if (ISPTAFTERDEBCOM(deb,pt)) {ncom++; pt -= 2;}
   else                               pt--;
  }
 if (ncom){ err->Flag  = COMMENT_DEB_NOT_FIND;
            err->pt    = pt_ini;
          }
 return pt;
}
/*------------------------ GotoReverseFirstParnth ---------------------------*/
char *GotoReverseFirstParnth(char *deb, char *pt, ERR_C *err)
{char *pt_ini = pt;
 int   nparnt = 1;
 while(nparnt && pt>deb)
  {if      ( ISPTAFTERENDCOM(deb, pt) )  {pt = GotoReverseFirstComent(deb, pt-2, err);
                                          if (err->Flag) return pt;
                                         }
   else if ( ISPTAFTERAPPOST(deb, pt) )  {pt = GotoReverseFirstAppost(deb, pt-1, err);
                                          if (err->Flag) return pt;
                                         }
   else if ( ISPTAFTERENDSTR(deb, pt) )  {pt = GotoReverseFirstGuillm(deb, pt-1, err);
                                          if (err->Flag) return pt;
                                         }
   else if ( pt[-1] == '('            )  {nparnt--; pt --;}
   else if ( pt[-1] == ')'            )  {nparnt++; pt --;}
   else                                   pt--;
  }
 if (nparnt){ err->Flag  = PARNTH_DEB_NOT_FIND;
              err->pt    = pt_ini;
            }
 return pt;
}
/*------------------------ GotoReverseFirstGuillm ---------------------------*/
char *GotoReverseFirstGuillm(char *deb, char *pt, ERR_C *err)
{char *pt_ini = pt;
 while(pt>deb)
  {if ( ISPTAFTERDEBSTR(deb, pt) ) {pt--; break;}
   else                             pt--;
  }
 if (pt==deb){ err->Flag  = GUILLM_DEB_NOT_FIND;
               err->pt    = pt_ini;
             }
 return pt;
}
/*------------------------ GotoReverseFirstAppost ---------------------------*/
char *GotoReverseFirstAppost(char *deb, char *pt, ERR_C *err)
{char *pt_ini = pt;
 while(pt>deb)
  {if      ( ISPTAFTERENDCOM(deb, pt)                 ) {pt  = GotoReverseFirstComent(deb, pt-2, err);
                                                         if (err->Flag) return pt;
                                                        }
   else if ( pt[-1]=='\'' && pt-1>deb && pt[-2]=='\\' )  pt -= 2;
   else if ( ISPTAFTERAPPOST(deb, pt)                 ) {pt--; break;}
   else                                                  pt--;
  }
 if (pt==deb){ err->Flag  = APPOST_DEB_NOT_FIND;
               err->pt    = pt_ini;
             }
 return pt;
}
/*------------------------GotoReverseFirstAcolld  ---------------------------*/
char *GotoReverseFirstAcolld(char *deb, char *pt, ERR_C *err)
{char *pt_ini = pt;
 int  naccoll = 1;
 while(naccoll && pt>deb)
  {if      ( ISPTAFTERENDCOM(deb, pt) )  {pt = GotoReverseFirstComent(deb, pt-2, err);
                                          if (err->Flag) return pt;
                                         }
   else if ( pt[-1] == ')'            )  {pt = GotoReverseFirstParnth(deb, pt-1, err);
                                          if (err->Flag) return pt;
                                         }
   else if ( ISPTAFTERAPPOST(deb, pt) )  {pt = GotoReverseFirstAppost(deb, pt-1, err);
                                          if (err->Flag) return pt;
                                         }
   else if ( ISPTAFTERENDSTR(deb, pt) )  {pt = GotoReverseFirstGuillm(deb, pt-1, err);
                                          if (err->Flag) return pt;
                                         }
   else if (  pt[-1] == '}'           ) {pt--; naccoll++;}
   else if (  pt[-1] == '{'           ) {pt--; naccoll--;}
   else                                  pt--; 
  }
 if (naccoll){ err->Flag  = ACCO_DEB_NOT_FIND;
               err->pt    = pt_ini;
             }
 return pt;
}

/*------------------------ Strfrwdstr ----------------------------------*/
char *Strfrwdstr(char *deb, char *pos, char *ref, long flag)
{register       char *pt = pos-1;  /* -1 car incremente  en entrant     */
 char              *find = 0;
 char                 ok;
 register size_t len_ref = strlen(ref);
 register char sav;
 if (pt==0) return 0;
 while(pt[1])  /*  pt[1] car incremente en entree */
  {pt++;
   sav         = pt[len_ref];
   pt[len_ref] = 0;
   ok          = TRUE;
   if (flag & FIND_WORD)
      {if (isalnum(sav)                 ||
           (pt>deb && isalnum(pt[-1]))  ||
           pt[-1] == '_'
          ) ok = FALSE;
      }
   if (ok)
      {if (flag & FIND_MINMAJ)
          {if (strcmpi(pt,ref)==0) 
              {find = pt;
               pt[len_ref] = sav;
               break;           /* met fin  la routine */
              }
          }
       else 
          {if (strcmp(pt,ref)==0) 
              {find = pt;
               pt[len_ref] = sav;
               break;           /* met fin  la routine */
              }
          }
      }
   pt[len_ref] = sav;
  }
 return find;
}

/*------------------------ Strbackstr ----------------------------------*/
char *Strbackstr(char *deb, char *pos, char *ref, long flag)
{register       char *pt = pos-1;
 char              *find = 0;
 char                 ok;
 register size_t len_ref = strlen(ref);
 register char sav;
 while(pt>=deb)
  {sav         = pt[len_ref];
   pt[len_ref] = 0;
   ok          = TRUE;
   if (flag & FIND_WORD)
      {if (isalnum(sav)                 ||
           (pt>deb && isalnum(pt[-1]))  ||
           pt[-1] == '_'
          ) ok = FALSE;
      }
   if (ok)
      {if (flag & FIND_MINMAJ)
          {if (strcmpi(pt,ref)==0)
              {find = pt;
               deb  = pt-1;         /* met fin  la routine */
              }
          }
       else
          {if (strcmp(pt,ref)==0) 
              {find = pt;
               deb  = pt-1;         /* met fin  la routine */
              }
          }
      }
   pt[len_ref] = sav;
   pt--;
  }
 return find;
}

/*-------------------------------- TesteFermantOuvrant -----------------------*/
int TesteFermantOuvrant(int w_ind, char *pt, TXTED_OB  *TXT_A)
{ERR_C err={0,0};
 char *deb_mark;
 char *end_mark;
 int   test_typ = 0;

 /*........... type de test en fonction du caractere .........................*/
 /*                     pointe par le curseur                                 */
 if      (ISPTDEBCOM(pt))                      test_typ =  TXT_MARK_COMM;
 else if (ISPTAFTERDEBCOM(TXT_A->ptTxt,pt))   {test_typ =  TXT_MARK_COMM; pt -= 2;}
 else if (ISPTENDCOM(pt))                      test_typ = -TXT_MARK_COMM;
 else if (ISPTAFTERENDCOM(TXT_A->ptTxt,pt))   {test_typ = -TXT_MARK_COMM; pt -= 2;}
 else if (pt>TXT_A->ptTxt && ISDEBSTRING(pt))  test_typ =  TXT_MARK_STR;
 else if (ISPTAFTERENDSTR(TXT_A->ptTxt, pt))  {test_typ = -TXT_MARK_STR;  pt--;}
 else if (*pt=='{')                            test_typ =  TXT_MARK_ACCO;
 else if (pt>TXT_A->ptTxt && pt[-1]=='{')     {test_typ =  TXT_MARK_ACCO; pt--;}
 else if (*pt=='}')                            test_typ = -TXT_MARK_ACCO;
 else if (pt>TXT_A->ptTxt && pt[-1]=='}')     {test_typ = -TXT_MARK_ACCO; pt--;}
 else if (*pt=='(')                            test_typ =  TXT_MARK_PARH;
 else if (pt>TXT_A->ptTxt && pt[-1]=='(')     {test_typ =  TXT_MARK_PARH; pt--;}
 else if (*pt==')')                            test_typ = -TXT_MARK_PARH;
 else if (pt>TXT_A->ptTxt && pt[-1]==')')     {test_typ = -TXT_MARK_PARH; pt--;}
 else if (*pt=='\n' || *pt=='\r')              test_typ =  TXT_MARK_EOL;

 if (test_typ == 0) return 0;
 /*............... chercher l'autre marque (fermante ou ouvrante) ............*/
 if (test_typ >  0)  
    {deb_mark = pt;
     switch(test_typ)
       { case  TXT_MARK_COMM: end_mark =  GotoEndComent(pt+1, &err); break;
         case  TXT_MARK_ACCO: end_mark =  GotoEndAcolld(pt+1, &err); break;
         case  TXT_MARK_PARH: end_mark =  GotoEndParnth(pt+1, &err); break;
         case  TXT_MARK_STR:  end_mark =  GotoEndGuillm(pt+1, &err); break;
         case  TXT_MARK_EOL:  deb_mark =  DebOfLine(TXT_A->ptTxt,pt);
                              end_mark =  NextLine(pt); err.Flag=0;  break;
       }
    }
 else     
    {end_mark = pt+1;
     switch(test_typ)
       { case -TXT_MARK_COMM: deb_mark =  GotoReverseFirstComent(TXT_A->ptTxt, pt, &err); end_mark++; break;
         case -TXT_MARK_ACCO: deb_mark =  GotoReverseFirstAcolld(TXT_A->ptTxt, pt, &err);   break;
         case -TXT_MARK_PARH: deb_mark =  GotoReverseFirstParnth(TXT_A->ptTxt, pt, &err);   break;
         case -TXT_MARK_STR:  deb_mark =  GotoReverseFirstGuillm(TXT_A->ptTxt, pt, &err);   break;
       }
    }
 /*.............. si erreur afficher message d'erreur ........................*/
 if (err.Flag)
    {switch(test_typ)
       { /*............ message du ressource .................*/
         case  TXT_MARK_COMM: pt =  TxtPtStrMess[ALR_COMM_END];  break;
         case  TXT_MARK_ACCO: pt =  TxtPtStrMess[ALR_ACCO_END];  break;
         case  TXT_MARK_PARH: pt =  TxtPtStrMess[ALR_PRTH_END];  break;
         case  TXT_MARK_STR:  pt =  TxtPtStrMess[ALR_STR_END];   break;
         case -TXT_MARK_COMM: pt =  TxtPtStrMess[ALR_COMM_DEB];  break;
         case -TXT_MARK_ACCO: pt =  TxtPtStrMess[ALR_ACCO_DEB];  break;
         case -TXT_MARK_PARH: pt =  TxtPtStrMess[ALR_PRTH_DEB];  break;
         case -TXT_MARK_STR:  pt =  TxtPtStrMess[ALR_STR_DEB];   break;
       }
     form_alert(1,pt);
    }
 /*.............. si pas d'erreur marquer le bloc ............................*/
 else
    {long  param[2];
     param[0] = (long)(deb_mark);
     param[1] = (long)TXT_A;       /*  W_G H_G  adresse de l'editeur cible       */
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,   (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB, (int*)param, 4, TXT_A);
     param[0] = (long)(end_mark);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END, (int*)param, 4, TXT_A);
   }
 return 1;
}

/*------------------ StrMenuToShortCut ---------------------------------*/
int StrMenuToShortCut(char *txt, int *key, int *ksp)
{char *pt         = txt + strlen(txt); 
 char pt_car[64];
 char pt_fst_key[64];
 char pt_scd_key[64];
 *ksp    = 0;
 *key    = 0;
 /*........... extraire les mots en partant de la fin .........*/
 pt = FromEndGetArg(txt, pt, pt_car);
 pt = FromEndGetArg(txt, pt, pt_fst_key);
 pt = FromEndGetArg(txt, pt, pt_scd_key);
 /*........... analyse des resultats ..........................*/
 if      (strcmp(pt_car, "HELP")==0)   *key = -98;
 else if (strcmp(pt_car, "UNDO")==0)   *key = -97;
 else if (strcmp(pt_car, "HOME")==0)   *key = -71;
 else if (strcmp(pt_car, "INSRT")==0)  *key = -82;
 else if (strcmp(pt_car, "F1")==0)     *key = -59;
 else if (strcmp(pt_car, "F2")==0)     *key = -60;
 else if (strcmp(pt_car, "F3")==0)     *key = -61;
 else if (strcmp(pt_car, "F4")==0)     *key = -62;
 else if (strcmp(pt_car, "F5")==0)     *key = -63;
 else if (strcmp(pt_car, "F6")==0)     *key = -64;
 else if (strcmp(pt_car, "F7")==0)     *key = -65;
 else if (strcmp(pt_car, "F8")==0)     *key = -66;
 else if (strcmp(pt_car, "F9")==0)     *key = -67;
 else if (strcmp(pt_car, "F10")==0)    *key = -68;
 else if (strcmp(pt_car, "DEL")==0)    *key = ''; 
 else if (strcmp(pt_car, "BACK")==0)   *key = '';
 else if (strcmp(pt_car, "SPACE")==0)  *key = ' ';
 else if (strcmp(pt_car, "TAB")==0)    *key = 9;
 else if (strcmp(pt_car, "RETURN")==0) *key = 13;
 else if (strcmp(pt_car, "ESC")==0)    *key = 27;
 else                                  *key = (*pt_car);
 
 if (*pt_fst_key)
    {if      (strcmp(pt_fst_key, "CTRL")==0)  *ksp |= K_CTRL;
     else if (strcmp(pt_fst_key, "ALT")==0)   *ksp |= K_ALT;
     else if (strcmp(pt_fst_key, "SHIFT")==0) *ksp |= K_LRSHIFT;
    }
 if (*pt_scd_key)
    {if      (strcmp(pt_scd_key, "CTRL")==0)  *ksp |= K_CTRL;
     else if (strcmp(pt_scd_key, "ALT")==0)   *ksp |= K_ALT;
     else if (strcmp(pt_scd_key, "SHIFT")==0) *ksp |= K_LRSHIFT;
    }
 
 return 1;
}

/*----------------------- FromEndGetArg -----------------------------------*/
char *FromEndGetArg(char *txt, char *pt, char *str_cpy)
{char *pt_end;
 char sav_car;
 
 *str_cpy = 0;
 if (pt[-1]==' ')  while(pt>txt && pt[-1]==' ') pt--;
 pt_end = pt;
 while(pt>txt && pt[-1] != ' ') pt--;
 if (pt_end>pt)
    {sav_car = *pt_end;
     *pt_end = 0;
     strcpy(str_cpy, pt);
     *pt_end = sav_car;
    }
 return pt;
}

/*--------------------------- NextLine ----------------------------------*/
char *NextLine(char *pt)
{while (*pt &&  *pt != 13 && *pt != 10)  pt++;
 if      (*pt=='\r' && pt[1]=='\n') pt += 2;
 else if (*pt)                      pt += 1;
 /* while (*pt && (*pt == 13 || *pt == 10)) pt++; */
 return pt;
}

/*--------------------------- EndOfLine ---------------------------------*/
char *EndOfLine(char *pt)
{while (*pt &&  *pt != 13 && *pt != 10)  pt++;
return pt;
}

/*---------------------------- DebOfLine ------------------------------------*/
char *DebOfLine(char *deb, char *pt)
{while (pt>deb)
  {pt--;
   if (ISPTEOL(pt)) return pt+1; 
  }
 return pt;
}

/*--------------------------- SetTxtChgIndicator --------------------------*/
int SetTxtChgIndicator(int w_ind, int state)
{OBJECT *object    = GETWINDTREE(w_ind);
 if (state)
    {object[EZ_TXT_CHG_INDIC].ob_flags &= ~HIDETREE;
     SendObjectRedraw(GETGEMHAND(w_ind), object, EZ_TXT_CHG_INDIC);
     *Windtab[w_ind].titre = '*';
    }
 else
    {*Windtab[w_ind].titre = ' ';
     if (Windtab[w_ind].w_attr & NAME) wind_set( GETGEMHAND(w_ind), WF_NAME, Windtab[w_ind].titre); 
     object[EZ_TXT_CHG_INDIC].ob_flags |= HIDETREE;
     Wobjc_draw(w_ind, object, EZ_TXT_CHG_INDIC, 1, 0);
    }
 if (Windtab[w_ind].w_attr & NAME) wind_set( GETGEMHAND(w_ind), WF_NAME, Windtab[w_ind].titre); 
 return 1;
}

/*--------------------------- IsKeyShortCut -------------------------------*/
int IsKeyShortCut(int ksp, int key)
{int nb_short_cut    = (int)(sizeof(ShortCut)/sizeof(SHORT_CUT));
 int car;
 int i;
 int ksp_ok;
 if (key&0xFF00)
    {key = key>>8;
     switch(key)
        {case 98:   /* "HELP" */ 
         case 97:   /* "UNDO" */ 
         case 71:   /* "HOME" */ 
         case 82:   /* "INS"  */ 
         case 59:   /* "F1"   */ 
         case 60:   /* "F2"   */ 
         case 61:   /* "F3"   */ 
         case 62:   /* "F4"   */ 
         case 63:   /* "F5"   */ 
         case 64:   /* "F6"   */ 
         case 65:   /* "F7"   */ 
         case 66:   /* "F8"   */ 
         case 67:   /* "F9"   */ 
         case 68:   /* "F10"  */ 
              car = -(key);
              break;
        }
    } /* endif if (key&0xFF00)  */
 else
    {car = key;
    }
 if (car==0) return 0;
 for (i=0; i<nb_short_cut; i++)
     {
      if      (ShortCut[i].ksp == K_CTRL_SHIFT && (ksp&K_CTRL))  ksp_ok = ksp & K_LRSHIFT;
      else if (ShortCut[i].ksp == K_LRSHIFT)                     ksp_ok = ksp & K_LRSHIFT;
      else if (ShortCut[i].ksp == ksp)                           ksp_ok = 1;
      else                                                       ksp_ok = 0;
      if (ShortCut[i].key == car && ksp_ok) return ShortCut[i].Func;
     }
 return 0;
}

/*------------------------------ WindTxtWind ----------------------------*/
CALLBACK WindTxtWind(int w_ind, EVNT_O *Evnt)
{/*.............. les variables locales suivantes sont souvent ..........*/
 /*           utiles pour toutes les fonctions de fenetre EZGEM pour:    */
 /*......... structure attachee  chaque ressource en fenetre........... */
 DLG_VAR *dlg     = &Windtab[w_ind].DlgVar;  
 /*.........pointeur sur 1er objet ressource en fenetre................. */
 OBJECT *object   = GETWINDTREE(w_ind);  /* recuperer pointeur ressource */
 /*.................... recuperer handles fenetres ......................*/
 int w_h          = GETGEMHAND(w_ind);  /* celui GEM de notre fenetre    */
 int wh_top;          
 wind_get( 0, WF_TOP, &wh_top);          /* celui de fenetre avant plan */
 
 /*...................TOUCHE CLAVIER APPUYEE (MU_KEYBD).................*/
 /* Dans le cadre d'une ressource en fenetre j'ai cree une fonction qui */
 /* s'occupe de gerer tout ce qui a un rapport avec une touche clavier  */
 /* Notamment l'edition et saisie de texte dans les champs editables et */
 /* les raccourcis clavier.                                             */
 /* Pour une ressource en fenetre il est indispensable que l'evenement  */
 /* MU_KEYBD soit traite avant l'evenement  MU_BUTTON afin de permettre */
 /* un fonctionnement correct des raccourcis clavier. En effet le       */
 /* raccourci clavier d'un objet simule un clic souris sur l'objet.     */
 /* en renvoyant un evenement MU_BUTTON                                 */

 if (Evnt->evnt & MU_KEYBD && w_h==wh_top)
    {Xform_keybd(w_ind, Evnt);
    }
    
 /*.......................... BOUTONS SOURIS ...........................*/
 /* Dans le cadre d'une ressource en fenetre j'ai cree une fonction qui */
 /* s'occupe de gerer tout ce qui a un rapport avec un appui sur un     */
 /* bouton de souris.                                                   */
 /* Notamment l'appui sur un bouton de la ressource, la selection du    */
 /* texte dans les champs editables, et le placement du curseur de      */
 /* texte dans les champs editables.                                    */
    
 if (Evnt->evnt & MU_BUTTON)
    {int ob_ret = Xform_button(w_ind, Evnt);  
     if (ob_ret>-1)
        {switch(ob_ret)
           {case EZ_TXT_COLOR_SYNT:              
              ExeTxtFunc(w_ind, PRM_COLOR_FUNC_ON);
              break;
            case EZ_TXT_CHG_INDIC:
              object[EZ_TXT_CHG_INDIC].ob_state &= ~SELECTED;
              ExeTxtFunc(w_ind, TXT_SAUVER);
              break; 
           } /* endswitch(ob_ret) */    
        }  /* endif objet selectable cliqu  */ 
    } /* endif MU_BUTTON  et fenetre au premier plan */
    
 /*.......................... TIMER ..................................*/
 /* Dans le cadre d'une ressource en fenetre la fonction: Xform_timer */
 /* s'occupe de tout ce que doit gerer le timer notamment le clignote */
 /* ment du curseur texte dans les champs editables                   */
 if (Evnt->evnt & MU_TIMER )  
    {if (w_h==wh_top) Xform_timer(w_ind, Evnt);
    }
    
 /*.......................... MU_MOVE ....................................*/
 /* L'vnement MU_MOVE se manifeste chaque fois que la souris a modifie  */
 /* sa position. L'appel  la fonction: Xform_mu_move() permet de traiter */
 /* tout ce qui concerne un mouvement souris au dessus d'une ressource en */
 /* fenetre et le mouvement de la souris au dessus des bords de la        */
 /* fenetre                                                               */
 if (Evnt->evnt & MU_MOVE)   /*  (EZGEM evenement)   */
    {Xform_mu_move(w_ind, Evnt);
    }      
    
 /*..........................Rpondre aux messages MU_MESAG ..............*/
 /* L'vnement MU_MESAG se manifeste chaque fois qu'EAZY_GEM demande    */
 /* la fonction de fenetre de rpondre  un message. ci_dessous nous      */
 /* allons rpondre aux messages concernant notre fenetre.                */
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT: 
             /***********************************************************/
             /*.................... WM_CONSTRUCT (EZGEM message)........*/
             /* Ce message est transmis avant la creation et ouverture  */
             /* de la fenetre associee  notre procedure de fenetre.    */
             /* c'est  cet endroit que vous devez initialiser tout ce  */
             /* qui concerne votre fenetre: Memoire, chargement d'un    */
             /* fichier ressource, modification des dimensions fenetre  */
             /* avant ouverture, declaration des Bulles d'aide associees*/
             /*  cette fenetre, titre de la fenetre.....etc            */
             /* eventuellement si pas deja fait avant: ouverture d'une  */
             /* Station de travail VDI autre que celle d'EAZY_GEM.      */
             /* EAZY_GEM vous laisse toute liberte pour faire ce que    */
             /* vous voulez:                                            */
             /* Vous pouvez tres bien charger votre fichier ressource  */
             /* cet endroit ou avant dans l'application..               */
             /* Lors de ce message il est donn dans:                   */
             /*                  Evnt->pipe[X_B]                        */
             /*                  Evnt->pipe[Y_B]                        */
             /*                  Evnt->pipe[W_B]                        */
             /*                  Evnt->pipe[H_B]                        */
             /*                               les dim exterieures  maxi */
             /* possibles d'ouverture de la fenetre sur l'ecran.        */
             /* c'est par defaut ces dimensions qui sont choisies pour  */
             /* ouvrir une fenetre.Si on veut d'autres dimensions c'est */
             /* ces valeurs qu'il faudra modifier.                      */
             /*                                                         */
             /* REPONDRE AU MESSAGE WM_CONTRUCT:                        */
             /* Il est possible de repondre au message WM_CONSTRUCT     */
             /* de deux manieres equivalentes au point de vue resultat: */
             /* Soit en faisant  Evnt->evnt = WM_ABORT; (ou WM_STANDBY) */
             /* Soit en faisant  return WM_ABORT;       (ou WM_STANDBY) */
             /*                                                         */
             /* Vous pouvez interrompre le processus de creation de la  */
             /* fenetre en retournant le message: WM_ABORT par exemple  */
             /* vous n'avez pas pu reserver toute la memoire souhaitable*/
             /* ou vous n'avez pas trouve un fichier indispensable      */
             /* ou pour toute autre raison liee a votre application.etc.*/
             /*                                                         */
             /* Vous pouvez empecher l'ouverture de la fenetre et donc  */
             /* permettre juste sa creation en retournant le message:   */
             /* WM_STANDBY. Pour ouvrir et afficher la fenetre ulterieu-*/
             /* ment il faudra utiliser la fonction: OpenWindow         */
             /* Si vous ne retournez pas ce message la fenetre s'ouvre  */
             /* dans la foulee (cas le plus utile).                     */
             /*                                                         */
             /* Pour les ressources en fenetre j'ai cree une fonction   */
             /* s'occupe de tout ce qu'il y a a faire  ce sujet        */
             /* la voici:  Xform_construct(w_ind, Evnt);                */
            {
             GRECT *grect_ini = (GRECT*)(Windtab[w_ind].UserPtr);
             GRECT *grect;
             int w_desk  ;
             int w_last  ;
             OBJECT *object ;
             void *adr_rsc = LoadAppliRsc( "EZ_TXT.RSC", NO_SCALE);
             if (WindDialogConstruct(w_ind, adr_rsc, 0, RSC_DIAL, Evnt ) == WM_ABORT
                )        
                                                                return WM_ABORT;
              
              grect    = (GRECT*)&Evnt->pipe[X_B];
              w_desk   = IsWindExist(W_TXT_DESK);
              w_last   = GetDerTXT_Wind(w_ind);
              /*.............. recuperer adresse 1 er objet ..................*/
              /*        (n'est valide qu'apres integration du RSC donc on     */
              /*         ne peut pas se servir de celui deja recupere au      */
              /*         debut de la fonction, car le ressource n'est pas     */
              /*         encore integr)                                      */
              object   = GETWINDTREE(w_ind); 
              /*............ recuperer pointeur de l'editeur de texte ........*/
              /*             cree par la SCROLL_EDIT                          */
              WTXT_A(w_ind)                = EZ_ED_GetTxtEditStruct(object, EZ_TXT_SCLBOX);
              WTXT_A(w_ind)->State        |= EDIT_TAB|EDIT_TAB_VISIBLE;
              /*............ detourner la fonction de formatage de ligne .....*/
              WTXT_A(w_ind)->InitTabLgnCtx = EZeditInitTabLgnCtx;
              /*....... reserver la place de la memoire de configuration .....*/
              WTXT_CFG(w_ind)              = malloc(sizeof(TXT_GFG));
              /*........... si echec de la creation de l'editeur ............*/
              /*            quitter le processus de creation de              */
              /*                        la fenetre                           */
              if (WTXT_A(w_ind) == 0 || WTXT_CFG(w_ind) == 0)
                 {Xform_Destruct(w_ind, Evnt); /* desintegrer ressources     */
                  RscFicUnLoad(dlg->AdrRsc);   /* decharger ressource        */
                                                               return WM_ABORT;
                 }
              /*........... noter le pointeur de configuration ...............*/
              /*            dans le parametre optionnel du                    */
              /*            composant d'edition de texte afin                 */
              /*            d'y avoir acces pendant la routine                */
              /*            de redessin de ligne.                             */
              WTXT_A(w_ind)->UsrPrm.PtV    = WTXT_CFG(w_ind);
              
              /*........... coordonnes de fenetre sont ......................*/
              /*       celles la derniere ouverte + ofset , ou sous           */
              /*        la barre d'outil si pas d'autre texte ouvert          */
              if (w_desk != -1) 
                 {grect->g_y = Windtab[w_desk].ExtGrectUse.g_y + Windtab[w_desk].ExtGrectUse.g_h;
                 }
              /*................ si un rectangle est fourni  l'ouverture ....*/
              /*                 adapter la ressource  ce rectangle          */
              /*                n'est possible que si IsCfgLoaded = 1         */
              /*                donc l'update du texte se fait plus loin      */
              if (grect_ini) 
                 {AdjustRscToNewGrectWind(Windtab[w_ind].w_attr, object, grect, grect_ini);
                  *grect =  *grect_ini;
                 }
              else if (w_last>-1)
                 {grect->g_y  = Windtab[w_last].ExtGrectUse.g_y + 10;
                  grect->g_x  = Windtab[w_last].ExtGrectUse.g_x + RSC_PLUS;
                 }
              
              /*.....initialiser la configuration sur celle par defaut ......*/
              *WTXT_CFG(w_ind) = DefTextCfg;
              if ( IsCfgLoaded  ) 
                 {CfgParamToTexte (w_ind, &DefHeadCfg,  (TXT_PRM *)&DefTextCfg, 0);
                  SetScrollBoxParam(object,EZ_TXT_SCLBOX,DefHeadCfg.IntLg,-2,-2,-2, -2, -2, -2,-2,(void*)-2L,-2);
                  UpdateParamTexte(object, EZ_TXT_SCLBOX, WTXT_A(w_ind)); 
                 }
              strcpy( WTXT_CFG(w_ind)->PathTxt,      PathAppli );
              strcpy( WTXT_CFG(w_ind)->PathSavUnder, PathAppli );
              strcpy( WTXT_CFG(w_ind)->PathBlk,      PathAppli );
              /*.... initialiser les voyants de focus et de texte change ....*/
              object[EZ_TXT_COLOR_SYNT].ob_flags |= HIDETREE;
              object[EZ_TXT_ED_CX].ob_flags      |= HIDETREE;
              object[EZ_TXT_ED_CY].ob_flags      |= HIDETREE;
              object[EZ_TXT_FOCUS_LED].ob_state  &= ~SELECTED;
              object[EZ_TXT_CHG_INDIC].ob_flags  |= HIDETREE;   
              /*........... ajuster taille ascensseur .......................*/
              VascHeightAdjust(object, EZ_TXT_SCLBOX, EZ_TXT_VERT_BAR, EZ_TXT_VERT_ASC);
              CurIDDoc = Windtab[w_ind].ident;
              /*........... installer les raccourcis clavier du menu ........*/
              xrsrc_gaddr (R_TREE, WIND_MENU, &object, dlg->AdrRsc);
              InstalleRaccInMenu(object);
             }                 
             break;
             
        case WM_WND_MENU:    
             {int ret=0; 
              OBJECT *menu_tree;
              char   *txt, *pt;
              /*......... si le menu responsable du message ............*/
              /*          est celui de notre fenetre                    */
              if (w_h == Evnt->pipe[WHND])
              /*if (*(long*)&Evnt->pipe[W_G] == (long)object)*/
                 {xrsrc_gaddr (R_TREE, Evnt->pipe[Y_G], &menu_tree, GETWINDRSC(w_ind));
                  txt = ObjcGetTxt(menu_tree, Evnt->pipe[X_G]);
                  pt  = strchr(txt, '|');
                  if (pt[1] != 0)
                     {ret = atoi(pt+1);
                     }
                  Evnt->evnt &= ~MU_MESAG;
                  if (ret) ExeTxtFunc(w_ind, ret);
                 }
             }        
             break;     
             
        case WM_DESTRUCT:       /*  (EZGEM message)   */
             /**************************************************************/
             /*........................ WM_DESTRUCT (EZGEM message)........*/
             /* Ce message est envoy a notre procedure de fenetre avant   */
             /* que le systeme ne la detruise. c'est  cet endroit qu'il   */
             /* convient de desinitialiser tout ce que l'on avait fait     */
             /* auparavant memoire, bulles d'aide, ressources....          */
             /*..................... liberer l'identificateur .............*/
            {int der_wind;
             int ident          = GETWINDIDENT(w_ind); /* identificateur de la fenetre */
             TXTED_OB  *TXT_A   = WTXT_A(w_ind);
             TXT_GFG *ptTxtCfg  = WTXT_CFG(w_ind);
             int wind_index     = IsWindExist(W_EZ_INFO); /* fenetre INDEX         */
             /*........... sauver texte si modifie ?? ..........................*/
             if (FicMustBeSavedOnQuit && ptTxtCfg && TXT_A->State & EDIT_CHG)
                {EZ_ED_SaveTxt(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_SAVE, TXT_A);
                 /*
                 EZ_ED_GraphUpdate(TXT_A);
                 Bsave(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_A->ptTxt, TXT_A->EndTxt - TXT_A->ptTxt);               
                 */                 
                } /* endif (TXT_A && ptTxtCfg && TXT_A->State & EDIT_CHG) */
             /*............. liberer l'identificateur de cette fenetre .........*/
             ReleaseTxtWindIdent(ident, WIND_ID, NB_WDOC, W_FIRST_DOC);
             /*............. effacer ressource et memoire de configuration .....*/
             Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(dlg->AdrRsc);
             free(ptTxtCfg);
             /*............ rechercher la derniere fenetre texte cree ..........*/
             der_wind = GetDerTXT_Wind(w_ind);    
             /*.......... si il reste une fenetre texte ........................*/
             if (der_wind > -1)
                {/*........ noter nouvelle fenetre texte courante ..............*/
                 CurIDDoc      = GETWINDIDENT(der_wind); 
                 /*........ avertir la boite "FIND REPLACE" du  ................*/
                 /*         changement de fenetre texte courante                */
                 if (wind_index >- 1 )
                    {Windtab[wind_index].UserPtr = 0;
                     ExeWindMessage(wind_index, WM_INIT_MARK, 0, 0);
                    }
                }
             else  
                {CurIDDoc       = -1;  /* plus de fenetre texte courante        */
                 if (wind_index != -1 && IsWindOpen(wind_index)) 
                    {ActiveInfoWindow(99); /* pas au top et onglet courant      */
                    }
                 else
                    {EZGemRun = -1;
                    }
                }
            }
             break;
                   
        case WM_TT_ON_OFF:      /*  (EZGEM message)   */
             /**************************************************************/
             /*...................... WM_TT_ON_OFF (EZGEM message).........*/
             /* Ce message est envoy  notre fenetre chaque fois qu'il est*/
             /* demand d'activer ou de desactiver l'affichage des bulles  */
             /* d'aide. Il suffit simplement d'appeler la fonction qui suit*/
             /* pour mettre  jour l'objet representant l'etat actif ou    */
             /* inactif de notre ressource (si il existe)                  */
             /* Cet Objet est un objet type BOXTEXT extended type 25 que   */
             /* vous devez placer sur votre formulaire. Il refletera l'etat*/
             /* actif ou inactif du systeme de bulle d'aide.               */
             SetBulleState(w_h, object);
             break; 
               
        case WM_EXEFUNC:        /*  (EZGEM message)   */
             /**************************************************************/
             /*...................... WM_EXEFUNC .(EZGEM message)..........*/
             /* Ce message est envoy a notre procedure de fenetre chaque  */
             /* fois qu'il est demand d'executer une fonction referencee  */
             /* par un numero de fonction.                                 */
             /* Le message est compose comme suit:                         */
             /* SI  Evnt->pipe[WHND]= RSC_DIAL; le message provient d'une  */
             /*                             ressource.  ET ALORS           */
             /*     Evnt->pipe[X_G] = indice objet declenchant le message  */
             /*     Evnt->pipe[Y_G] = numero de la fonction referencee     */
             /*     *(long*)&Evnt->pipe[W_G] =  adr arbre ou est l'objet   */
             break;         
             
        case WM_TT_GET_TXT:     /*  (EZGEM message)   */
             /**************************************************************/
             /*...................... WM_TT_GET_TXT .(EZGEM message).......*/
             /* Ce message est envoy a notre procedure de fenetre chaque  */
             /* fois que le systeme d'affichage d'une bulle d'aide desire  */
             /* qu'on lui fournisse un texte  afficher.                   */
             /* Ce texte peut etre affiche sur plusieurs lignes en mettant */
             /* comme separateur le signe | .                              */
             /* Exemple:                                                   */
             /* strcpy(sztt_txt,"Premiere ligne|deuxieme ligne|troisieme");*/
             /* Si vous placez une chaine vide "", la bulle d'aide ne sera */
             /* pas affichee.                                              */
             /*  Exemple: strcpy(sztt_txt,"");                             */
             /*                                                            */
             break;        
                      
        case WM_REDRAW:               
             /**************************************************************/
             /*........................ WM_REDRAW (GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* il faut redessiner une partie de la fenetre (par exemple un*/
             /* accessoire qui la recouvrait vient de se fermer, il faut   */
             /* alors retracer la partie de notre fenetre que l'accessoire */
             /* recouvrait. Avant c'etait un veritable enfer, maintenant   */
             /* il vous faut juste appeler la routine: Lister_rectangles   */
             /* qui vous renvoie le message WM_PAINT (voir doc)            */
             /* et vous n'avez plus  vous occuper de savoir comment faire */
             /* notamment pour traiter la liste des rectangles et leur     */
             /* intersection avec notre fenetre.                           */
             /* Dans cet exemple, tout etant sous forme de ressource,      */
             /* EAZY_GEM ne gnre pas de message WM_PAINT, car il n'y a   */
             /* pas de surface client  retracer.                          */
             /* Il faut tout de meme appeler la fonction:                  */
             /*         Lister_rectangles() , afin que la ressource soit   */
             /*         retrace.                                          */
             Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);
             break;    
             
        case WM_BOTTOM:
             /**************************************************************/
             /*........................ (GEM message)......................*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* on lui demande de se mettre au dernier plan. Il convient   */
             /* de le faire avec la fonction: wind_set(w_h, WF_BOTTOM );   */
             wind_set(w_h, WF_BOTTOM );   
             break;                    
        case WM_TOPPED:
             /**************************************************************/
             /*........................ WM_TOPPED (GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* on lui demande de se mettre en premier plan. Il convient   */
             /* de le faire avec la fonction: wind_set(w_h, WF_TOP );      */
             /* wind_set(w_h, WF_TOP );                                    */
             wind_set(Windtab[w_ind].w_h, WF_TOP);
             break;
             
        case WM_CLOSED:
             /*........................ WM_CLOSED (GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre         */
             /* lorsqu'une demande de fermeture de la fenetre est demandee */
             /* si vous voulez detruire completement cette fenetre il faut */
             /* appeler imperativement la fonction: DestroyWindow          */
             /* pour la reouvrir ensuite il vous faudra appeler la         */
             /* fonction:                           CreateWindow           */
             /* sinon il vous faut faire un simple: CloseWindow  et la     */
             /* reouvrir par:                       OpenWindow             */
             /* sans etre oblige de tout reinitialiser                     */
             /* CloseWindow(w_ind);                                        */
             
             /* Ici je mets la variable: EZGemRun  zero, de faon  ce    */
             /* que le programme s'arrete sans demande de confirmation.    */
             if (ExeTxtFunc(w_ind, TXT_CLOSED) !=1)  DestroyWindow(w_h);
             break;
             
        case WM_ALLICONIFY:
             /**************************************************************/
             /*........................ WM_ALLICONIFY (GEM message)........*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* il faut iconifier toutes les fenetres. EAZY_GEM met  votre*/
             /* disposition une fonction s'occupant de tout: AllIconify()  */
             /* vous pouvez lui donner en entree l'adresse d'une structure */
             /* GRECT, contenant des coordonnes d'iconification. Si vous  */
             /* placez zero alors EAZY_GEM les calcule pour vous.          */
             AllIconify((GRECT*)& Evnt->pipe[X_G]);
             break;
             
        case WM_ICONIFY:
             /**************************************************************/
             /*........................ WM_ICONIFY (GEM message)...........*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* il faut iconifier une fenetre.EAZY_GEM met  votre service */
             /* une fonction s'occupant de tout: IconifyWindow()           */
             /* Elle demande en entree l'indice EAZY_GEM de la fenetre    */
             /* iconifier.                                                 */
             /* vous pouvez aussi lui donner en entree l'adresse d'une     */
             /* structure GRECT, contenant des coordonnes d'iconification.*/
             /* Si vous placez zero alors EAZY_GEM les calcule pour vous.  */
             IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]);
             break;
             
        case WM_UNICONIFY:
             /**************************************************************/
             /*........................ WM_UNICONIFY (GEM message).........*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* il faut desiconifier une fenetre.EAZY_GEM met  votre      */
             /* service une fonction s'occupant de tout: UnconifyWindow()  */
             /* Elle demande en entree l'indice EAZY_GEM de la fenetre    */
             /* iconifier.                                                 */
             UnconifyWindow(w_ind);
             /*.......... mettre  jour le rectangle edition texte ........*/
             break;
             
        case WM_SIZED:
             /**************************************************************/
             /*........................ WM_SIZED (GEM message).............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* on lui demande de a jour ses dimensions apres une demande  */
             /* de changement de taille lors de l'appui sur une case de    */
             /* dimensionnement, ou lors d'une demande logicielle.         */
             /* ou apres une modification des coordonnes de la fenetre     */
             /* les dimmensions externes de la fenetre sont recuperables   */
             /* la ou classiquement le GEM les place  dans:                */
             /*      Evnt->pipe[X_G],Evnt->pipe[Y_G],Evnt->pipe[W_G], et   */
             /*      Evnt->pipe[H_G]   ce qui n'est pas l'endroit logique  */
             /*      ou elles doivent etre selon EZ_GEM.                   */
             /* Donc il vaut mieux les recopier en:                        */
             /*      Evnt->pipe[X_B],Evnt->pipe[Y_B],Evnt->pipe[W_B], et   */
             /*      Evnt->pipe[H_B]  et placer les dimensions interieures */
             /*      apres calcul avec: WindGemBorderToEZWork, en          */
             /*      Evnt->pipe[X_G],Evnt->pipe[Y_G],Evnt->pipe[W_G], et   */
             /*      Evnt->pipe[H_G]                                       */
             /* EAZY_GEM met  votre service une fonction s'occupant de    */
             /* tout: OnWm_sized()                                         */
             {GRECT wgrect, old_wgrect,deltgrect;
              int deltx,delty;
              CloseListBox (w_ind);

              GetGemWindExtGRECT(Windtab[w_ind].w_h, &wgrect); 
              WindGemBorderToEZWork(Windtab[w_ind].w_attr, &wgrect, &old_wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr,(GRECT*)& Evnt->pipe[X_G], &wgrect);

              deltx = wgrect.g_w -  old_wgrect.g_w; 
              delty = wgrect.g_h -  old_wgrect.g_h;    
              object[EZ_TXT_VERT_BAR].ob_x           += deltx;
              object[EZ_TXT_VERT_UP].ob_x            += deltx;
              object[EZ_TXT_VERT_DOWN].ob_x          += deltx;
              object[EZ_TXT_BULLE_ON_OFF].ob_x       += deltx;
              object[EZ_TXT_SCLBOX].ob_width         += deltx;
              object[EZ_TXT_VERT_DOWN].ob_y          += delty;
              object[EZ_TXT_VERT_BAR].ob_height      += delty;
              object[EZ_TXT_SCLBOX].ob_height        += delty;
              
              object[EZ_TXT_HORZ_BAR].ob_y           += delty;
              object[EZ_TXT_HORZ_LEFT].ob_y          += delty;
              object[EZ_TXT_HORZ_RIGHT].ob_y         += delty;
              object[EZ_TXT_HORZ_RIGHT].ob_x         += deltx;
              object[EZ_TXT_HORZ_BAR].ob_width       += deltx;
                                    
              SetScrollBoxParam(object,EZ_TXT_SCLBOX,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_NODRAW);          
              OnWm_sized(w_ind, Evnt);  
              SetScrollBoxParam(object,EZ_TXT_SCLBOX,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_DRAW);
              SendObjectRedraw(w_h, object, EZ_TXT_SCLBOX);

              /*................ ajuster les ascenseurs ...........*/
              AdjustSrollEditSlide(object);
              SendObjectRedraw(w_h, object, EZ_TXT_HORZ_BAR);
              SendObjectRedraw(w_h, object, EZ_TXT_VERT_BAR);    
              /*................. TRACER LES RELIQUATS ............*/
              objc_offset(object,EZ_TXT_SCLBOX,&deltx,&delty);
              if (wgrect.g_w<old_wgrect.g_w)
                 {deltgrect.g_x = deltx + object[EZ_TXT_SCLBOX].ob_width;
                  deltgrect.g_y = wgrect.g_y;
                  deltgrect.g_w = wgrect.g_x + wgrect.g_w - deltgrect.g_x;
                  deltgrect.g_h = wgrect.g_h;
                  SendGrectRedrawMessage( Windtab[w_ind].w_h, &deltgrect);
                  ExeAllMessage();                  
                 }                
                 
              if (wgrect.g_h<old_wgrect.g_h)
                 {deltgrect.g_x = wgrect.g_x;
                  deltgrect.g_y = delty + object[EZ_TXT_SCLBOX].ob_height;
                  deltgrect.g_w = wgrect.g_w;
                  deltgrect.g_h = wgrect.g_y + wgrect.g_h - deltgrect.g_y; 
                  SendGrectRedrawMessage( Windtab[w_ind].w_h, &deltgrect);
                  ExeAllMessage(); 
                 }        
              /*.................. mettre  jour le rectangle edition texte ........*/
              UpdateParamTexte(object, EZ_TXT_SCLBOX, WTXT_A(w_ind));
             }
             break;   
             
        case WM_MOVED:
             /**************************************************************/
             /*........................ WM_MOVED (GEM message).............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* on lui demande de a jour ses dimensions apres une demande  */
             /* de changement de place de la fenetre. En gnral aprs     */
             /* dplacement de la barre de titre ou d'une poignee de       */
             /* dplacement.                                               */
             /* Les dimmensions externes de la fenetre sont recuperables   */
             /* la ou classiquement le GEM les place  dans:                */
             /*      Evnt->pipe[X_G],Evnt->pipe[Y_G],Evnt->pipe[W_G], et   */
             /*      Evnt->pipe[H_G]   ce qui n'est pas l'endroit logique  */
             /*      ou elles doivent etre selon EZ_GEM.                   */
             /* Donc il vaut mieux les recopier en:                        */
             /*      Evnt->pipe[X_B],Evnt->pipe[Y_B],Evnt->pipe[W_B], et   */
             /*      Evnt->pipe[H_B]  et placer les dimensions interieures */
             /*      apres calcul avec: WindGemBorderToEZWork, en          */
             /*      Evnt->pipe[X_G],Evnt->pipe[Y_G],Evnt->pipe[W_G], et   */
             /*      Evnt->pipe[H_G]                                       */
             /* EAZY_GEM met  votre service une fonction s'occupant de    */
             /* tout: OnWm_moved()                                         */
             OnWm_moved(w_ind, Evnt);             
             break;   
             
        case WM_FULLED: 
             /**************************************************************/
             /*........................ WM_FULLED (GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* on lui demande de a jour ses dimensions apres une demande  */
             /* de changement de taille lors de l'appui sur une case de    */
             /* plein ecran (FULLER), ou lors d'une demande logicielle.    */
             /* les dimmensions externes de la fenetre sont recuperables   */
             /* la ou classiquement le GEM les place  dans:                */
             /*      Evnt->pipe[X_G],Evnt->pipe[Y_G],Evnt->pipe[W_G], et   */
             /*      Evnt->pipe[H_G]   ce qui n'est pas l'endroit logique  */
             /*      ou elles doivent etre selon EZ_GEM.                   */
             /* Donc il vaut mieux les recopier en:                        */
             /*      Evnt->pipe[X_B],Evnt->pipe[Y_B],Evnt->pipe[W_B], et   */
             /*      Evnt->pipe[H_B]  et placer les dimensions interieures */
             /*      apres calcul avec: WindGemBorderToEZWork, en          */
             /*      Evnt->pipe[X_G],Evnt->pipe[Y_G],Evnt->pipe[W_G], et   */
             /*      Evnt->pipe[H_G]                                       */
             /* EAZY_GEM met  votre service une fonction s'occupant de    */
             /* tout: OnWm_fulled()                                        */
             OnWm_fulled( w_ind, Evnt);  
             /*.......... mettre  jour le rectangle edition texte ........*/
             break;  
        
        case WM_CURS_TO_INDENT:
             {long param[2];
              TXTED_OB* TXT_A; 
              param[0]          = *(long*)&Evnt->pipe[X_G]; /* recuperer nbr space */
              (long)TXT_A       = *(long*)&Evnt->pipe[W_G];
              if (Evnt->pipe[WHND]==w_h)
                 {param[0] += (long)EZ_ED_GETCURLIG(TXT_A);
                  param[1]  = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
                  EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
                 }
             }
              break;
       
        case WM_MOUSEWHEEL:
             Xform_WheelButton(w_ind, Evnt, 3);
             break;
        
        case WM_EDIT_UPDATE:
             /**************************************************************/              
             /*................ WM_EDIT_UPDATE (EZ_GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* un editeur de texte lui notifie un changement succeptible  */
             /* d'entrainer une mise a jour de la fenetre, ou lui notifie  */
             /* une action future pouvant etre modifiee.                   */
             /* en Evnt->pipe[X_G] se trouve la nature de la notification  */
             /* si egal a:                                                 */
             
            {switch(Evnt->pipe[X_G])
               {/*..... ED_CLICK_IN (il a ete clique dans le texte)...............*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_CLICK_IN:
                    {EVNT_O*   Evnt_txt;
                     TXTED_OB* TXT_A; 
                     TXT_GFG*  ptTxtCfg = WTXT_CFG(w_ind);
                     (long)Evnt_txt     = *(long*)&Evnt->pipe[X_B];
                     (long)TXT_A        = *(long*)&Evnt->pipe[W_G];
                     /*.................. BOUTON DROIT ...........................*/
                     if (Evnt->k == 2)  
                        {char* item_str;
                         char  path[MAX_PATH];
                         void* adr_rsc   = GETWINDRSC(w_ind);
                         /*....... rechercher le path des ressources ........*/
                         /*    (l ou devrait se trouver: EDITPOP.POP        */
                         if (adr_rsc< (void*) 10) return 1;
                         GetPathRsc(adr_rsc, path);
                         /*............ ces deux lignes pour que NAES .......*/
                         /*             n'envoie plus de click parasites     */
                         /*             dans le popup apres scrolling        */
                         SendObjectRedraw(w_h, object, EZ_TXT_ED_CX);
                         ExeAllMessage();
                         /*.............. creer une chaine avec noms ........*/
                         /*                des fenetres textes               */
                         /*                 et les marques                   */
                         item_str = GetMarkListWindList(PopMenWidth, IsMarkList, IsWindList);
                         if (item_str==0)            {item_str = malloc(128); *item_str=0;}
                         if (item_str)
                            {/*.......... appel du popup fichier .............*/
                             /*     auquel on ajoute la liste de fenetres     */
                             int ob_r;
                             OBJECT *popup = DynFilePopupCreate(path, "EDITPOP.POP", item_str);
                             InstalleRaccInMenu(popup);
                             ob_r = DynFilePopupDo(object, EZ_TXT_WINDMEN, popup, item_str);
                             DestroyDynamicPopup(popup);
                             /*
                             ob_r = DoPopMenuFromFile(object, EZ_TXT_WINDMEN, path, "EDITPOP.POP", item_str);
                             */
                             if (*item_str && ob_r>0)
                                {char *pt = item_str + strlen(item_str);
                                 char der_arg[16];
                                 char avt_der_arg[16];
                                 /*...... regarder si c'est pas un item ......*/
                                 /*       de la liste des fenetres            */
                                 /*........... extraire les mots en partant de la fin .........*/
                                  pt = FromEndGetArg(item_str, pt, der_arg);
                                  pt = FromEndGetArg(item_str, pt, avt_der_arg);
                                  if (strcmp(avt_der_arg,"W:")==0)
                                     {int wind = GETGEMHAND(atoi(der_arg));
                                      SendWindMessage(wind, WM_TOPPED, &Windtab[wind].GemWorkGrect);
                                     }
                                  else if (strcmp(avt_der_arg,"M:")==0)
                                     {ExeTxtFunc(w_ind, TXT_F1 + atoi(der_arg) - 1 );
                                     }
                                  else
                                     {int ret;
                                      char *pt  = strchr(item_str, '|');
                                      if (pt[1] != 0)
                                         {ret = atoi(pt+1);
                                         }
                                      if (ret) ExeTxtFunc(w_ind, ret);
                                     }
                                }
                             free (item_str);
                             Evnt->evnt     &= ~MU_BUTTON;
                             Evnt_txt->evnt &= ~MU_BUTTON;
                             Evnt->k         = 0;
                             Evnt_txt->k     = 0;
                             return 0;
                            }
                        }
                     /*.................. DOUBLE CLICK ...........................*/
                     else if (Evnt_txt->click == 2)
                        {char *pt;
                         long lig = Evnt->y;
                         long col = Evnt->x;
                         EZ_ED_GraphUpdate(TXT_A);
                         pt = EZ_ED_GetLigCol(XY_TO_LIGPT, &lig, &col, TXT_A);
                         if (Evnt_txt->ksp==0 && TesteFermantOuvrant(w_ind, pt + col, TXT_A)) 
                            {Mouse_on();
                             return 0;
                            }
                        }
                     
                     /*..... si click avec CTRL et Bloc ==> Drag&Drop .......*/
                     else if (  Evnt_txt->ksp & K_CTRL     &&
                              !(TXT_A->State&MO_TRACK_ON)  &&
                               (TXT_A->BlkEndLig != TXT_A->BlkDebLig  ||
                                TXT_A->BlkEndCar != TXT_A->BlkDebCar
                               )
                             )
                             {char *data = 0;
                              long  lig_deb, col_deb, lig_end, col_end;
                              char *txt_deb, *txt_end;
                              GRECT grect;
                              GRECT blk_grect_up;
                              /*................ calculer le rectangle .....................*/
                              txt_deb   = EZ_ED_GetLigCol(BLK_DEBXY, &lig_deb, &col_deb, TXT_A);
                              txt_end   = EZ_ED_GetLigCol(BLK_ENDXY, &lig_end, &col_end, TXT_A);
                              grect.g_x = 0;
                              grect.g_y = 0;
                              grect.g_w = Ecran_l;
                              grect.g_h = Ecran_h;
                              if (lig_end==lig_deb)
                                 {int x0 = Max(TXT_A->TxtGrect.g_x,(int)Min(col_deb,col_end));
                                  int x1 = Min(TXT_A->TxtGrect.g_x+TXT_A->TxtGrect.g_w,(int)Max(col_deb,col_end));
                                  blk_grect_up.g_x = x0;
                                  blk_grect_up.g_y = (int)lig_deb;
                                  blk_grect_up.g_w = x1-x0;
                                  blk_grect_up.g_h = TXT_A->IntLg;
                                 }
                              else
                                 {blk_grect_up.g_x = TXT_A->TxtGrect.g_x;
                                  blk_grect_up.g_y =  (int)Min(lig_deb, lig_end);
                                  blk_grect_up.g_w = TXT_A->TxtGrect.g_w;
                                  blk_grect_up.g_h = TXT_A->IntLg + abs((int)(lig_end-lig_deb));
                                  Rc_intersect(&grect, &blk_grect_up);
                                  Rc_intersect(&TXT_A->TxtGrect, &blk_grect_up);
                                 }
                              /*........ faire voler le rectangle ..........................*/
                              if (FlyGrect(&blk_grect_up, Evnt->x, Evnt->y, 0) !=0)  return 0;
                              /*........ remettre reperes texte en ordre ...................*/
                              if (txt_deb>txt_end)
                                 {char *t=txt_deb;
                                  txt_deb=txt_end;
                                  txt_end=t;
                                 }
                             /*.................... poser les donnees ......................*/
                              data = malloc((txt_end-txt_deb) + 2);
                              if (data)
                                 {long len = txt_end-txt_deb;
                                  long   x = Mousex();
                                  long   y = Mousey();
                                  int wind_targ;
                                  memcpy(data, txt_deb, len);
                                  data[len] = 0;
                                  wind_targ = WindHandToIndice( wind_find((int)x, (int)y));
                                  /*.......... SI c'est notre fenetre faire un D&D interne ...........*/
                                  if (wind_targ<MAX_WIND)
                                     {int ident = GETWINDIDENT(wind_targ);
                                      if (IS_IDWINDTXT(ident))
                                         {int param[8];
                                          TXTED_OB* TXT_TRG  = WTXT_A(wind_targ);
                                          char *txt;
                                          *(long*) &param[2] = (long)TXT_TRG;  /*  W_G H_G  adresse de l'editeur cible           */
                                          if (Evnt->ksp&K_LRSHIFT)
                                             {EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_DEL, param, 4, TXT_TRG);
                                             }
                                          txt                = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_TRG);
                                          *(long*) &param[0] = (long)txt+x;  /* pointe sur texte ou on doit placer le curseur  */
                                          EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, param, 4, TXT_TRG);
                                          *(long*) &param[0] = (long)data;       /*  path du fichier a merger                    */
                                          EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_MEMORY_PASTE, param, 4, TXT_TRG);
                                          free(data);
                                          return 0; /* return 0 pour que click souris ne soit pas interprete */
                                         }
                                     }
                                  /*.......... SI fenetre autre appli D&D systeme ....................*/
                                  else
                                     {PutDragDropData(data, len + 1, '.TXT', (int)x, (int)y, Evnt->ksp);
                                     }
                                  free(data);
                                 }
                             }
                     /*..... si click et que bloc defini le deselectionner .......*/
                     else if (ptTxtCfg->IsBlocPersist==0   &&
                              !(TXT_A->State&MO_TRACK_ON)  &&
                              !(Evnt_txt->ksp & K_LRSHIFT)
                             )
                             {ExeTxtFunc(w_ind, BLK_SET_RELEASE);
                             }
                     return 1;
                    }
                /*.......  ED_SIZE_CHG (la taille du texte a chang)..............*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] position du changement.        */
                /*        *(long*)&Evnt->pipe[W_B] nbr d'octets en + ou -         */
                case ED_SIZE_CHG:
                    {int i;
                     long pos          = *(long*)&Evnt->pipe[X_B];
                     long nb_oct       = *(long*)&Evnt->pipe[W_B];
                     TXT_GFG *ptTxtCfg = WTXT_CFG(w_ind);
                     int wind          = IsWindExist(W_BOOK);    
                     /*.... si reinitialisation du texte ....*/
                     /*         effacer les marques          */
                     if (pos==-1)
                        {for (i=0; i<10; i++)
                             {if (ptTxtCfg->Bookmark[i]>pos)ptTxtCfg->Bookmark[i]=-1;
                             }
                         if (wind >- 1)
                            {Windtab[wind].UserPtr = 0;
                             ExeWindMessage(wind, WM_INIT_MARK, 0, 0);
                            }
                        }
                     else
                        {/*............ modifier les bookmark sous jacents .........*/
                         for (i=0; i<10; i++)
                             {if (ptTxtCfg->Bookmark[i]>pos) 
                                 {ptTxtCfg->Bookmark[i] += nb_oct;
                                  if (ptTxtCfg->Bookmark[i]<0)
                                     {ptTxtCfg->Bookmark[i] = -1;
                                      if (wind > -1)
                                         {int param[4];
                                          param[0]              = i;
                                          *(long*)&param[2]     = -1L; 
                                          ptTxtCfg->Bookmark[i] = -1;
                                          ExeWindMessage(wind, WM_MARK_CHG, param, 4);
                                         }
                                     }
                                 }
                             }
                         /*... modifier marqueur de fin de bloc si sous jacent ...*/
                         if (ptTxtCfg->FindEnd > pos) ptTxtCfg->FindEnd += nb_oct;
                        }
                    }
                    break;
                /*................................................................*/



                /*.......  ED_RETURN_DWN (la touche RETURN a ete appuyee).........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_RETURN_DWN:
                    {TXT_GFG *ptTxtCfg = WTXT_CFG(w_ind);
                     TXTED_OB* TXT_A  = (TXTED_OB*)*(long*)&Evnt->pipe[W_G]; 
                     long param[2];
                     int  nb_car;
                     /*............ si return indenter  au dernier espace .......*/
                     #pragma warn -pia   /* Possible incorrect assignment. */
                     if (ptTxtCfg->IsAlignIndent && (nb_car = ComputeIndentation(TXT_A)))
                        {/*........... message curseur a droite .................*/
                         param[0] = nb_car;
                         param[1] = (long)TXT_A;
                         SendWindMessage(w_h, WM_CURS_TO_INDENT,(GRECT*)param);
                         /*........... retourner  l'editeur la nature ..............*/
                         /*            de la modification                            */
                         Evnt->pipe[X_G] = (int)TXT_A->CarPt; /* position de la modif */
                         Evnt->pipe[Y_G] = (int)nb_car;       /* nbr de car de  modif */
                         return (ED_RETURN_CHG);
                        }
                      return 1;
                      #pragma warn .pia
                     }
                        
                /*.......  ED_KEYB_DWN (une touche CLAVIER a ete appuyee)..........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte   */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel   */
                /* Si il est retourne 0  ce message, l'editeur de texte ne        */
                /* ne recevra pas l'evenement.                                     */
                case ED_KEYB_DWN:
                    {int func;
                     TXT_GFG *ptTxtCfg = WTXT_CFG(w_ind);
                     EVNT_O *Evnt_txt  = (EVNT_O*)*(long*)&Evnt->pipe[X_B];
                     /*........ si curseur bouge effacer le bloc ...*/
                     if ((Evnt_txt->key)==0x11B)
                        {DumpEventStack("E:\\PURE_C\\EZ_EDIT\\EVNT_DMP.TXT", 0);
                         return 0;
                        }
                     if      (EZ_PG_DW && Evnt_txt->key==EZ_PG_DW)  
                             {Evnt_txt->key =0x5000;
                              Evnt_txt->ksp =K_LRSHIFT;
                             }
                     else if (EZ_PG_UP && Evnt_txt->key==EZ_PG_UP)  
                             {Evnt_txt->key =0x4800;
                              Evnt_txt->ksp =K_LRSHIFT;
                             }
                     if (ptTxtCfg->IsBlocPersist==0)
                        {switch(Evnt_txt->key&0xFF00)
                            {case 0x5200:     /* 82 INSRT */
                                 {char *car = " ";         /* un buffer de 1 caractere             */
                                  *car      = 0;           /* le mettre  zero                     */
                                  /*....... on passe le buffer caractere comme perametre ..........*/
                                  /*        au dialogue de saisie                                  */
                                  CreateModalWindow (XBORDER, W_EZ_ASCII,(void*)car, WindProcEZ_ASCII, 0, 0, 0, 0, " Saisie Code ASCII" );
                                  /*.......... former le code cavier compos ......................*/
                                  /*           comme l'exige l'evnt_multi du GEM                   */
                                  /*           en mettant un faux Scancode (2) qui passe           */
                                  /*           partout.                                            */
                                  if (*car)
                                     {if (*car==10) *car=13;         /* ne pas inserer un LF tout nu      */
                                      Evnt_txt->key = (2<<8) + *car; /* mettre 2 en scan code pour leurer */
                                      Evnt_txt->ksp = 0;             /* ya plus d'ALTERNATE ui tienne !!  */
                                      return 1;
                                     }
                                  }
                                  return 0;
                                  
                             case 0x4D00:     /* 77 RG    */
                             case 0x4B00:     /* 75 LF    */
                             case 0x5000:     /* 80 DW    */
                             case 0x4800:     /* 72 UP    */
                             case 0x4700:     /* 71 HOME  */
                                  ExeTxtFunc(w_ind, BLK_SET_RELEASE);
                                  break;
                             }
                        }
                     if (Evnt_txt->key & 0x00FF)        return 1;
                     func = IsKeyShortCut(Evnt_txt->ksp, Evnt_txt->key);
                     /*..... UNDO est a bloquer car reentree!! .........*/
                     if (func==0 || func==TXT_UNDO)              
                        {
                         return 1;
                        }
                     ExeTxtFunc(w_ind, func);
                    }
                     return 0;
                
                /*.......  ED_KEYB_ALT (la touche ALTERNATE a ete appuyee)........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_KEYB_ALT:
                    {EVNT_O *Evnt_txt = (EVNT_O*)*(long*)&Evnt->pipe[X_B];
                     /*....... si appui sur touche numrotes avec Alternate Seul..............*/
                     /*        on saisi le code ASCII du caractere                             */
                     if (Evnt_txt->ksp==K_ALT && MachineInfo.mult_os =='MagX')
                        {int kr    = ScanToAscii(Evnt_txt->key, Evnt_txt->ksp);
                         char *car = " ";         /* un buffer de 1 caractere             */
                         *car      = (char)kr;    /* placer le caractere appuye avec ALT  */
                                                  /* lors de la 1re utilisation          */
                         /*........... Selon Systeme reactions differentes ...............*/
                         /*            Magic retourne une touche pave numerique           */
                         /*            valide avec ALT, donc exploitable                  */
                         if (kr >= '0' && kr <= '9')
                            {/*....... on passe le buffer caractere comme perametre ..........*/
                             /*        au dialogue de saisie                                  */
                             CreateModalWindow (XBORDER, W_EZ_ASCII,(void*)car, WindProcEZ_ASCII, 0, 0, 0, 0, " Saisie Code ASCII" );
                             /*.......... former le code cavier compos ......................*/
                             /*           comme l'exige l'evnt_multi du GEM                   */
                             /*           en mettant un faux Scancode (2) qui passe           */
                             /*           partout.                                            */
                             if (*car)
                                {if (*car==10) *car=13;         /* ne pas inserer un LF tout nu      */
                                 Evnt_txt->key = (2<<8) + *car; /* mettre 2 en scan code pour leurer */
                                 Evnt_txt->ksp = 0;             /* ya plus d'ALTERNATE ui tienne !!  */
                                 return 1;
                                }
                             *(char*)(1+&Evnt_txt->key) = (char)(kr|' ');
                            }
                        } /*endif (Evnt_txt->ksp==K_ALT && MachineInfo.mult_os =='MagX') */
                     return 1;
                    } /* endcase ED_KEYB_ALT: */
                 /* break; */
                /*.......  ED_KEYB_CNTRL (la touche CONTROL a ete appuyee)........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_KEYB_CNTRL:
                    {int func, key;
                     EVNT_O *Evnt_txt = (EVNT_O*)*(long*)&Evnt->pipe[X_B];
                     key              = ((char)ScanToAscii(Evnt_txt->key, Evnt_txt->ksp)); 
                     func             = IsKeyShortCut(Evnt_txt->ksp, key);
                     if (func==0 ) return 1;
                     /*........... prise en charge de COLLER ....................*/
                     if (func>=BLK_COUPER && func<=BLK_CUT_LGN && func != BLK_COLLER)
                        {return 1;
                        }
                     ExeTxtFunc(w_ind, func);
                    }
                     return 0;
                case ED_TXT_CHG:
                     SetTxtChgIndicator(w_ind, 1);
                     break;
                /*.....  ED_LOSE_FOCUS (le texte perd le focus evenementiel)......*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /* pour interompre le processus de perte de focus, retournez 0    */
                /*      et alors le texte gardera le focus.                       */
                case ED_LOSE_FOCUS:
                     object[EZ_TXT_ED_CX].ob_flags |= HIDETREE;
                     object[EZ_TXT_ED_CY].ob_flags |= HIDETREE;
                     
                     SendObjectRedraw(w_h, object, EZ_TXT_ED_CX); 
                     SendObjectRedraw(w_h, object, EZ_TXT_ED_CY); 
                     object[EZ_TXT_FOCUS_LED].ob_state &= ~SELECTED;
                     Wobjc_draw(w_ind, object, EZ_TXT_FOCUS_LED, 1, 0);
                     return 1; 
                /*.....  ED_SET_FOCUS (le texte recoit le focus evenementiel).....*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /* pour interompre le processus de d'affectaction de focus,       */
                /* retournez 0 et alors le texte n'aura pas le focus.             */
                case ED_SET_FOCUS:
                    {int wind_book     = IsWindExist(W_BOOK);
                     int wind_Parm     = IsWindExist(W_CONFIG);
                     int wind_Prnt     = IsWindExist(W_EZ_EDIT_PRT);
                     int wind_Info     = IsWindExist(W_EZ_INFO);
                     object[EZ_TXT_ED_CX].ob_flags &= ~HIDETREE;
                     object[EZ_TXT_ED_CY].ob_flags &= ~HIDETREE;
                     SendObjectRedraw(w_h, object, EZ_TXT_ED_CX);
                     SendObjectRedraw(w_h, object, EZ_TXT_ED_CY);
                     object[EZ_TXT_FOCUS_LED].ob_state |= SELECTED;
                     Wobjc_draw(w_ind, object, EZ_TXT_FOCUS_LED, 1, 0);
                     if (IS_IDWINDTXT(Windtab[w_ind].ident))
                        {CurIDDoc = Windtab[w_ind].ident;
                        }
                     if (wind_book >- 1)
                        {Windtab[wind_book].UserPtr = 0;
                         ExeWindMessage(wind_book, WM_INIT_MARK, 0, 0);
                        }
                     if (wind_Parm >- 1)
                        {ExeWindMessage(wind_Parm, WM_ACT_TXT_CHG, 0, 0);
                        }
                     if (wind_Prnt >- 1)
                        {ExeWindMessage(wind_Prnt, WM_ACT_TXT_CHG, 0, 0);
                        }
                     if (wind_Info >- 1)
                        {ExeWindMessage(wind_Info, WM_ACT_TXT_CHG, 0, 0);
                        }
                     }
                     break;
                /*.......  ED_POS_CURS_CHG (La position du curseur a change)......*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] ligne pointee par le curseur   */
                /*                                 SI -1 pas de changement        */
                /*        *(long*)&Evnt->pipe[W_B] colonne pointee par le curseur */
                /*                                 SI -1 pas de changement        */
                case ED_POS_CURS_CHG:
                    {long lig_pt      = *(long*)&Evnt->pipe[X_B];  /* X_G + 4 */
                     long car_pt      = *(long*)&Evnt->pipe[W_B];  /* X_G + 6 */
                     char buft[32];
                     WSetCursObEditOff(w_ind, 0); 
                     if (lig_pt != -1)
                        {ObjcSetTxt (object, EZ_TXT_ED_CY,ltoa(lig_pt+OFSL, buft, 10));
                         Wobjc_draw(w_ind, object, EZ_TXT_ED_CY, 1, 0);
                        }
                     if (car_pt != -1)
                        {TXTED_OB* TXT_A  = (TXTED_OB*)*(long*)&Evnt->pipe[W_G];
                         ObjcSetTxt (object, EZ_TXT_ED_CX,ltoa(PtTxtToPosCar(TXT_A->BuffEdit, TXT_A->BuffEdit+car_pt, TXT_A->ExpTAB)+OFSL, buft, 10));
                         Wobjc_draw(w_ind, object, EZ_TXT_ED_CX, 1, 0);
                        }
                    }
                     break;
               }
             }break;
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*----------------------------- PtTxtToPosCar ----------------------------------*/
/* ACTION: donne la position du caractre  l'ecran en tenant compte des TAB    */
int PtTxtToPosCar(char *pt, char *pt_pos, int tab)
{int pos = 0;
 while (pt < pt_pos)
   {if (*pt=='\t')
       {pos += tab - (pos % tab);
       }
    else
       {pos++;
       }
    pt++;
   }
 return pos;
}
/*------------------------ AdjustRscToWind ------------------------------*/
void AdjustRscToNewGrectWind(long w_attr, OBJECT *object, GRECT *oldGrect,  GRECT *newGrect)
{GRECT old_wgrect,new_wgrect;
 int deltx,delty;

 WindGemBorderToEZWork(w_attr, oldGrect, &old_wgrect);
 WindGemBorderToEZWork(w_attr, newGrect, &new_wgrect);

 deltx = new_wgrect.g_w -  old_wgrect.g_w; 
 delty = new_wgrect.g_h -  old_wgrect.g_h;    
 object[EZ_TXT_VERT_BAR].ob_x           += deltx;
 object[EZ_TXT_VERT_UP].ob_x            += deltx;
 object[EZ_TXT_VERT_DOWN].ob_x          += deltx;
 object[EZ_TXT_BULLE_ON_OFF].ob_x       += deltx;
 object[EZ_TXT_SCLBOX].ob_width         += deltx;
 object[EZ_TXT_VERT_DOWN].ob_y          += delty;
 object[EZ_TXT_VERT_BAR].ob_height      += delty;
 object[EZ_TXT_SCLBOX].ob_height        += delty;
 
 object[EZ_TXT_HORZ_BAR].ob_y           += delty;
 object[EZ_TXT_HORZ_LEFT].ob_y          += delty;
 object[EZ_TXT_HORZ_RIGHT].ob_y         += delty;
 object[EZ_TXT_HORZ_RIGHT].ob_x         += deltx;
 object[EZ_TXT_HORZ_BAR].ob_width       += deltx;
}

/*------------------------ AdjustSrollEditSlide -------------------------*/
void AdjustSrollEditSlide(OBJECT *object)
{GRECT grect;
 int lgnh, clnw, nbl_view, nbc_view;
 long nb_lgn, nb_cln, fstc, fstl, posh, posv;
              
 GetScrollBoxGRECT( object, EZ_TXT_SCLBOX, &grect, -1);
 GetScrollBoxLParam(object, EZ_TXT_SCLBOX, &lgnh, &clnw, &nb_lgn, &nb_cln, &fstl, &fstc, 0, 0, 0, 0);
 nbl_view = grect.g_h / lgnh;
 nbc_view = grect.g_w / clnw;
 SetSlideWidth(object, EZ_TXT_HORZ_BAR,  nb_cln, nbc_view, fstc, MIN_SLIDE_W, HORIZONTAL); 
 SetSlideWidth(object, EZ_TXT_VERT_BAR,  nb_lgn, nbl_view, fstl, MIN_SLIDE_W, VERTICAL);   
 posh = Min(fstc, nb_cln - nbc_view);
 posv = Min(fstl, nb_lgn - nbl_view);
 DocPosToSlidePos(object,  EZ_TXT_HORZ_BAR, nb_cln, nbc_view, posh, HORIZONTAL);
 DocPosToSlidePos(object,  EZ_TXT_VERT_BAR, nb_lgn, nbl_view, posv, VERTICAL);
 SetScrollBoxParam(object,EZ_TXT_SCLBOX,-2,-2,-2,-2, posv, posh, -2,-2,(void*)-2L,-2);
}                 
              
/*------------------------ UpdateParamTexte -----------------------------*/
void UpdateParamTexte( OBJECT *object, int ob_ind, TXTED_OB *TXT_A)
{int nbr_l, prm_l;
 /*.................. mettre  jour le rectangle edition texte ..........*/
 GetScrollBoxParam       (object,                     /* adresse de l'arbre dans lequel est l'objet      */
                          ob_ind,                     /* indice de l'objet dans l'arbre                  */
                          &TXT_A->IntLg,              /* hauteur en pixels d'une ligne de scrolling      */
                          0,                          /* largeur en pixels d'une colonne scrolling       */
                          0,                          /* Nombre total de lignes document                 */
                          0,                          /* nombre total de colonnes document               */
                          &prm_l,                     /* indice ligne document  afficher en 1er         */
                          0,                          /* indice colonne document  afficher  gauche     */
                          0,                          /* ligne selectionne ( mettre en surbrillance)   */
                          0,                          /* colonne selectionne ( mettre en surbrillance) */
                          0,                          /* paramtre optionnel  type de pointeur          */
                          &nbr_l                      /* nbr de cases afichables                         */
                         );
 /*.......... updater les parametres de ligne de l'editeur ..............*/                        
 TXT_A->PremLigVisible = prm_l;
 TXT_A->NbreLigVisible = nbr_l;
 /*........... updater le rectangle texte de l'editeur ..................*/
 GetScrollBoxGRECT(object, ob_ind, &TXT_A->TxtGrect, -1);
 /*............. appeler fonction d'update de l'editeur de texte ........*/
 TXT_A->EditTxtPosChg(TXT_A);
}

/*------------------------------ IsThisTxtLoaded ------------------------*/
int IsThisTxtLoaded(char *path, char* nom)
{int register wind, ident;
 char path_c[MAX_PATH];
 char path_d[MAX_PATH];
 TXT_GFG *ptTxtCfg = 0;
 strcpy(path_d, path);
 if (nom) strcat(path_d, nom);
 for (wind=0; wind<MAX_WIND; wind++)
     {ident = GETWINDIDENT(wind);
      if (IS_IDWINDTXT(ident)) 
         {ptTxtCfg = WTXT_CFG(wind);
          strcpy(path_c,  ptTxtCfg->PathTxt);
          strcat(path_c,  ptTxtCfg->NomTxt);
          StrTrimEnd(path_c);
          StrTrimEnd(path_d);
          if ( strcmpi(path_c, path_d)==0 ) return wind;
         }
     } /* end for(wind==0; wind<MAX_WIND; wind++) */
 return -1;
}

/*-------------------------- TXT_ED_To_Wind ----------------------------------*/
int TXT_ED_To_Wind (TXTED_OB *TXT_A)
{int register wind, ident;
 for (wind=0; wind<MAX_WIND; wind++)
     {ident = GETWINDIDENT(wind);
      if (IS_IDWINDTXT(ident) &&  WTXT_A(wind) == TXT_A) return wind;
     } /* end for(wind==0; wind<MAX_WIND; wind++) */
 return -1;
}

/*------------------------- GetDerTXT_Wind -----------------------------------*/
int GetDerTXT_Wind(int w_ind)
{int wind, ident;
 int der_wind = INT_MIN;                            
  for (wind=0; wind<MAX_WIND; wind++)
      {ident = GETWINDIDENT(wind);
       if ( w_ind != wind && IS_IDWINDTXT(ident) )
          {der_wind = Max(der_wind, wind);
          }
      } /* end for(wind==0; wind<MAX_WIND; wind++) */
 if (der_wind>=0) return der_wind;
 else return -1;     
}

/*------------------------- GetNbTXT_Wind ------------------------------------*/
int GetNbTXT_Wind(void)
{int wind, ident;
 int nb_wind = 0;                            
  for (wind=0; wind<MAX_WIND; wind++)
      {ident = GETWINDIDENT(wind);
       if (IS_IDWINDTXT(ident) )
          {nb_wind++;
          }
      } /* end for(wind==0; wind<MAX_WIND; wind++) */
 return nb_wind;     
}

/*------------------------- GetFirstWindTxt ----------------------------------*/
int   GetFirstWindTxt(void)
{int wind, ident;
 for (wind=0; wind<MAX_WIND; wind++)
     {ident = GETWINDIDENT(wind);
      if (IS_IDWINDTXT(ident) ) return wind;
     } /* end for(wind==0; wind<MAX_WIND; wind++) */
 return -1;
}

/*--------------------------- GetNextWindTxt ----------------------------*/
int GetNextWindTxt(int w_ind)
{int ident, pt_wind;
 int next_wind = -1;   
 if    (w_ind == MAX_WIND - 1) pt_wind = 0;
 else                          pt_wind = Min(w_ind + 1, MAX_WIND - 1);
 while (pt_wind != w_ind)
    {ident = GETWINDIDENT(pt_wind);
     if (IS_IDWINDTXT(ident))
        {next_wind = pt_wind;
         break;
        }
     pt_wind++;
     if (pt_wind == MAX_WIND) pt_wind = 0;
    }      
 return next_wind;
}

/*------------------------- CreateNewTxtWindIdent -------------------------*/
/* ACTION: reserve un nouvel identificateur de fenetre dans la liste       */
/*         un identificateur est en fait un indice pointant sur la liste   */
/*         (ofset du first_ID enlev). Une place prise est indiquee par un */
/*         nbr different de zero. une place libre par zero.                */
/*         pour connaitre le nombre d'elements de la liste, il suffit de   */
/*         compter les places prises. (nombre de fenetres documents).      */
/*         Ce dispositif est utile pour les architectures multi documents  */
/*         ou la creation du meme type de fenetre doit se faire            */
/*         automatiquement.                                                */
/* ENTREE: int *TabIdent: table des identificateurs (autant que nb_maxId)  */
/*         int nb_maxId:  nombre maximum d'identificateurs possibles.      */
/*         int first_ID:  numero du premier identificateur possible, les   */
/*                        autres sont incrementes a partir du premier.     */
/* SORTIE: identificateur de la fenetre. Ce nombre est unique dans les ID  */
/*         de fenetre crees, pour peu que l'on ne choisisse pas d'en       */
/*         ouvrir d'autres sans passer par cette fonction avec un nombre   */
/*         compris entre: first_ID et first_ID + maxIdent.                 */
/*         En d'autres termes, si vous ne voulez pas qu'il y ait de        */
/*         conflits entre identificateurs, prenez en un soit avec cette    */
/*         fonction, soit un en dehors de first_ID et first_ID + maxIdent  */
/*         car la regle est que chaque fenetre EAZY_GEM doit absolument    */
/*         posseder un identificateur unique !!!.                          */
/*         -1 si la liste est pleine.                                      */
int CreateNewTxtWindIdent(int *TabIdent, int maxIdent, int first_ID)
{int  register i;
 for (i=0; i<maxIdent; i++)
     {if (TabIdent[i]==0) 
         {TabIdent[i]=1;
          return i + first_ID;
         }
     }
 return -1;
}
                  
/*----------------------------- ComputeIndentation -----------------------------*/
int ComputeIndentation(TXTED_OB* TXT_A)
{KEY_WRD  *key_out;
 KEY_WRD  *lastKeyW;
 char     *lastptkw;
 LGN_STAT *lgn_stat;
 int       com_state;
 int       IsKwSection;
 char     *pt;
 long      len_str;
 char     *pt_buft;
 char     *pt_curs;
 char     *firstNoSpce;
 char      isTabBefore;
 char     *elseif;
 int       pos_indent;
 int       nb_tab_to_insert;
 int       nb_spc_to_insert;
 KWSECTION  *kwsection;
 TXT_GFG *ptTxtCfg   = (TXT_GFG*) TXT_A->UsrPrm.PtV;
 SYNT_PARAM *syntprm = ptTxtCfg->SyntPrm;
 /*.......... si rien avant RETURN alors rien  indenter cassos ...................*/
 if (TXT_A->CarPt==0) return 0;
 
 len_str       = strlen(TXT_A->BuffEdit);
 pt_buft       = TXT_A->BuffEdit;
 pt_curs       = pt_buft + TXT_A->CarPt;
 firstNoSpce   = Min(GoFirstValid(pt_buft, " \t"), pt_curs);
 /*............ relever si TAB avant ................................*/
 if (firstNoSpce>pt_buft)
    {isTabBefore = 0;
     pt          = pt_buft;
     while (pt<firstNoSpce)
           {if (*pt=='\t')
               {isTabBefore = 1;
               }
            pt++;
           }
    }
 /*.......... SI Syntaxe colore rechercher si mot clef..................*/
 /*           et indenter selon directives du mot clef                   */
 if ( syntprm )
    {/*......... relever etat commentaire de la ligne ...................*/
     lgn_stat      = (LGN_STAT*)TXT_A->SupLgnCtxtMem;
 
     if (TXT_A->LigPt==0) 
        {IsKwSection = 0;
         com_state   = 0;
        }
     else
        {com_state   = lgn_stat[TXT_A->LigPt-1].LgnState;
         IsKwSection = lgn_stat[TXT_A->LigPt-1].KwSection;
        }
 
     kwsection     = &syntprm->KwSection[lgn_stat->KwSection];
     /*......... relever le dernier mot clef de la ligne ................*/
     key_out     = 0;
     lastKeyW    = 0;
     lastptkw    = 0;
     pt          = pt_buft;
     elseif      = 0;
     while ( (pt = IsKeyWordInThisLigne(pt_buft, pt, &IsKwSection, &com_state, &key_out, syntprm)) !=0 )
           {/*........ si else le noter (car else if possible) ............*/
            if      ( (strcmp( "else", key_out->Name))==0)             elseif = pt;
            /*........ Si pas if et que elseif possible annuler elseif ....*/
            else if ( (strcmp( "if",   key_out->Name))!=0 && elseif )  elseif = 0;
            lastKeyW  = key_out;
            lastptkw  = pt;
            pt       += key_out->LenKey;
           }
     /*......... calcul de l'indentation selon contexte .................*/
     if (IS_C_OPP(pt_curs - 1, kwsection->Operator) && kwsection->OppIndent[pt_curs[-1]] > NO_INDENT)
        {pos_indent  =  PtTxtToPosCar(pt_buft,
                                      Max(pt_buft, pt_curs + kwsection->OppIndent[pt_curs[-1]] ),
                                      TXT_A->ExpTAB);
        }
     else if (elseif && lastKeyW->NbToIndent > NO_INDENT)
        {pos_indent = lastKeyW->NbToIndent + PtTxtToPosCar(pt_buft, elseif,   TXT_A->ExpTAB);
        }
     else if (lastKeyW && lastKeyW->NbToIndent > NO_INDENT)
        {pos_indent = lastKeyW->NbToIndent + PtTxtToPosCar(pt_buft, lastptkw, TXT_A->ExpTAB);
        }
     else if (firstNoSpce)
        {pos_indent = PtTxtToPosCar(pt_buft, firstNoSpce, TXT_A->ExpTAB);
        }
     else return 0;
   }
 /*.......... SI pas de syntaxe colore active ..........................*/
 /*           indenter sur dernier non espace                            */
 else if (firstNoSpce)
   {pos_indent = PtTxtToPosCar(pt_buft, firstNoSpce, TXT_A->ExpTAB);
   }
 else return 0;
   
 /*.............. creer et inserer l'indentation ....................*/
 if (isTabBefore)
    {nb_tab_to_insert = (pos_indent/TXT_A->ExpTAB);
     nb_spc_to_insert =  pos_indent - (TXT_A->ExpTAB*nb_tab_to_insert);
    }
 else
    {nb_tab_to_insert = 0;
     nb_spc_to_insert = pos_indent;
    }
 /*............ faire la place dans le buffer texte ................*/
 memcpy(pt_curs + nb_spc_to_insert + nb_tab_to_insert, pt_curs, len_str - TXT_A->CarPt + 2);
 if (nb_tab_to_insert) memset(pt_curs,                    '\t', nb_tab_to_insert);
 if (nb_spc_to_insert) memset(pt_curs + nb_tab_to_insert, ' ' , nb_spc_to_insert);
 return nb_spc_to_insert + nb_tab_to_insert;
}

/*----------------------------- EZeditInitTabLgnCtx ----------------------------*/
/* ACTION: passe en revue le texte  partir de  char *txt et initialise la      */
/*         table des pointeurs de lignes                                        */
/*                            TXT_A->TabLgnCtx[i].ptTxt   avec les adresses des */
/*         debuts de chaque lignes (cette table doit toujours etre  jour pour  */
/*         un fonctionnement correct du composant d'edition).                   */
/*         met aussi  jour l'etat de fin de ligne de chaque ligne:             */
/*                  (LGN_STAT*)(TXT_A->SupLgnCtxtMem)[i].LgnState               */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur le composant d'edition de texte pour   */
/*                          lequel il est demande un formattage de lignes.      */
/*         char *txt:   adresse texte  partir de laquelle cette mise  jour    */
/*                      doit se faire.                                          */
/*         long iTab:   indice du premier element de la table  mettre  jour.  */
/*         long nb_l:   nombre de lignes  mettre  jour. Si plus grand que le  */
/*                      texte, tout le texte sous jacent sera remis  jour.     */
/* NOTE:   le membre    TXT_A->SupLgnCtxtMem, contient l'adresse d'une zone     */
/*         memoire ou il est stock pour chaque ligne une structure: LGN_STAT   */
/*         dont le membre: LgnState, indique l'etat du dernier caractre de la  */
/*         ligne.                                                               */
/* RETOUR: long: retourne le dernier indice+1 remis  jour (pointe apres)       */
/* NOTE:   cette fonction est celle qui remplace celle par defaut du composant  */
/*         d'edition de texte. Elle est reecrite afin de tenir  jour l'etat    */
/*         de fin de ligne permettant  la ligne suivante de savoir comment     */
/*         son premier caractere doit etre affiche (en mode commentaire,normal, */
/*         ou chaine de caractere).                                             */
/*         Pour cela une structure stockant cet etat est disponible en debut de */
/*         chaque ligne. LGN_STAT                                               */
/*         La memoire  reserver en plus, pour stocker cette structure pour     */
/*         chaque ligne est definie par le 14me paramtre                      */
/*         de la chaine de parametrage du composant d'edition de texte.         */
/*         ce parametre est 2 car la structure mesure deux octets et donc la    */
/*         memoire  reserver en plus pour chaque ligne est de deux octets.     */
/*                                                                              */
/*         le composant d'edition de texte appelle la fonction de formattage de */
/*         ligne stockee dans le membre: InitTabLgnCtx , lorsqu'il a besoin de  */
/*         mettre  jour les pointeurs de lignes. Nous avons donc plac dans le */
/*         membre: InitTabLgnCtx, notre fonction (lors du message WM_CONSTRUCT) */
/*         ainsi lors du formattage de lignes, c'est notre fonction qui est     */
/*         appele et nous en profitons, en meme temps que mettre les pointeurs */
/*         de debut de ligne  jour, pour mettre  jour l'etat du dernier       */
/*         caractre de la ligne,                                               */
/*                                                                              */
long EZeditInitTabLgnCtx(TXTED_OB *TXT_A, char *txt, long iTab, long nb_l)
{register char *pt_src        = txt;
 char          *ptdebl        = txt;
 long flag_no_erase           = nb_l;
 long len_max                 = TXT_A->SizeLgn;
 LGN_STAT    *lgn_stat        = (LGN_STAT*)TXT_A->SupLgnCtxtMem;
 TXT_GFG     *ptTxtCfg        = (TXT_GFG*) TXT_A->UsrPrm.PtV;
 SYNT_PARAM  *syntprm         = ptTxtCfg->SyntPrm;
 char        *beg_tab;
 char        *end_tab;
 char        *kwbeg_tab;
 char        *kwend_tab;
 KWSECTION   *kwsection;
 /*.... relever pointeur sur table des structures d'etat de ligne ..............*/
 int isInSection;
 int isInkwSection;
 char *validTab;
 int dumy, nb_car;
 
 /*.............. noter etat courant de depart ...............*/
 /*               (celui du dernier caractere de la           */
 /*                ligne precedente)                          */
 if (iTab==0)
    {isInSection        =  0; /* car pas de ligne precedente  */
     isInkwSection      =  0; /* car pas de ligne precedente  */
    }
 else
    {isInSection        = lgn_stat[iTab-1].LgnState;
     isInkwSection      = lgn_stat[iTab-1].KwSection;
    }
 
 /*.......... noter table d'acceleration de section ..........*/
 if (syntprm)
    {kwbeg_tab                = syntprm->KwSectBegFirstCar;
     kwend_tab                = syntprm->KwSectEndFirstCar;
     kwsection                = &syntprm->KwSection[isInkwSection];
     validTab                 = kwsection->ValidChar;
     beg_tab                  = kwsection->BegSection;
     end_tab                  = kwsection->EndSection;
    }
 
 /*........... initialiser pointeur texte de la premiere  ....*/
 /*                    ligne  traiter                        */
 TXT_A->TabLgnCtx[iTab].ptTxt = txt;
 /*........... intialiser les autres lignes ..................*/
 while(*pt_src && nb_l)
   {/*............. si une fin de ligne est rencontre .......*/
    if (*pt_src==13 || *pt_src==10 ||(pt_src - ptdebl)>=len_max)
       {if ( (pt_src - ptdebl) >=len_max)
           {pt_src [-1] = '\r';
            pt_src++;
           }
        else
           {pt_src++;
            if (*pt_src && pt_src[-1]==13 && *pt_src==10) pt_src++;
           }
        ptdebl = pt_src;
        /*........... mettre  jour letat de fin de ligne .....*/
        /*            de la ligne en cours                     */
        if (isInSection  && 
            kwsection->SectionAdr[isInSection-1].EndStr[0]  == '\r'
           )
           {isInSection   = 0;
           }
        if (isInkwSection      && 
            syntprm->KwSection[isInkwSection].EndStr[0]   == '\r'
           )
           {isInkwSection = 0;
           }
        lgn_stat[iTab].LgnState  = (char)isInSection;
        lgn_stat[iTab].KwSection = (char)isInkwSection;
        /*........... ligne suivante ..........................*/
        iTab++;     
        /*........... initialiser pointeur texte ..............*/
        /*            de la ligne suivante                     */
        TXT_A->TabLgnCtx[iTab].ptTxt     = pt_src;
        nb_l --;
       }
    else if (syntprm)
       {/*........... voir si Section graphique ...............*/
        #pragma warn -pia   /* Possible incorrect assignment. */
        if (isInSection)
           {if (end_tab[*pt_src]  && 
                (nb_car = IsEndSection(pt_src, &isInSection, isInkwSection, syntprm))
               )
               {pt_src += nb_car;
               }
            else
               {pt_src++;
               }
           }
        else
           {if ( beg_tab[*pt_src]            &&
                (nb_car = IsBegSection(pt_src, &isInSection, &dumy, isInkwSection, syntprm))
               )
               {pt_src += nb_car;
               }
            /*...... voir si fin de Section de mots clefs .........*/
            /*        (qu'en dehors d'une section graphique)       */
            
            else if (isInkwSection)
               {/*....... voir si fin de section par mot clef ......*/
                if (kwsection->MajMin&4 &&  validTab[*pt_src] &&
                    BeforeIsValid(pt_src, iTab, validTab, TXT_A)
                   )
                   {KEY_WRD key_input, *key_result;
                    nb_car           = CPY_STR_TO_TEST(pt_src, key_input.Name, (long) validTab);
                    key_input.LenKey = nb_car;
                    key_result       = (KEY_WRD*)bsearch(&key_input,
                                                  kwsection->KwAdr,
                                                  kwsection->NbKeyW,
                                                  sizeof(KEY_WRD),
                                                  NewKeyWordCompare
                                                );
                   if (key_result && kwsection->MajMin&4)
                      {isInkwSection      = 0;
                       kwsection          = &syntprm->KwSection[isInkwSection];
                       validTab           = kwsection->ValidChar;
                       beg_tab            = kwsection->BegSection;
                       end_tab            = kwsection->EndSection;
                      }
                   pt_src    += nb_car;
                  }
                /*....... voir si fin de section par delimiteur .....*/
                else if (kwend_tab[*pt_src] &&
                         (nb_car = IsEndKwSection(pt_src, &isInkwSection, &dumy, syntprm))
                        )
                  {kwsection  = &syntprm->KwSection[isInkwSection];
                   validTab   = kwsection->ValidChar;
                   beg_tab    = kwsection->BegSection;
                   end_tab    = kwsection->EndSection;
                   pt_src    += nb_car;
                  }
                else
                  {pt_src++;
                  }
               }
            /*...... voir si debut de Section de mots clefs .......*/
            /*        (qu'en dehors d'une section graphique)       */
            
            else if (kwbeg_tab[*pt_src] &&
                     (nb_car = IsBegKwSection(pt_src, &isInkwSection, &dumy, syntprm))
                    )
               {kwsection  = &syntprm->KwSection[isInkwSection];
                validTab   = kwsection->ValidChar;
                beg_tab    = kwsection->BegSection;
                end_tab    = kwsection->EndSection;
                pt_src    += nb_car;
               }
            else
               {pt_src++;
               }
           }
        #pragma warn .pia
       }
    else pt_src++;
   }
 /*........ ne pas oublier de noter etat derniere ligne ...........*/
 lgn_stat[iTab].LgnState  = (char)isInSection;
 lgn_stat[iTab].KwSection = (char)isInkwSection;
 if (flag_no_erase == LONG_MAX) TXT_A->TabLgnCtx[iTab+1].ptTxt   = 0;
 return iTab;
}

/*------------------- NewKeyWordCompare -----------------------------------*/
int NewKeyWordCompare (const void *one, const void *two)
{KEY_WRD *kw_one = (KEY_WRD*) one;
 KEY_WRD *kw_two = (KEY_WRD*) two;
 if (kw_two->MajMin&0x0001) return strcmpi( kw_one->Name, kw_two->Name);
 else                       return strcmp ( kw_one->Name, kw_two->Name);

}

/*------------------------- ReleaseTxtWindIdent ---------------------------*/
/* ACTION: corolaire de la precedente cette fonction est obligatoirement   */
/*          appeler lors de destruction d'une fenetre, ayant ete creee    */
/*         avec un identificateur fourni par: CreateNewTxtWindIdent()      */
/* ENTREE: int ident: identificateur de la fenetre cree par la fonction    */
/*                    CreateNewTxtWindIdent()                              */
/*         int *TabIdent: table des identificateurs (autant que nb_maxId)  */
/*         int nb_maxId:  nombre maximum d'identificateurs possibles.      */
/*         int first_ID:  numero du premier identificateur possible, les   */
/*                        autres sont incrementes a partir du premier.     */
/* RETOUR: neant.                                                          */

void ReleaseTxtWindIdent( int ident, int *TabIdent, int nbIdent, int first_ID)
{if ((ident-100)>=nbIdent) return;
 TabIdent[ident-first_ID]=0;
}

/*-------------------------- AfficheColorLigne ---------------------------------*/
int AfficheColorLigne(long i, int tx, int ty, TXTED_OB *TXT_A)
{int d;
 char *affi_buff       = TXT_A->AffiBuff;
 char *pt_dst          = affi_buff;
 LGN_STAT* lgn_stat    = (LGN_STAT*)TXT_A->SupLgnCtxtMem;
 TXT_GFG *ptTxtCfg     = (TXT_GFG*) TXT_A->UsrPrm.PtV;
 SYNT_PARAM *syntprm   = ptTxtCfg->SyntPrm;
 char *kwbeg_tab       = syntprm->KwSectBegFirstCar;
 char *kwend_tab       = syntprm->KwSectEndFirstCar;
 int    tab            = TXT_A->ExpTAB;
 int    pos            = 0;
 int  isInSection      = 0;
 int  isInkwSection    = 0;
 
 register char *pt_src;
 register char *beg_tab;
 register char *validTab;
 register char *end_tab;
 KWSECTION  *kwsection;
 int    idgrclass;
 int    nb_car;
 int    intGrClass;
 /*............ Si edition active et affi de la ligne en edition ...........*/
 if ( i == TXT_A->LigPt )
    {pt_src = TXT_A->BuffEdit;            /* on affiche le buffer de saisie */
    }
 else
    {pt_src = TXT_A->TabLgnCtx[i].ptTxt;  /* on affiche le texte normal     */
    }
 /*............ positionner les attributs graphiques .......................*/
 vst_alignment (VDIhandle, ALI_LEFT, ALI_BASE, &d, &d);   
 tx -= TXT_A->OfsX;
 /*.............. Si numero de ligne positionn .....................*/
 if (TXT_A->ATT_Def[ATT_TXT_NUM_LGN].CarCol>-1)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NUM_LGN];
     TXT_A->DrawTxt(tx+2, ty, ltoa(i+OFSL, "                                ", 10), TXT_A) ;
    } 
 
 tx += TXT_A->MargLeft;
 /*....... relever etat de la ligne .......................................*/
 if (i)
    {isInSection   = (char)lgn_stat[i-1].LgnState;
     isInkwSection = (char)lgn_stat[i-1].KwSection;
    }
 /*............ initialisation des variables ...............................*/
 kwsection         = &syntprm->KwSection[isInkwSection];
 intGrClass        = kwsection->IntGrClass;
 if       (isInSection)  TXT_A->ATT_Cur = kwsection->SectionAdr[isInSection-1].CarAtt;
 else                    TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
 validTab          = kwsection->ValidChar;
 beg_tab           = kwsection->BegSection;
 end_tab           = kwsection->EndSection;
 #pragma warn -pia   /* Possible incorrect assignment. */
 /*............ analyser la ligne ..........................................*/
 while (*pt_src && *pt_src != 13 && *pt_src != 10)
  {   /* TABULATION */
   if (*pt_src == '\t')
      {int fill = tab - (pos % tab);
       while (fill--) {*pt_dst++ = ' '; }
       pos += tab - (pos % tab);
       if (TXT_A->State & EDIT_TAB_VISIBLE && pt_dst[-tab]==' ')
          {pt_dst[-tab] = TXT_A->CharTAB;
          } 
       pt_src++;
      }
      /* END SECTION */
   else if (isInSection)
      {if ( end_tab[*pt_src] &&
           (nb_car = IsEndSection(pt_src, &isInSection, isInkwSection, syntprm)) 
          )
          {/*........ afficher le texte avant ..........*/
           FAST_CHARNCPY(pt_src, pt_dst, nb_car); /* met le zero de fin */
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           pt_src        += nb_car;
           pos           += nb_car;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       else
          {*pt_dst++      = *pt_src++;
           pos++;
          }
      }
   else    
      /* NUMERIC */
      {if (kwsection->NumCarBeg[*pt_src]                         &&
           BeforeIsValid(pt_src, i, kwsection->NumCar, TXT_A)
          )
          {nb_car = (int)IS_NUMERIC(pt_src+1, kwsection->NumCar);
           /*........ afficher le texte avant ..........*/
           *pt_dst        = 0;
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*...... recuperer attribut graphique de la valeur numerique ...*/
           if (kwsection->NumBegGrClass!=kwsection->NumGrClass)
              {*affi_buff     = *pt_src;
               affi_buff[1]   = 0;
               TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumBegGrClass].AttGr;
               tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
               if (nb_car)
                  {FAST_CHARNCPY(pt_src+1, affi_buff, nb_car);
                   TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumGrClass].AttGr;
                   tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
                  }
              }
           else
              {TXT_A->ATT_Cur = &syntprm->GrClass[kwsection->NumGrClass].AttGr;
               /*........ afficher la valeur numerique ...........*/
               FAST_CHARNCPY(pt_src, affi_buff, nb_car+1);
               tx                += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
              }
           nb_car++;     /* tenir compte de l'introducteur  */
           /*........ avancer positions ...............*/
           pt_src            += nb_car;
           pos               += nb_car;
           
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       /* KEYWORD */
       else if ( validTab[*pt_src]                        && /* si IS_C_NAME(pt_src)  len = au minimum 1 */
            BeforeIsValid(pt_src, i, validTab, TXT_A)
          ) 
          {KEY_WRD key_input, *key_result;
           nb_car           = CPY_STR_TO_TEST(pt_src, key_input.Name, (long) validTab);
           key_input.LenKey = nb_car;
           key_result       = (KEY_WRD*)bsearch(&key_input,
                                                 kwsection->KwAdr,
                                                 kwsection->NbKeyW,
                                                 sizeof(KEY_WRD),
                                                 NewKeyWordCompare
                                               );
           if (key_result)
              {/*........... afficher le texte avant .......................*/
               *pt_dst        = 0;
               tx            += TXT_A->DrawTxt( tx,  ty, TXT_A->AffiBuff, TXT_A);
               /*........... afficher le texte du mot clef .................*/
               TXT_A->ATT_Cur = &syntprm->GrClass[key_result->GraphClass].AttGr;
               tx            += TXT_A->DrawTxt( tx,  ty, key_input.Name, TXT_A);
               /*........... si mot clef = fin de section ..................*/
               if (kwsection->MajMin & 4)
                  {isInkwSection      = 0;
                   kwsection          = &syntprm->KwSection[isInkwSection];
                   intGrClass         = kwsection->IntGrClass;
                   validTab           = kwsection->ValidChar;
                   beg_tab            = kwsection->BegSection;
                   end_tab            = kwsection->EndSection;
                  }
               TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
               pt_dst         = affi_buff;
              }
           else
              {
               /*FAST_CHARMEMCPY(pt_src, pt_dst, nb_car);*/
               memcpy(pt_dst, pt_src, nb_car); 
               pt_dst        += nb_car;
               /*tx            += TXT_A->DrawTxt( tx,  ty, key_input.Name, TXT_A);*/
              }
           pt_src   += nb_car;
           pos      += nb_car;
          }
       /* BEG SECTION */
       else if ( beg_tab[*pt_src] &&
                (nb_car = IsBegSection(pt_src, &isInSection, &idgrclass, isInkwSection, syntprm))
               )
          {/*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           pt_dst         = affi_buff;
           FAST_CHARMEMCPY(pt_src, pt_dst, nb_car);
           pt_dst        += nb_car;
           pt_src        += nb_car;
           pos           += nb_car;
          }
       /* BEG KW_SECTION */
       else if (isInkwSection == 0   &&
                kwbeg_tab[*pt_src]   &&
                (nb_car = IsBegKwSection(pt_src, &isInkwSection, &idgrclass, syntprm))
               )
          {/*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           /*........ afficher le delimiteur ...........*/
           FAST_CHARNCPY(pt_src, affi_buff, nb_car);
           tx               += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           kwsection          = &syntprm->KwSection[isInkwSection];
           intGrClass         = kwsection->IntGrClass;
           
           pt_dst             = affi_buff;
           TXT_A->ATT_Cur     = &syntprm->GrClass[intGrClass].AttGr;
           pt_src            += nb_car;
           pos               += nb_car;
           
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
          }
       /* END KW_SECTION */
       else if (isInkwSection       &&
                kwend_tab[*pt_src]  &&
                (nb_car = IsEndKwSection(pt_src, &isInkwSection, &idgrclass, syntprm))
               )
          {
           /*........ afficher le texte avant ..........*/
           pt_dst[0]      = 0;
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           /*........ afficher le delimiteur ...........*/
           FAST_CHARNCPY(pt_src, affi_buff, nb_car);
           tx                += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*........ placer attribut graphique ........*/
           kwsection          = &syntprm->KwSection[isInkwSection];
           intGrClass         = kwsection->IntGrClass;
           
           pt_dst             = affi_buff;
           TXT_A->ATT_Cur     = &syntprm->GrClass[intGrClass].AttGr;
           pt_src            += nb_car;
           pos               += nb_car;
           
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
          }
       /* OPERATOR */
       else if ( (idgrclass = IS_C_OPP(pt_src, kwsection->Operator))
               )
          {/*........ afficher le texte avant ..........*/
           *pt_dst        = 0;
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*........ afficher le '(' ..................*/
           TXT_A->ATT_Cur = &syntprm->GrClass[idgrclass].AttGr;
           pt_dst         = affi_buff;
           *pt_dst++      = *pt_src++;
           pos++;
           /*.......... petite optimisation pour si suite pareille ..........*/
           while (                         /* SI espace ou operateur de meme couleur   */
                   (*pt_src==' '  ||
                    (idgrclass  == IS_C_OPP(pt_src, kwsection->Operator))
                   )
                  &&
                   (!kwend_tab[*pt_src] && /* et pas ne fin de section de mot clef     */
                    !kwbeg_tab[*pt_src] && /* et pas un debut de section de mot clef   */
                    !beg_tab[*pt_src]   && /* et pas un debut de section classique     */
                    !validTab[*pt_src]     /* et pas un debut de mot clef              */
                   )
                 )                         /* ALORS le rajouter  l'affichage          */
              {*pt_dst++  = *pt_src++;
                pos++;
              }
           *pt_dst        = 0;
           tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
           /*......... retablir attribut ...............*/
           pt_dst         = affi_buff;
           TXT_A->ATT_Cur = &syntprm->GrClass[intGrClass].AttGr;
          }
       else
          {*pt_dst++ = *pt_src++;
           pos++;
          }
      }
  }/* endwhile */
  #pragma warn .pia
 /*........ traiter le cas du fin de section EOF .................*/
 /*         qui ne passe pas dans les test car while( EOF)        */
 if (isInSection        && kwsection->SectionAdr[isInSection-1].EndStr[0] == '\r')
    {isInSection   = 0;
    }
 if (isInkwSection      && kwsection->MajMin & 8)
    {isInkwSection = 0;
    }
  *pt_dst = 0;
 lgn_stat[i].LgnState  = (char)isInSection;
 lgn_stat[i].KwSection = (char)isInkwSection;
 tx += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
 /*............. si couleur fin de ligne positionne .................*/
 if (TXT_A->ATT_Def[ATT_TXT_EOL].CarCol>-1)
    {int EOF_COL[2] = {2,0};
     EOF_COL[0]     = TXT_A->ATT_Def[ATT_TXT_EOL].CarCol; 
     Put_mono_color(tx, ty + TXT_A->IntLg - IC_EOF[1]-1,IC_EOF,2,EOF_COL);
    }
 /*................ si curseur positionne ...........................*/
 if ( TXT_A->CurState && i==TXT_A->LigPt )
    {EZ_ED_PaintCurs(TXT_A);
    }
 /*.............. si un bloc est positionn .........................*/
 if (TXT_A->BlkEndLig != TXT_A->BlkDebLig || TXT_A->BlkEndCar != TXT_A->BlkDebCar)
    {long blk_first = TXT_A->BlkDebLig; 
     long blk_last  = TXT_A->BlkEndLig;
     /*.... le debut et fin de ligne de bloc peuvent etre inverses ...*/
     /*           donc les remettre en ordre pour test                */
     if (blk_last < blk_first)
        {blk_first = TXT_A->BlkEndLig;
         blk_last  = TXT_A->BlkDebLig;
        }
     /*......... tester si la ligne en cours d'affichage est .........*/
     /*                    dans le bloc                               */
     if (i>= blk_first && i<= blk_last)
        {/*............ afficher le  bloc ............................*/
         EZ_ED_DrawBlkFrame(i, BLK_LINE_DRAW, TXT_A);
        }
    }
 return 1;

}

/*------------------------- IsBegSection ------------------------------------*/
/* ACTION: verifie si le texte pointe est un debut de section particulire   */
/*         type commentaire ou string.                                       */
/*         si oui retourne, la classe graphique associe, le type de section */
/*         le nombre de caractres marquant cette section.                   */
/* ENTREE: char *pt_src: pointe sur le texte dont il faut evaluer si les     */
/*                       caractres sont un debut de section.                */
/*         int *section_type: pointe sur un int dans lequel il sera retourne */
/*                            le type de section (en fait indice ds la table */
/*                            des chaines  reconnaitre comme debut de       */
/*                            section)                                       */
/*         int *idgrclass: pointe sur un int dans lequel sera retourn       */
/*                         l'indice de la classe graphique  utiliser.       */
/*         SYNT_PARAM *syntprm: parametres syntaxiques du texte en cours.    */
/* RETOUR: int nbr de caractere de la chaine de delimitation de debut de     */
/*             section                                                       */
/* RAPPEL:                                                                   */
/* typedef struct                                                                   */
/*     {char LenBegstr;    longueur de la chaine                                    */
/*      char BegStr[16];   nom du mot clef marquant le debut de section             */
/*      char LenEndStr;    longueur de la chaine                                    */
/*      char EndStr[16];   nom du mot clef marquant la fin de section               */
/*      int  GraphClass;   classe graphique de la section                           */
/*      char EscCar;       caractre d'echapement d'une section                     */
/*      CAR_ATTR *CarAtt;  adresse des attributs graphiques  de la classe graphique */
/*     } SECTION;                                                                   */
/*typedef struct
    {int          NbGrClass;
     CLASS_GRAPH *GrClass;
     int          NbKeyW;
     KEY_WRD     *KeyW;
     int          NbSection;
     SECTION     *Section;
     int          TypeOppC[256];
     int          IndentOpp[256];
     char         SectBegFirstCar[256];
     char         SectEndFirstCar[256];
     char         Extension[256];
    } SYNT_PARAM;
*/
 
int IsBegSection(char *pt_src, int *section_type,  int *idgrclass, int kwID, SYNT_PARAM *syntprm)
{int idSection;
 KWSECTION *kwsection  = &syntprm->KwSection[kwID];
 SECTION   *section    = kwsection->SectionAdr;
 int nb_car =  ISSECTION(pt_src, section->BegStr, (int)sizeof(SECTION), (long)&idSection);
 if (nb_car)
    {*idgrclass    =  section[idSection].GraphClass;
     *section_type = idSection+1;
    }
 return nb_car;
}

/*------------------------- IsEndSection ------------------------------------*/
/* ACTION: verifie si le texte pointe est une fin de section particulire    */
/*         type commentaire ou string.                                       */
/*         si oui met  zero le type de section et retourne                  */
/*         le nombre de caractres marquant cette fin de section.            */
/* ENTREE: char *pt_src: pointe sur le texte dont il faut evaluer si les     */
/*                       caractres sont un debut de section.                */
/*         int *section_type: pointe sur un int dans lequel il y a l'indice  */
/*                            de la section  tester et si les caracteres    */
/*                            pointes par: char *pt_src sont ceux de fin de  */
/*                            cette section, alors ce int pointe par:        */
/*                            int *section_type  est mis  zero.             */
/*         int *idgrclass: pointe sur un int dans lequel sera retourn       */
/*                         l'indice de la classe graphique  utiliser.       */
/*         SYNT_PARAM *syntprm: parametres syntaxiques du texte en cours.    */
/* RETOUR: int nbr de caractere de la chaine de delimitation de fin de       */
/*                    de section.                                            */

int IsEndSection(char *pt_src, int *section_type, int kwID, SYNT_PARAM *syntprm)
{KWSECTION *kwsection  = &syntprm->KwSection[kwID];
 SECTION   *section    = &kwsection->SectionAdr[*section_type - 1];
 int  nb_car       = ISENDSECTION(section->EscCar, pt_src, section->EndStr);
 if (nb_car) 
    {*section_type = 0;
    }
 return nb_car;
}

/*------------------------- IsBegKwSection ----------------------------------*/
int IsBegKwSection(char *pt_src, int *section_type, int *idgrclass, SYNT_PARAM *syntprm)
{int idSection;
 int nb_car =  ISSECTION(pt_src, syntprm->KwSection->BegStr, (int)sizeof(KWSECTION), (long)&idSection);
 if (nb_car)
    {*idgrclass    =  syntprm->KwSection[idSection].GraphClass;
     *section_type = idSection;
    }
 return nb_car;
}

/*------------------------- IsEndKwSection ----------------------------------*/
int IsEndKwSection(char *pt_src, int *section_type, int *idgrclass, SYNT_PARAM *syntprm)
{KWSECTION *kwsection  = &syntprm->KwSection[*section_type];
 int  nb_car           = ISENDSECTION(0, pt_src, kwsection->EndStr);
 if (nb_car) 
    {*idgrclass    = syntprm->KwSection[*section_type].GraphClass;
     *section_type = 0;
    }
 return nb_car;
}

/*------------------------- IS_NUMERIC --------------------------------------*/
/*
long IS_NUMERIC(char *pt_src, char *valid_tab)
{char *pt_deb = pt_src;
 while(valid_tab[*pt_src])pt_src++;
 return pt_src-pt_deb;
}
*/

/*-------------------------- BeforeIsValid --------------------------------*/
int BeforeIsValid(char *pt_src, long lig, char* validTab, TXTED_OB *TXT_A)
{/*...... si avant mot clef c'est pas conforme sortir ........*/
 /*              >> SI il s'agit de la ligne en edition       */
 if (lig == TXT_A->LigPt )
    {/*             >> SI premier car du buffer ne pas tester */
     /*                   car avant c'est toujours valide     */
     /*                   car soit \r\n\ soit debut texte     */
     if (pt_src == TXT_A->BuffEdit)              return 1;  
     /*             >> SINON car a tester est celui d'avant   */
    }
 /*              >> SI il s'agit d'une ligne normale de texte */
 else   
    {/*             >> SI premier car de la ligne, pas tester */
     /*                   car avant c'est toujours valide     */
     /*                   car soit \r\n\ soit debut texte     */
     if (pt_src == TXT_A->TabLgnCtx[lig].ptTxt)  return 1;
     /* if (pt_src == EZ_ED_GETCURLIG(TXT_A))  return 1; */
     /*             >> SINON car a tester est celui d'avant   */
     }
 if (validTab[*(--pt_src)])                      return 0;
 /*               SI pas alphanumerique c'est valide          */
                                                 return 1;
}

void Spys(const char *mes)
{puts("\33H");
 printf("%s","                                                                                                                                                                 ");
 puts("\33H");
 printf("%s",mes);
 /*getch();*/
}